Module module_add_nox_lightning
   USE module_domain
;   real, allocatable :: sorc3d(:,:,:),colnox(:,:),phydro(:,:,:)
   integer, allocatable :: numnox(:,:)
   logical setzero
   integer nlnlgt ! number of levels of lightning profile
   parameter (nlnlgt=16)
   real slnox_profile(nlnlgt,3)
   logical donoxlightning
CONTAINS
   subroutine add_nox_lightning(id,dtstep,ktau,p8w,z_at_w,z,   &
   chem,num_chem,xlat, &
   xland,rho_phy,p_phy,t_phy,htop,hbot,dx, &
   ims,ime, jms,jme, kms,kme, &
   its,ite, jts,jte, kts,kte,sorc3d,colnox,restart)
   USE module_domain, only : p_no
!   USE model_state_description, only : p_no
   IMPLICIT NONE

   INTEGER, INTENT( IN ) :: its,ite, jts,jte, kts,kte, &
   ims,ime, jms,jme, kms,kme,num_chem
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme, num_chem ), &
   INTENT( INOUT ) ::               chem
   REAL, DIMENSION( ims:ime, jms:jme ) , &
   INTENT( IN ) ::               xlat ,xland
   REAL, DIMENSION( ims:ime, jms:jme ) , &
   INTENT( INOUT ) ::               htop,hbot,colnox
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), &
   INTENT( INOUT ) :: sorc3d
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), &
   INTENT( IN ) ::               z_at_w,z,rho_phy,p_phy,p8w,t_phy
!   real ajl2(ims:ime,kms:kme,jms:jme)
   integer lccoldbot
   real NA,molwgtair,condentomolcm3
   parameter (NA=6.02214179e23) ! avogradro's number
   parameter (molwgtair=28.97)
   parameter (condentomolcm3=NA*.001/molwgtair)
   real dtstep,dx,dxkm
   logical first,restart
   data first/.true./
   save first
!c Lightning flashrate param from Allen and Pickering, JGR 2002
   real ap_a,ap_b,ap_c,ap_d,ap_e,cgnox,ccnox
   parameter(ap_a = 0.021, ap_b = -0.648, ap_c = 7.493, &
     &          ap_d = -36.540, ap_e = 63.090)
   parameter(cgnox = 6.7e26)   ! molecules NO/flash
   parameter(ccnox = 6.7e25)   ! molecules NO/flash
   integer i,j,lip,ip,li,iprof,ijg,ijg2,id,ktau,lnoxtop,l,ll,lbot,numdo,k
   parameter (ijg=32,ijg2=64)
   real rlat,z1,z2,column,ccldht,flash,zhu,zhl,dz,fcg,areacm2,wtav,dens
   real sorclnox(kms:kme)
   character*10 cusepr94,cdoareafix,cnoxlightning
   logical dopr94,doareafix
   real coefpr94,coefpr94dx
   save dopr94,coefpr94,doareafix,area225,areacm2,arearatio
   real dtor,recm,area225,arearatio
   parameter(dtor=3.1415926535/180.)        ! degrees to radians
   parameter(recm = 6.371e8)   ! radius of earth in cm
   numdo=0
   if(first)then
     cnoxlightning=' '
     call getenv('NOXLIGHTNING',cnoxlightning)
     if(cnoxlightning.eq.'no'.or.cnoxlightning.eq.'NO')then
       donoxlightning=.false.
     else if(cnoxlightning.eq.'yes')then
       donoxlightning=.true.
     else if(cnoxlightning.eq.' ')then
       donoxlightning=.true.
     else
       donoxlightning=.true.
     endif
     write(6,*)'NOXLIGHTNING',donoxlightning
     call flush(6)
     if(.not.donoxlightning)then
       first=.false.
     endif
   endif
   if(.not.donoxlightning)then
     return
   endif
!#define WALLT
#ifdef WALLT
   call wallt('noxlight',0)
#endif
   if(first)then
     write(6,*)'call noxall',ims,ime,kms,kme,jms,kme
     call flush(6)
     call noxallocate(ims,ime,kms,kme,jms,jme)
!   ajl2=0.0
     areacm2=dx*dx*1.e4
     area225=recm*recm*2.*2.5*dtor*dtor*cos(30.*dtor)
     arearatio=areacm2/area225
     write(6,*)'area ratio',areacm2/area225,'arearatio',arearatio
     cusepr94=' '
     call getenv('USEPR94',cusepr94)
     doareafix=.false.
     cdoareafix=' '
     call getenv('AREAFIX',cdoareafix)
     if(cdoareafix.eq.'yes')then
       doareafix=.true.
       write(6,*)'doareafix'
     endif
     if(cusepr94.eq.'yes')then
       dopr94=.true.
       dxkm=dx*.001
       coefpr94=.97241*exp(.048203*(35./111.1)**2.)
       coefpr94dx=.97241*exp(.048203*(dxkm/111.1)**2.)
       write(6,*)'do pr94 coef',coefpr94,'dx',dx,'coefkm',coefpr94dx
       call flush(6)
       coefpr94=coefpr94dx
       write(6,*)'coefpr94',coefpr94
     else
       dopr94=.false.
       write(6,*)'dont do pr94 coef '
     endif
     first=.false.
     call readprofile(slnox_profile,nlnlgt)
     if(.not.restart)then
     sorc3d=0.0
     colnox=0.0
     endif
     numnox=0
     setzero=.false.
   endif
!   write(6,*)'setzero',setzero
!   call flush(6)
   if(setzero)then
     sorc3d=0.0
     colnox=0.0
     numnox=0
     setzero=.false.
   endif
!  get density for chem from rho_phy
!   dens=NA*rho_phy
!        dens=7.2431122e+18*clim_plev(l)/tc(l) ! from chemistry=NA/R*P/T while rho=p/(RT)
!  calculate rate
!  areacm2 is dx**2*10.e4
!  Replace climatological column with instantaneous flashrate-based calc.
!  Top of profile is convective cloudtop height instead of tropopause
!
!  #define DIAGNOX
#ifdef DIAGNOX
   write(6,*)'its',its,ite,jts,jte
   call flush(6)
   write(6,*)'htop',htop(its,jts),htop(ite,jte),hbot(its,jts),htop(ite,jte)
   call flush(6)
   write(6,*)'colnox',colnox(its,jts),colnox(ite,jte)
   call flush(6)
   write(6,*)'sorc3d',sorc3d(its,kts,jts),sorc3d(ite,kte,jte)
   call flush(6)
#endif

   do j=jts,jte
     do i=its,ite
#ifdef DIAGNOX
         write(6,*)'htop',htop(i,j),hbot(i,j),i,j
         call flush(6)
#endif
!       if(htop(i,j).ne.0.0.or.hbot(i,j).ne.0.0)then
!       !write(6,*)'htop',htop(i,j),'hbot',hbot(i,j)
!       call flush(6)
!       endif
       column = 0.
!      lnoxtop = lconvcld(i,j)           ! lconvcld index is T->B
       lnoxtop=htop(i,j)
       lnoxtop=max(lnoxtop,1)
       l=lnoxtop
       sorclnox=0.
       rlat=xlat(i,j)
       if (p_phy(i,l,j) .le. 440.e2) then
#ifdef DIAGNOX
         write(6,*)'p_phy',p_phy(i,l,j),t_phy(i,k,j)
         call flush(6)
#endif
         lbot=hbot(i,j)
         lbot=max(lbot,1)
!        dz = ccthk(i,j)
         if(lbot>=lnoxtop)then
           dz=0.0
         else
           lccoldbot=lnoxtop
           do k=min(lnoxtop-1,kte-1),lbot,-1
!             write(6,*)'tkp',k+1,t_phy(i,k+1,j),k,t_phy(i,k,j)
             if(t_phy(i,k+1,j)<273.and.t_phy(i,k,j)>273.)then
               lccoldbot=k
               go to 888
             endif
           end do
888        continue
!          dz in km
!          z is z at mid point dashes
#ifdef DIAGNOX
           write(6,*)'lnoxtop',lnoxtop,lccoldbot,i,j
           call flush(6)
#endif
           dz=(z(i,lnoxtop,j)-z(i,lccoldbot,j))/1000.
!           write(6,*)'dz',dz,'lnoxtop',lnoxtop,'lccoldbot',lccoldbot,'ltop',lnoxtop,'i',i,j, &
#ifdef DIAGNOX
           write(6,*)'dz',dz,i,j,'l',l
           call flush(6)
#endif
          
           
           dz=max(dz,5.5)
         endif
!        dz=htop(i,j)-hbot(i,j)
         if (dz .gt. 0.) then
           if (dz .ge. 14.) then
             fcg = 0.02
           else
             fcg = 1./(ap_a*dz**4+ap_b*dz**3+ap_c*dz**2+ap_d*dz+ap_e+1)
           endif
!           write(6,*)'fcg',fcg
!          l = ltb(lconvcld(i,j))          ! lconvcld index is T->B
!          l=lnoxtop
!          if (pgrd(i,j,l) .le. 440.) then
!          if (p_phy(i,l,j) .le. 440.e2) then
!          ccldht = zgrd(i,j,l)/1000.     !km
           ccldht = z(i,l,j)/1000.     !km
!          z is mid point dashes
!          if (zlwigrd(i,j) .ge. 1.5 .and. zlwigrd(i,j) .le. 2.5) then
!          xland is 1 for land 2 for ocean
#ifdef DIAGNOX
           write(6,*)'xland',xland(i,j),i,j
           call flush(6)
#endif
           if(xland(i,j) < 1.5 )then ! Land
             flash = 3.44e-5*ccldht**4.9
#ifdef DIAGLIGHTNING
             if(i.eq.104.and.j.eq.173)then
               write(6,*)'flash land',flash,' ccldht ',ccldht
             endif
#endif
           else
             ! Ocean (include ice)
             flash = 6.40e-4*ccldht**1.73
           endif
           ! Scale flashrate according to Pickering [pers.comm. 2005]
           flash = flash*0.648                   !global
!          if (zlwigrd(i,j) .lt. 1.5) then
           if(xland(i,j) > 1.5 )then ! ocean
             flash = flash*5.145                 !oceanic
!          else if (zlwigrd(i,j) .lt. 2.5) then
           else  ! assume land
             if (rlat .ge. 0.) then
               flash = flash*1.044               !NH continental
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
            write(6,*)'flash nh'
            call flush(6)
           endif
#endif
             else
               flash = flash*0.485               !SH continental
             endif
           endif
           ! Have flashrate/min/gridbox, calculate NOx molecules/cm^2/sec
           !
           column = flash*(cgnox*fcg+ccnox*(1.-fcg))
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
!           if((i.ge.91.and.i.le.100).and.(j.ge.171.and.j.le.173))then
             write(6,*)i,j,l,'z',z(i,l,j),'flash',flash,'xland',xland(i,j)
             write(6,*)i,j,l,'areacm2',areacm2,'dx',dx,'coef',coefpr94
             write(6,*)'column',column
           endif
#endif
           if(doareafix)then
#ifdef DIAGLIGHTNING
             write(6,*)i,j,'column',column,'areacm2',areacm2,'area225',area225
             call flush(6)
#endif
!             column=column*areacm2/area225
             column=column*arearatio
            
           endif
           if(dopr94)then
             column = column/areacm2/60.*coefpr94
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
              write(6,*)'column',column,' coefpr94 ',coefpr94
           endif
#endif
           else
             column = column/areacm2/60.
           endif
         endif
!        Determine whether midlatitude, tropical marine, or tropical land
!        land/water/ice flag: 1=ocean, 2=land, 3=ice
         iprof=1
         if (rlat.ge. -23.5 .and. rlat.le. 23.5) then
           if(xland(i,j) > 1.5 )then ! ocean
!          if (zlwigrd(i,j) .lt. 1.5) then
             iprof=2
           else
             iprof=3
           endif
         endif
!c       test=0
         zhu=16.
         li=16
!        now lbot is l of bottom
         lbot=1
!        do ip=1,lbot
#ifdef DIAGNOX
         write(6,*)i,j,'lnoxtop',lnoxtop,lbot
         call flush(6)
#endif
         do ip=lnoxtop,lbot,-1 ! ip =1 now at bottom and so is l
!          l=ltb(ip)
           l=ip
!          sorclnox(ip)=0.
           if(column.gt.0.) then
!
!            Get normalized Z at cell edges corresponding to Pickering 0-16km grid
!             zhl=16.*(zgeoh(ip)-zgeoh(lbot))/(zgeoh(lnoxtop-1)-zgeoh(lbot))
             zhl=16.*(z_at_w(i,ip,j)-z_at_w(i,lbot,j))/(z_at_w(i,lnoxtop+1,j)-z_at_w(i,lbot,j))
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
             write(6,*)'zhl',zhl,'ip',ip,'lnoxtop',lnoxtop,'zatwp+1=',z_at_w(i,lnoxtop+1,j), &
             'zip',z_at_w(i,ip,j),'lbot',lbot,'zlbot',z_at_w(i,lbot,j),'ratio=', &
             (z_at_w(i,ip,j)-z_at_w(i,lbot,j))/(z_at_w(i,lnoxtop+1,j)-z_at_w(i,lbot,j))
           endif
#endif
!
!            Sum/interpolate Pickering intervals to get distribution on our grid
             lip=int(zhl)
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
             write(6,*)'lip=',lip
           endif
#endif
             wtav=0.
!c           print*,ip,zhu,zhl,li,lip
             z1=zhu
             ll=li
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
            write(6,*)'ip',ip,'ll',ll,'lip+1=',lip+1
           endif
#endif
             do while (ll .gt. lip+1)
               z2=float(ll)-1.
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
!              if(i.eq.82.and.j.eq.189)then
                 write(6,*)'z1',z1,z2,'dz',z1-z2,'wtav',wtav
                 write(6,*)'ll',ll,'prof',slnox_profile(ll,iprof)
               endif
#endif
               wtav=wtav+slnox_profile(ll,iprof)*(z1-z2)
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
!              if(i.eq.82.and.j.eq.189)then
                 write(6,*)'wtav',wtav
               endif
#endif
!c             print*,ll,z1,z2,wtav
               z1=z2
               ll=ll-1
             enddo
             z2=zhl
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
            write(6,*)'add bottom',slnox_profile(ll,iprof),'z1',z1,'z2',z2,'dz',z1-z2,'add', &
             slnox_profile(ll,iprof)*(z1-z2),'ll',ll,'iprof',iprof
           endif
#endif
             wtav=wtav+slnox_profile(ll,iprof)*(z1-z2)
!c           print*,ll,z1,z2,wtav
!
!            Divide by layer thickness to get rate, convert km-1 to cm-1,
!            and divide by 100 to convert from percent
!            sorclnox(ip)=wtav*column*1.e-7/(zgeoh(ip-1)-zgeoh(ip))
!            zgeoh was in km
             sorclnox(ip)=wtav*column*1.e-4/(z_at_w(i,ip+1,j)-z_at_w(i,ip,j))
!            if(do5km)then
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
               if(sorclnox(ip).ne.0.0)then
                 write(6,*)i,j,ip,'wtav',wtav,'column',column,'dz',z_at_w(i,ip+1,j)-z_at_w(i,ip,j)
                 write(6,*)'dz',dz,'htop',htop(i,j),hbot(i,j),'sorc',sorclnox(ip)
                 write(6,*)'zatw',ip+1,z_at_w(i,ip+1,j),ip,z_at_w(i,ip,j)
                 write(6,*)'dzatw',z_at_w(i,ip+1,j)-z_at_w(i,ip,j)
                 write(6,*)'percent',wtav
                 write(6,*)'percentperk',wtav/(z_at_w(i,ip+1,j)-z_at_w(i,ip,j))*1000.
                 write(6,*)'column',column
                 call  flush(6)
               endif
               endif
#endif
 
!            endif
!            if(i.eq.82.and.j.eq.189)then
!             if(sorclnox(ip).ne.0.0)then
!               write(6,*)'wtav',wtav,'column',column,'dz',z_at_w(i,ip+1,j)-z_at_w(i,ip,j)
!               write(6,*)'dz',dz,'htop',htop(i,j),hbot(i,j),'sorc',sorclnox(ip)
!               call  flush(6)
!             endif
             zhu=zhl
             li=ll
!            test=test+wtav
           endif
!          add in tendency to no for now
           dens=condentomolcm3*rho_phy(i,ip,j)
!          parameter (condentomolcm3=NA*.001/molwgtair)
!          if(sorclnox(ip).ne.0.0)then
!            write(6,*)'i',i,'k',ip,'j',j,'dens',dens,'rho_phy',rho_phy(i,ip,j), &
!           'sorcl',sorclnox(ip),'dtstep',dtstep,'ratio',sorclnox(ip)/dens
!          endif
!           if((i.ge.91.and.i.le.100).and.(j.ge.171.and.j.le.173).and.sorclnox(ip).ne.0.0)then
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173.and.sorclnox(ip).ne.0.0)then
             write(6,*)i,j,'ip',ip,'sorclnox',sorclnox(ip),'dens',dens,'dtstep',dtstep,'new sorc',sorclnox(ip)/dens*1.e6*dtstep,'rho_phy',rho_phy(i,ip,j)
           endif
#endif
#ifdef DIAGNOX
           write(6,*)'set sorclnox',i,j
           call flush(6)
#endif
           sorclnox(ip)=sorclnox(ip)/dens*1.e6*dtstep
#ifdef DIAGNOX
           write(6,*)'did set sorclnox',i,j
           call flush(6)
#endif
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173.and.sorclnox(ip).ne.0.0)then
              write(6,*)'final sorcl',sorclnox(ip),ip,'tend',sorclnox(ip)/dtstep
           endif
#endif
           numdo=numdo+1
          
         
!          if(do5km)then
!             if(sorclnox(ip).ne.0.0)then
!               write(6,*)'i',i,'ip',ip,'j',j,'no before',chem(i,ip,j,p_no),'tend', &
!               sorclnox(ip),'wtav',wtav
!               call flush(6)
!             endif
!           endif
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
            if(sorclnox(ip).ne.0.0)then
              write(6,*)'sorclnox',ip,sorclnox(ip),'dens',dens
            endif
            endif
#endif
#ifdef DIAGNOX
           write(6,*)'chem p_no',chem(i,ip,j,p_no),sorclnox(ip)
           call flush(6)
#endif
           chem(i,ip,j,p_no)=chem(i,ip,j,p_no)+sorclnox(ip)
#ifdef DIAGNOX
           write(6,*)'did chem p_no',chem(i,ip,j,p_no),sorclnox(ip)
           call flush(6)
#endif
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
             write(6,*)ip,' sorc3dold ',sorc3d(i,ip,j),' add ',sorclnox(ip)
           endif
#endif
           sorc3d(i,ip,j)=sorc3d(i,ip,j)+sorclnox(ip)
#ifdef DIAGNOX
           write(6,*)'set sorc3d',sorc3d(i,ip,j)
           call flush(6)
!           ajl2(i,ip,j)=ajl2(i,ip,j)+sorclnox(ip)
           write(6,*)'did set sorc3d',sorc3d(i,ip,j)
           call flush(6)
#endif
#ifdef DIAGLIGHTNING
           if(i.eq.104.and.j.eq.173)then
            write(6,*)ip,' sorc3d ',sorc3d(i,ip,j),' ktau ',ktau
           endif
#endif
           colnox(i,j)=colnox(i,j)+sorclnox(ip)*(p8w(i,ip,j)-p8w(i,ip+1,j))/9.80616
         enddo ! ip
#ifdef DIAGLIGHTNING
         if(i.eq.104.and.j.eq.173)then
           write(6,*)'colnox',colnox(i,j),'numnox',numnox(i,j),' ktau ',ktau
         endif
#endif
         numnox(i,j)=numnox(i,j)+1
       endif ! p < 440 mb
     end do
   end do
!  need to reset htop,hbot before next convection call
   htop=0.0
   hbot=real(kte)
!   write(6,*)'maxval colnox',maxval(colnox)
!   call flush(6)
!   write(6,*)'numdo=',numdo,'ktau',ktau
!  call flush(6)
#ifdef WALLT
   call wallt('noxlight',1)
#endif
   return
   end subroutine add_nox_lightning
   subroutine readprofile(slnox_profile,nlnlgt)
   use module_dm,only : mytask,ntasks,local_communicator,getrealmpitype
   IMPLICIT NONE
   integer nlnlgt,idum,j,wrf_dm_monitor_rank
   real slnox_profile(nlnlgt,3)
   integer mpireal,communicator,collective_root,ierr,k
   mpireal=getrealmpitype()
   CALL wrf_get_dm_communicator ( communicator )
!   communicator=local_communicator
!   communicator=mpi_comm_world
   collective_root = wrf_dm_monitor_rank()
   if(mytask.eq.0)then
     open(500,file='lnox_frac_profile.dat',status='old',form='formatted')
     do idum=1,4
       read(500,*)
     enddo
     read(500,*) (slnox_profile(idum,1),idum=1,nlnlgt)
     print*,'Midlat Contin:'
     print*,(slnox_profile(idum,1),idum=1,nlnlgt)
     read(500,*)
     read(500,*) (slnox_profile(idum,2),idum=1,nlnlgt)
     print*,'Tropic Marine:'
     print*,(slnox_profile(idum,2),idum=1,nlnlgt)
     read(500,*)
     read(500,*) (slnox_profile(idum,3),idum=1,nlnlgt)
     print*,'Tropic Contin:'
     print*,(slnox_profile(idum,3),idum=1,nlnlgt)
     close(500)
!     write(6,*)'nlnlgt',nlnlgt
!     do k=1,nlnlgt
!      write(6,*)'slnox',k,slnox_profile(k,:)
!     !end do
   endif
   write(6,*)'mpibcast'
   call flush(6)
   call mpi_bcast(slnox_profile,3*nlnlgt,mpireal,collective_root,communicator,ierr)
   write(6,*)'did mpibcast'
   call flush(6)
!   do k=1,nlnlgt
!     write(6,*)'aftslnox',k,slnox_profile(k,:)
!   end do
   return
   end subroutine readprofile
   subroutine noxallocate(is,ie,ks,ke,js,je)
   if(.not.allocated(sorc3d))then
!     write(6,*)'do allocate',is,ie,ks,ke,js,je
!     call flush(6)
!     allocate (sorc3d(is:ie,ks:ke,js:je))
!     allocate (colnox(is:ie,js:je))
     allocate (numnox(is:ie,js:je))
   endif
   return
   end subroutine noxallocate
end Module module_add_nox_lightning
   subroutine getnoxlightning(noxlightning3d,colnoxout,is,ie,ks,ke,js,je)
   use module_add_nox_lightning
   real noxlightning3d(is:ie,ks:ke,js:je),amax,amin,colnoxout(is:ie,js:je)
   numsum=0
!   write(6,*)'top getnoxlightning',is,ie,ks,ke,js,je
!   call flush(6)
    if(.not.allocated(numnox))then
!     write(6,*)'do allocate',is,ie,ks,ke,js,je
!     call flush(6)
!     allocate (sorc3d(is:ie,ks:ke,js:je))
!     allocate (phydro(is:ie,ks:ke,js:je))
!     write(6,*)'do numnox'
!     call flush(6)
     allocate (numnox(is:ie,js:je))
     !allocate (colnox(is:ie,js:je))
!     write(6,*)'zero'
!     call flush(6)
     noxlightning3d=0.0
     numnox=0
     sorc3d=0.0
     colnox=0.0
     return
   endif
   if(.not.donoxlightning)then
     noxlightning3d=0.0
     colnoxout=0.0
     return
   endif
   amax=-1.e50
   amin=1.e50
   noxlightning=0.0
   colnoxout=0.0
   noxlightning3d=0.0
   do j=js,je
     do i=is,ie
       if(numnox(i,j).ne.0)then
         numsum=numsum+1
         do k=ks,ke
!           noxlightning3d(i,k,j)=sorc3d(i,k,j)/float(numnox(i,j))
           noxlightning3d(i,k,j)=sorc3d(i,k,j)
!           if(noxlightning3d(i,k,j)<-1.e50.or.noxlightning3d(i,k,j)>1.e50)then
!            write(6,*)'noxlig',i,k,j,noxlightning3d(i,k,j),sorc3d(i,k,j),numnox(i,j)
!           endif
           amax=max(noxlightning3d(i,k,j),amax)
           amin=min(noxlightning3d(i,k,j),amin)
         end do
         colnoxout(i,j)=colnox(i,j)
       endif
     end do
   end do
   if(numsum.ne.0)then
   write(6,*)'numsum',numsum,'max',amax,amin
   endif
   setzero=.true.
   return
   end subroutine getnoxlightning
