Module module_add_nox_lightning
   USE module_domain
; real, allocatable :: sorc3d(:,:,:),colnox(:,:),phydro(:,:,:)
   integer, allocatable :: numnox(:,:)
   logical setzero
   integer nlnlgt
   parameter (nlnlgt=16)
   real slnox_profile(nlnlgt,3)
   logical donoxlightning
CONTAINS
   subroutine add_nox_lightning(id,dtstep,ktau,p8w,z_at_w,z, &
   chem,num_chem,xlat, &
   xland,rho_phy,p_phy,t_phy,htop,hbot,dx, &
   ims,ime, jms,jme, kms,kme, &
   its,ite, jts,jte, kts,kte,sorc3d,colnox,restart)
   USE module_domain, only : p_no

   IMPLICIT NONE

   INTEGER, INTENT( IN ) :: its,ite, jts,jte, kts,kte, &
   ims,ime, jms,jme, kms,kme,num_chem
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme, num_chem ), &
   INTENT( INOUT ) :: chem
   REAL, DIMENSION( ims:ime, jms:jme ) , &
   INTENT( IN ) :: xlat ,xland
   REAL, DIMENSION( ims:ime, jms:jme ) , &
   INTENT( INOUT ) :: htop,hbot,colnox
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), &
   INTENT( INOUT ) :: sorc3d
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), &
   INTENT( IN ) :: z_at_w,z,rho_phy,p_phy,p8w,t_phy

   integer lccoldbot
   real NA,molwgtair,condentomolcm3
   parameter (NA=6.02214179e23)
   parameter (molwgtair=28.97)
   parameter (condentomolcm3=NA*.001/molwgtair)
   real dtstep,dx,dxkm
   logical first,restart
   data first/.true./
   save first

   real ap_a,ap_b,ap_c,ap_d,ap_e,cgnox,ccnox
   parameter(ap_a = 0.021, ap_b = -0.648, ap_c = 7.493, &
     & ap_d = -36.540, ap_e = 63.090)
   parameter(cgnox = 6.7e26)
   parameter(ccnox = 6.7e25)
   integer i,j,lip,ip,li,iprof,ijg,ijg2,id,ktau,lnoxtop,l,ll,lbot,numdo,k
   parameter (ijg=32,ijg2=64)
   real rlat,z1,z2,column,ccldht,flash,zhu,zhl,dz,fcg,areacm2,wtav,dens
   real sorclnox(kms:kme)
   character*10 cusepr94,cdoareafix,cnoxlightning
   logical dopr94,doareafix
   real coefpr94,coefpr94dx
   save dopr94,coefpr94,doareafix,area225,areacm2,arearatio
   real dtor,recm,area225,arearatio
   parameter(dtor=3.1415926535/180.)
   parameter(recm = 6.371e8)
   numdo=0
   if(first)then
     cnoxlightning=' '
     call getenv('NOXLIGHTNING',cnoxlightning)
     if(cnoxlightning.eq.'no'.or.cnoxlightning.eq.'NO')then
       donoxlightning=.false.
     else if(cnoxlightning.eq.'yes')then
       donoxlightning=.true.
     else if(cnoxlightning.eq.' ')then
       donoxlightning=.true.
     else
       donoxlightning=.true.
     endif
     write(6,*)'NOXLIGHTNING',donoxlightning
     call flush(6)
     if(.not.donoxlightning)then
       first=.false.
     endif
   endif
   if(.not.donoxlightning)then
     return
   endif




   if(first)then
     write(6,*)'call noxall',ims,ime,kms,kme,jms,kme
     call flush(6)
     call noxallocate(ims,ime,kms,kme,jms,jme)

     areacm2=dx*dx*1.e4
     area225=recm*recm*2.*2.5*dtor*dtor*cos(30.*dtor)
     arearatio=areacm2/area225
     write(6,*)'area ratio',areacm2/area225,'arearatio',arearatio
     cusepr94=' '
     call getenv('USEPR94',cusepr94)
     doareafix=.false.
     cdoareafix=' '
     call getenv('AREAFIX',cdoareafix)
     if(cdoareafix.eq.'yes')then
       doareafix=.true.
       write(6,*)'doareafix'
     endif
     if(cusepr94.eq.'yes')then
       dopr94=.true.
       dxkm=dx*.001
       coefpr94=.97241*exp(.048203*(35./111.1)**2.)
       coefpr94dx=.97241*exp(.048203*(dxkm/111.1)**2.)
       write(6,*)'do pr94 coef',coefpr94,'dx',dx,'coefkm',coefpr94dx
       call flush(6)
       coefpr94=coefpr94dx
       write(6,*)'coefpr94',coefpr94
     else
       dopr94=.false.
       write(6,*)'dont do pr94 coef '
     endif
     first=.false.
     call readprofile(slnox_profile,nlnlgt)
     if(.not.restart)then
     sorc3d=0.0
     colnox=0.0
     endif
     numnox=0
     setzero=.false.
   endif


   if(setzero)then
     sorc3d=0.0
     colnox=0.0
     numnox=0
     setzero=.false.
   endif
   do j=jts,jte
     do i=its,ite
       column = 0.
       lnoxtop=htop(i,j)
       lnoxtop=max(lnoxtop,1)
       l=lnoxtop
       sorclnox=0.
       rlat=xlat(i,j)
       if (p_phy(i,l,j) .le. 440.e2) then
         lbot=hbot(i,j)
         lbot=max(lbot,1)
         if(lbot>=lnoxtop)then
           dz=0.0
         else
           lccoldbot=lnoxtop
           do k=min(lnoxtop-1,kte-1),lbot,-1
             if(t_phy(i,k+1,j)<273.and.t_phy(i,k,j)>273.)then
               lccoldbot=k
               go to 888
             endif
           end do
888 continue
           dz=(z(i,lnoxtop,j)-z(i,lccoldbot,j))/1000.
           dz=max(dz,5.5)
         endif
         if (dz .gt. 0.) then
           if (dz .ge. 14.) then
             fcg = 0.02
           else
             fcg = 1./(ap_a*dz**4+ap_b*dz**3+ap_c*dz**2+ap_d*dz+ap_e+1)
           endif
           ccldht = z(i,l,j)/1000.
           if(xland(i,j) < 1.5 )then
             flash = 3.44e-5*ccldht**4.9
           else
             flash = 6.40e-4*ccldht**1.73
           endif
           flash = flash*0.648
           if(xland(i,j) > 1.5 )then
             flash = flash*5.145
           else
             if (rlat .ge. 0.) then
               flash = flash*1.044
             else
               flash = flash*0.485
             endif
           endif
           column = flash*(cgnox*fcg+ccnox*(1.-fcg))
           if(doareafix)then
             column=column*arearatio
           endif
           if(dopr94)then
             column = column/areacm2/60.*coefpr94
           else
             column = column/areacm2/60.
           endif
         endif
         iprof=1
         if (rlat.ge. -23.5 .and. rlat.le. 23.5) then
           if(xland(i,j) > 1.5 )then
             iprof=2
           else
             iprof=3
           endif
         endif
         zhu=16.
         li=16
         lbot=1
         do ip=lnoxtop,lbot,-1
           l=ip
           if(column.gt.0.) then
             zhl=16.*(z_at_w(i,ip,j)-z_at_w(i,lbot,j))/(z_at_w(i,lnoxtop+1,j)-z_at_w(i,lbot,j))
             lip=int(zhl)
             wtav=0.
             z1=zhu
             ll=li
             do while (ll .gt. lip+1)
               z2=float(ll)-1.
               wtav=wtav+slnox_profile(ll,iprof)*(z1-z2)
               z1=z2
               ll=ll-1
             enddo
             z2=zhl
             wtav=wtav+slnox_profile(ll,iprof)*(z1-z2)
             sorclnox(ip)=wtav*column*1.e-4/(z_at_w(i,ip+1,j)-z_at_w(i,ip,j))
             zhu=zhl
             li=ll
           endif
           dens=condentomolcm3*rho_phy(i,ip,j)
           sorclnox(ip)=sorclnox(ip)/dens*1.e6*dtstep
           numdo=numdo+1
           chem(i,ip,j,p_no)=chem(i,ip,j,p_no)+sorclnox(ip)
           sorc3d(i,ip,j)=sorc3d(i,ip,j)+sorclnox(ip)
           colnox(i,j)=colnox(i,j)+sorclnox(ip)*(p8w(i,ip,j)-p8w(i,ip+1,j))/9.80616
         enddo
         numnox(i,j)=numnox(i,j)+1
       endif
     end do
   end do
   htop=0.0
   hbot=real(kte)
   return
   end subroutine add_nox_lightning
   subroutine readprofile(slnox_profile,nlnlgt)
   use module_dm,only : mytask,ntasks,local_communicator,getrealmpitype
   IMPLICIT NONE
   integer nlnlgt,idum,j,wrf_dm_monitor_rank
   real slnox_profile(nlnlgt,3)
   integer mpireal,communicator,collective_root,ierr,k
   mpireal=getrealmpitype()
   CALL wrf_get_dm_communicator ( communicator )
   collective_root = wrf_dm_monitor_rank()
   if(mytask.eq.0)then
     open(500,file='lnox_frac_profile.dat',status='old',form='formatted')
     do idum=1,4
       read(500,*)
     enddo
     read(500,*) (slnox_profile(idum,1),idum=1,nlnlgt)
     print*,'Midlat Contin:'
     print*,(slnox_profile(idum,1),idum=1,nlnlgt)
     read(500,*)
     read(500,*) (slnox_profile(idum,2),idum=1,nlnlgt)
     print*,'Tropic Marine:'
     print*,(slnox_profile(idum,2),idum=1,nlnlgt)
     read(500,*)
     read(500,*) (slnox_profile(idum,3),idum=1,nlnlgt)
     print*,'Tropic Contin:'
     print*,(slnox_profile(idum,3),idum=1,nlnlgt)
     close(500)
   endif
   write(6,*)'mpibcast'
   call flush(6)
   call mpi_bcast(slnox_profile,3*nlnlgt,mpireal,collective_root,communicator,ierr)
   write(6,*)'did mpibcast'
   call flush(6)
   return
   end subroutine readprofile
   subroutine noxallocate(is,ie,ks,ke,js,je)
   if(.not.allocated(sorc3d))then
     allocate (numnox(is:ie,js:je))
   endif
   return
   end subroutine noxallocate
end Module module_add_nox_lightning
   subroutine getnoxlightning(noxlightning3d,colnoxout,is,ie,ks,ke,js,je)
   use module_add_nox_lightning
   real noxlightning3d(is:ie,ks:ke,js:je),amax,amin,colnoxout(is:ie,js:je)
   numsum=0
    if(.not.allocated(numnox))then
     allocate (numnox(is:ie,js:je))
     noxlightning3d=0.0
     numnox=0
     sorc3d=0.0
     colnox=0.0
     return
   endif
   if(.not.donoxlightning)then
     noxlightning3d=0.0
     colnoxout=0.0
     return
   endif
   amax=-1.e50
   amin=1.e50
   noxlightning=0.0
   colnoxout=0.0
   noxlightning3d=0.0
   do j=js,je
     do i=is,ie
       if(numnox(i,j).ne.0)then
         numsum=numsum+1
         do k=ks,ke
           noxlightning3d(i,k,j)=sorc3d(i,k,j)
           amax=max(noxlightning3d(i,k,j),amax)
           amin=min(noxlightning3d(i,k,j),amin)
         end do
         colnoxout(i,j)=colnox(i,j)
       endif
     end do
   end do
   if(numsum.ne.0)then
   write(6,*)'numsum',numsum,'max',amax,amin
   endif
   setzero=.true.
   return
   end subroutine getnoxlightning
