Module module_assimaod
!   real, allocatable :: aodassm(:,:),aodinc(:,:)
!    real, allocatable ::  cumaodinc(:,:),cumaoddiff(:,:)
!    real, allocatable ::  cumaoddiff(:,:)
   integer mpireal,mpiinteger,collective_root,communicator,mpiint,mpichar,nrec
   integer,allocatable :: ikjgsend(:,:,:)
   integer, allocatable :: sendaod(:),dispaod(:)
   logical doassimaod,doassimaodsave
#define SAVEAOD
#ifdef SAVEAOD
   real, allocatable :: aodpart(:,:,:),aodlvl(:,:,:),extlvl(:,:,:,:),dzlvl(:,:,:)
   integer iext
#endif
CONTAINS
   subroutine assimaod(p_phy,t_phy,dz8w,moist,n_moist,chem,num_chem,grid, &
   idsin,idein,jdsin,jdein,kdsin,kdein, &
   ims,ime,jms,jme,kms,kme, &
   ips,ipein,jps,jpein,kps,kpe,idat,xlatlon,dohour,aodassm,aodinc,cumaodinc,ktau) 
   USE module_domain, only : p_sulf,p_bc1,p_bc2,p_oc1,p_oc2, &
       p_dust_1,p_dust_2,p_dust_3,p_dust_4,p_seas_1,p_seas_2,p_seas_3, &
       p_seas_4,p_dust_5,domain
    USE module_dm,only : mytask,ntasks,local_communicator,getrealmpitype
   USE MODULE_GFS_PHYSCONS, only :  RD => con_RD
   USE MODULE_GFS_FUNCPHYS ,ONLY : gfuncphys
   USE module_domain, only : p_QV
!   use pmgrid, only : mpiint
!----------------------------------------------------------------------
   IMPLICIT NONE
!----------------------------------------------------------------------

       TYPE(domain) , TARGET          :: grid

   integer, external :: wrf_dm_monitor_rank
   include "mpif.h"
   INTEGER ,          INTENT(IN   ) :: n_moist,ktau
   real xlatlon(2,ips:ipein,jps:jpein)

   INTEGER, INTENT(IN) :: ims,ime,jms,jme,kms,kme, &
   idsin,idein,jdsin,jdein,kdsin,kdein, &
   ips,jps,kps,kpe,ipein,jpein
   REAL, DIMENSION( ims:ime, kms:kme , jms:jme , n_moist ), INTENT(IN) :: moist
   logical dohour



   REAL , DIMENSION( ims:ime , kms:kme , jms:jme ) ,                 &
          INTENT(  IN)                                  ::   p_phy,t_phy,dz8w
   integer its,ite,jts,jte,kts,kte,ii
   integer ipe,jpe
   integer nchem,nc,nl,nac_hlut,nac,nac_hlut_tmp,nchemaod,num_chem,nj
   integer ids,ide,jds,jde,kds,kde
   parameter (nchem=17,nac_hlut=14,nac=6,nchemaod=14)
   real convert(nchem),convertb(nchem)
   real, dimension (ims:ime, jms:jme) :: aodassm,aodinc,cumaodinc
   REAL,DIMENSION(grid%sm31:grid%em31,grid%sm32:grid%em32,   &
   &grid%sm33:grid%em33,num_chem) ::               chem
   real ratioaod(ips:ipein,jps:jpein),aodnew(ips:ipein,jps:jpein)
   real, allocatable :: chemp(:,:,:,:),den(:,:,:),rh(:,:,:),dz(:,:,:)
   real, allocatable :: aod1stguessj(:,:),ratioj(:,:),aodincj(:,:),xlatlonj(:,:,:)
   real, allocatable :: ext_3d(:,:,:,:),mass_ext_3d(:,:,:,:),ratio(:,:)
   real, allocatable :: aodassmd(:,:),aodincd(:,:),xlatlond(:,:,:),aod1stguess(:,:)
#ifdef SAVEAOD
   real, allocatable :: aodpartj(:,:,:),aodlvlj(:,:,:)
#endif
#define COMPAOD2
#ifdef COMPAOD2
   real, allocatable :: aaod(:,:),diffaod(:,:)
   real rmx,rmn,rms
#endif
!   real ratio(idsin:idein,jdsin:jdein),aod1stguess(idsin:idein,jdsin:jdein), &
!   real ratio(idsin:idein,jdsin:jdein),aod1stguess(idsin:idein,jdsin:jdein), &
!   aodassmd(idsin:idein,jdsin:jdein),aodincd(idsin:idein,jdsin:jdein), &
!   xlatlond(2,idsin:idein,jdsin:jdein)
   real, allocatable :: mole_frac_3d(:,:,:,:)
!  tks only 14 chemicals used in assimilation for now
!  the following converts indexing of chemp to Chieko's indexing
   integer order(nchemaod),iorder(nchem)
   integer i,j,k,ij,idat
!   integer i_start,j_start,k_start,k_end,i_end,j_end
   integer i_start,j_start,k_start,i_end,j_end
   integer nnn,n,iac,nlay,iext,nn
   real mass_ttl_new,x_new,mass_new,mass_w_new
   real mw_so4,mw_bc,mw_oc,mw_air,mw_no3,mw_w,mw_aero,ext_3d_new
   real mw_du,mw_ss
   real maxaodj,minaodj
   real maxaodd,maxq,minq,minaodd
   real maxaodjj(1:ntasks),minaodjj(1:ntasks)
   integer imax,jmax,irest,imin,jmin,ierr
   character *4 cassimaod
   logical doratioaod,haveaodinc,first
   character *3 cratioaod
   integer ilist((ipein-ips+1)*(jpein-jps+1)),jlist((ipein-ips+1)*(jpein-jps+1)),numlist
   save first
   data first/.true./
   


!20060223      parameter(mw_so4=96.,mw_bc=12.,mw_oc=16.8,mw_air=28.9)
   character *6 cpartt(14)
   data cpartt/'AODSUL','AODBC1','AODBC2','AODOC1','AODOC2', &
   'AODDU1','AODDU2','AODDU3','AODDU4','AODSS1','AODSS2','AODSS3','AODSS4','AODNO3'/
   parameter(mw_so4=132.,mw_bc=12.,mw_oc=16.8,mw_air=28.97)
   parameter(mw_no3=79.,mw_w=18.)
! J. said to have dust and seasalt to have mw same as air 2-27-08
! to be consistent with GOCART
!     parameter(mw_du=29.,mw_ss=36.)
   parameter(mw_du=28.97,mw_ss=28.97)

   data order/4,17,18,19,20,44,21,22,23,24,26,27,28,29/
!   data convert/1.e-6,16*1.e-9/
!   data convertb/1.e6,12.e9/28.97,12.e9/28.97,16.e9/28.97,12*1.e9/
   cassimaod=' '
   call getenv('ASSIMAOD',cassimaod)
   if(first)then
     write(6,*)'cassimaod',cassimaod
     cumaodinc=0.0
!     cumaoddiff=0.0
   endif
   doassimaodsave=.false.
   if(cassimaod.eq.'no')then
     doassimaod=.false.
     if(first)then
       write(6,*)'no ASSIMAOD'
     endif
     return
   elseif(cassimaod.eq.'save')then
     doassimaodsave=.true.
     if(first)then
       write(6,*)'doassimaodsave'
     endif
   else
     doassimaod=.true.
     if(first)then
       write(6,*)'ASSIMAOD'
     endif
   endif
   cratioaod=' '
   call getenv('RATIOAOD',cratioaod)
   if(cratioaod.eq.'yes')then
     doratioaod=.true.
     if(first)then
       if(mytask.eq.0)print *,'do ratioaod'
     endif
   else
     doratioaod=.false.
     if(first)then
       if(mytask.eq.0)print *,'no ratioaod'
     endif
   endif
   first=.false.
   convertb(1)=1.e6
   call flush(6)
   convertb(2:3)=12.e9/28.97
   convertb(4:5)=16.e9/28.97
   convertb(6:17)=1.e9
   convert(1)=1.e-6
   convert(2:3)=28.97e-9/12.
   convert(4:5)=28.97e-9/16.
   convert(6:17)=1.e-9
   mpireal=getrealmpitype()
   mpiinteger=MPI_INTEGER
   mpiint=MPI_INTEGER
   mpichar=MPI_CHARACTER
   CALL wrf_get_dm_communicator ( communicator )
!   communicator=local_communicator
!  communicator=mpi_comm_world
   collective_root = wrf_dm_monitor_rank()
!   write(100+mytask,*)'0mpireal',mpireal,'mpicom',communicator
!   write(100+mytask,*)'idstop',ids,ide
!#ifdef DOSDF
!        write(6,*)'call initmpi'
!        call flush(6)
#ifdef SDFAERWRFLL
       call initmpi(mytask,ntasks,communicator,mpireal)
#endif
!        write(6,*)'did call initmpi'
!        call flush(6)
!#endif
!#define DIAGSDF
#ifdef DIAGSDF
   if(mytask.eq.0)then
     write(6,*)'call gfuncphys'
     call flush(6)
   endif
#endif
   call gfuncphys
#ifdef DIAGSDF
   if(mytask.eq.collective_root)then
     write(6,*)'did call gfuncphys'
     call flush(6)
   endif
   write(100+mytask,*)'ims',ims,ime,jms,jme
   write(100+mytask,*)'gridsm31',grid%sm31,grid%em31,grid%sm32,grid%em32, &
   grid%sm33,grid%em33
   call flush(100+mytask)
#endif
    if(.not.allocated(aodpart))then
!    if(.not.allocated(cumaodinc))then
!     allocate (aodassm(ims:ime,jms:jme),aodinc(ims:ime,jms:jme))
!     allocate (cumaodinc(ims:ime,jms:jme),cumaoddiff(ims:ime,jms:jme))
!      allocate (cumaoddiff(ims:ime,jms:jme))
!     cumaodinc=0.0
!     cumaoddiff=0.0
#ifdef SAVEAOD
     allocate (aodpart(ims:ime,jms:jme,14))
     allocate (aodlvl(ims:ime,kms:kme,jms:jme)) 
!     write(6,*)'ims',ims,ime,'kms',kms,kme,'jms',jms,jme
     allocate (extlvl(ims:ime,kms:kme,jms:jme,4),dzlvl(ims:ime,kms:kme,jms:jme))
#endif
   endif
   aodassm=0.0
   aodinc=0.0
   ids=idsin
   ide=idein-1
   jds=jdsin
   jde=jdein-1
   kds=kdsin
   kde=kdein
#ifdef DIAGSDF
   write(6,*)'idstop',ids,ide,jds,jde,kds,kde
#endif
   ipe=min(ipein,idein-1)
   jpe=min(jpein,jdein-1)
   nl=kde-1
#ifdef DIAGSDF
   write(100+mytask,*)'ipe',ipe,jpe,'nl',nl,'nac_hlut',nac_hlut
   call flush(100+mytask)
#endif
   allocate (aodassmd(ids:ide,jds:jde),aod1stguess(ids:ide,jds:jde))
   allocate (aodincd(ids:ide,jds:jde),ratio(ids:ide,jds:jde))
   allocate (xlatlond(2,ids:ide,jds:jde),xlatlonj(2,ips:ipe,jps:jpe))
#ifdef COMPAOD2
   allocate (aaod(ids:ide,jds:jde),diffaod(ids:ide,jds:jde))
#endif
 
   allocate (chemp(ips:ipe,jps:jpe,nl,nchem),den(ips:ipe,jps:jpe,nl), &
   ratioj(ips:ipe,jps:jpe),aodincj(ips:ipe,jps:jpe))
   allocate (aod1stguessj(ips:ipe,jps:jpe))
#ifdef SAVEAOD
!   write(6,*)'ips',ips,ipe,'kps',kps,kpe,'jps',jps,jpe
!   call flush(6)
   allocate (aodpartj(ips:ipe,jps:jpe,14),aodlvlj(ims:ime,kms:kme,jms:jme))
!   write(6,*)'ips',ips,ipe,'kps',kps,kpe,'jps',jps,jpe
   aodlvlj=0.0
#endif
   allocate (ext_3d(ips:ipe,jps:jpe,nl,nac_hlut),mass_ext_3d(ips:ipe,jps:jpe,nl,nac_hlut))
   allocate (mole_frac_3d(ips:ipe,jps:jpe,nl,nac_hlut))
!   write(6,*)'findzzips',ips,ipe,'jps',jps,jpe
!   call flush(6)
!  call mpibarrier(communicator)
!   write(100+mytask,*)'pask barrier 1'
!   call flush(100+mytask)
!  call mpibarrier(communicator)
!   write(100+mytask,*)'pask barrier 2'
!   call flush(100+mytask)
!  call mpibarrier(communicator)
   do j=jps,jpe
!     write(6,*)'findj',j,'ips',ips,ipe
!     call flush(6)
     do i=ips,ipe
!       write(100+mytask,*)'i',i
!       call flush(100+mytask)
!       write(100+mytask,*)'xlatloni',i,j,xlatlon(1,i,j),xlatlon(2,i,j)
!       call flush(100+mytask)

       xlatlonj(:,i,j)=xlatlon(:,i,j)
!       write(100+mytask,*)'xlatlonj',i,j,xlatlonj(1,i,j),xlatlonj(2,i,j)
!       call flush(100+mytask)
!       if(i.eq.124.and.j.eq.140)print *,'xlatlonj124',xlatlonj(:,i,j)
     end do
   end do
!   write(100+mytask,*)'pask barrier 4'
!   call flush(100+mytask)
!   write(6,*)'did findzzips',ips,ipe,'jps',jps,jpe
!   call flush(6)
!  call mpibarrier(communicator)
   iorder(1)=p_sulf
   iorder(2)=p_bc1
   iorder(3)=p_bc2
   iorder(4)=p_oc1
   iorder(5)=p_oc2
   iorder(6)=-1
   iorder(7)=p_dust_1
   iorder(8)=p_dust_2
   iorder(9)=p_dust_3
   iorder(10)=p_dust_4
   iorder(11)=p_seas_1
   iorder(12)=p_seas_2
   iorder(13)=p_seas_3
   iorder(14)=p_seas_4
   iorder(15)=-1
   iorder(16)=p_dust_5
   iorder(17)=-1
   write(6,*)'sulf ',maxval(chem(:,:,:,p_sulf)),minval(chem(:,:,:,p_sulf))
   call flush(6)
   do k=1,nl
     do j=jps,jpe
       do i=ips,ipe
         do nn=1,17
           if(iorder(nn)>0)then
             chemp(i,j,k,nn)=chem(i,k,j,iorder(nn))*convert(nn)
           else
             chemp(i,j,k,nn)=0.0
           endif
         end do
#ifdef OLDCODE
         chemp(i,j,k,1)=chem(i,k,j,p_sulf)
         chemp(i,j,k,2)=chem(i,k,j,p_bc1)
         chemp(i,j,k,3)=chem(i,k,j,p_bc2)
         chemp(i,j,k,4)=chem(i,k,j,p_oc1)
         chemp(i,j,k,5)=chem(i,k,j,p_oc2)
#ifdef DIAGSDF
         if(i.eq.124.and.j.eq.140)then
          write(6,*)'124,140 oc2in',k,chemp(i,j,k,5),'ips',ips,'jps',jps,'p_oc2',p_oc2
         endif
         if(i.eq.143.and.j.eq.116)then
          write(6,*)'143,116 oc2in',k,chemp(i,j,k,5),'ips',ips,'jps',jps,'p_oc2',p_oc2
         endif
         if(i.eq.149.and.j.eq.127)then
          write(6,*)'149,127 oc2in',k,chemp(i,j,k,5),'ips',ips,'jps',jps,'p_oc2',p_oc2
         endif
#endif
         chemp(i,j,k,6)=0.0
         chemp(i,j,k,7)=chem(i,k,j,p_dust_1)
         chemp(i,j,k,8)=chem(i,k,j,p_dust_2)
         chemp(i,j,k,9)=chem(i,k,j,p_dust_3)
         chemp(i,j,k,10)=chem(i,k,j,p_dust_4)
         chemp(i,j,k,11)=chem(i,k,j,p_seas_1)
         chemp(i,j,k,12)=chem(i,k,j,p_seas_2)
         chemp(i,j,k,13)=chem(i,k,j,p_seas_3)
         chemp(i,j,k,14)=chem(i,k,j,p_seas_4)
         chemp(i,j,k,15)=0.0
         chemp(i,j,k,16)=chem(i,k,j,p_dust_5)
         chemp(i,j,k,17)=0.0
#endif
         den(i,j,k)=p_phy(i,k,j)/rd/t_phy(i,k,j)
#ifdef DIAGSDF
         if(i.eq.279.and.j.eq.1)then
           write(6,*)'chemp279,1 ',k,chemp(i,j,k,:),'den',den(i,j,k)
         endif
#endif
!         if(den(i,j,k).eq.0.0)then
!           write(100+mytask,*)'denzero',i,j,k
!         endif
!         if(i.eq.ips.and.j.eq.jps.and.k.eq.kps)then
!          write(100+mytask,*)'den',k,den(i,j,k),'p',p_phy(i,k,j),'rd',rd,'t',t_phy(i,k,j)
!         endif
#ifdef DIAGSDF
   if(jps.le.140.and.140.le.jpe.and.k.eq.1)then
       if(j.eq.140.and.i.ge.123.and.i.le.123)then
         write(6,*)mytask,'findchemp 140 i',i,chemp(i,j,k,1:5),chemp(i,j,k,7:14),chemp(i,j,k,16)
       endif
   endif
#endif
       end do
     end do
   end do
#ifdef DIAGSDF
   if(jps.le.140.and.140.le.jpe)then
     do k=1,nl
       write(6,*)'chepbratio',chemp(124,140,k,5)
     end do
   endif
#endif
#ifdef OLDCODE
   do i=1,17
     chemp(:,:,:,i)=chemp(:,:,:,i)*convert(i)
   end do
#endif
#ifdef DIAGSDF
   if(jps.le.140.and.140.le.jpe)then
     do k=1,nl
       write(6,*)'chepratio',chemp(124,140,k,5)
     end do
   endif
#endif
!  now get new chemicals
!  tks only going over nlay       do k=1,nl
!   nlay=20
!!!!tks 40 layer WRF   nlay=38
   nlay=kpe-2             !tks kpe=35, NSSL WRF number of levels

!  set up omp loop if one
#ifdef DIAGSDF
   write(100+mytask,*)'omp loop'
   call flush(100+mytask)
#endif
   aod1stguessj=0.0
!$OMP PARALLEL DO   &
!$OMP PRIVATE (ij,its,ite,jts,jte,kts,kte,i_start,i_end,j_start,j_end,k_start,nc,nj)
   DO ij = 1 , grid%num_tiles
     its = grid%i_start(ij) 
     ite = min(grid%i_end(ij),idein-1)
     jts = grid%j_start(ij)
     jte = min(grid%j_end(ij),jdein-1) 
     kts=1
     kte=kde-1
     k_start=1
!     k_end=kte
     i_start=its
     i_end=min( ite,idein-1 )
     j_start=jts
     j_end=min( jte,jdein-1 )
     nc=i_end-i_start+1
     nj=j_end-j_start+1
!     nl=k_end-k_start+1
#ifdef DIAGSDF
     write(100+mytask,*)'omp loop',nc,nj,nl,'i_start',i_start,j_start,k_start
     call flush(100+mytask)
     write(100+mytask,*)'ims',ims,ime,jms,jme,kms,kme
     write(100+mytask,*)'ips',ips,ipe,jps,jpe,kps,kpe
     write(100+mytask,*)'its',its,ite,jts,jte,kts,kte,'idat',idat
     call flush(100+mytask)
     write(100+mytask,*)'p_phy',p_phy(ips,kps,jps),t_phy(ips,kps,jps),dz8w(ips,kps,jps)
     call flush(100+mytask)
     write(100+mytask,*)'moist',moist(ips,kps,jps,1),n_moist
     call flush(100+mytask)
#endif
     maxq=0.0
     minq=1.e30
     do j=j_start,j_end
       do i=i_start,i_end
         maxq=max(maxq,moist(i,1,j,P_QV))
         minq=min(minq,moist(i,1,j,P_QV))
       end do
     end do
#ifdef DIAGSDF
     write(6,*)'maxq',maxq,minq,'nc',nc,'nj',nj,'i_start',i_start,'j_start',j_start
     write(6,*)'its',its,'ips',ips
     write(6,*)'jts',jts,'jps',jps
     write(100+mytask,*)'do compute ids',ids,ide
#endif
     ratioj=0.0
     ext_3d=0.0
     mass_ext_3d=0.0
     mole_frac_3d=0.0
     aodlvl=0.0
     call compute_aod(nc,nj,nl,nchem,nac_hlut,nlay, &
     p_phy,t_phy,dz8w,moist,n_moist,chemp,den, &
     aod1stguessj,ratioj, &
     ext_3d,mass_ext_3d,mole_frac_3d, &
     i_start,j_start,k_start, &
     ims,ime,jms,jme,kms,kme, &
     ips,ipe,jps,jpe,kps,kpe, &
#ifdef SAVEAOD
     its,ite,jts,jte,kts,kte,idat,aodpartj,aodlvl,doratioaod)
#else
     its,ite,jts,jte,kts,kte,idat,doratioaod)
#endif
   do j=1,14
     print *,'aod',j,aodpartj(ips+2,jps+2,j)
   end do
   print *,'aod1stguessj',aod1stguessj(ips+2,jps+2),ips+2,jps+2


   if(mytask.eq.40)then
     write(6,*)'ims',ims,ime,jms,jme
     write(6,*)'ips',ips,ipe,jps,jpe
     write(6,*)'i_start',i_start,j_start,'end',i_end,j_end
!     write(6,*)'aod',aod1stguessj(122:126,78)
   endif
#ifdef DIAGSDF
   write(100+mytask,*)'did compute ids',ids,ide
   call flush(100+mytask)
#endif
   end do
   if(ips<=443.and.ipe>=443.and.jps<=245.and.jpe>=245)then
     write(6,*)' at 443,245 aod1stguessj ',aod1stguessj(443,245)
     do j=1,14
       write(6,*)'aodpart ',j,aodpartj(443,245,j)
     end do
   endif
   if(ips<=454.and.ipe>=454.and.jps<=274.and.jpe>=274)then
     write(6,*)' at 454,274  aod1stguessj ',aod1stguessj(454,274)
     do j=1,14
       write(6,*)'aodpart ',j,aodpartj(454,274,j)
     end do
   endif
   if(ips<=176.and.ipe>=176.and.jps<=208.and.jpe>=208)then
     write(6,*)' at 176,208  aod1stguessj ',aod1stguessj(176,208)
     do j=1,14
       write(6,*)'aodpart ',j,aodpartj(176,208,j)
     end do
   endif
!  now gather to do assimilation
!  gather aodassm,ratio
!   aodassm=aod1stguess
   aod1stguess=0.0
   ratio=0.0
!   if(ips<=124.and.ipe>=124.and.jps<=78.and.jpe>=78)then
!     write(6,*)'aod1stguessj',aod1stguessj(124,77)
!   endif
   call dogatheraod(aod1stguessj,ratioj, &
   aod1stguess,ratio,xlatlonj,xlatlond, &
   ips,ipe,jps,jpe, &
   ids,ide,jds,jde)
#ifdef DIAGAOD
    write(400+mytask,*)'did gather ids',ids,ide
    call flush(400+mytask)
#endif
   aodincd=0.0
#define DIAGLOCALAOD
#ifdef DIAGLOCALAOD   
   if(mytask.eq.collective_root)then
;     write(6,*)'xlatlond124',xlatlond(:,124,140)
     maxaodd=-100.
     minaodd=1.e20
     do j=jds,jde
       do i=ids,ide
         if(aod1stguess(i,j)>maxaodd)then
           maxaodd=aod1stguess(i,j)
         endif
         if(aod1stguess(i,j)<minaodd)then
           minaodd=aod1stguess(i,j)
         endif
       end do
     end do
     print *,'maxaodddguess',maxaodd,minaodd
   endif
   maxaodj=-100.
   minaodj=1.e20
   imin=0
   jmin=0
   imax=0
   jmax=0
   do j=jps,jpe
     do i=ips,ipe
       if(aod1stguessj(i,j)>maxaodj)then
         maxaodj=aod1stguessj(i,j)
         imax=i
         jmax=j
       endif
       if(aod1stguessj(i,j)<minaodj)then
         minaodj=aod1stguessj(i,j)
         imin=i
         jmin=j
       endif
     end do
   end do
   call mpi_gather(maxaodj,1,mpireal,maxaodjj,1,mpireal,collective_root,communicator,ierr)
   call mpi_gather(minaodj,1,mpireal,minaodjj,1,mpireal,collective_root,communicator,ierr)
#ifdef DIAGSDF
   write(6,*)'maxaodj',mytask,maxaodj,imax,jmax,'minaodj',minaodj,'i',imin,jmin
#endif
#endif
#ifdef DIAGLOCALAOD   
   if(mytask.eq.collective_root)then
     maxaodd=-100.
     minaodd=1.e20
!     do j=1,ntasks
!       write(6,*)'maxaodjj',j,maxaodjj(j),'min',minaodjj(j)
!     end do
!     aodassmd=aod1stguess
!     aodincd=.1*aodassmd
!     write(6,*)'aodassmd',aodassmd(1,1),aodassmd(279,279)
!     call flush(6)
     do j=jds,jde
       do i=ids,ide
         aodassmd(i,j)=aod1stguess(i,j)
         if(aodassmd(i,j)>maxaodd)then
           maxaodd=aodassmd(i,j)
           imax=i
           jmax=j
         endif
         if(aodassmd(i,j)<minaodd)then
           minaodd=aodassmd(i,j)
           imin=i
           jmin=j
         endif
       end do
     end do
     write(6,*)'aodassmdmaxaodd',maxaodd,imax,jmax
     write(6,*)'aodassmdminaodd',minaodd,imin,jmin
   endif
#else
     do j=jds,jde
       do i=ids,ide
         aodassmd(i,j)=aod1stguess(i,j)
       end do
     end do
#endif
!   call mpi_bcast(imax,1,mpiinteger,collective_root, &
!      &communicator,ierr)
!   call mpi_bcast(jmax,1,mpiinteger,collective_root, &
!      &communicator,ierr)
!      if(ips<=imax.and.ipe>=imax.and.jps<=jmax.and.jpe>=jmax)then
!      do k=1,14
!      write(6,*)'aodpart',cpartt(k),aodpart(imax,jmax,k)
!      end do
!      endif
#ifdef DIAGSDF
   write(100+mytask,*)'did ainc ids',ids,ide
   call flush(100+mytask)
   write(100+mytask,*)'idsin',idsin,idein,jdsin,jdein
   write(100+mytask,*)'ids',ids,ide,jps,jpe
   write(100+mytask,*)'mpicom',communicator
#endif
!#define USEWORLD
#ifdef USEWORLD
   communicator=mpicom
#else
  call mpi_barrier(communicator,ierr)
#endif
   irest=0
!   call sdfaerwrfll(aodassmd,aodincd,idat,irest,ratio,xlatlond,ids,ide,jds,jde)
!   write(6,*)'find dohour ',dohour,doassimaodsave
   if(dohour)then
     if(doassimaodsave)then
       aodincd=0.0
     else
!       write(6,*)'call sdfaerwrfll'
#ifdef SDFAERWRFLL
       call sdfaerwrfll(aodassmd,aodincd,idat,irest,ratio,xlatlond,ide-ids+1,jde-jds+1)
#endif
     endif
   else
     aodincd=0.0
   endif
!   call sdfvtomsaer(aodassmd,aodincd,idat,irest,ratio,ids)
#ifdef DIAGSDF
   write(100+mytask,*)'did sdfvtomsaer ids',ids,ide,jds,jde
   call flush(100+mytask)
   write(100+mytask,*)'idsout',idsin,idein,jdsin,jdein
   write(100+mytask,*)'ids',ids,ide,jps,jpe
   write(100+mytask,*)'mpicom',communicator
!  call mpibarrier(communicator)
  call mpi_barrier(communicator,ierr)
#endif
!  now scatter to do chemistry change
!  scatter aodinc
!   write(6,*)'call doscatter ',maxval(aodincd),minval(aodincd)
!   call flush(6)
   call doscatteraod(aodincd,aodincj,ips,ipe,jps,jpe, &
   ids,ide,jds,jde)
#ifdef DIAGSDF
   write(100+mytask,*)'did doscatter' 
   call flush(100+mytask)
#endif
   aodinc=0.0
   aodassm(ips:ipe,jps:jpe)=aod1stguessj(ips:ipe,jps:jpe)
!   if(mytask.eq.40)then
!    do j=80,75,-1
!     print *,'aodassm',j,aodassm(122:126,j)
!    end do
!    do j=80,75,-1
!     print *,'aodincj',j,aodincj(122:126,j)
!    end do
!   endif
#ifdef DIAGSDF
   if(jps.le.140.and.140.le.jpe)then
     do i=ips,ipe
       if(i.ge.124.and.i.le.124)then
         write(6,*)'findaodassm 140 i',i,aodassm(i,140)
       endif
     end do
   endif
#endif
   aodinc(ips:ipe,jps:jpe)=aodincj(ips:ipe,jps:jpe)
   aodpart=0.0
   aodpart(ips:ipe,jps:jpe,:)=aodpartj(ips:ipe,jps:jpe,:)
!   write(6,*)'move aodlvljips',ips,ipe,'kps',kps,kpe,'jps',jps,jpe
!   write(6,*)'move aodlvljits',its,ite,'jts',jts,jte
!   if(its<=10.and.ite>=10)then
!     do j=jts,jte
!       write(6,*)'aodlvj',j,aodlvlj(10,j,6)
!     end do
!   endif
!   call flush(6)
   extlvl=0.0
   dzlvl=0.0
!   do k=kps,40
!  fix ajl 05/05/2014 not hardwired any more
!   write(6,*)'find aod nl',nl,'kme',kme
!   call flush(6)
   do k=kps,min(nl,kme)
     do j=jps,jpe
       do i=ips,ipe
         extlvl(i,k,j,1)=ext_3d(i,j,k,1)
#ifdef DIAGEXT
         if(i.eq.10.and.k.eq.40)then
          write(6,*)'extsul40',j,extlvl(i,k,j,1)
         endif
#endif
       end do
       do iext=2,5
         do i=ips,ipe
           extlvl(i,k,j,2)=extlvl(i,k,j,2)+ext_3d(i,j,k,iext)
#ifdef DIAGEXT
           if(i.eq.10.and.k.eq.40)then
             write(6,*)'extcc',iext,j,ext_3d(i,j,k,iext)
           endif
#endif
         end do
       end do
       do iext=7,10
         do i=ips,ipe
           extlvl(i,k,j,3)=extlvl(i,k,j,3)+ext_3d(i,j,k,iext)
#ifdef DIAGEXT
           if(i.eq.10.and.k.eq.40)then
             write(6,*)'extdu',iext,j,ext_3d(i,j,k,iext)
           endif
#endif
         end do
       end do
       do iext=11,14
         do i=ips,ipe
           extlvl(i,k,j,4)=extlvl(i,k,j,4)+ext_3d(i,j,k,iext)
#ifdef DIAGEXT
           if(i.eq.10.and.k.eq.40)then
             write(6,*)'extss',iext,j,ext_3d(i,j,k,iext)
           endif
#endif
         end do
       end do
     end do
   end do
!tks   extlvl(:,41,:,:)=extlvl(:,40,:,:)
   extlvl(:,kpe,:,:)=extlvl(:,kpe-1,:,:)
   dzlvl(ips:ipe,kps:kpe,jps:jpe)=dz8w(ips:ipe,kps:kpe,jps:jpe)
#ifdef DIAGSDF
   write(100+mytask,*)'did scatter aodinc',aodinc(ips,jps),aodinc(ipe,jpe)
   call flush(100+mytask)
#endif
   if(dohour.and..not.doassimaodsave)then
!   do k=1,nlay
#ifdef DIAGSDF
   write(100+mytask,*)'kchem',k,nchemaod
   call flush(100+mytask)
#endif
!
! loop over chemical species (n is index number)
!
   haveaodinc=.false.
   numlist=0
#ifdef OLDCODE
   if(doratioaod)then
#endif
     aodnew=0.0
     ratioaod=1.
     do j=jps,jpe
       do i=ips,ipe
!         if(aodinc(i,j).ne.0.0)then
         if (abs(aodinc(i,j)).gt.1.e-12.and. &
             aod1stguessj(i,j).gt.1.e-4)then
           haveaodinc=.true.
           numlist=numlist+1
           ilist(numlist)=i
           jlist(numlist)=j
!           ratioaod(i,j)=1.+aodinc(i,j)/aod1stguessj(i,j)
!           if(abs(ratioaod(i,j))>10.)then
!              write(6,*)'ratioaod ',i,j,ratioaod(i,j),' inc ',aodinc(i,j),' guess ',aod1stguessj(i,j)
!              call flush(6)
!           endif
           ratioaod(i,j)=1.+aodinc(i,j)/aod1stguessj(i,j)
           aodnew(i,j)=aod1stguessj(i,j)+aodinc(i,j)
         endif
       end do
     end do
#ifdef OLDCODE
   else
     do j=jps,jpe
       do i=ips,ipe
!         if(aodinc(i,j).ne.0.0)then
         if (abs(aodinc(i,j)).gt.1.e-12.and. &
             aod1stguessj(i,j).gt.1.e-4)then
           haveaodinc=.true.
           numlist=numlist+1
           ilist(numlist)=i
           jlist(numlist)=j
         endif
       end do
     end do
   endif
#endif
#ifdef DIAGAOD
   write(400+mytask,*)'haveaodinc',haveaodinc,'numlist',numlist
   call flush(400+mytask)
#endif
   if(haveaodinc)then
     cumaodinc(ips:ipe,jps:jpe)=cumaodinc(ips:ipe,jps:jpe)+aodinc(ips:ipe,jps:jpe)
#ifdef DIAGAOD
     write(6,*)'add into cumaodinc'
     call flush(6)
#endif

   do nnn=1,nchemaod
     n=order(nnn)
#ifdef DIAGSDF
   write(100+mytask,*)'nnn',nnn,'n',n
   call flush(100+mytask)
#endif
!    tks
;

!    do all aod chemicals now 3-27-08

!

!    n=4 is so4 (sulfate aerosol)
     if(n.eq.4) iac=1
     if(n.eq.4) mw_aero=mw_so4
!    n=17 is hydrophobic black carbon
     if(n.eq.17) iac=2
     if(n.eq.17) mw_aero=mw_bc
!    n=18 is hydrophilic black carbon
     if(n.eq.18) iac=3
     if(n.eq.18) mw_aero=mw_bc
!    n=19 is hydrophobic organic carbon
     if(n.eq.19) iac=4
     if(n.eq.19) mw_aero=mw_oc
!    n=20 is hydrophilic organic carbon
     if(n.eq.20) iac=5
     if(n.eq.20) mw_aero=mw_oc
!    n=44 is nitrate aerosol
     if(n.eq.44) iac=6
     if(n.eq.44) mw_aero=mw_no3
!    n=21 is dust size class 0.1-1 um
     if(n.eq.21) iac=7
     if(n.eq.21) mw_aero=mw_du
!    n=22 is dust size class 1-1.8 um
     if(n.eq.22) iac=8
     if(n.eq.22) mw_aero=mw_du
!    n=23 is dust size class 1.8-3 um
     if(n.eq.23) iac=9
     if(n.eq.23) mw_aero=mw_du
!    n=24 is dust size class 3-6 um
     if(n.eq.24) iac=10
     if(n.eq.24) mw_aero=mw_du
!    n=26 is sea-salt class 0.1-0.5
     if(n.eq.26) iac=11
     if(n.eq.26) mw_aero=mw_ss
!    n=27 is sea-salt class 0.5-1.5
     if(n.eq.27) iac=12
     if(n.eq.27) mw_aero=mw_ss
!    n=28 is sea-salt class 1.5-5.0
     if(n.eq.28) iac=13
     if(n.eq.28) mw_aero=mw_ss
!    n=29 is sea-salt class 5.0-10.0
     if(n.eq.29) iac=14
     if(n.eq.29) mw_aero=mw_ss
     if(nnn.ne.iac)then
        write(6,*)'error nnn',nnn,iac
        stop
     endif
#ifdef DIAGSDF
     write(100+mytask,*)'iac',iac,'mw_aero',mw_aero,'ips',ips,ipe,jps,jpe
     call flush(100+mytask)
#endif
!
!
!cccc tks 4-23-07 if (aodassm(i,j).gt.0.and.
!     do j=jps,jpe
!       do i=ips,ipe
#ifdef DIAGAOD
      write(400+mytask,*)'numlist',numlist,'nnn',nnn,iac,nlay
      call flush(400+mytask)
#endif
      do ii=1,numlist
        j=jlist(ii)
        i=ilist(ii)
#ifdef DIAGAOD
        write(400+mytask,*)'ii',ii,'i',i,j,'nnn',nnn,'iac',iac
        call flush(400+mytask)
#endif

        do k=1,nlay
          if(chemp(i,j,k,nnn).gt.1.e-20) then
!
!           first obtain new extinction for each species
#ifdef OLDCODE
            if(doratioaod)then
#endif
              if(iac.lt.11.or.iac.gt.14)then
                if(iorder(iac)>0)then
                  chem(i,k,j,iorder(iac))=chem(i,k,j,iorder(iac))*ratioaod(i,j)
                  if(chem(i,k,j,iorder(iac))>1000.)then
                      write(6,*)'error chem ',i,k,j,iac,iorder(iac),'ratioaod',ratioaod(i,j),chem(i,k,j,iorder(iac))
                      stop
                  endif
                  chem(i,k,j,iorder(iac))=max(chem(i,k,j,iorder(iac)),0.)
                  chemp(i,j,k,iac)=chem(i,k,j,iorder(iac))*convert(iac)
!                 set to zero ?
                endif
#ifdef OLDCODE
                chemp(i,j,k,nnn)=chemp(i,j,k,nnn)*ratioaod(i,j)
                chemp(i,j,k,nnn)=max(chemp(i,j,k,nnn),0.)
#endif
              endif
#ifdef OLDCODE
            else
!
              ext_3d_new=ext_3d(i,j,k,iac)+ext_3d(i,j,k,iac)/aod1stguessj(i,j)*aodinc(i,j)
!             now obtain new total (water+aerosol) mass for each species
!             based on mass exctinction coefficient

              mass_ttl_new=ext_3d_new/mass_ext_3d(i,j,k,iac)
!
!             deal with mole fraction of water
!
              x_new=1./mw_aero-mole_frac_3d(i,j,k,iac)/mw_aero+mole_frac_3d(i,j,k,iac)/mw_w
!
!             obtain new dry mass for each species
              mass_new=mole_frac_3d(i,j,k,iac)/mw_w*mass_ttl_new*1./x_new
              mass_w_new=mass_ttl_new-mass_new
!
!             update species array in kg/kg
!
!             tks  chemp(k,i,j,n)=mass_new/mw_aero*mw_air/den(k,i,j)
!             ctks chemp(k,i,j,inchem,n)=max(chemp(k,i,j,inchem,n),0.)
         
!             tks 4-1-08 exclude assimilation adjustment on sea salt for now
!             sea salt iac=11,14

              if(iac.lt.11.or.iac.gt.14)then
                chemp(i,j,k,nnn)=mass_new/mw_aero*mw_air/den(i,j,k)
                chemp(i,j,k,nnn)=max(chemp(i,j,k,nnn),0.)
              endif
!             tks 4-1-08 exclude assimilation adjustment on sea salt for now

            endif
#endif
          endif
        enddo   !end k
      enddo ! ii
!     enddo ! J
   enddo  !end nnn
!  return chemistry
#ifdef OLDCODE
   do i=1,17
     chemp(:,:,:,i)=chemp(:,:,:,i)*convertb(i)
   end do
   do k=kps,kpe
     do j=jps,jpe
       do i=ips,ipe
         chem(i,k,j,p_sulf)=chemp(i,j,k,1)
         chem(i,k,j,p_bc1)=chemp(i,j,k,2)
         chem(i,k,j,p_bc2)=chemp(i,j,k,3)
         chem(i,k,j,p_oc1)=chemp(i,j,k,4)
         chem(i,k,j,p_oc2)=chemp(i,j,k,5)
         chem(i,k,j,p_dust_1)=chemp(i,j,k,7)
         chem(i,k,j,p_dust_2)=chemp(i,j,k,8)
         chem(i,k,j,p_dust_3)=chemp(i,j,k,9)
         chem(i,k,j,p_dust_4)=chemp(i,j,k,10)
         chem(i,k,j,p_seas_1)=chemp(i,j,k,11)
         chem(i,k,j,p_seas_2)=chemp(i,j,k,12)
         chem(i,k,j,p_seas_3)=chemp(i,j,k,13)
         chem(i,k,j,p_seas_4)=chemp(i,j,k,14)
         chem(i,k,j,p_dust_5)=chemp(i,j,k,16)
       end do
     end do
   end do
#endif
   endif ! haveaodinc
#ifdef COMPAOD2
#ifdef DIAGAOD
   write(400+mytask,*)'haveaodinc 2 '
   call flush(400+mytask)
#endif
   ratioj=0.0
   aod1stguessj=0.0
#ifdef OLDCODE
   if(haveaodinc)then
     do i=1,17
       chemp(:,:,:,i)=chemp(:,:,:,i)*convert(i)
     end do
   endif
#endif
   call compute_aod(nc,nj,nl,nchem,nac_hlut,nlay, &
   p_phy,t_phy,dz8w,moist,n_moist,chemp,den, &
   aod1stguessj,ratioj, &
   ext_3d,mass_ext_3d,mole_frac_3d, &
   i_start,j_start,k_start, &
   ims,ime,jms,jme,kms,kme, &
   ips,ipe,jps,jpe,kps,kpe, &
#ifdef SAVEAOD
   its,ite,jts,jte,kts,kte,idat,aodpartj,aodlvlj,doratioaod)
#else
   its,ite,jts,jte,kts,kte,idat,doratioaod)
#endif
#ifdef DIAGSDF
   write(100+mytask,*)'did compute ids',ids,ide
   call flush(100+mytask)
#endif
!  now gather to do assimilation
!  gather aodassm,ratio
!   aodassm=aod1stguess
   aaod=0.0
   ratio=0.0
#ifdef DIAGAOD
   write(400+mytask,*)' do cumaoddiff'
   call flush(400+mytask)
#endif
!   do j=jps,jpe
!     do i=ips,ipe
!       cumaoddiff(i,j)=cumaoddiff(i,j)+aod1stguessj(i,j) &
!   -aodnew(i,j)
!   if(cumaoddiff(i,j)>1.)then
!    write(400+mytask,*)'cumaoddiff',cumaoddiff(i,j),'aod1stguessj',aod1stguessj(i,j), &
!    'aodnew',aodnew(i,j),'i',i,j
!   call flush(400+mytask)
!  endif
!  if(cumaoddiff(i,j)<-1.)then
!   write(400+mytask,*)'negcumaoddiff',cumaoddiff(i,j),'aod1stguessj',aod1stguessj(i,j), &
!   'aodnew',aodnew(i,j),'i',i,j
!   call flush(400+mytask)
!  endif
!    end do
!   end do
#ifdef DIAGAOD
   write(400+mytask,*)' did cumaoddiff'
   call flush(400+mytask)
   write(400+mytask,*)' dogatheraod'
   call flush(400+mytask)
#endif
   call dogatheraod(aod1stguessj,ratioj, &
   aaod,ratio,xlatlonj,xlatlond, &
   ips,ipe,jps,jpe, &
   ids,ide,jds,jde)
#ifdef DIAGAOD
   write(400+mytask,*)' did gatheraod'
   call flush(400+mytask)
#endif
   if(mytask.eq.collective_root)then
     diffaod=aaod-aod1stguess
!     write(6,*)'diffaod40,12',diffaod(40,12),'aaod',aaod(40,12),aod1stguess(40,12)
     call mxmn(diffaod,ide-ids+1,jde-jds+1,'DIFFAOD',0,1,rmx,rmn,rms)
   endif
#endif
   endif
!         if(aodinc(i,j).ne.0.0)haveaodinc
#ifdef COMPAOD2
   deallocate (diffaod,aaod)
#endif
   deallocate (chemp,den,ratioj,aodincj,ext_3d, &
   mass_ext_3d,mole_frac_3d)
   deallocate (aodassmd,aod1stguess,aodincd,ratio,xlatlond,xlatlonj)
   deallocate (aod1stguessj)
#ifdef SAVEAOD
   deallocate (aodpartj,aodlvlj)
#endif
#ifdef DIAGAOD
   write(100+mytask,*)' bottom aodpartj'
   call flush(100+mytask)
#endif
   return
   end subroutine assimaod
   subroutine compute_aod(nc,nj,nl,nchem,nac_hlut,nlay, &
   p_phy,t_phy,dz8w,moist,n_moist,chemp,den, &
   aod1stguessj,ratioj, &
   ext_3d,mass_ext_3d,mole_frac_3d, &
   i_start,j_start,k_start, &
   ims,ime,jms,jme,kms,kme, &
   ips,ipe,jps,jpe,kps,kpe, &
#ifdef SAVEAOD
   its,ite,jts,jte,kts,kte,idat,aodpart,aodlvl,doratioaod)
#else
   its,ite,jts,jte,kts,kte,idat,doratioaod)
#endif
   USE module_domain, only : p_QV
   USE MODULE_GFS_FUNCPHYS ,ONLY : fpvs
   USE MODULE_GFS_PHYSCONS, only :  EPS => con_eps, EPSM1 => con_epsm1
    USE module_dm,only : mytask
   implicit none
   logical doratioaod
   integer nc,nj,nl,nchem,nac_hlut,n_moist
   integer i_start,j_start,k_start
   integer ims,ime,jms,jme,kms,kme
   integer ips,ipe,jps,jpe,kps,kpe
   integer its,ite,jts,jte,kts,kte,naod
   REAL, DIMENSION( ims:ime, kms:kme , jms:jme , n_moist ), INTENT(IN) :: moist

   REAL , DIMENSION( ims:ime , kms:kme , jms:jme ) ,                 &
          INTENT(  IN)                                  ::   p_phy,t_phy,dz8w
   real chemt(nc,nj,nl,nchem),dent(nc,nj,nl),rh(nc,nj,nl),dz(nc,nj,nl)
   real ratiot(nc,nj),ext_3dt(nc,nj,nl,nac_hlut),mass_ext_3dt(nc,nj,nl,nac_hlut)
   real aod1stguessjt(nc,nj),mole_frac_3dt(nc,nj,nl,nac_hlut)
#ifdef SAVEAOD
   real aodpart(ips:ipe,jps:jpe,14),aodlvl(ims:ime,kms:kme,jms:jme)
#endif
   real chemp(ips:ipe,jps:jpe,nl,nchem),den(ips:ipe,jps:jpe,nl), &
   ratioj(ips:ipe,jps:jpe),aod1stguessj(ips:ipe,jps:jpe)
   real ext_3d(ips:ipe,jps:jpe,nl,nac_hlut)
   real mass_ext_3d(ips:ipe,jps:jpe,nl,nac_hlut)
   real mole_frac_3d(ips:ipe,jps:jpe,nl,nac_hlut)
   real aodso4(nc,nj),threshold
   real*8 tphys
!   parameter (threshold=100.e-6*(18./28.97))
!  ajl changed since Brad said too big 1/28/2015
   parameter (threshold=1.e-6*(18./28.97))
   integer i,j,k,ii,jj,kk,nlay,idat
   real es,qsat,maxq,maxq0,minq0
   logical first
   save first
   data first/.true./
#ifdef DIAGAOD
   write(400+mytask,*)'top compute aod',nj,j_start
   call flush(400+mytask)
#endif
   maxq=0.0
   maxq0=0.0
   minq0=1.e20
   
   do j=1,nj
     jj=j-1+j_start
!     if(jj.eq.140)then
!      do i=1,nc
!         !ii=i-1+i_start
!         if(ii.ge.124.and.ii.le.124)then
!           do k=1,nl
!             kk=k-1+k_start
!             tphys=t_phy(ii,kk,jj)
!             es=fpvs(tphys)
!             es=min(es,p_phy(ii,kk,jj))
!             qsat=eps*es/(p_phy(ii,kk,jj)+epsm1*es)
!             rh(i,j,k)=max(threshold,moist(i,k,j,P_QV))/qsat*100.
!             write(6,*)'ii',ii,k,'T',tphys,'p',p_phy(ii,kk,jj),'q',moist(i,k,j,P_QV), &
!             'qsat',qsat
!           end do
!         endif
!       end do
!     endif
     do k=1,nl
       kk=k-1+k_start
       do i=1,nc
         ii=i-1+i_start
         chemt(i,j,k,:)=chemp(ii,jj,kk,:)
#ifdef DIAGSDF
         if(ii.eq.124.and.jj.eq.140)then
          write(6,*)'124,140 oc2chemt',k,chemp(ii,jj,kk,5),'p',p_phy(ii,kk,jj) 
          write(6,*)'t',t_phy(ii,kk,jj),'q',moist(ii,kk,jj,P_QV)
         endif
         if(ii.eq.143.and.jj.eq.116)then
          write(6,*)'143,116 oc2chemt',k,chemp(ii,jj,kk,5),'i',i,j,'ii',ii,jj, &
          'i_start',i_start,'j_start',j_start
         endif
         if(ii.eq.149.and.jj.eq.127)then
          write(6,*)'149,127 oc2chemt',k,chemp(ii,jj,kk,5),'i',i,j,'ii',ii,jj, &
          'i_start',i_start,'j_start',j_start
         endif
#endif
         dent(i,j,k)=den(ii,jj,kk)
!         now rh
         tphys=t_phy(ii,kk,jj)
         es=fpvs(tphys)
         es=min(es,p_phy(ii,kk,jj))
         qsat=eps*es/(p_phy(ii,kk,jj)+epsm1*es)
         rh(i,j,k)=max(threshold,moist(ii,kk,jj,P_QV))/qsat*100.
         maxq=max(maxq,moist(ii,kk,jj,P_QV))
         rh(i,j,k)=max(0.0,min(99.,rh(i,j,k)))
#ifdef DIAGSDF
         if(ii.eq.279.and.jj.eq.1)then
          write(6,*)'rh',rh(i,j,k)
         endif
#endif
!    if(jj.eq.140.and.ii.ge.124.and.ii.le.124)then
!      !write(6,*)'rh',k,rh(i,j,k),'q',moist(ii,kk,jj,P_QV),'qsat',qsat,'threshold',threshold
!    endif
         dz(i,j,k)=dz8w(ii,kk,jj)
!         if(i.eq.1.and.j.eq.1.and.k.eq.1)then
!          !write(100+mytask,*)'dent',dent(i,j,k),'t',tphys,'es',es,'qsat',qsat,'rh',rh(i,j,k), &
!         'dz',dz(i,j,k),'ii',ii,jj,kk
!          call flush(100+mytask)
!         endif
       end do
     end do
   end do


#ifdef DIAGSDF
   write(6,*)'maxq',mytask,maxq
#endif
   aod1stguessjt=0.0
   aodso4=0.0
   ratioj=0.0
!   nlay=20 ! CHECK ON
#ifdef DIAGSDF
   write(100+mytask,*)'call comp2 nl',nl,nc,nj,'nchem',nchem,'nlay',nlay
   call flush(100+mytask)
#endif
   ext_3dt=0.0
   mass_ext_3dt=0.0
   mole_frac_3dt=0.0
   call compute_aod_raqms(nl,nc,nj,nchem,dent,rh,dz, &
   chemt,aod1stguessjt,aodso4,ratiot,idat,nlay, &
#ifdef SAVEAOD
!  missing doratioaod
   ext_3dt,mass_ext_3dt,mole_frac_3dt,i_start,j_start,aodpart, &
   ims,ime,kms,kme,jms,jme, &
   aodlvl,doratioaod)
#else
   ext_3dt,mass_ext_3dt,mole_frac_3dt,i_start,j_start,doratioaod)
#endif
   do j=1,nj
     jj=j-1+j_start
     do k=1,nl
       kk=k-1+k_start
       do i=1,nc
         ii=i-1+i_start
         ext_3d(ii,jj,kk,:)=ext_3dt(i,j,k,:)
#ifdef DIAGEXT
         if(ii.eq.163.and.jj.eq.152)then
            write(6,*)'ext_3d k ',k,'kk',kk,ext_3dt(i,j,k,1)
!            write(6,*)'kk',kk,'k',k,'i',i,j,'ii',ii,jj
         endif
#endif
         mass_ext_3d(ii,jj,kk,:)=mass_ext_3dt(i,j,k,:)
         mole_frac_3d(ii,jj,kk,:)=mole_frac_3dt(i,j,k,:)
       end do
     end do
     do i=1,nc
       ii=i-1+i_start
       aod1stguessj(ii,jj)=aod1stguessjt(i,j)
       ratioj(ii,jj)=ratiot(i,j)
     end do
   end do
   if(mytask.eq.0)then
     if(first)print *,'threshold',threshold
   endif
   first=.false.
   return
   end subroutine compute_aod
       subroutine dogatheraod(aod1stguessj,ratioj,&
       aod1stguess,ratio,xlatlon,xlatlond, &
       ips,ipe,jps,jpe, &
       ids,ide,jds,jde) 
       USE module_dm,only : mytask,ntasks
       implicit none
       integer ip,ips,ipe,jps,jpe
       integer ids,ide,jds,jde
       integer ipsl,ipel,jdsl,jdel
!       real maxaodj,minaodj,maxaodrec,minaodrec,maxaodd
       real maxaodj,minaodj,maxaodd
       integer imaxaodd,jmaxaodd,ipaodd
       real, allocatable :: aodrec(:),ratiorec(:),xlatlonrec(:)
       real aod1stguessj(ips:ipe,jps:jpe),ratioj(ips:ipe,jps:jpe)
       real aod1stguess(ids:ide,jds:jde),ratio(ids:ide,jds:jde)
       real xlatlon(2,ips:ipe,jps:jpe),xlatlond(2,ids:ide,jds:jde)
       integer displat(0:ntasks-1),sendlat(0:ntasks-1)
       integer n,k,i,j,ierr,ii,iilat
       integer ikjsend(2,3)
       real maxaodjj(ntasks),minaodjj(ntasks)
       if(.not.allocated(sendaod))then
         allocate(sendaod(0:ntasks-1),dispaod(0:ntasks-1))
       endif
       if(.not.allocated(ikjgsend))then
         allocate (ikjgsend(2,3,ntasks))
       endif
!      need to gather i,k,j limits for each processor so that
!      masterprocessor can calculate number of points coming from
!      each processors and which i,k,j s are coming
       ikjsend(1,1)=ips
       ikjsend(2,1)=ipe
       ikjsend(1,3)=jps
       ikjsend(2,3)=jpe
!       call mpi_gather(ikjsend,6,MPI_INTEGER,ikjgsend,6,MPI_INTEGER, &
       call mpi_gather(ikjsend,6,mpiinteger,ikjgsend,6,mpiinteger, &
      &collective_root,communicator,ierr)
       if(mytask.eq.collective_root)then
         do ip=1,ntasks
           ipsl=ikjgsend(1,1,ip)
           ipel=ikjgsend(2,1,ip)
           jdsl=ikjgsend(1,3,ip)
           jdel=ikjgsend(2,3,ip)
!           write(6,*)'ip',ip,'ipsl',ipsl,ipel,'jd',jdsl,jdel
!       calculate number of data points and lat-long to send
           sendaod(ip-1)=(ipel-ipsl+1)*(jdel-jdsl+1)
!           write(6,*)'sendaod',ip,sendaod(ip-1),'ips',ipsl,ipel,'jps',jdsl,jdel
         end do
       endif
!       call mpi_bcast(sendaod,ntasks,MPI_INTEGER,collective_root, &
       call mpi_bcast(sendaod,ntasks,mpiinteger,collective_root, &
      &communicator,ierr)
!      calculate displacements in one dimension gather array
       dispaod(0)=0
       do ip=1,ntasks-1
         dispaod(ip)=dispaod(ip-1)+sendaod(ip-1)
       end do
       if(mytask.eq.collective_root)then
!        calculate length of receive buffer
         nrec=dispaod(ntasks-1)+sendaod(ntasks-1)
       else
         nrec=1
       endif
       displat=2*dispaod
       sendlat=2*sendaod
       allocate (aodrec(nrec))
       allocate (ratiorec(nrec))
       allocate (xlatlonrec(2*nrec))
!       write(100+mytask,*)'1mpireal',mpireal,'com',communicator
!       call flush(100+mytask)
!       write(100+mytask,*)'collective_root',collective_root
!       write(100+mytask,*)'send',sendaod
!       write(100+mytask,*)'dispaod',dispaod
!       call flush(100+mytask)
!       call mpi_barrier(communicator,ierr)
!       write(100+mytask,*)'mpi_gatherv'
!       call flush(100+mytask)
       maxaodj=-1000.
       minaodj=1000.
       do j=jps,jpe
         do i=ips,ipe
           if(aod1stguessj(i,j)>maxaodj)then
             maxaodj=aod1stguessj(i,j)
           endif
           if(aod1stguessj(i,j)<minaodj)then
             minaodj=aod1stguessj(i,j)
           endif
         end do
       end do
!       write(6,*)'sendlat',sendlat
!       write(6,*)'displat',displat
!       write(6,*)'gathermaxadoj',maxaodj,minaodj
!       call flush(6)
       call mpi_gather(maxaodj,1,mpireal,maxaodjj,1,mpireal,collective_root,communicator,ierr)
       call mpi_gather(minaodj,1,mpireal,minaodjj,1,mpireal,collective_root,communicator,ierr)


       call mpi_gatherv(aod1stguessj,sendaod(mytask),mpireal, &
                        aodrec,sendaod,dispaod,mpireal,collective_root, &
                        communicator,ierr)
!       write(100+mytask,*)'did mpi_gatherv'
!       call flush(100+mytask)
       call mpi_gatherv(ratioj,sendaod(mytask),mpireal, &
                        ratiorec,sendaod,dispaod,mpireal,collective_root, &
                        communicator,ierr)
!       write(100+mytask,*)'did mpi_gathervratio'
!       call flush(100+mytask)
       call mpi_gatherv(xlatlon,sendlat(mytask),mpireal, &
                        xlatlonrec,sendlat,displat,mpireal,collective_root, &
                        communicator,ierr)
!       write(100+mytask,*)'did mpi_gatherv2'
!       call flush(100+mytask)
!      unpack
       if(mytask.eq.collective_root)then
!         do ip=1,ntasks
!           write(6,*)ip,'maxaodjj',maxaodjj(ip),minaodjj(ip)
!         !end do
         ii=0
         iilat=1 
         maxaodd=-1000.
         imaxaodd=0
         jmaxaodd=0
         ipaodd=0
         do ip=1,ntasks
!           maxaodrec=-1000.
!           minaodrec=1000.
!           write(100+mytask,*)'ip',ikjgsend(:,3,ip),ikjgsend(:,1,ip),'ii',ii,'nrec',nrec, &
!           'ids',ids,ide,jps,jpe
!           call flush(100+mytask)
           do j=ikjgsend(1,3,ip),ikjgsend(2,3,ip)
             do i=ikjgsend(1,1,ip),ikjgsend(2,1,ip)
               ii=ii+1
!               if(aodrec(ii)>maxaodrec)then
!                 maxaodrec=aodrec(ii)
!               endif
!               if(aodrec(ii)>minaodrec)then
!                 minaodrec=aodrec(ii)
!               endif
!       write(100+mytask,*)'ii',ii,'i',i,j
!       call flush(100+mytask)
               aod1stguess(i,j)=aodrec(ii)
!               if(i.eq.124.and.j.eq.140)then
!                 write(6,*)'aod1stguess 124,140 ',ii,ii,'ip',ip,aod1stguess(i,j)
!               endif
               if(aod1stguess(i,j)>maxaodd)then
                 maxaodd=aod1stguess(i,j)
                 imaxaodd=i
                 jmaxaodd=j
                 ipaodd=ip
               endif
               ratio(i,j)=ratiorec(ii)
               
               xlatlond(1,i,j)=xlatlonrec(iilat)
               xlatlond(2,i,j)=xlatlonrec(iilat+1)
               iilat=iilat+2
             end do
           end do
!           write(6,*)'ip',ip,'maxaodrec',maxaodrec,minaodrec
         end do
!         write(6,*)'ipaodd',ipaodd,imaxaodd,jmaxaodd,'maxaodd',maxaodd
         maxaodd=0.0
         imaxaodd=0
         jmaxaodd=0
         do j=jds,jde
           do i=ids,ide
             if(aod1stguess(i,j)>maxaodd)then
                 maxaodd=aod1stguess(i,j)
                 imaxaodd=i
                 jmaxaodd=j
             endif
           end do
         end do
         print *,'maxoadd2',imaxaodd,jmaxaodd,maxaodd
       endif
!       write(100+mytask,*)'did unpack'
!       call flush(100+mytask)
       deallocate (aodrec,ratiorec,xlatlonrec)
       return
       end subroutine dogatheraod
       subroutine dogatheraodpart(aod1stguessj,&
       aod1stguess, &
       ips,ipe,jps,jpe, &
       ids,ide,jds,jde) 
       USE module_dm,only : mytask,ntasks
       implicit none
       integer ip,ips,ipe,jps,jpe
       integer ids,ide,jds,jde
       integer ipsl,ipel,jdsl,jdel
       integer ipaodd,ipart
       real, allocatable :: aodrec(:)
       real aod1stguessj(ips:ipe,jps:jpe,14)
       real aod1stguess(ids:ide,jds:jde,14)
       integer displat(0:ntasks-1),sendlat(0:ntasks-1)
       integer n,k,i,j,ierr,ii,iilat
       if(mytask.eq.collective_root)then
!        calculate length of receive buffer
         nrec=dispaod(ntasks-1)+sendaod(ntasks-1)
       else
         nrec=1
       endif
       allocate (aodrec(nrec))

       do ipart=1,14
         call mpi_gatherv(aod1stguessj(ips,jps,ipart),sendaod(mytask),mpireal, &
                        aodrec,sendaod,dispaod,mpireal,collective_root, &
                        communicator,ierr)
!      unpack
       if(mytask.eq.collective_root)then
         ii=0
         iilat=1 
         ipaodd=0
         do ip=1,ntasks
           do j=ikjgsend(1,3,ip),ikjgsend(2,3,ip)
             do i=ikjgsend(1,1,ip),ikjgsend(2,1,ip)
               ii=ii+1
               aod1stguess(i,j,ipart)=aodrec(ii)
               iilat=iilat+2
             end do
           end do
         end do
       endif
       end do
       deallocate (aodrec)
       return
       end subroutine dogatheraodpart
       subroutine doscatteraod(aodinc,aodincj,&
       ips,ipe,jps,jpe, &
       ids,ide,jds,jde) 
       USE module_dm,only : mytask,ntasks
       implicit none
       integer ip,ips,ipe,jps,jpe
       integer ids,ide,jds,jde
       integer isl,ipel,jdsl,jdel
       real, allocatable :: aodrec(:)
       real aodincj(ips:ipe,jps:jpe)
       real aodinc(ids:ide,jds:jde),maxaodsend,maxaodrec
       integer n,k,i,j,ierr,ii
!       write(100+mytask,*)'nrec',nrec,'ntasks',ntasks,'coll',collective_root
!       call flush(100+mytask)
!       write(100+mytask,*)'ids',ids,ide,jds,jde
        allocate (aodrec(nrec))
!      pack
       maxaodrec=0.0
     
       if(mytask.eq.collective_root)then
         ii=0
         maxaodsend=0.0
         do ip=1,ntasks
#ifdef DIAGSDF
           write(100+mytask,*)'ip',ip,'ii',ii,'ikjgsend',ikjgsend(:,3,ip),ikjgsend(:,1,ip)
           call flush(100+mytask)
#endif
           do j=ikjgsend(1,3,ip),ikjgsend(2,3,ip)
             do i=ikjgsend(1,1,ip),ikjgsend(2,1,ip)
               ii=ii+1
!           if(ii>nrec)then
!             write(100+mytask,*)'ii too big',ii,nrec,'i',i,j,'ip',ip
!             call flush(100+mytask)
!           endif
!            write(100+mytask,*)'ii',ii,'i',i,j
!            call flush(100+mytask)
!            write(100+mytask,*)'aodinc',i,j,aodinc(i,j)
!            !call flush(100+mytask)
!            write(100+mytask,*)'aodrec',ii,aodrec(ii)
!            call flush(100+mytask)
               aodrec(ii)=aodinc(i,j)
               maxaodsend=max(maxaodsend,aodrec(ii))
             end do
           end do
         end do
!         write(6,*)'maxaodsend',maxaodsend
       endif
!       write(100+mytask,*)'call mpiscat'
!       call flush(100+mytask)
       aodincj=0.0
       call mpi_scatterv(aodrec,sendaod,dispaod,mpireal, &
                        aodincj,sendaod(mytask),mpireal,collective_root, &
                        communicator,ierr)
!       write(100+mytask,*)'did call mpiscat'
!       call flush(100+mytask)
       call mpi_barrier(communicator,ierr)
       do j=jps,jpe
         do i=ips,ipe
           maxaodrec=max(maxaodrec,aodincj(i,j))
         end do
       end do
!       write(6,*)mytask,'maxaodrec',maxaodrec
!       call flush(6)
       deallocate (aodrec)
       return
       end subroutine doscatteraod
           
end Module module_assimaod
   subroutine getextlvl(iext,extlvlout,is,ie,ks,ke,js,je)
   use module_assimaod, only : extlvl,dzlvl
   implicit none
   integer is,ie,js,je,i,j,ks,ke,k,iext,isum
   real extlvlout(is:ie,ks:ke,js:je)
   extlvlout=0.0
   if(.not.allocated(extlvl))then
     return
   endif
   if(iext.eq.6)then
     do j=js,je
       do i=is,ie
         do k=ks,ke
           extlvlout(i,k,j)=dzlvl(i,k,j)
         end do
       end do
     end do
   elseif(iext.eq.5)then
     do j=js,je
       do i=is,ie
         do k=ks,ke
           do isum=1,4
             extlvlout(i,k,j)=extlvlout(i,k,j)+extlvl(i,k,j,isum)
           end do
         end do
       end do
     end do
   else
     do j=js,je
       do i=is,ie
         do k=ks,ke
           extlvlout(i,k,j)=extlvl(i,k,j,iext)
         end do
       end do
     end do
   endif
   return
   end subroutine getextlvl
!#include <options.h>
!!!!!!!!!#define ZARA
      subroutine compute_aod_raqms(n1,n2,n3,nchem,den,rh,dz, &
                    chemp,aod,aod_so4,ratio,idat,nlay,ext_3d, &
#ifdef SAVEAOD
                    mass_ext_3d,mole_frac_3d,istart,jstart,aodpart, &
                    ims,ime,kms,kme,jms,jme, &
                    aodlvl,doratioaod)
#else
                    mass_ext_3d,mole_frac_3d,istart,jstart,doratioaod)
#endif

! tks
! note subscripts on some arrays were changed.
!!!!!! arrays have different indices than in RAQMS
! rv is mixing ratio
! theta is theta here; in original code it was virtual theta

! This is based on 'compute_aod_RAQMS_ck.pro'

!  use funcphys
   use module_assimaod, only : communicator,mpireal,mpiint,mpichar
   USE MODULE_GFS_FUNCPHYS ,ONLY : fpvs
   USE MODULE_GFS_PHYSCONS, only :  EPS => con_eps, EPSM1 => con_epsm1
  USE module_dm,only : mytask,ntasks
!  use pmgrid, only : iam,beglat,endlat,masterproc
!#ifdef DOMPI
  !use mpishorthand
!#endif
#define DOMPI

  implicit none
  integer iam
  logical masterproc
  integer n1,n2,n3,nchem,nlay,istart,jstart,jj,ii,mpicom
  integer ims,ime,jms,jme,kms,kme
  integer beglat,endlat
! n1 is number of layers in atmosphere
! nlay is number of layers (from bottom) to do this calculation
  logical fexist,first
  save first
  data first/.true./
!  real aod(n2,beglat:endlat),ratio(n2,beglat:endlat)
  real aod(n2,n3),ratio(n2,n3)
#ifdef SAVEAOD
  real aodpart(n2,n3,14),aodlvl(ims:ime,kms:kme,jms:jme),aodlvlsum(n2,n3)
#endif
!  real aod_so4(n2,beglat:endlat),aod_bc1(n2,n3),aod_bc2(n2,n3)
  real aod_so4(n2,n3),aod_bc1(n2,n3),aod_bc2(n2,n3)
  real aod_oc1(n2,n3),aod_oc2(n2,n3),aod_no3(n2,n3)
  real aod_so4_hlut(n2,n3),aod_bc1_hlut(n2,n3),aod_bc2_hlut(n2,n3)
  real aod_oc1_hlut(n2,n3),aod_oc2_hlut(n2,n3),aod_no3_hlut(n2,n3)
  real aod_du1_hlut(n2,n3),aod_du2_hlut(n2,n3)
  real aod_du3_hlut(n2,n3),aod_du4_hlut(n2,n3),aod_du5_hlut(n2,n3)
  real aod_ss1_hlut(n2,n3),aod_ss2_hlut(n2,n3)
  real aod_ss3_hlut(n2,n3),aod_ss4_hlut(n2,n3)
  real time,aod_cc(n2,n3)
!tks  real ,dimension(n1,n2,n3) :: den,rh,rv,pp,theta
!tks  real ,dimension(n1,n2,n3,3,nchem) :: chemp 
!  real ,dimension(n2,n3,n1) :: rv,den,pp,theta
!  real ,dimension(n2,beglat:endlat,n1) :: den,dz
  real ,dimension(n2,n3,n1) :: den,dz
!  real ,dimension(n1,n2,beglat:endlat) :: rh
!  real ,dimension(n2,beglat:endlat,n1) :: rh
  real ,dimension(n2,n3,n1) :: rh
!  real ,dimension(n2,beglat:endlat,n1,nchem) :: chemp 
  real ,dimension(n2,n3,n1,nchem) :: chemp 


  real rmin,rms,rmax,sss(n2,n3),ttt(n2,n3),bbb(n2,n3)

  integer nac,iiac,iz
  parameter(nac=6)

  real cp,R,cpr, cappa
!  parameter(cp=1004.,R=287.,cpr=cp/R, cappa= R/cp)
!match values in UW model (CCM3 physics)
  parameter(cp=1004.64,R=287.04,cpr=cp/R, cappa= R/cp)
  integer nest,iest,es2,i,j,k,idat
  parameter(nest=150)
  real estbar_tmp,estbar(nest),es,es1,es3,es4,es5,qs


 integer nac_hlut
 parameter (nac_hlut=14)

  real mw_aero(nac_hlut),mw_air,mw_w
  parameter(mw_w=18.)
!tks
  real aero_min
!tks
  real den_aero(nac_hlut)
  real aero_conc(n1,nac_hlut)
  integer iac,itau

  character*100 infl,indir,date*10
  integer irh,nrh,irh1,irh2
  parameter(nrh=99)
  integer rh_lut(nrh),rh_tmp
  real mole_frac_so4(nrh),den_mix_so4(nrh)
  real mole_frac_bc(nrh),den_mix_bc(nrh)
  real mole_frac_oc(nrh),den_mix_oc(nrh)
  real mole_frac_no3(nrh),den_mix_no3(nrh)
  real ratio_tmp,mole_frac_tmp,den_mix_tmp
  integer im,nmole_frac,im1,im2
  parameter(nmole_frac=100)
#ifdef DOMPI
  real moledensend(2,4,nrh)
  real qrsend(2,4,nmole_frac)
#endif
  real qext_tmp,reff_tmp
  real mole_frac_lut(nmole_frac)
  real qext_so4(nmole_frac)
  real qext_bc(nmole_frac)
  real qext_oc(nmole_frac)
  real qext_no3(nmole_frac)
  real reff_so4(nmole_frac)
  real reff_bc(nmole_frac)
  real reff_oc(nmole_frac)
  real reff_no3(nmole_frac)
  real molef_rh(n1,nac),vmxr_w(n1,nac)
  real mass_w(n1,nac),ext(n1,nac)
  real reff_molef(n1,nac),mole_frac(n1,nac)
  real den_mix_rh(n1,nac),mass_ext(n1,nac)
  real mole_fractemp
  real qext_molef(n1,nac)
!  real pi,dz_in
  real pi
  real q_column(nac)




!  parameter(pi=3.14159265,dz_in=400.)
  parameter(pi=3.14159265)

! Wavelength for which AOD is calculated
  integer n_atau
  parameter(n_atau=1)
  real a_wli
  parameter(a_wli=0.55)

! Output AOD array
  real a_taus(n_atau,nac)

  integer nc
  character*10 ct,ct_new
  character*200 fl_aod

  real vmax,vmin
  real deltax,deltay,centrallat,centrallon
!  real ext_3d(n2,beglat:endlat,n1,nac_hlut)
  real ext_3d(n2,n3,n1,nac_hlut)
!  real mass_ext_3d(n2,beglat:endlat,n1,nac_hlut)
  real mass_ext_3d(n2,n3,n1,nac_hlut)
  
!  real mole_frac_3d(n2,beglat:endlat,n1,nac_hlut)
  real mole_frac_3d(n2,n3,n1,nac_hlut)

! Variables for Harvard Lookup table

 character(len=50)  infl_qext
 character(len=10)  spec_name(nac_hlut)
 integer ispec,ilamda,iterm
 integer nspec_hlut,nlamda_hlut,nterm_hlut
 parameter (nspec_hlut=42,nlamda_hlut=7,nterm_hlut=8)

 real rh_hlut(7)

 real q_hlut(nlamda_hlut,nspec_hlut)
 real reff_hlut(nlamda_hlut,nspec_hlut)
 real ssa_hlut(nlamda_hlut,nspec_hlut)
 real pf_hlut(nterm_hlut,nlamda_hlut,nspec_hlut)
 real lamda_hlut(nlamda_hlut)
 real tmp_hlut(12)

  real q_tmp_hlut(7),reff_tmp_hlut(7)
  real ssa_tmp_hlut(7),pf_tmp_hlut(nterm_hlut,7)
  real q_rh_hlut(n1,nac_hlut),reff_rh_hlut(n1,nac_hlut)
  real ssa_rh_hlut(n1,nac_hlut),pf_rh_hlut(n1,nterm_hlut,nac_hlut)
  real beta_aero_hlut(n1,nac_hlut),q_column_hlut(nac_hlut)
  real f_w,den_aerow,mass_aerow,mass_aerow_min

! Wavelength for which AOD is calculated
  integer n_atau_hlut,ierr
  parameter(n_atau_hlut=1)
  real a_wli_hlut
  parameter(a_wli_hlut=0.55)
  logical doratioaod

! Output AOD array
  real a_taus_hlut(n_atau_hlut,nac_hlut)

 character(len=30)  spec_line(nspec_hlut)
 character(len=30)  line

 save rh_hlut
 data rh_hlut/0.,50.,70.,80.,90.,95.,99./


!this is for GFS physics
!#ifdef USEGFUNCPHYS
!      call gfuncphys
!#endif


!tks 5-24-07 can be Nan otherwise
mpicom=communicator
reff_rh_hlut=0.
q_rh_hlut=0


! aerosol physical/chemical properties
!20060223 den_aero(1)=1.7e+3   ! sulfate
iam=mytask
!write(6,*)'n1',n1,n2,n3,' istart ',istart,jstart
!write(6,*)'iend',istart-1+n2,jstart-1+n3
!call flush(6)

if(mytask.eq.0)then
  masterproc=.true.
else
  masterproc=.false.
endif
beglat=1
endlat=n3
!#define DIAGCOL
#ifdef DIAGCOL
write(300+iam,*)'n1',n1,n2,n3
call flush(300+iam)
#endif
den_aero(1)=1.769e+3   ! sulfate
den_aero(2)=1.0e+3   ! bc
den_aero(3)=1.0e+3   ! bc
den_aero(4)=1.4e+3   ! oc
den_aero(5)=1.4e+3   ! oc
den_aero(6)=1.725e+3   ! no3
den_aero(7)=2500.
den_aero(8)=2650.
den_aero(9)=2650.
den_aero(10)=2650.
den_aero(11)=2200.
den_aero(12)=2200.
den_aero(13)=2200.
den_aero(14)=2200.
#ifdef DIAGCOL
write(300+iam,*)'den_aero'
call flush(300+iam)
#endif

!mw_aero(1)=96.   ! sulfate
mw_aero(1)=132.   ! sulfate
mw_aero(2)=12.   ! bc
mw_aero(3)=12.   ! bc
mw_aero(4)=16.8   ! oc
mw_aero(5)=16.8   ! oc
mw_aero(6)=79.    ! no3
mw_aero(7)=28.97    !dust
mw_aero(8)=28.97    !dust
mw_aero(9)=28.97    !dust
mw_aero(10)=28.97   !dust
!Chieko said to use 29 for dust, now consistent with calling program
!mw_aero(7)=60.1
!mw_aero(8)=60.1
!mw_aero(9)=60.1
!mw_aero(10)=60.1
!J said to use 28.97 (air) for seasalt
mw_aero(11)=28.97   !seasalt
mw_aero(12)=28.97   !seasalt
mw_aero(13)=28.97   !seasalt
mw_aero(14)=28.97   !seasalt
#ifdef DIAGCOL
write(300+iam,*)'nw_aero'
call flush(300+iam)
#endif

spec_name(1)='sulfate'
spec_name(2)='Black C'
spec_name(3)='Black C'
spec_name(4)='Organic C'
spec_name(5)='Organic C'
spec_name(6)='sulfate' ! use sulfate extinction efficiency for now
spec_name(7)='Mdust 0.8'
spec_name(8)='Mdust 1.5'
spec_name(9)='Mdust 2.5'
spec_name(10)='Mdust 4.0'
spec_name(11)='SSa00 Sea Salt (accum)'
!spec_name(12)='SSa00 Sea Salt (accum)'
!changed 3-19-08
spec_name(12)='SSc00 Sea Salt (coarse)'
spec_name(13)='SSc00 Sea Salt (coarse)'
spec_name(14)='SSc00 Sea Salt (coarse)'

! Initialize mole_frac_3d as 1.
#ifdef DIAGCOL
write(300+iam,*)'nac_hlut',nac_hlut,'nlay',nlay,'n3',n3,'n2',n2
write(300+iam,*)'beglat',beglat,endlat
call flush(300+iam)
#endif
do iac=1,nac_hlut
!do k=1,n1

do k=1,nlay
!do j=1,n3 
#ifdef DIAGCOL
write(300+iam,*)'colassim j loop 1 beglat',beglat,endlat,'iac',iac
call flush(300+iam)
#endif
!do j= beglat,endlat
do j= 1,n3
do i=1,n2
 mole_frac_3d(i,j,k,iac)=1.
enddo
enddo
enddo
enddo
!write(300+iam,*)'did molefrac'
!call flush(300+iam)

! others
!tks 20080328mw_air=28.9
mw_air=28.97

!!!!!!  indir='/home/todds/DATA/AOD_lut/'
#ifdef CRUNCH
  indir='/DATA/RAQMS/INTEX/AOD_lut/'
#else
#if (defined DRJ1 || defined DRJ)
  indir='/home/lenzen/raqms_data/INTEX/AOD_lut/'
#else
  indir='sierra/raqms_data/INTEX/AOD_lut/'
#endif
#endif
!#define DIAGCOMP
  if(masterproc)then
#ifdef DIAGCOMP
    write(6,*)'indir ',indir
    call flush(6)
#endif

!tks fix for now  8-25-11
  indir='/home/lenzen/raqms_data/INTEX/AOD_lut/'
!tks

! Read in values from LUP

    infl='hygroscopic_growth_factors_nh4so4_0.1um_273K.txt'
#ifdef DIAGCOMP
    write(6,*)trim(indir)//trim(infl)
    call flush(6)
#endif
#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else

    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif


    do irh=1,nrh
      read (1,"(i12,f13.5,f13.7,f13.2)",advance="yes") &
      rh_tmp,ratio_tmp,mole_frac_tmp,den_mix_tmp
      rh_lut(irh)=rh_tmp
      mole_frac_so4(irh)=mole_frac_tmp
     den_mix_so4(irh)=den_mix_tmp
    enddo
    close(1)

    infl='hygroscopic_growth_factors_bc_0.1um_273K.txt'
#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif
    do irh=1,nrh
      read (1,"(i12,f13.5,f13.7,f13.2)",advance="yes") &
      rh_tmp,ratio_tmp,mole_frac_tmp,den_mix_tmp
      mole_frac_bc(irh)=mole_frac_tmp
      den_mix_bc(irh)=den_mix_tmp
    enddo
    close(1)

    infl='hygroscopic_growth_factors_oc_0.1um_273K.txt'
#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif
    do irh=1,nrh
      read (1,"(i12,f13.5,f13.7,f13.2)",advance="yes") &
      rh_tmp,ratio_tmp,mole_frac_tmp,den_mix_tmp
      mole_frac_oc(irh)=mole_frac_tmp
      den_mix_oc(irh)=den_mix_tmp
    enddo
    close(1)

    infl='hygroscopic_growth_factors_nh4no3_0.1um_273K.txt'
#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif
    do irh=1,nrh
      read (1,"(i12,f13.5,f13.7,f13.2)",advance="yes") &
      rh_tmp,ratio_tmp,mole_frac_tmp,den_mix_tmp
      mole_frac_no3(irh)=mole_frac_tmp
      den_mix_no3(irh)=den_mix_tmp
    enddo
    close(1)
#ifdef ZARA
    infl='estbar.dat'
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else

    open(1,file=trim(indir)//'estbar.dat',status='old',form='formatted')
#endif
    estbar_tmp=0.
    do iest=1,nest
      read(1,*) estbar_tmp
      estbar(iest)=estbar_tmp
    enddo
    close(1)

! Read in values from LUT
    infl='scat_effic_nh4so4_r0.075_s2.txt'
#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif
    do im=1,nmole_frac
      read (1,"(3f13.6)",advance="yes") &
      mole_frac_tmp,qext_tmp,reff_tmp
      mole_frac_lut(im)=mole_frac_tmp
      qext_so4(im)=qext_tmp
      reff_so4(im)=reff_tmp
    enddo
    close(1)

!   Read in values from LUT
    infl='scat_effic_bc_r0.075_s2.txt'
#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif
    do im=1,nmole_frac
      read (1,"(3f13.6)",advance="yes") &
      mole_frac_tmp,qext_tmp,reff_tmp
      qext_bc(im)=qext_tmp
      reff_bc(im)=reff_tmp
    enddo
    close(1)

!   Read in values from LUT
    infl='scat_effic_oc_r0.075_s2.txt'
#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif
    do im=1,nmole_frac
      read (1,"(3f13.6)",advance="yes") &
      mole_frac_tmp,qext_tmp,reff_tmp
      qext_oc(im)=qext_tmp
      reff_oc(im)=reff_tmp
    enddo
    close(1)

!   Read in values from LUT
!    write(100+iam,*)'set inf'
!    call flush(100+iam)
   
    infl='scat_effic_nh4no3_r0.075_s2.txt'
#ifdef ZARA
#ifdef DIAGCOMP
    write(6,*)'indir',trim(indir)
    write(6,*)'infl',trim(infl)
    call flush(6)
#endif
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl)//' '//trim(infl))
    endif
#ifdef DIAGCOMP
    inquire(file=trim(infl),exist=fexist)
    if(.not.fexist)then
      write(6,*)'file',trim(infl),'does not exist'
      call flush(6)
    endif
#endif
    open (1,file=trim(infl),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl),status='old', &
        form='formatted')
#endif
#ifdef DIAGCOMP
    write(6,*)'nmole_frac',nmole_frac
    call flush(6)
#endif
    do im=1,nmole_frac
#ifdef DIAGCOMP
      write(6,*)'im',im
      call flush(6)
#endif
      read (1,"(3f13.6)",advance="yes") &
     mole_frac_tmp,qext_tmp,reff_tmp
     qext_no3(im)=qext_tmp
     reff_no3(im)=reff_tmp
    enddo
    close(1)
  endif
#ifdef DOMPI
! bcast parameters
#ifdef DIAGCOMP
  write(6,*)'send'
  call flush(6)
#endif
  moledensend(1,1,:)=mole_frac_so4(:)
  moledensend(1,2,:)=mole_frac_bc(:)
  moledensend(1,3,:)=mole_frac_oc(:)
  moledensend(1,4,:)=mole_frac_no3(:)
  moledensend(2,1,:)=den_mix_so4(:)
  moledensend(2,2,:)=den_mix_bc(:)
  moledensend(2,3,:)=den_mix_oc(:)
  moledensend(2,4,:)=den_mix_no3(:)
#ifdef DIAGCOMP
  write(6,*)'mpibc1',mpireal,mpicom,'communicator',communicator
  call flush(6)
  write(100+iam,*)'mpibc1'
  call flush(100+iam)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif

  call mpi_bcast(moledensend,8*nrh,mpireal,0,mpicom,ierr)

#ifdef DIAGCOMP
  write(100+iam,*)'mpibc2'
  call flush(100+iam)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
  call mpi_bcast(rh_lut,nrh,mpiint,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'mpibc3'
  call flush(100+iam)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
  write(6,*)'didmpibc1'
  call flush(6)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
  mole_frac_so4(:)=moledensend(1,1,:)
  mole_frac_bc(:)=moledensend(1,2,:)
  mole_frac_oc(:)=moledensend(1,3,:)
  mole_frac_no3(:)=moledensend(1,4,:)
  den_mix_so4(:)=moledensend(2,1,:)
  den_mix_bc(:)=moledensend(2,2,:)
  den_mix_oc(:)=moledensend(2,3,:)
  den_mix_no3(:)=moledensend(2,4,:)
#ifdef DIAGCOMP
  write(100+iam,*)'mpibc4'
  call flush(100+iam)
  !call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
  write(6,*)'do moleden'
  call flush(6)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
  call mpi_bcast(estbar,nest,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'mpibc5'
  call flush(100+iam)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
  call mpi_bcast(mole_frac_lut,nmole_frac,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'mpibc6'
  call flush(100+iam)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
  write(6,*)'did moleden'
  call flush(6)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
  qrsend(1,1,:)=qext_so4(:)
  qrsend(1,2,:)=qext_bc(:)
  qrsend(1,3,:)=qext_oc(:)
  qrsend(1,4,:)=qext_no3(:)
  qrsend(2,1,:)=reff_so4(:)
  qrsend(2,2,:)=reff_bc(:)
  qrsend(2,3,:)=reff_oc(:)
  qrsend(2,4,:)=reff_no3(:)
#ifdef DIAGCOMP
  write(100+iam,*)'mpibc7'
  call flush(100+iam)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
  write(6,*)'do qr'
  call flush(6)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
  call mpi_bcast(qrsend,8*nmole_frac,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'mpibc8'
  call flush(100+iam)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
  write(6,*)'did qr'
  call flush(6)
!  call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
  qext_so4(:)=qrsend(1,1,:)
  qext_bc(:)=qrsend(1,2,:)
  qext_oc(:)=qrsend(1,3,:)
  qext_no3(:)=qrsend(1,4,:)
  reff_so4(:)=qrsend(2,1,:)
  reff_bc(:)=qrsend(2,2,:)
  reff_oc(:)=qrsend(2,3,:)
  reff_no3(:)=qrsend(2,4,:)
#endif

! um to m
#ifdef DIAGCOL
write(300+iam,*)'did 2molefrac'
call flush(300+iam)
!call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
reff_so4=reff_so4*1.e-6
reff_bc=reff_bc*1.e-6
reff_oc=reff_oc*1.e-6
reff_no3=reff_no3*1.e-6

aod=0.
aod_so4=0.
aod_bc1=0.
aod_bc2=0.
aod_oc1=0.
aod_oc2=0.
aod_no3=0.
aod_so4_hlut=0.
aod_bc1_hlut=0.
aod_bc2_hlut=0.
aod_oc1_hlut=0.
aod_oc2_hlut=0.
aod_no3_hlut=0.
aod_du1_hlut=0.
aod_du2_hlut=0.
aod_du3_hlut=0.
aod_du4_hlut=0.
aod_ss1_hlut=0.
aod_ss2_hlut=0.
aod_ss3_hlut=0.
aod_ss4_hlut=0.
do k=1,nlay
!  call mxmn2(chemp(1,beglat,k,5),'OC233',k,1,rmax,rmin,rms)
  call mxmn2(chemp(1,1,k,5),'OC233',k,1,rmax,rmin,rms)
end do


#ifdef DIAGCOL
write(300+iam,*)'at do k',nlay
call flush(300+iam)
!call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
!rh brought in now
!do j=1,n3
!do j=beglat,endlat
#ifdef DIAGCOL
write(6,*)'istart',istart,jstart,'n2',n2,'n3',n3,'n1',n1
write(6,*)'iend=',istart+n2-1,'jend',jstart+n3-1
#endif
do j=1,n3
  jj=j-1+jstart
#ifdef DIAGCOMP
 write(300+iam,*)'j',j,'n2',n2
 call flush(300+iam)
#endif
do i=1,n2
  ii=i-1+istart
#ifdef DIAGEXT
  if(ii.eq.279.and.jj.eq.1)write(6,*)'top ii',ii,jj,'i',i,j
#endif

! in RAQMS theta is theta tks
! temp is T in K
! rv is specific humidity for UWCCM3

!  do k=1,n1
!  do k=1,nlay
!    p3d=pp(i,j,k)                                   ! tks pressure (hPa)
!    temp=theta(i,j,k)*(p3d/1000.)**cappa            ! tks T (K)

!tks    p3d=pp(k,i,j)                                   ! tks pressure (hPa)
!tks    temp=theta(k,i,j)*(p3d/1000.)**cappa            ! tks T (K)

! CCM3 Physics
!    ES1=ESTBLF(TEMP)*.01

!NCEP physics for now
!    ES1=fpvs(TEMP)*.01      !mb 
!    epsqs=0.622

!    ES1=MIN(ES1,p3d)
!    QS=EPSQS*ES1/(p3d - (1. - EPSQS)*ES1)
!tks    rh(k,i,j)=rv(k,i,j)/QS
! leaving rh subscipted this way since it is used later
! I did change rv since it comes from the model
!    rh(k,i,j)=100.*rv(i,j,k)/QS
!    if(rh(k,i,j).lt.0.0)print*,'neg rh ',i,j,k,rh(k,i,j)
!    if(rh(k,i,j).gt.100.0)print*,'>100 rh ',i,j,k,rh(k,i,j)

!    rh(k,i,j)=max(rh(k,i,j),0.)
!    rh(k,i,j)=min(rh(k,i,j),99.)

112  format(1x,i3,2x,3(f7.1,2x),e7.1,2x,f7.1)
!  if(i.eq.144.and.j.eq.60)write(6,112)k,p3d,temp,den(i,j,k),rv(i,j,k), &
!    rh(k,i,j)

!    es=0.
!    es1=min(temp-163.,148.)
!    es2=max(int(es1),0)
!    es3=min((temp-(es2+163.)*1.),0.)
!    es4=max(es3,0.)
!    es=estbar(es2)*(1.-es4)+estbar(es2+1)*es4
!    es5=0.
!    es5=max(1.e-10,(p3d*100.-es))
!    qs=.622*es/es5
!    rh(k,i,j)=rv(k,i,j)/qs*100.
!    rh(k,i,j)=max(rh(k,i,j),0.)
!    rh(k,i,j)=min(rh(k,i,j),99.)
!  enddo
!write(300+iam,*)'atend  do k',nlay
!call flush(300+iam)


!============================================================
do itau=1,n_atau
do iac=1,nac
!Chieko's
!if(iac.eq.1) iiac=4
!if(iac.eq.2) iiac=17
!if(iac.eq.3) iiac=18
!if(iac.eq.4) iiac=19
!if(iac.eq.5) iiac=20
!if(iac.eq.6) iiac=44

!RAQMS Global
 if(iac.eq.1) iiac=1
 if(iac.eq.2) iiac=2
 if(iac.eq.3) iiac=3
 if(iac.eq.4) iiac=4
 if(iac.eq.5) iiac=5
 if(iac.eq.6) iiac=6
 q_column(iac)=0.

! Convert mixing ratio to mass concentration

!do k=1,n1
 do k=1,nlay
!tks  chemp(k,i,j,1,iiac)=max(chemp(k,i,j,1,iiac),0.)
!tks aero_conc(k,iac)=chemp(k,i,j,1,iiac)*mw_aero(iac)/ &
!                 mw_air*den(k,i,j) ! in kg/m3
!tks
#ifdef DIAG140
   if(iiac.eq.5)then
         if(ii.eq.124.and.jj.eq.140)then
          write(6,*)'124,140 oc2chemc',k,chemp(i,j,k,5)
         endif
         if(ii.eq.143.and.jj.eq.116)then
          write(6,*)'143,116 oc2chemc',k,chemp(i,j,k,5)
         endif
         if(ii.eq.149.and.jj.eq.127)then
          write(6,*)'149,127 oc2chemc',k,chemp(i,j,k,5)
         endif
   endif
#endif
!  if(i.eq.1.and.j.eq.88.and.iac.eq.3)then
!    write(6,*)'chempin',chemp(i,j,k,iiac),'iiac',iiac,'iac',iac
!  endif
 chemp(i,j,k,iiac)=max(chemp(i,j,k,iiac),0.)
 aero_conc(k,iac)=chemp(i,j,k,iiac)*mw_aero(iac)/ &
                  mw_air*den(i,j,k) ! in kg/m3
!tks
 enddo


! Relative humidity (rh) dependency
!do k=1,n1

do k=1,nlay
  ! Find two closest relative humidities from rh_lut
  do irh=1,nrh
#ifdef DIAGCOL2
   if(i.eq.1.and.j.eq.1)then
    write(6,*)'rh',k,rh(k,i,j)
   endif
#endif
!   if(rh(k,i,j).le.rh_lut(irh)) goto 18
!    if(jj.eq.56.and.ii.ge.185.and.ii.le.188.and.k.eq.1)then
!      write(6,*)'rh',i,j,k,rh(i,j,k),'irh',irh,'rh_lut',rh_lut(irh)
!    endif
   if(rh(i,j,k).le.rh_lut(irh)) goto 18
  enddo
! safer to say irh is nrh else could be nrh+1 which is out of bounds ajl
  irh=nrh
18 continue

  if(irh.eq.1) irh1=1
  if(irh.ge.2) irh1=irh-1
  if(irh.eq.1) irh2=1
  if(irh.ge.2) irh2=irh

  if(iac.eq.2) then
   molef_rh(k,iac)=1.
   den_mix_rh(k,iac)=den_mix_bc(1)
  endif
  if(iac.eq.4) then
   molef_rh(k,iac)=1.
   den_mix_rh(k,iac)=den_mix_oc(1)
  endif

  if((rh_lut(irh2)-rh_lut(irh1))<1.) then
  if(iac.eq.1) then
   molef_rh(k,iac)=mole_frac_so4(irh1)
   den_mix_rh(k,iac)=den_mix_so4(irh1)
  endif
  if(iac.eq.3) then
   molef_rh(k,iac)=mole_frac_bc(irh1)
   den_mix_rh(k,iac)=den_mix_bc(irh1)
  endif
  if(iac.eq.5) then
   molef_rh(k,iac)=mole_frac_oc(irh1)
   den_mix_rh(k,iac)=den_mix_oc(irh1)
  endif
  if(iac.eq.6) then
   molef_rh(k,iac)=mole_frac_no3(irh1)
   den_mix_rh(k,iac)=den_mix_no3(irh1)
  endif

  endif
#ifdef DIAGSDF
    if(i.eq.1.and.j.eq.1.and.k.eq.1)then
     write(100+iam,*)'irh2',irh2,irh1,'rh',rh_lut(irh2),rh_lut(irh1),'iac',iac,'molef',molef_rh(k,iac)
    endif
#endif

  if((rh_lut(irh2)-rh_lut(irh1))>=1.) then
  if(iac.eq.1) then 
  molef_rh(k,iac)=mole_frac_so4(irh1)+ &
   (mole_frac_so4(irh2)-mole_frac_so4(irh1))/ &
         (rh_lut(irh2)-rh_lut(irh1))* &
!         (rh(k,i,j)-rh_lut(irh1))
         (rh(i,j,k)-rh_lut(irh1))
#ifdef DIAGSDF
    if(i.eq.1.and.j.eq.1.and.k.eq.1)then
      write(100+iam,*)'iac',iac,'rh',rh(i,j,k),'rhlut',rh_lut(irh1),'mole',mole_frac_so4(irh1)
    endif
#endif
  endif
  if(iac.eq.3) then
  molef_rh(k,iac)=mole_frac_bc(irh1)+ &
   (mole_frac_bc(irh2)-mole_frac_bc(irh1))/ &
         (rh_lut(irh2)-rh_lut(irh1))* &
!         (rh(k,i,j)-rh_lut(irh1))
         (rh(i,j,k)-rh_lut(irh1))
  endif
  if(iac.eq.5) then
  molef_rh(k,iac)=mole_frac_oc(irh1)+ &
   (mole_frac_oc(irh2)-mole_frac_oc(irh1))/ &
         (rh_lut(irh2)-rh_lut(irh1))* &
!         (rh(k,i,j)-rh_lut(irh1))
         (rh(i,j,k)-rh_lut(irh1))
#ifdef DIAGSDF
    if(jj.eq.140.and.ii.ge.124.and.ii.le.124.and.iac.eq.5)then
      write(6,*)'molef_rh',k,molef_rh(k,iac),'mole_frac_oc',irh1,mole_frac_oc(irh1)
      write(6,*)'irh2',irh2,mole_frac_oc(irh2)
      write(6,*)'irh2 rh_lut',irh2,rh_lut(irh2),irh1,rh_lut(irh1)
      write(6,*)k,'rh',rh(i,j,k)
    endif
#endif
!    if(jj.eq.56.and.ii.ge.185.and.ii.le.188.and.k.eq.1)then
!      !write(6,*)'molef_rh',ii,molef_rh(k,iac)
!    endif
  endif
  if(iac.eq.6) then
  molef_rh(k,iac)=mole_frac_no3(irh1)+ &
   (mole_frac_no3(irh2)-mole_frac_no3(irh1))/ &
         (rh_lut(irh2)-rh_lut(irh1))* &
!         (rh(k,i,j)-rh_lut(irh1))
         (rh(i,j,k)-rh_lut(irh1))
  endif
  if(iac.eq.1) then
  den_mix_rh(k,iac)=den_mix_so4(irh1)+ &
            (den_mix_so4(irh2)-den_mix_so4(irh1))/ &
            (rh_lut(irh2)-rh_lut(irh1))* &
!            (rh(k,i,j)-rh_lut(irh1))
            (rh(i,j,k)-rh_lut(irh1))
  endif
  if(iac.eq.3) then
  den_mix_rh(k,iac)=den_mix_bc(irh1)+ &
            (den_mix_bc(irh2)-den_mix_bc(irh1))/ &
            (rh_lut(irh2)-rh_lut(irh1))* &
!            (rh(k,i,j)-rh_lut(irh1))
            (rh(i,j,k)-rh_lut(irh1))
  endif
  if(iac.eq.5) then
  den_mix_rh(k,iac)=den_mix_oc(irh1)+ &
            (den_mix_oc(irh2)-den_mix_oc(irh1))/ &
            (rh_lut(irh2)-rh_lut(irh1))* &
!            (rh(k,i,j)-rh_lut(irh1))
            (rh(i,j,k)-rh_lut(irh1))
!    if(jj.eq.56.and.ii.ge.185.and.ii.le.188.and.k.eq.1)then
!       write(6,*)'denmix',ii,den_mix_rh(k,iac)
!    endif
  endif
  if(iac.eq.6) then
  den_mix_rh(k,iac)=den_mix_no3(irh1)+ &
            (den_mix_no3(irh2)-den_mix_no3(irh1))/ &
            (rh_lut(irh2)-rh_lut(irh1))* &
!            (rh(k,i,j)-rh_lut(irh1))
            (rh(i,j,k)-rh_lut(irh1))
  endif

  endif ! end if for rh

  den_mix_rh(k,iac)=min(den_mix_rh(k,iac),1800.)
  den_mix_rh(k,iac)=max(den_mix_rh(k,iac),1000.)


  vmxr_w(k,iac)=(1.-molef_rh(k,iac))/molef_rh(k,iac)* &
                chemp(i,j,k,iiac)
#ifdef DIAG140
  if(jj.eq.140.and.ii.ge.124.and.ii.le.124.and.iac.eq.5)then
    write(6,*)'vmr',k,vmxr_w(k,iac),'molef',molef_rh(k,iac),'chemp',chemp(i,j,k,iiac)
  endif
#endif
!  if(i.eq.1.and.j.eq.1.and.k.eq.1)then
!    write(650+iam,*)k,'molef',molef_rh(k,iac),'iac',iac,'chemp',chemp(i,j,k,iiac),'iiac',iiac
!  endif
#ifdef DIAGCOL2
  if(i.eq.1.and.j.eq.1.and.iac.eq.1)then
     write(6,*)'molefrh',molef_rh(i,iac),'chemp',chemp(i,j,k,iiac), &
     'iiac',iiac
  endif
#endif
!tks                chemp(k,i,j,1,iiac)

!tks   mass_w(k,iac)=vmxr_w(k,iac)*mw_w/mw_air*den(k,i,j)

  mass_w(k,iac)=vmxr_w(k,iac)*mw_w/mw_air*den(i,j,k)
  if(mass_w(k,iac)>1.0)then
    write(6,*)'vmxr_w',k,iac,vmxr_w(k,iac),'mw_w',mw_w,'air',mw_air,'den',den(i,j,k)
    write(6,*)'molef_rh',molef_rh(k,iac),'chemp',chemp(i,j,k,iiac),'iiac',iiac
    call flush(6)
  endif
#ifdef DIAG140
  if(jj.eq.140.and.ii.ge.124.and.ii.le.124.and.iac.eq.5)then
    write(6,*)'mass_w',iac,mass_w(k,iac),'vmxr_w',vmxr_w(k,iac),'mw_w',mw_w, &
    'mw_air',mw_air,'den',den(i,j,k)
  endif
#endif
!  if(i.eq.1.and.j.eq.1.and.k.eq.1)then
!    call flush(650+iam)
!  endif
#ifdef DIAG140
  if(.not.mass_w(k,iac).le.0.0.and..not.mass_w(k,iac).ge.0.0)then
    write(600+iam)'mass-w nan',k,iac,'v',vmxr_w(k,iac),'mw',mw_w,mw_air,'den',den(i,j,k)
  endif
  if(mass_w(k,iac).gt.1.e50)then
    write(600+iam)'mass-w inf',k,iac,'v',vmxr_w(k,iac),'mw',mw_w,mw_air,'den',den(i,j,k)
  endif
#endif

#ifdef DIAGCOL2
  if(i.eq.1.and.j.eq.1.and.iac.eq.1)then
   write(6,*)'vmxr',k,vmxr_w(k,iac),'mww',mw_w,mw_air, &
   'den',den(i,j,k)
  endif
#endif
  mole_frac(k,iac)=1.

!tks
! if((chemp(k,i,j,1,iiac)+vmxr_w(k,iac)).gt.1e-10) &
! mole_frac(k,iac)=chemp(k,i,j,1,iiac)/ &
!   (chemp(k,i,j,1,iiac)+vmxr_w(k,iac))
! ajl 11/06/2009
! ajl 11/13/2009 since vmxr_w prop to chemp mole_frac=molef_rh always
!  write(6,*)'before ratioaod'
!  call flush(6)
!  write(6,*)'doratioaod',doratioaod
!  call flush(6)
#ifdef OLDCODE
  if(doratioaod)then
#endif
    mole_frac(k,iac)=molef_rh(k,iac)
#ifdef OLDCODE
     if(chemp(i,j,k,iiac).ne.0.0)then
       mole_fractemp=chemp(i,j,k,iiac)/ &
       (chemp(i,j,k,iiac)+vmxr_w(k,iac))
       if(abs(mole_frac(k,iac)-mole_fractemp)>1.e-6)then
         print *,'molef error ',i,j,k,iac,molef_rh(k,iac),mole_frac(k,iac)
       endif
     endif
  else
! end ajl 11/06/2009

    if((chemp(i,j,k,iiac)+vmxr_w(k,iac)).gt.1e-10) &
    mole_frac(k,iac)=chemp(i,j,k,iiac)/ &
    (chemp(i,j,k,iiac)+vmxr_w(k,iac))
  endif
#endif


! Find two closest mole fractions from lut
  do im=1,nmole_frac
#ifdef DIAG140
  if(jj.eq.140.and.ii.ge.124.and.ii.le.124.and.iac.eq.5)then
     write(6,*)'molefrac',k,iac,mole_frac(k,iac),'im',im,mole_frac_lut(im)
  endif
#endif
   if(mole_frac(k,iac).le.mole_frac_lut(im)) goto 19
  enddo
  
19 continue
  if(im.eq.1) im1=1
  if(im.ge.2) im1=im-1
  if(im.eq.1) im2=1
  if(im.ge.2) im2=im

  if(iac.eq.2) then
   qext_molef(k,iac)=qext_bc(nmole_frac)
   reff_molef(k,iac)=reff_bc(nmole_frac)
  endif
  if(iac.eq.4) then
   qext_molef(k,iac)=qext_oc(nmole_frac)
   reff_molef(k,iac)=reff_oc(nmole_frac)
  endif
  
  if((mole_frac_lut(im2)-mole_frac_lut(im1))<0.01) then
  if(iac.eq.1) then
   qext_molef(k,iac)=qext_so4(im1)
   reff_molef(k,iac)=reff_so4(im1)
  endif
  if(iac.eq.3) then
   qext_molef(k,iac)=qext_bc(im1)
   reff_molef(k,iac)=reff_bc(im1)
  endif
  if(iac.eq.5) then
   qext_molef(k,iac)=qext_oc(im1)
   reff_molef(k,iac)=reff_oc(im1)
#ifdef DIAG140
   if(jj.eq.140.and.ii.ge.124.and.ii.le.124.and.iac.eq.5)then
     write(6,*)'qext_moef',k,qext_molef(k,iac),'r',reff_molef(k,iac)
   endif
#endif
  endif
  if(iac.eq.6) then
   qext_molef(k,iac)=qext_no3(im1)
   reff_molef(k,iac)=reff_no3(im1)
  endif
  endif


  if((mole_frac_lut(im2)-mole_frac_lut(im1))>=0.01) then

  if(iac.eq.1) then
   qext_molef(k,iac)=qext_so4(im1)+ &
            (qext_so4(im2)-qext_so4(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))

   reff_molef(k,iac)=reff_so4(im1)+ &
            (reff_so4(im2)-reff_so4(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))
  endif

  if(iac.eq.3) then
   qext_molef(k,iac)=qext_bc(im1)+ &
            (qext_bc(im2)-qext_bc(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))
   reff_molef(k,iac)=reff_bc(im1)+ &
            (reff_bc(im2)-reff_bc(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))
  endif

  if(iac.eq.5) then
   qext_molef(k,iac)=qext_oc(im1)+ &
            (qext_oc(im2)-qext_oc(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))
   reff_molef(k,iac)=reff_oc(im1)+ &
            (reff_oc(im2)-reff_oc(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))
!   if(jj.eq.140.and.ii.ge.124.and.ii.le.124.and.iac.eq.5)then
!     write(6,*)'qext_molef2',k,qext_molef(k,iac),'r',reff_molef(k,iac)
!   endif
  endif

  if(iac.eq.6) then
   qext_molef(k,iac)=qext_no3(im1)+ &
            (qext_no3(im2)-qext_no3(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))
   reff_molef(k,iac)=reff_no3(im1)+ &
            (reff_no3(im2)-reff_no3(im1))/ &
            (mole_frac_lut(im2)-mole_frac_lut(im1))* &
            (mole_frac(k,iac)-mole_frac_lut(im1))
  endif

  endif ! end of mole_frac


  mass_ext(k,iac)=3./4.*qext_molef(k,iac)/ &
                  (den_mix_rh(k,iac)*reff_molef(k,iac))

  ext(k,iac)=mass_ext(k,iac)*(aero_conc(k,iac)+mass_w(k,iac))
  if(ext(k,iac)>1000.)then
    write(6,*)'ext',k,iac,ext(k,iac),'mass',mass_ext(k,iac),'aero_conc',aero_conc(k,iac)
    write(6,*)'qext',qext_molef(k,iac),'den',den_mix_rh(k,iac),'reff',reff_molef(k,iac)
    write(6,*)'im1',im1,'im2',im2
    call flush(6)
  endif
#ifdef DIAG140
  if(.not.ext(k,iac).le.0.0.and..not.ext(k,iac).ge.0.0)then
     write(600+iam,*)'mass',mass_ext(k,iac),'aero',aero_conc(k,iac),mass_w(k,iac), &
    'denmix',den_mix_rh(k,iac),reff_molef(k,iac),k,iac,'qest',qext_molef(k,iac),'i',i,j
  endif
#endif
!  q_column(iac)=q_column(iac)+ext(k,iac)*dz_in
  q_column(iac)=q_column(iac)+ext(k,iac)*dz(i,j,k)
  aodlvl(ii,k,jj)=aodlvl(ii,k,jj)+ext(k,iac)*dz(i,j,k)
!  if(ii.eq.110.and.k.eq.15.and.jj.ge.205.and.jj.le.215)then
!    write(6,*)'aodlvlii iac',iac,'jj',jj,aodlvl(ii,k,jj),'add',ext(k,iac)*dz(i,j,k)
!  endif
  
  if(q_column(iac)>100.)then
   write(6,*)'q_column',iac,q_column(iac),' ext',ext(k,iac),'dz',dz(i,j,k),'i',i,j,k,'iac',iac,'mass',mass_ext(k,iac), &
   'aero',aero_conc(k,iac),'massw',mass_w(k,iac)
  endif
#ifdef DIAG140
   if(jj.eq.140.and.ii.ge.124.and.ii.le.124.and.iac.eq.5)then
     write(6,*)'ext',k,ext(k,iac),'dz',dz(i,j,k),'prod',ext(k,iac)*dz(i,j,k)
   endif
#endif
!  if(.not.q_column(iac).le.0.0.and..not.q_column(iac).ge.0.0)then
!    write(600+iam,*)'q_column',iac,'k',k,'ext',ext(i,iac),'dz',dz(i,j,k)
!    call flush(600+iam)
!  endif
#ifdef DIAGSDF
  if(i.eq.1.and.j.eq.88.and.iac.eq.3)then
   write(6,*)'ext',k,iac,ext(k,iac),'dz',dz(i,j,k)
  endif
#endif
  if(q_column(iac)<0.0)then
   write(6,*)'q_column neg',i,j,k,q_column(iac),'ext',ext(k,iac),'dz',dz(i,j,k)
  endif
#ifdef DIAGCOL2
  if(i.eq.1.and.j.eq.1.and.iac.eq.1)then
    write(6,*)'ext',k,ext(k,iac),'dz',dz(i,j,k),'mass_ext', &
    mass_ext(k,iac),'aero_conc',aero_conc(k,iac),'mass_w', &
    mass_w(k,iac)
  endif
#endif
 
  ext_3d(i,j,k,iac)=ext(k,iac)
  if(ii.eq.10.and.k.eq.40)then
     write(6,*)'inside ext-3d iac',iac,'i',i,'j',j,'jj',jj,ext_3d(i,j,k,iac)
     call flush(6)
  endif
  mass_ext_3d(i,j,k,iac)=mass_ext(k,iac)
  mole_frac_3d(i,j,k,iac)=mole_frac(k,iac)

 enddo   ! end loop over layers

 a_taus(itau,iac)=q_column(iac)


enddo  ! end loop over species
enddo  ! end loop over wavelength

do itau=1,n_atau
 do iac=1,nac
#ifdef DIAGSDF
  if(i+istart-1.eq.148.and.j+jstart-1.eq.74)then
     write(6,*)'sum up aod',aod(i,j),'ataus',a_taus(itau,iac),itau,iac
  endif
#endif
  if(ii.eq.533.and.jj.eq.230)then
    write(6,*)'aod',aod(i,j),'iac',iac,'a_taus',a_taus(itau,iac),'itau',itau
  endif
  aod(i,j)=aod(i,j)+a_taus(itau,iac)
  if(aod(i,j)>100.)then
    write(6,*)'aod big',i,j,aod(i,j),'iac',iac, &
  'a_taus',a_taus(itau,iac),'itau',itau
  endif
#ifdef DIAG140
  if(jj.eq.1.and.ii.ge.279)then
    write(6,*)'aod i',i,aod(i,j),'iac',iac,'a_taus',a_taus(itau,iac)
  endif
  if(jj.eq.140.and.ii.ge.124.and.ii.le.124)then
    write(6,*)'aod i',i,aod(i,j),'iac',iac,'a_taus',a_taus(itau,iac)
  endif
#endif
#ifdef DIAGCOL2
  if(i.eq.1.and.j.eq.1)then
    write(6,*)'aod inc',aod(i,j),'itau',itau,iac,a_taus(itau,iac)
  endif
#endif
  if(iac.eq.1) aod_so4(i,j)=aod_so4(i,j)+a_taus(itau,iac)
  if(iac.eq.2) aod_bc1(i,j)=aod_bc1(i,j)+a_taus(itau,iac)
  if(iac.eq.3) aod_bc2(i,j)=aod_bc2(i,j)+a_taus(itau,iac)
!  if(iac.eq.3.and.i.eq.1.and.j.eq.88)write(6,*)'aod_bc2',aod_bc2(i,j),'iac',iac,'itau',itau
  if(iac.eq.4) aod_oc1(i,j)=aod_oc1(i,j)+a_taus(itau,iac)
  if(iac.eq.5) aod_oc2(i,j)=aod_oc2(i,j)+a_taus(itau,iac)
  if(iac.eq.6) aod_no3(i,j)=aod_no3(i,j)+a_taus(itau,iac)
 enddo
enddo

aod_cc(i,j)=aod_bc1(i,j)+aod_bc2(i,j)+aod_oc1(i,j)+aod_oc2(i,j)
ratio(i,j)=5.
#ifdef DIAGCOL
if(i.eq.145.and.beglat+j-1.eq.6)then
  write(6,*)'findaod_cc',aod_cc(i,j),'bc',aod_bc1(i,j),aod_bc2(i,j),aod_oc1(i,j),aod_oc2(i,j)
endif
#endif
!if(aod_cc(i,j).gt.0.01)then
! write(6,*)iam,'set ratio',aod_so4(i,j),aod_cc(i,j),'ratio', &
!  aod_so4(i,j)/aod_cc(i,j)
!elseif(aod_cc(i,j).ne.0.0)then
!  write(6,*)iam,'aodcc small',i,beglat+j-1,aod_cc(i,j)
!endif
!if (aod_cc(i,j).ne.0.0)then
!  write(500+iam,*)'aod_cc',aod_cc(i,j),i,j,'bc',aod_bc1(i,j),aod_bc2(i,j),'oc',aod_oc1(i,j),aod_oc2(i,j)
!  call flush(500+iam)
!endif
if(aod_cc(i,j).gt.0.01) then
  ratio(i,j)=aod_so4(i,j)/aod_cc(i,j)
  if(ratio(i,j)<0.0.or.ratio(i,j)>1.e20)then
    write(6,*)'rationew',i,j,ratio(i,j),'aos_so4',aod_so4(i,j),'aod_cc', &
    aod_cc(i,j)
    call flush(6)
  endif
endif

enddo  ! end loop over i
enddo  ! end loop over j

!call mxmn2(aod_bc1(1,beglat),'BC1',0,1,rmax,rmin,rms)
call mxmn2(aod_bc1(1,1),'BC1',0,1,rmax,rmin,rms)
!call mxmn2(aod_bc2(1,beglat),'BC2',0,1,rmax,rmin,rms)
call mxmn2(aod_bc2(1,1),'BC2',0,1,rmax,rmin,rms)
!call mxmn2(aod_oc1(1,beglat),'OC1',0,1,rmax,rmin,rms)
call mxmn2(aod_oc1(1,1),'OC1',0,1,rmax,rmin,rms)
!call mxmn2(aod_oc2(1,beglat),'OC2',0,1,rmax,rmin,rms)
call mxmn2(aod_oc2(1,1),'OC2',0,1,rmax,rmin,rms)
!call mxmn2(aod_so4(1,beglat),'SO4',0,1,rmax,rmin,rms)
call mxmn2(aod_so4(1,1),'SO4',0,1,rmax,rmin,rms)
#ifdef DIAGCOMP
write(300+iam,*)'did ij loop'
call flush(300+iam)
!call mpibarrier(mpicom)
#endif
#ifdef DIAGCOL
call mxmn2(ratio,'RATOJJ',0,1,rmax,rmin,rms)
#endif



!tks jump around dust contributions
!!!!!!!!!!!!!!!!!!!!!      go to 1147


! Write AOD into a file

!      write(ct,'(I10)')INT(TIME+.1)
!      DO NC=1,10
!       if(ct(nc:nc).ne.' ') then
!        ct_new=ct(nc:10)
!        goto 999
!       endif
!      ENDDO
!999    continue

!-------------------------------------------------------------------------
!-------------------------------------------------------------------------

! Compute AOD using Harvard Lookup table

! Read in values from LUP

!tks
  if(masterproc)then
#ifdef DIAGCOMP
    write(300+iam,*)'top of masterproc'
    call flush(300+iam)
#endif
    infl_qext='Qext_Reff_GEOS-CHEM.dat'

#ifdef ZARA
    if(first)then
      call system('rsync -avz firefly::'//trim(indir)//trim(infl_qext)//' '//trim(infl_qext))
    endif
    open (1,file=trim(infl_qext),status='old', &
        form='formatted')
#else
    open (1,file=trim(indir)//trim(infl_qext),status='old', &
        form='formatted')
#endif
    read (1,"(a20)",advance="yes") line
    do ispec=1,nspec_hlut
!#    write(300+iam,*)'ispec',ispec,nspec_hlut,nlamda_hlut
!#    call flush(300+iam)
      read (1,"(a20)",advance="yes") line
      spec_line(ispec)=line
      do ilamda=1,nlamda_hlut
#ifdef DIAGCOMP
        write(300+iam,*)'ilamda',ilamda,'ispec',ispec
        call flush(300+iam)
#endif
        read (1,*) tmp_hlut
        lamda_hlut(ilamda)=tmp_hlut(1)
        q_hlut(ilamda,ispec)=tmp_hlut(2)
        reff_hlut(ilamda,ispec)=tmp_hlut(3)*1.e-6
        ssa_hlut(ilamda,ispec)=tmp_hlut(4)
        pf_hlut(1,ilamda,ispec)=tmp_hlut(5)
        pf_hlut(2,ilamda,ispec)=tmp_hlut(6)
        pf_hlut(3,ilamda,ispec)=tmp_hlut(7)
        pf_hlut(4,ilamda,ispec)=tmp_hlut(8)
        pf_hlut(5,ilamda,ispec)=tmp_hlut(9)
        pf_hlut(6,ilamda,ispec)=tmp_hlut(10)
        pf_hlut(7,ilamda,ispec)=tmp_hlut(11)
        pf_hlut(8,ilamda,ispec)=tmp_hlut(12)
     enddo
    enddo
    close(1)
  endif
#ifdef DOMPI
#ifdef DIAGCOMP
 write(6,*)iam,'dop pfhlut',nlamda_hlut,nspec_hlut
 call flush(6)
  write(300+iam,*)'do mpibcast pf',nlamda_hlut,nspec_hlut
  call flush(300+iam)
  write(300+iam,*)'nspec',nspec_hlut,'mpichar',mpichar
  call flush(300+iam)
! call mpibarrier(mpicom)
#endif
  call mpi_bcast(spec_line,30*nspec_hlut,mpichar,0,mpicom,ierr)
!  write(300+iam,*)'ph_hlut',pf_hlut,'nlamda',nlamda_hlut,'nspec', &
!  nspec_hlut,'3mpireal',mpireal,'mpicom',mpicom
  !call flush(300+iam)
  call mpi_bcast(pf_hlut,8*nlamda_hlut*nspec_hlut,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(300+iam,*)'ddid mpibcast pf',nlamda_hlut,nspec_hlut
  call flush(300+iam)
  write(100+iam,*)'did pf_hlut'
  call flush(100+iam)
!call mpibarrier(mpicom)
#endif
  call mpi_bcast(lamda_hlut,nlamda_hlut,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'did lamda_hlut'
  call flush(100+iam)
!call mpibarrier(mpicom)
#endif
  call mpi_bcast(q_hlut,nlamda_hlut*nspec_hlut,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'did q_hlut'
  call flush(100+iam)
!call mpibarrier(mpicom)
#endif
  call mpi_bcast(reff_hlut,nlamda_hlut*nspec_hlut,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'did reff_hlut'
  call flush(100+iam)
!call mpibarrier(mpicom)
#endif
  call mpi_bcast(ssa_hlut,nlamda_hlut*nspec_hlut,mpireal,0,mpicom,ierr)
#ifdef DIAGCOMP
  write(100+iam,*)'did ssa_hlut'
  call flush(100+iam)
!call mpibarrier(mpicom)
 write(6,*)'ddidp pfhlut'
 call flush(6)
  write(100+iam,*)'diddid pf_hlut'
  call flush(100+iam)
!call mpibarrier(mpicom)
#endif
#endif
#ifdef DIAGCOMP
  write(300+iam,*)'n_atau_hlut',n_atau_hlut,'n2',n2,'nlamda_hlut',nlamda_hlut
  call flush(300+iam)
#endif

do j=1,n3
  jj=j-1+jstart
!do j=beglat,endlat
do i=1,n2
  ii=i-1+istart

do itau=1,n_atau_hlut  ! loop ever wavelengths

   do ilamda=1,nlamda_hlut
     if(abs(lamda_hlut(ilamda)-a_wli_hlut*1000.).lt.1.) goto 9
   enddo
   write(6,*)'lamda is not found'
   call flush(6)
   call killit('no lamda')
! stop
9 continue
!print *,'ilamda=',ilamda


do iac=1,nac_hlut
!Chieko's
!if(iac.eq.1) iiac=4
!if(iac.eq.2) iiac=17
!if(iac.eq.3) iiac=18
!if(iac.eq.4) iiac=19
!if(iac.eq.5) iiac=20
!if(iac.eq.6) iiac=44
!if(iac.eq.7) iiac=21
!if(iac.eq.8) iiac=22
!if(iac.eq.9) iiac=23
!if(iac.eq.10) iiac=24
!if(iac.eq.11) iiac=26
!if(iac.eq.12) iiac=27
!if(iac.eq.13) iiac=28
!if(iac.eq.14) iiac=29

!RAQMS Global (index of chemp)

 if(iac.eq.1) iiac=1
 if(iac.eq.2) iiac=2
 if(iac.eq.3) iiac=3
 if(iac.eq.4) iiac=4
 if(iac.eq.5) iiac=5
 if(iac.eq.6) iiac=6
 if(iac.eq.7) iiac=7
 if(iac.eq.8) iiac=8
 if(iac.eq.9) iiac=9
 if(iac.eq.10) iiac=10
 if(iac.eq.11) iiac=11
 if(iac.eq.12) iiac=12
 if(iac.eq.13) iiac=13
 if(iac.eq.14) iiac=14
 q_column_hlut(iac)=0.

 do ispec=1,nspec_hlut
   if(index(spec_line(ispec),trim(spec_name(iac))).gt.0) goto 99
 enddo
 write(100+iam,*)'spec is not found',spec_line(ispec)
 call flush(100+iam)
 do ispec=1,nspec_hlut
   write(100+iam,*)'spec_name',spec_name(iac)
   call flush(100+iam)
 end do
 call killit('spec not found')
99 continue
!print *,'ispec=',ispec,iac

!============================================================



! Convert mixing ratio to mass concentration
! do k=1,n1
 do k=1,nlay
!tks aero_conc(k,iac)=chemp(k,i,j,1,iiac)*mw_aero(iac)/ &
!tks                  mw_air*den(k,i,j) ! in kg/m3

 aero_conc(k,iac)=chemp(i,j,k,iiac)*mw_aero(iac)/ &
                  mw_air*den(i,j,k) ! in kg/m3
 enddo

!-------------------------------------------!
!  q(nlamda,nspec),  reff(nlamda,nspec)
!  ssa(nlamda,nspec),pf(nterm,nlamda,nspec)
!-------------------------------------------!


! Exitinction coefficient at lamda

! ispec:ispec+6 code was put in place of original
! ispec:ispec+7 from Chieko.  Chieko and Brad 
! reviewed this code and recommended the change 4-19-07

if(iac.le.6.or.iac.ge.11) & 
 q_tmp_hlut(1:7)=q_hlut(ilamda,ispec:ispec+6)
if(iac.ge.7.and.iac.le.10) &
 q_tmp_hlut(1)=q_hlut(ilamda,ispec)

! Effective radius
if(iac.le.6.or.iac.ge.11) &
 reff_tmp_hlut(1:7)=reff_hlut(ilamda,ispec:ispec+6)
if(iac.ge.7.and.iac.le.10) &
 reff_tmp_hlut(1)=reff_hlut(ilamda,ispec)

! Single scattering albedo
if(iac.le.6.or.iac.ge.11) &
 ssa_tmp_hlut(1:7)=ssa_hlut(ilamda,ispec:ispec+6)
if(iac.ge.7.and.iac.le.10) &
 ssa_tmp_hlut(1)=ssa_hlut(ilamda,ispec)

! Phase function terms
if(iac.le.6.or.iac.ge.11) &
 pf_tmp_hlut(1:nterm_hlut,1:7)=pf_hlut(1:nterm_hlut,ilamda,ispec:ispec+6)

if(iac.ge.7.and.iac.le.10) &
 pf_tmp_hlut(1:nterm_hlut,1)=pf_hlut(1:nterm_hlut,ilamda,ispec)

! Relative humidity (rh) dependency
!do k=1,n1
do k=1,nlay
  ! Find two closest relative humidities from rh_lut
  do irh=1,7
!   if(rh(k,i,j).le.rh_hlut(irh)) goto 8
   if(rh(i,j,k).le.rh_hlut(irh)) goto 8
  enddo
8 continue
  if(irh.eq.1) irh1=1
  if(irh.ge.2) irh1=irh-1
  if(irh.eq.1) irh2=1
  if(irh.ge.2) irh2=irh
  if((rh_hlut(irh2)-rh_hlut(irh1))>=1.) &
  q_rh_hlut(k,iac)=q_tmp_hlut(irh1)+ &
         (q_tmp_hlut(irh2)-q_tmp_hlut(irh1))/ &
         (rh_hlut(irh2)-rh_hlut(irh1))* &
!         (rh(k,i,j)-rh_hlut(irh1))
         (rh(i,j,k)-rh_hlut(irh1))
  if(iac.eq.2.or.iac.eq.4) q_rh_hlut(k,iac)=q_tmp_hlut(1)

  if(iac.ge.7.and.iac.le.10) q_rh_hlut(k,iac)=q_tmp_hlut(1)


! if((rh_hlut(irh2)-rh_hlut(irh1))>=1.) &
! reff_rh_hlut(k,iac)=reff_tmp_hlut(irh1)+ &
!           (reff_tmp_hlut(irh2)-reff_tmp_hlut(irh1))/ &
!           (rh_hlut(irh2)-rh_hlut(irh1))* &
!           (rh(k,i,j)-rh_hlut(irh1))
!           (rh(i,j,k)-rh_hlut(irh1))

  if((rh_hlut(irh2)-rh_hlut(irh1))>=1.) then
  reff_rh_hlut(k,iac)=reff_tmp_hlut(irh1)+ &
            (reff_tmp_hlut(irh2)-reff_tmp_hlut(irh1))/ &
            (rh_hlut(irh2)-rh_hlut(irh1))* &
!            (rh(k,i,j)-rh_hlut(irh1))
            (rh(i,j,k)-rh_hlut(irh1))
!
! rbp fix hydrophillic bc, oc and dust reff bug (no re-initialize)
!
!   may not want inside of this loop
    if(iac.eq.2.or.iac.eq.4) reff_rh_hlut(k,iac)=reff_tmp_hlut(1)

    if(iac.ge.7.and.iac.le.10) reff_rh_hlut(k,iac)=reff_tmp_hlut(1)
! else ajl
  else
   write(6,*)'i',i,j,k,'at zero diff irh1',irh1,irh2,'reff',reff_rh_hlut(k,iac)
   call flush(6)
   endif

  reff_rh_hlut(k,iac)=max(reff_rh_hlut(k,iac),1.e-10)
  reff_rh_hlut(k,iac)=min(reff_rh_hlut(k,iac),10.e-6)

!  if(iac.eq.2.or.iac.eq.4) ssa_rh_hlut(k,iac)=ssa_tmp_hlut(1)

!  if(iac.ge.7.and.iac.le.10) ssa_rh_hlut(k,iac)=ssa_tmp_hlut(1)


  if((rh_hlut(irh2)-rh_hlut(irh1))>=1.) &
  ssa_rh_hlut(k,iac)=ssa_tmp_hlut(irh1)+ &
           (ssa_tmp_hlut(irh2)-ssa_tmp_hlut(irh1))/ &
           (rh_hlut(irh2)-rh_hlut(irh1))* &
!           (rh(k,i,j)-rh_hlut(irh1))
           (rh(i,j,k)-rh_hlut(irh1))
  if((rh_hlut(irh2)-rh_hlut(irh1))<1.) then
      write(6,*)'rhdiff too small',i,j,k,iac
      call flush(6)
      call killit('rhdiff')
  endif
!
! rbp fix hydrophillic bc, oc and dust ssa bug (no re-initialize)
!

  if(iac.eq.2.or.iac.eq.4) ssa_rh_hlut(k,iac)=ssa_tmp_hlut(1)

  if(iac.ge.7.and.iac.le.10) ssa_rh_hlut(k,iac)=ssa_tmp_hlut(1)
  do iterm=1,nterm_hlut
   if((rh_hlut(irh2)-rh_hlut(irh1))>=1.) &
   pf_rh_hlut(k,iterm,iac)=pf_tmp_hlut(iterm,irh1)+ &
           (pf_tmp_hlut(iterm,irh2)-pf_tmp_hlut(iterm,irh1))/ &
            (rh_hlut(irh2)-rh_hlut(irh1))* &
!            (rh(k,i,j)-rh_hlut(irh1))
            (rh(i,j,k)-rh_hlut(irh1))
   if(iac.eq.2.or.iac.eq.4) &
    pf_rh_hlut(k,iterm,iac)=pf_tmp_hlut(iterm,1)
   if(iac.ge.7.and.iac.le.10) &
    pf_rh_hlut(k,iterm,iac)=pf_tmp_hlut(iterm,1)
  enddo

!tks    reff_rh_hlut can't be less that 1e-10 because of 
!of the max(), min() 20 lines above

  if(reff_rh_hlut(k,iac)>=1.e-15) &
   f_w=reff_tmp_hlut(1)**3/reff_rh_hlut(k,iac)**3
  if(reff_rh_hlut(k,iac)<1.e-15) &
   f_w=1.
  den_aerow=f_w*den_aero(iac)+(1.-f_w)*1.e+3

!  mass_aerow=aero_conc(k,iac)
!   +4./3.*pi*(reff_rh(k,iac)**3)*den_aerow

  mass_aerow=1./f_w*den_aerow/den_aero(iac)*aero_conc(k,iac)

  ! beta: specific extinction (m2/kg)
!tks 4-24-07

   aero_min=1.e-20

!    aero_min=1.e-12

!tks 3-27-08 added after discussion with Brad, avoids possible division
! by zero

  mass_aerow_min=1./f_w*den_aerow/den_aero(iac)*aero_min
  if(mass_aerow.lt.mass_aerow_min)mass_aerow=mass_aerow_min
! tks 3-27-08


!tks  if(aero_conc(k,iac)>=1.e-12) &
!tks 3-27-08  if(aero_conc(k,iac)>=aero_min) &

  beta_aero_hlut(k,iac)=3.*q_rh_hlut(k,iac) &
   /(4.*den_aerow*reff_rh_hlut(k,iac))


!tks  if(aero_conc(k,iac) < 1.e-12) beta_aero_hlut(k,iac)=0.
!tks 3-27-08  if(aero_conc(k,iac) < aero_min) beta_aero_hlut(k,iac)=0.
#ifndef NOBRADSSSFIX
  q_column_hlut(iac)=q_column_hlut(iac)+ &
    beta_aero_hlut(k,iac)*(aero_conc(k,iac)+mass_aerow)*dz(i,j,k)
  if(iac.ge.7.and.iac.le.14) then 
    ext_3d(i,j,k,iac)=beta_aero_hlut(k,iac)*(aero_conc(k,iac)+mass_aerow)
    mass_ext_3d(i,j,k,iac)=beta_aero_hlut(k,iac)
    aodlvl(ii,k,jj)=aodlvl(ii,k,jj)+ &
    beta_aero_hlut(k,iac)*(aero_conc(k,iac)+mass_aerow)*dz(i,j,k)
  endif
#else

  q_column_hlut(iac)=q_column_hlut(iac)+ &
!   beta_aero_hlut(k,iac)*mass_aerow*dz_in
   beta_aero_hlut(k,iac)*mass_aerow*dz(i,j,k)
  if(iac.ge.7.and.iac.le.14) then
    aodlvl(ii,k,jj)=aodlvl(ii,k,jj)+ &
    beta_aero_hlut(k,iac)*mass_aerow*dz(i,j,k)
  endif

  if(iac.ge.7.and.iac.le.14) then 
  ext_3d(i,j,k,iac)=beta_aero_hlut(k,iac)*aero_conc(k,iac)
  mass_ext_3d(i,j,k,iac)=beta_aero_hlut(k,iac)

  endif
#endif

 enddo   ! end loop over layers

 a_taus_hlut(itau,iac)=q_column_hlut(iac)


enddo  ! end loop over species
enddo  ! end loop over wavelengths
#ifdef DIAGCOMP
  write(300+iam,*)'at itau',n_atau_hlut,nac_hlut,'i',i,'j',j,'beglat',beglat,endlat,'n2',n2
  call flush(300+iam)
#endif

do itau=1,n_atau_hlut
  do iac=1,nac_hlut
!20880327  if(iac.ge.7.and.iac.le.10) &
  if(iac.ge.7.and.iac.le.14)then
#ifdef DIAGSDF
    if(i+istart-1.eq.148.and.j+jstart-1.eq.74)then
      write(6,*)'add in ss',aod(i,j),a_taus_hlut(itau,iac),itau,iac
    endif
#endif
    if(i+istart-1.eq.533.and.j+jstart-1.eq.230)then
      write(6,*)'aod',aod(i,j),'ataushlut',a_taus_hlut(itau,iac),itau,itau,'iac',iac
    endif
    aod(i,j)=aod(i,j)+a_taus_hlut(itau,iac)
  endif
  if(iac.eq.1) aod_so4_hlut(i,j)=aod_so4_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.2) aod_bc1_hlut(i,j)=aod_bc1_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.3) aod_bc2_hlut(i,j)=aod_bc2_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.4) aod_oc1_hlut(i,j)=aod_oc1_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.5) aod_oc2_hlut(i,j)=aod_oc2_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.6) aod_no3_hlut(i,j)=aod_no3_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.7) aod_du1_hlut(i,j)=aod_du1_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.8) aod_du2_hlut(i,j)=aod_du2_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.9) aod_du3_hlut(i,j)=aod_du3_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.10) aod_du4_hlut(i,j)=aod_du4_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.11) aod_ss1_hlut(i,j)=aod_ss1_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.12) aod_ss2_hlut(i,j)=aod_ss2_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.13) aod_ss3_hlut(i,j)=aod_ss3_hlut(i,j)+a_taus_hlut(itau,iac)
  if(iac.eq.14) aod_ss4_hlut(i,j)=aod_ss4_hlut(i,j)+a_taus_hlut(itau,iac)
 enddo
enddo
aodlvlsum(i,j)=0.0
do k=1,nlay
  aodlvlsum(i,j)=aodlvlsum(i,j)+aodlvl(ii,k,jj)
end do
if(abs(aodlvlsum(i,j)-aod(i,j))>.0001)then
   write(6,*)'aodlvlsum',i,j,aodlvlsum(i,j),'aod',aod(i,j)
aodlvlsum(i,j)=0.0
   do k=1,nlay
     aodlvlsum(i,j)=aodlvlsum(i,j)+aodlvl(ii,k,jj)
     write(6,*)'aodlvl',k,aodlvl(ii,k,jj),' int ',aodlvlsum(i,j)
   end do
endif

enddo ! end loop over i
enddo ! end loop over j
#ifdef DIAGCOMP
write(300+iam,*)'did ij loop'
call flush(300+iam)
!call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif


!!!!!!!!!!!!!!!!!!!!!!!!1147  continue

!============================================================
!!!tks change
!!!fl_aod='/idea_data1/Aero_fx/Output/AOD/uwnms_aod_'// &
!!!trim(ct_new)//'.dat'

#ifdef DIAGCOL
call mxmn2(ratio,'2BOTRATIO',0,1,rmax,rmin,rms)
#endif
#ifdef SAVEAOD
 do j= beglat,endlat
 do i=1,n2
 aodpart(i,j,1)=aod_so4(i,j)
 aodpart(i,j,2)=aod_bc1(i,j)
 aodpart(i,j,3)=aod_bc2(i,j)
 aodpart(i,j,4)=aod_oc1(i,j)
 aodpart(i,j,5)=aod_oc2(i,j)
 aodpart(i,j,6)=aod_du1_hlut(i,j)
 aodpart(i,j,7)=aod_du2_hlut(i,j)
 aodpart(i,j,8)=aod_du3_hlut(i,j)
 aodpart(i,j,9)=aod_du4_hlut(i,j)
 aodpart(i,j,10)=aod_ss1_hlut(i,j)
 aodpart(i,j,11)=aod_ss2_hlut(i,j)
 aodpart(i,j,12)=aod_ss3_hlut(i,j)
 aodpart(i,j,13)=aod_ss4_hlut(i,j)
 aodpart(i,j,14)=aod_no3(i,j)
 end do
 end do
 call mxmn2(aodpart(1,beglat,10),'ss1',0,1,rmax,rmin,rms)
#endif

#ifdef SAVEAODDAT
 write(date,"(i10)")idat
 fl_aod=date//'_aod1.dat'
! write(6,*)fl_aod
! call flush(6)
 if(masterproc)then
 open(1,file=fl_aod,status='unknown',form='unformatted')
 write(1) n2,n3,n1,nac,nac_hlut
 endif
#ifdef DOMPI
 call writer8mpi(1,1,1,aod)
 call writer8mpi(1,1,1,ratio)
 call writer8mpi(1,n1,nac_hlut,ext_3d)
 call writer8mpi(1,n1,nac_hlut,mass_ext_3d)
 call writer8mpi(1,n1,nac_hlut,mole_frac_3d)
#else
 write(1) aod
 write(1) ratio 
 write(1) ext_3d
 write(1) mass_ext_3d
 write(1) mole_frac_3d 
#endif
!write(1) aod_so4
!write(1) aod_bc1
!write(1) aod_bc2
!write(1) aod_oc1
!write(1) aod_oc2
!write(1) aod_no3
!write(1) aod_du1_hlut
!write(1) aod_du2_hlut
!write(1) aod_du3_hlut
!write(1) aod_du4_hlut
!write(1) aod_ss1_hlut
!write(1) aod_ss2_hlut
!write(1) aod_ss3_hlut
!write(1) aod_ss4_hlut
!write(1) aod_so4_hlut
!write(1) aod_bc1_hlut
!write(1) aod_bc2_hlut
!write(1) aod_oc1_hlut
!write(1) aod_oc2_hlut
!write(1) aod_no3_hlut
!write(1) aod_cc
!write(1) chemp
 if(masterproc)then
 close(1)
 endif
#endif
#ifdef DIAGCOL
call mxmn2(ratio,'3BOTRATIO',0,1,rmax,rmin,rms)
#endif
#ifdef DOMPIDIAG
  call mxmn2(aod,'AOD',999,1,rmax,rmin,rms)
#else

!call mxmn(aod,n2,n3,'AOD',999,1,rmax,rmin,rms)
#endif
#ifdef DIAGCOL
call mxmn2(ratio,'4BOTRATIO',0,1,rmax,rmin,rms)
#endif
!vmax=-1.e+20
!vmin=+1.e+20
!do j=1,n3
!do i=1,n2
! if (aod(i,j).ge.vmax) vmax=aod(i,j)
! if (aod(i,j).le.vmin) vmin=aod(i,j)
!enddo
!enddo
!#ifdef DIAGCOL
!call mxmn2(ratio,'BOTRATIO',0,1,rmax,rmin,rms)
#ifdef DIAGCOMP
write(300+iam,*)'bottom of col'
call flush(300+iam)
!call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
write(300+iam,*)'bottom of col2'
call flush(300+iam)
!call mpibarrier(mpicom)
  call mpi_barrier(mpicom,ierr)
#endif
first=.false.

return
end subroutine compute_aod_raqms 
subroutine mxmn2(ain,name,ik,i1,rmax,rmin,rms)
character *(*)name
return
end

      SUBROUTINE KILLIT(TEXT)
      CHARACTER *(*)TEXT
      write(6,*)'killit',TEXT
      call flush(6)
      STOP
      END 

      subroutine mxmn4(a4,nr,nc,lbl,num,ipr,bigo4,smlo4,rmso4)
      real*4 a4(nr,nc),bigo4,smlo4,rmso4
      real*8 a(nr,nc),bigo,smlo,rmso
      character *(*) lbl
      a=a4
      call mxmn8(a,nr,nc,lbl,num,ipr,bigo,smlo,rmso)
      bigo4=bigo
      smlo4=smlo
      rmso4=rmso
      return
      end subroutine mxmn4
      SUBROUTINE MXMN(A,NR,NC,LBL,NUM,IPR,BIGo,SMLo,RMSo)
      character *(*) lbl
      real*8 A(NR,NC)
      call mxmn8(a,nr,nc,lbl,num,ipr,bigo,smlo,rmso)
      return
      end subroutine mxmn
    
      SUBROUTINE MXMN8(A,NR,NC,LBL,NUM,IPR,BIGo,SMLo,RMSo)
      real*8 A(NR,NC)
      CHARACTER*(*)LBL
      MXR=0
      MXC=0
      MNR=0
      MNC=0
      BIG=A(1,1)
      SML=A(1,1)
      ABBIG=ABS(A(1,1))
      ABSML=ABS(A(1,1))
      DO 250 I=1,NR
      DO 250 J=1,NC
      IF(A(I,J).GT.1.E30)GOTO 250
      BIG=MAX(BIG,A(I,J))
      IF(A(I,J).EQ.BIG)MXR=I
      IF(A(I,J).EQ.BIG)MXC=J
      ABBIG=MAX(ABBIG,ABS(A(I,J)))
      SML=MIN(SML,A(I,J))
      IF(A(I,J).EQ.SML)MNR=I
      IF(A(I,J).EQ.SML)MNC=J
      ABSML=MIN(ABSML,ABS(A(I,J)))
250   CONTINUE
      RMS=0.
      IF(ABBIG.GT.1.E17)GOTO 500
      IF(ABSML.LT.1.E-17.AND.ABSML.NE.0.)GOTO 500
      NWDS=0
      DO 350 J=1,NC
      DO 350 I=1,NR
      IF(A(I,J).GT.1.E30)GO TO 350
      NWDS=NWDS+1
      RMS=RMS+A(I,J)*A(I,J)
350   CONTINUE
      RMS=SQRT(RMS/FLOAT(NWDS))
500   bigo=big
      smlo=sml
      rmso=rms
      IF(IPR.EQ.0)RETURN
      IF(NUM.NE.999) THEN
      PRINT 600,LBL,NUM,BIG,MXR,MXC,SML,MNR,MNC,RMS
600   FORMAT(1X,A6,1X,I3,1X,'MX:',1PE12.5,' (',I4,',',I3,')',1X, &
      'MN:',1PE12.5,' (',I4,',',I3,')',1X,'RM:',1PE12.5)
      ELSE
      PRINT 610,LBL,BIG,MXR,MXC,SML,MNR,MNC,RMS
610   FORMAT(1X,A6,1X,'MX:',1PE12.5,' (',I4,',',I3,')',1X, &
      'MN:',1PE12.5,' (',I4,',',I3,')',1X,'RM:',1PE12.5)
      END IF
      RETURN
      END SUBROUTINE MXMN8
      subroutine gettime(wall)
      include 'mpif.h'
      real wall
      wall=mpi_wtime()
      return
      end subroutine gettime
