! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cbmz_bb_Parameters.f90
! Time                 : Tue Sep 16 01:33:48 2014
! Working directory    : /data/users/lenzen/WRF/WRFV3.5.1/WRFV3/chem/KPP/mechanisms/cbmz_bb
! Equation file        : cbmz_bb.kpp
! Output root filename : cbmz_bb
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE cbmz_bb_Parameters

  USE cbmz_bb_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 58 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 56 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 54 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 2 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 136 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 57 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 509 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 576 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 57 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 0 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 
! PI - Value of pi
  REAL(kind=dp), PARAMETER :: PI = 3.14159265358979 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_H2SO4 = 1 
  INTEGER, PARAMETER :: ind_HCl = 2 
  INTEGER, PARAMETER :: ind_NH3 = 3 
  INTEGER, PARAMETER :: ind_HCOOH = 4 
  INTEGER, PARAMETER :: ind_RCOOH = 5 
  INTEGER, PARAMETER :: ind_O1D = 6 
  INTEGER, PARAMETER :: ind_SO2 = 7 
  INTEGER, PARAMETER :: ind_ANOL = 8 
  INTEGER, PARAMETER :: ind_H2O2 = 9 
  INTEGER, PARAMETER :: ind_PAN = 10 
  INTEGER, PARAMETER :: ind_TOL = 11 
  INTEGER, PARAMETER :: ind_N2O5 = 12 
  INTEGER, PARAMETER :: ind_XYL = 13 
  INTEGER, PARAMETER :: ind_CH4 = 14 
  INTEGER, PARAMETER :: ind_CRO = 15 
  INTEGER, PARAMETER :: ind_HNO4 = 16 
  INTEGER, PARAMETER :: ind_C2H6 = 17 
  INTEGER, PARAMETER :: ind_TO2 = 18 
  INTEGER, PARAMETER :: ind_XPAR = 19 
  INTEGER, PARAMETER :: ind_CH3OOH = 20 
  INTEGER, PARAMETER :: ind_ETHOOH = 21 
  INTEGER, PARAMETER :: ind_HONO = 22 
  INTEGER, PARAMETER :: ind_ETH = 23 
  INTEGER, PARAMETER :: ind_CH3OH = 24 
  INTEGER, PARAMETER :: ind_O3P = 25 
  INTEGER, PARAMETER :: ind_CRES = 26 
  INTEGER, PARAMETER :: ind_HNO3 = 27 
  INTEGER, PARAMETER :: ind_CO = 28 
  INTEGER, PARAMETER :: ind_PAR = 29 
  INTEGER, PARAMETER :: ind_OPEN = 30 
  INTEGER, PARAMETER :: ind_ISOPN = 31 
  INTEGER, PARAMETER :: ind_ISOPP = 32 
  INTEGER, PARAMETER :: ind_ISOPO2 = 33 
  INTEGER, PARAMETER :: ind_OLET = 34 
  INTEGER, PARAMETER :: ind_ISOP = 35 
  INTEGER, PARAMETER :: ind_HCHO = 36 
  INTEGER, PARAMETER :: ind_XO2 = 37 
  INTEGER, PARAMETER :: ind_AONE = 38 
  INTEGER, PARAMETER :: ind_OLEI = 39 
  INTEGER, PARAMETER :: ind_ETHP = 40 
  INTEGER, PARAMETER :: ind_NAP = 41 
  INTEGER, PARAMETER :: ind_MGLY = 42 
  INTEGER, PARAMETER :: ind_ALD2 = 43 
  INTEGER, PARAMETER :: ind_CH3O2 = 44 
  INTEGER, PARAMETER :: ind_ISOPRD = 45 
  INTEGER, PARAMETER :: ind_ANO2 = 46 
  INTEGER, PARAMETER :: ind_ROOH = 47 
  INTEGER, PARAMETER :: ind_RO2 = 48 
  INTEGER, PARAMETER :: ind_ONIT = 49 
  INTEGER, PARAMETER :: ind_OH = 50 
  INTEGER, PARAMETER :: ind_O3 = 51 
  INTEGER, PARAMETER :: ind_NO2 = 52 
  INTEGER, PARAMETER :: ind_C2O3 = 53 
  INTEGER, PARAMETER :: ind_NO3 = 54 
  INTEGER, PARAMETER :: ind_HO2 = 55 
  INTEGER, PARAMETER :: ind_NO = 56 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_H2O = 57 
  INTEGER, PARAMETER :: ind_M = 58 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_H2O = 1 
  INTEGER, PARAMETER :: indf_M = 2 

END MODULE cbmz_bb_Parameters

