! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Jacobian of Chemical Model File
! 
! Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cri_mosaic_4bin_aq_Jacobian.f90
! Time                 : Tue Sep 16 01:33:53 2014
! Working directory    : /data/users/lenzen/WRF/WRFV3.5.1/WRFV3/chem/KPP/mechanisms/cri_mosaic_4bin_aq
! Equation file        : cri_mosaic_4bin_aq.kpp
! Output root filename : cri_mosaic_4bin_aq
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE cri_mosaic_4bin_aq_Jacobian

  USE cri_mosaic_4bin_aq_Parameters
  USE cri_mosaic_4bin_aq_JacobianSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP_Vec - function for sparse multiplication: sparse Jacobian times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JUV       - Jacobian times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP_Vec ( JVS, UV, JUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JUV - Jacobian times user vector
  REAL(kind=dp) :: JUV(NVAR)

  JUV(1) = JVS(1)*UV(1)
  JUV(2) = JVS(2)*UV(2)
  JUV(3) = JVS(3)*UV(3)
  JUV(4) = JVS(4)*UV(4)+JVS(5)*UV(5)+JVS(6)*UV(53)
  JUV(5) = JVS(7)*UV(5)+JVS(8)*UV(10)+JVS(9)*UV(127)+JVS(10)*UV(173)
  JUV(6) = JVS(11)*UV(6)+JVS(12)*UV(53)+JVS(13)*UV(110)+JVS(14)*UV(228)+JVS(15)*UV(231)
  JUV(7) = JVS(16)*UV(7)+JVS(17)*UV(42)+JVS(18)*UV(231)
  JUV(8) = JVS(19)*UV(8)+JVS(20)*UV(223)
  JUV(9) = JVS(21)*UV(9)+JVS(22)*UV(231)
  JUV(10) = JVS(23)*UV(10)+JVS(24)*UV(127)+JVS(25)*UV(231)
  JUV(11) = JVS(26)*UV(11)+JVS(27)*UV(231)
  JUV(12) = JVS(28)*UV(12)+JVS(29)*UV(231)
  JUV(13) = JVS(30)*UV(13)+JVS(31)*UV(231)
  JUV(14) = JVS(32)*UV(14)+JVS(33)*UV(231)
  JUV(15) = JVS(34)*UV(15)+JVS(35)*UV(231)
  JUV(16) = JVS(36)*UV(16)+JVS(37)*UV(231)
  JUV(17) = JVS(38)*UV(17)+JVS(39)*UV(231)
  JUV(18) = JVS(40)*UV(18)+JVS(41)*UV(231)
  JUV(19) = JVS(42)*UV(19)+JVS(43)*UV(231)
  JUV(20) = JVS(44)*UV(20)+JVS(45)*UV(231)
  JUV(21) = JVS(46)*UV(21)+JVS(47)*UV(231)
  JUV(22) = JVS(48)*UV(22)+JVS(49)*UV(231)
  JUV(23) = JVS(50)*UV(23)+JVS(51)*UV(231)
  JUV(24) = JVS(52)*UV(24)+JVS(53)*UV(231)
  JUV(25) = JVS(54)*UV(25)+JVS(55)*UV(231)
  JUV(26) = JVS(56)*UV(26)+JVS(57)*UV(231)
  JUV(27) = JVS(58)*UV(27)+JVS(59)*UV(231)
  JUV(28) = JVS(60)*UV(28)+JVS(61)*UV(231)
  JUV(29) = JVS(62)*UV(29)+JVS(63)*UV(231)
  JUV(30) = JVS(64)*UV(30)+JVS(65)*UV(231)
  JUV(31) = JVS(66)*UV(31)+JVS(67)*UV(231)
  JUV(32) = JVS(68)*UV(32)+JVS(69)*UV(230)+JVS(70)*UV(232)
  JUV(33) = JVS(71)*UV(33)+JVS(72)*UV(231)
  JUV(34) = JVS(73)*UV(34)+JVS(74)*UV(97)+JVS(75)*UV(231)
  JUV(35) = JVS(76)*UV(35)+JVS(77)*UV(210)+JVS(78)*UV(232)
  JUV(36) = JVS(79)*UV(36)+JVS(80)*UV(231)
  JUV(37) = JVS(81)*UV(37)+JVS(82)*UV(210)+JVS(83)*UV(231)
  JUV(38) = JVS(84)*UV(38)+JVS(85)*UV(81)+JVS(86)*UV(231)
  JUV(39) = JVS(87)*UV(39)+JVS(88)*UV(102)+JVS(89)*UV(103)+JVS(90)*UV(231)
  JUV(40) = JVS(91)*UV(40)+JVS(92)*UV(165)+JVS(93)*UV(223)+JVS(94)*UV(231)
  JUV(41) = JVS(95)*UV(41)+JVS(96)*UV(229)+JVS(97)*UV(231)
  JUV(42) = JVS(98)*UV(42)+JVS(99)*UV(109)+JVS(100)*UV(231)
  JUV(43) = JVS(101)*UV(43)+JVS(102)*UV(214)+JVS(103)*UV(231)
  JUV(44) = JVS(104)*UV(44)+JVS(105)*UV(156)+JVS(106)*UV(231)
  JUV(45) = JVS(107)*UV(45)+JVS(108)*UV(116)+JVS(109)*UV(231)
  JUV(46) = JVS(110)*UV(36)+JVS(111)*UV(46)+JVS(112)*UV(154)+JVS(113)*UV(177)+JVS(114)*UV(223)+JVS(115)*UV(231)
  JUV(47) = JVS(116)*UV(30)+JVS(117)*UV(47)+JVS(118)*UV(230)+JVS(119)*UV(231)
  JUV(48) = JVS(120)*UV(47)+JVS(121)*UV(48)+JVS(122)*UV(230)+JVS(123)*UV(231)+JVS(124)*UV(232)
  JUV(49) = JVS(125)*UV(31)+JVS(126)*UV(49)+JVS(127)*UV(230)+JVS(128)*UV(231)
  JUV(50) = JVS(129)*UV(49)+JVS(130)*UV(50)+JVS(131)*UV(230)+JVS(132)*UV(231)+JVS(133)*UV(232)
  JUV(51) = JVS(134)*UV(51)+JVS(135)*UV(216)+JVS(136)*UV(231)
  JUV(52) = JVS(137)*UV(52)+JVS(138)*UV(150)+JVS(139)*UV(161)+JVS(140)*UV(223)+JVS(141)*UV(231)
  JUV(53) = JVS(142)*UV(53)+JVS(143)*UV(171)+JVS(144)*UV(223)+JVS(145)*UV(228)+JVS(146)*UV(232)
  JUV(54) = JVS(147)*UV(54)+JVS(148)*UV(218)+JVS(149)*UV(229)+JVS(150)*UV(231)
  JUV(55) = JVS(151)*UV(55)+JVS(152)*UV(213)+JVS(153)*UV(229)+JVS(154)*UV(231)
  JUV(56) = JVS(155)*UV(56)+JVS(156)*UV(216)+JVS(157)*UV(228)+JVS(158)*UV(231)
  JUV(57) = JVS(159)*UV(57)+JVS(160)*UV(206)+JVS(161)*UV(228)+JVS(162)*UV(231)
  JUV(58) = JVS(163)*UV(58)+JVS(164)*UV(221)+JVS(165)*UV(228)+JVS(166)*UV(231)
  JUV(59) = JVS(167)*UV(59)+JVS(168)*UV(208)+JVS(169)*UV(228)+JVS(170)*UV(231)
  JUV(60) = JVS(171)*UV(60)+JVS(172)*UV(148)+JVS(173)*UV(228)+JVS(174)*UV(231)
  JUV(61) = JVS(175)*UV(61)+JVS(176)*UV(145)+JVS(177)*UV(228)+JVS(178)*UV(231)
  JUV(62) = JVS(179)*UV(62)+JVS(180)*UV(204)+JVS(181)*UV(228)+JVS(182)*UV(231)
  JUV(63) = JVS(183)*UV(63)+JVS(184)*UV(228)+JVS(185)*UV(231)+JVS(186)*UV(232)
  JUV(64) = JVS(187)*UV(64)+JVS(188)*UV(180)+JVS(189)*UV(229)+JVS(190)*UV(231)
  JUV(65) = JVS(191)*UV(65)+JVS(192)*UV(144)+JVS(193)*UV(228)+JVS(194)*UV(231)
  JUV(66) = JVS(195)*UV(66)+JVS(196)*UV(198)+JVS(197)*UV(229)+JVS(198)*UV(231)
  JUV(67) = JVS(199)*UV(67)+JVS(200)*UV(193)+JVS(201)*UV(229)+JVS(202)*UV(231)
  JUV(68) = JVS(203)*UV(68)+JVS(204)*UV(193)+JVS(205)*UV(228)+JVS(206)*UV(231)
  JUV(69) = JVS(207)*UV(69)+JVS(208)*UV(222)+JVS(209)*UV(228)+JVS(210)*UV(231)
  JUV(70) = JVS(211)*UV(70)+JVS(212)*UV(146)+JVS(213)*UV(228)+JVS(214)*UV(231)
  JUV(71) = JVS(215)*UV(71)+JVS(216)*UV(212)+JVS(217)*UV(228)+JVS(218)*UV(231)
  JUV(72) = JVS(219)*UV(72)+JVS(220)*UV(158)+JVS(221)*UV(228)+JVS(222)*UV(231)
  JUV(73) = JVS(223)*UV(73)+JVS(224)*UV(214)+JVS(225)*UV(228)+JVS(226)*UV(231)
  JUV(74) = JVS(227)*UV(74)+JVS(228)*UV(156)+JVS(229)*UV(228)+JVS(230)*UV(231)
  JUV(75) = JVS(231)*UV(75)+JVS(232)*UV(215)+JVS(233)*UV(228)+JVS(234)*UV(231)
  JUV(76) = JVS(235)*UV(76)+JVS(236)*UV(219)+JVS(237)*UV(228)+JVS(238)*UV(231)
  JUV(77) = JVS(239)*UV(77)+JVS(240)*UV(153)+JVS(241)*UV(155)+JVS(242)*UV(170)+JVS(243)*UV(183)+JVS(244)*UV(231)
  JUV(78) = JVS(245)*UV(78)+JVS(246)*UV(162)+JVS(247)*UV(231)
  JUV(79) = JVS(248)*UV(79)+JVS(249)*UV(224)+JVS(250)*UV(229)+JVS(251)*UV(231)
  JUV(80) = JVS(252)*UV(80)+JVS(253)*UV(178)+JVS(254)*UV(224)+JVS(255)*UV(228)+JVS(256)*UV(231)
  JUV(81) = JVS(257)*UV(81)+JVS(258)*UV(220)+JVS(259)*UV(228)+JVS(260)*UV(231)
  JUV(82) = JVS(261)*UV(82)+JVS(262)*UV(213)+JVS(263)*UV(228)+JVS(264)*UV(231)
  JUV(83) = JVS(265)*UV(83)+JVS(266)*UV(167)+JVS(267)*UV(228)+JVS(268)*UV(231)
  JUV(84) = JVS(269)*UV(84)+JVS(270)*UV(156)+JVS(271)*UV(229)+JVS(272)*UV(231)
  JUV(85) = JVS(273)*UV(85)+JVS(274)*UV(188)+JVS(275)*UV(228)+JVS(276)*UV(231)
  JUV(86) = JVS(277)*UV(86)+JVS(278)*UV(200)+JVS(279)*UV(228)+JVS(280)*UV(231)
  JUV(87) = JVS(281)*UV(87)+JVS(282)*UV(201)+JVS(283)*UV(231)+JVS(284)*UV(232)
  JUV(88) = JVS(285)*UV(88)+JVS(286)*UV(186)+JVS(287)*UV(228)+JVS(288)*UV(231)
  JUV(89) = JVS(289)*UV(89)+JVS(290)*UV(164)+JVS(291)*UV(228)+JVS(292)*UV(231)
  JUV(90) = JVS(293)*UV(90)+JVS(294)*UV(210)+JVS(295)*UV(229)+JVS(296)*UV(231)
  JUV(91) = JVS(297)*UV(91)+JVS(298)*UV(214)+JVS(299)*UV(229)+JVS(300)*UV(231)
  JUV(92) = JVS(301)*UV(92)+JVS(302)*UV(182)+JVS(303)*UV(228)+JVS(304)*UV(231)
  JUV(93) = JVS(305)*UV(93)+JVS(306)*UV(210)+JVS(307)*UV(228)+JVS(308)*UV(231)
  JUV(94) = JVS(309)*UV(94)+JVS(310)*UV(216)+JVS(311)*UV(229)+JVS(312)*UV(231)
  JUV(95) = JVS(313)*UV(95)+JVS(314)*UV(205)+JVS(315)*UV(228)+JVS(316)*UV(231)
  JUV(96) = JVS(317)*UV(96)+JVS(318)*UV(184)+JVS(319)*UV(228)+JVS(320)*UV(231)
  JUV(97) = JVS(321)*UV(97)+JVS(322)*UV(212)+JVS(323)*UV(229)+JVS(324)*UV(231)
  JUV(98) = JVS(325)*UV(98)+JVS(326)*UV(206)+JVS(327)*UV(229)+JVS(328)*UV(231)
  JUV(99) = JVS(329)*UV(99)+JVS(330)*UV(185)+JVS(331)*UV(229)+JVS(332)*UV(231)
  JUV(100) = JVS(333)*UV(100)+JVS(334)*UV(215)+JVS(335)*UV(229)+JVS(336)*UV(231)
  JUV(101) = JVS(337)*UV(101)+JVS(338)*UV(198)+JVS(339)*UV(228)+JVS(340)*UV(231)
  JUV(102) = JVS(341)*UV(102)+JVS(342)*UV(211)+JVS(343)*UV(229)+JVS(344)*UV(231)
  JUV(103) = JVS(345)*UV(103)+JVS(346)*UV(211)+JVS(347)*UV(228)+JVS(348)*UV(231)
  JUV(104) = JVS(349)*UV(104)+JVS(350)*UV(209)+JVS(351)*UV(225)+JVS(352)*UV(229)+JVS(353)*UV(231)
  JUV(105) = JVS(354)*UV(105)+JVS(355)*UV(174)+JVS(356)*UV(202)+JVS(357)*UV(229)+JVS(358)*UV(231)
  JUV(106) = JVS(359)*UV(106)+JVS(360)*UV(176)+JVS(361)*UV(228)+JVS(362)*UV(231)
  JUV(107) = JVS(363)*UV(107)+JVS(364)*UV(159)+JVS(365)*UV(165)+JVS(366)*UV(191)+JVS(367)*UV(203)+JVS(368)*UV(223)&
               &+JVS(369)*UV(228)+JVS(370)*UV(231)
  JUV(108) = JVS(371)*UV(75)+JVS(372)*UV(100)+JVS(373)*UV(108)+JVS(374)*UV(159)+JVS(375)*UV(215)+JVS(376)*UV(223)&
               &+JVS(378)*UV(229)+JVS(379)*UV(230)+JVS(380)*UV(231)
  JUV(109) = JVS(381)*UV(109)+JVS(382)*UV(230)+JVS(383)*UV(231)
  JUV(110) = JVS(384)*UV(42)+JVS(386)*UV(110)+JVS(387)*UV(230)+JVS(388)*UV(231)
  JUV(111) = JVS(389)*UV(109)+JVS(390)*UV(111)+JVS(391)*UV(229)+JVS(392)*UV(230)+JVS(393)*UV(231)
  JUV(112) = JVS(394)*UV(112)+JVS(395)*UV(204)+JVS(396)*UV(231)+JVS(397)*UV(232)
  JUV(113) = JVS(398)*UV(113)+JVS(399)*UV(188)+JVS(400)*UV(231)+JVS(401)*UV(232)
  JUV(114) = JVS(402)*UV(114)+JVS(403)*UV(180)+JVS(404)*UV(228)+JVS(405)*UV(231)
  JUV(115) = JVS(406)*UV(115)+JVS(407)*UV(201)+JVS(408)*UV(228)+JVS(409)*UV(231)
  JUV(116) = JVS(410)*UV(116)+JVS(411)*UV(217)+JVS(412)*UV(228)+JVS(413)*UV(231)
  JUV(117) = JVS(414)*UV(117)+JVS(415)*UV(200)+JVS(416)*UV(231)+JVS(417)*UV(232)
  JUV(118) = JVS(418)*UV(118)+JVS(419)*UV(218)+JVS(420)*UV(228)+JVS(421)*UV(231)
  JUV(119) = JVS(422)*UV(119)+JVS(423)*UV(164)+JVS(424)*UV(229)+JVS(425)*UV(231)
  JUV(120) = JVS(426)*UV(48)+JVS(427)*UV(120)+JVS(428)*UV(230)+JVS(429)*UV(231)+JVS(430)*UV(232)
  JUV(121) = JVS(431)*UV(121)+JVS(432)*UV(182)+JVS(433)*UV(229)+JVS(434)*UV(231)
  JUV(122) = JVS(435)*UV(50)+JVS(436)*UV(122)+JVS(437)*UV(230)+JVS(438)*UV(231)+JVS(439)*UV(232)
  JUV(123) = JVS(440)*UV(123)+JVS(441)*UV(222)+JVS(442)*UV(231)+JVS(443)*UV(232)
  JUV(124) = JVS(444)*UV(124)+JVS(445)*UV(194)+JVS(446)*UV(228)+JVS(447)*UV(231)
  JUV(125) = JVS(448)*UV(125)+JVS(449)*UV(185)+JVS(450)*UV(228)+JVS(451)*UV(231)
  JUV(126) = JVS(452)*UV(126)+JVS(453)*UV(169)+JVS(454)*UV(228)+JVS(455)*UV(231)
  JUV(127) = JVS(456)*UV(127)+JVS(457)*UV(171)+JVS(458)*UV(172)+JVS(459)*UV(173)+JVS(460)*UV(231)+JVS(461)*UV(232)
  JUV(128) = JVS(462)*UV(128)+JVS(463)*UV(176)+JVS(464)*UV(229)+JVS(465)*UV(231)
  JUV(129) = JVS(466)*UV(129)+JVS(467)*UV(219)+JVS(468)*UV(231)+JVS(469)*UV(232)
  JUV(130) = JVS(470)*UV(130)+JVS(471)*UV(174)+JVS(472)*UV(202)+JVS(473)*UV(228)+JVS(474)*UV(231)
  JUV(131) = JVS(475)*UV(131)+JVS(476)*UV(189)+JVS(477)*UV(196)+JVS(478)*UV(228)+JVS(479)*UV(231)
  JUV(132) = JVS(480)*UV(57)+JVS(481)*UV(98)+JVS(482)*UV(132)+JVS(486)*UV(231)
  JUV(133) = JVS(487)*UV(99)+JVS(488)*UV(125)+JVS(489)*UV(126)+JVS(490)*UV(133)+JVS(491)*UV(159)+JVS(492)*UV(169)&
               &+JVS(493)*UV(185)+JVS(494)*UV(223)+JVS(496)*UV(229)+JVS(497)*UV(230)+JVS(498)*UV(231)
  JUV(134) = JVS(499)*UV(134)+JVS(500)*UV(157)+JVS(501)*UV(197)+JVS(502)*UV(228)+JVS(503)*UV(231)
  JUV(135) = JVS(504)*UV(135)+JVS(505)*UV(226)+JVS(506)*UV(229)+JVS(507)*UV(231)
  JUV(136) = JVS(508)*UV(78)+JVS(509)*UV(136)+JVS(511)*UV(230)+JVS(512)*UV(231)
  JUV(137) = JVS(513)*UV(137)+JVS(514)*UV(209)+JVS(515)*UV(225)+JVS(516)*UV(228)+JVS(517)*UV(231)
  JUV(138) = JVS(518)*UV(79)+JVS(519)*UV(80)+JVS(520)*UV(138)+JVS(525)*UV(231)
  JUV(139) = JVS(526)*UV(139)+JVS(527)*UV(189)+JVS(528)*UV(196)+JVS(529)*UV(229)+JVS(530)*UV(231)
  JUV(140) = JVS(531)*UV(55)+JVS(532)*UV(82)+JVS(533)*UV(140)+JVS(537)*UV(231)
  JUV(141) = JVS(538)*UV(135)+JVS(539)*UV(141)+JVS(540)*UV(175)+JVS(541)*UV(226)+JVS(542)*UV(229)+JVS(543)*UV(230)&
               &+JVS(544)*UV(231)
  JUV(142) = JVS(545)*UV(142)+JVS(546)*UV(157)+JVS(547)*UV(197)+JVS(548)*UV(229)+JVS(549)*UV(231)
  JUV(143) = JVS(550)*UV(111)+JVS(551)*UV(143)+JVS(552)*UV(223)+JVS(553)*UV(229)+JVS(556)*UV(232)
  JUV(144) = JVS(557)*UV(144)+JVS(558)*UV(177)+JVS(559)*UV(228)+JVS(560)*UV(229)+JVS(561)*UV(230)
  JUV(145) = JVS(562)*UV(145)+JVS(563)*UV(161)+JVS(564)*UV(228)+JVS(565)*UV(229)+JVS(566)*UV(230)
  JUV(146) = JVS(567)*UV(146)+JVS(568)*UV(165)+JVS(569)*UV(228)+JVS(570)*UV(229)+JVS(571)*UV(230)
  JUV(147) = JVS(572)*UV(59)+JVS(573)*UV(140)+JVS(574)*UV(147)+JVS(575)*UV(196)+JVS(576)*UV(197)+JVS(580)*UV(229)&
               &+JVS(581)*UV(230)+JVS(582)*UV(231)
  JUV(148) = JVS(583)*UV(148)+JVS(584)*UV(154)+JVS(585)*UV(228)+JVS(586)*UV(229)+JVS(587)*UV(230)
  JUV(149) = JVS(588)*UV(149)+JVS(589)*UV(215)+JVS(590)*UV(228)+JVS(591)*UV(229)+JVS(592)*UV(230)
  JUV(150) = JVS(593)*UV(150)+JVS(594)*UV(223)+JVS(595)*UV(230)+JVS(596)*UV(231)
  JUV(151) = JVS(597)*UV(36)+JVS(598)*UV(89)+JVS(599)*UV(92)+JVS(600)*UV(119)+JVS(601)*UV(121)+JVS(602)*UV(151)+JVS(603)&
               &*UV(164)+JVS(604)*UV(182)+JVS(605)*UV(189)+JVS(606)*UV(196)+JVS(608)*UV(229)+JVS(609)*UV(230)+JVS(610)&
               &*UV(231)
  JUV(152) = JVS(611)*UV(65)+JVS(612)*UV(144)+JVS(613)*UV(152)+JVS(616)*UV(229)+JVS(617)*UV(230)+JVS(618)*UV(231)
  JUV(153) = JVS(619)*UV(106)+JVS(620)*UV(128)+JVS(621)*UV(153)+JVS(622)*UV(176)+JVS(624)*UV(229)+JVS(625)*UV(230)&
               &+JVS(626)*UV(231)
  JUV(154) = JVS(627)*UV(154)+JVS(628)*UV(223)+JVS(629)*UV(230)+JVS(630)*UV(231)
  JUV(155) = JVS(631)*UV(89)+JVS(632)*UV(119)+JVS(633)*UV(155)+JVS(634)*UV(164)+JVS(635)*UV(182)+JVS(636)*UV(196)&
               &+JVS(638)*UV(229)+JVS(639)*UV(230)+JVS(640)*UV(231)
  JUV(156) = JVS(641)*UV(26)+JVS(642)*UV(156)+JVS(643)*UV(228)+JVS(644)*UV(229)+JVS(645)*UV(230)+JVS(646)*UV(231)
  JUV(157) = JVS(647)*UV(21)+JVS(648)*UV(22)+JVS(649)*UV(23)+JVS(650)*UV(24)+JVS(651)*UV(28)+JVS(652)*UV(29)+JVS(653)&
               &*UV(157)+JVS(654)*UV(228)+JVS(655)*UV(229)+JVS(656)*UV(230)+JVS(657)*UV(231)
  JUV(158) = JVS(658)*UV(71)+JVS(659)*UV(72)+JVS(660)*UV(158)+JVS(661)*UV(212)+JVS(662)*UV(228)+JVS(663)*UV(229)&
               &+JVS(664)*UV(230)+JVS(665)*UV(231)
  JUV(159) = JVS(666)*UV(159)+JVS(667)*UV(223)+JVS(668)*UV(230)+JVS(669)*UV(231)
  JUV(160) = JVS(670)*UV(124)+JVS(671)*UV(160)+JVS(672)*UV(194)+JVS(674)*UV(229)+JVS(675)*UV(230)+JVS(676)*UV(231)
  JUV(161) = JVS(677)*UV(161)+JVS(678)*UV(223)+JVS(679)*UV(230)+JVS(680)*UV(231)
  JUV(162) = JVS(681)*UV(162)+JVS(682)*UV(205)+JVS(683)*UV(229)+JVS(684)*UV(231)
  JUV(163) = JVS(685)*UV(88)+JVS(686)*UV(152)+JVS(687)*UV(163)+JVS(689)*UV(186)+JVS(691)*UV(229)+JVS(692)*UV(230)&
               &+JVS(693)*UV(231)
  JUV(164) = JVS(694)*UV(30)+JVS(695)*UV(164)+JVS(696)*UV(228)+JVS(697)*UV(229)+JVS(698)*UV(230)+JVS(699)*UV(231)
  JUV(165) = JVS(700)*UV(165)+JVS(701)*UV(223)+JVS(702)*UV(230)+JVS(703)*UV(231)
  JUV(166) = JVS(704)*UV(67)+JVS(705)*UV(68)+JVS(706)*UV(70)+JVS(707)*UV(146)+JVS(708)*UV(165)+JVS(709)*UV(166)+JVS(710)&
               &*UV(193)+JVS(711)*UV(223)+JVS(713)*UV(229)+JVS(714)*UV(230)+JVS(715)*UV(231)
  JUV(167) = JVS(716)*UV(150)+JVS(717)*UV(167)+JVS(719)*UV(228)+JVS(720)*UV(229)+JVS(721)*UV(230)
  JUV(168) = JVS(723)*UV(104)+JVS(724)*UV(120)+JVS(725)*UV(137)+JVS(726)*UV(168)+JVS(728)*UV(225)+JVS(730)*UV(229)&
               &+JVS(731)*UV(230)+JVS(732)*UV(231)
  JUV(169) = JVS(734)*UV(126)+JVS(735)*UV(159)+JVS(736)*UV(169)+JVS(738)*UV(228)+JVS(739)*UV(229)+JVS(740)*UV(230)&
               &+JVS(741)*UV(231)
  JUV(170) = JVS(742)*UV(134)+JVS(743)*UV(142)+JVS(744)*UV(157)+JVS(745)*UV(170)+JVS(746)*UV(189)+JVS(747)*UV(196)&
               &+JVS(750)*UV(229)+JVS(751)*UV(230)+JVS(752)*UV(231)
  JUV(171) = JVS(753)*UV(110)+JVS(754)*UV(171)+JVS(755)*UV(172)+JVS(756)*UV(223)+JVS(757)*UV(230)+JVS(758)*UV(231)&
               &+JVS(759)*UV(232)
  JUV(172) = JVS(760)*UV(143)+JVS(761)*UV(172)+JVS(762)*UV(223)+JVS(766)*UV(232)
  JUV(173) = JVS(767)*UV(8)+JVS(768)*UV(127)+JVS(771)*UV(173)+JVS(772)*UV(223)+JVS(773)*UV(229)+JVS(774)*UV(230)&
               &+JVS(776)*UV(232)
  JUV(174) = JVS(777)*UV(98)+JVS(778)*UV(174)+JVS(780)*UV(228)+JVS(781)*UV(229)+JVS(782)*UV(230)
  JUV(175) = JVS(784)*UV(149)+JVS(785)*UV(175)+JVS(787)*UV(226)+JVS(788)*UV(228)+JVS(791)*UV(231)
  JUV(176) = JVS(792)*UV(25)+JVS(793)*UV(176)+JVS(794)*UV(228)+JVS(795)*UV(229)+JVS(796)*UV(230)+JVS(797)*UV(231)
  JUV(177) = JVS(798)*UV(177)+JVS(799)*UV(223)+JVS(800)*UV(230)+JVS(801)*UV(231)
  JUV(178) = JVS(802)*UV(178)+JVS(803)*UV(220)+JVS(804)*UV(228)+JVS(805)*UV(229)+JVS(806)*UV(230)
  JUV(179) = JVS(807)*UV(54)+JVS(808)*UV(117)+JVS(809)*UV(118)+JVS(810)*UV(179)+JVS(811)*UV(200)+JVS(812)*UV(201)&
               &+JVS(815)*UV(229)+JVS(816)*UV(230)+JVS(817)*UV(231)
  JUV(180) = JVS(819)*UV(177)+JVS(820)*UV(180)+JVS(822)*UV(228)+JVS(823)*UV(229)+JVS(824)*UV(230)+JVS(825)*UV(231)
  JUV(181) = JVS(826)*UV(105)+JVS(827)*UV(122)+JVS(828)*UV(123)+JVS(829)*UV(130)+JVS(831)*UV(181)+JVS(832)*UV(202)&
               &+JVS(836)*UV(229)+JVS(837)*UV(230)+JVS(838)*UV(231)
  JUV(182) = JVS(840)*UV(31)+JVS(841)*UV(182)+JVS(842)*UV(228)+JVS(843)*UV(229)+JVS(844)*UV(230)+JVS(845)*UV(231)
  JUV(183) = JVS(846)*UV(92)+JVS(847)*UV(121)+JVS(848)*UV(131)+JVS(849)*UV(139)+JVS(850)*UV(182)+JVS(851)*UV(183)&
               &+JVS(854)*UV(197)+JVS(856)*UV(229)+JVS(857)*UV(230)+JVS(858)*UV(231)
  JUV(184) = JVS(859)*UV(96)+JVS(860)*UV(136)+JVS(861)*UV(160)+JVS(863)*UV(184)+JVS(866)*UV(228)+JVS(867)*UV(229)&
               &+JVS(868)*UV(230)+JVS(869)*UV(231)
  JUV(185) = JVS(870)*UV(125)+JVS(871)*UV(159)+JVS(872)*UV(185)+JVS(874)*UV(228)+JVS(875)*UV(229)+JVS(876)*UV(230)&
               &+JVS(877)*UV(231)
  JUV(186) = JVS(878)*UV(152)+JVS(880)*UV(186)+JVS(882)*UV(228)+JVS(883)*UV(229)+JVS(884)*UV(230)+JVS(885)*UV(231)
  JUV(187) = JVS(886)*UV(36)+JVS(887)*UV(88)+JVS(888)*UV(96)+JVS(889)*UV(112)+JVS(890)*UV(113)+JVS(891)*UV(117)+JVS(892)&
               &*UV(129)+JVS(893)*UV(136)+JVS(894)*UV(150)+JVS(895)*UV(151)+JVS(896)*UV(152)+JVS(897)*UV(154)+JVS(898)&
               &*UV(159)+JVS(899)*UV(160)+JVS(900)*UV(161)+JVS(903)*UV(177)+JVS(905)*UV(184)+JVS(906)*UV(186)+JVS(907)&
               &*UV(187)+JVS(910)*UV(190)+JVS(911)*UV(191)+JVS(914)*UV(199)+JVS(916)*UV(201)+JVS(917)*UV(203)+JVS(920)&
               &*UV(207)+JVS(922)*UV(223)+JVS(923)*UV(227)+JVS(925)*UV(229)+JVS(926)*UV(230)+JVS(927)*UV(231)+JVS(929)&
               &*UV(233)
  JUV(188) = JVS(930)*UV(78)+JVS(931)*UV(85)+JVS(932)*UV(113)+JVS(934)*UV(188)+JVS(935)*UV(199)+JVS(937)*UV(228)&
               &+JVS(938)*UV(229)+JVS(939)*UV(230)+JVS(940)*UV(231)+JVS(941)*UV(232)
  JUV(189) = JVS(942)*UV(27)+JVS(943)*UV(189)+JVS(944)*UV(228)+JVS(945)*UV(229)+JVS(946)*UV(230)+JVS(947)*UV(231)
  JUV(190) = JVS(948)*UV(58)+JVS(949)*UV(106)+JVS(950)*UV(115)+JVS(951)*UV(128)+JVS(952)*UV(131)+JVS(953)*UV(134)&
               &+JVS(954)*UV(139)+JVS(955)*UV(142)+JVS(956)*UV(157)+JVS(957)*UV(163)+JVS(958)*UV(176)+JVS(960)*UV(179)&
               &+JVS(961)*UV(182)+JVS(964)*UV(190)+JVS(965)*UV(191)+JVS(968)*UV(200)+JVS(970)*UV(203)+JVS(973)*UV(223)&
               &+JVS(975)*UV(229)+JVS(976)*UV(230)+JVS(977)*UV(231)
  JUV(191) = JVS(979)*UV(64)+JVS(980)*UV(114)+JVS(981)*UV(180)+JVS(982)*UV(191)+JVS(983)*UV(223)+JVS(985)*UV(229)&
               &+JVS(986)*UV(230)+JVS(987)*UV(231)
  JUV(192) = JVS(988)*UV(47)+JVS(989)*UV(49)+JVS(990)*UV(109)+JVS(991)*UV(110)+JVS(992)*UV(120)+JVS(993)*UV(122)&
               &+JVS(994)*UV(136)+JVS(995)*UV(160)+JVS(997)*UV(166)+JVS(998)*UV(191)+JVS(999)*UV(192)+JVS(1002)*UV(199)&
               &+JVS(1003)*UV(203)+JVS(1005)*UV(207)+JVS(1007)*UV(227)+JVS(1010)*UV(230)+JVS(1011)*UV(231)+JVS(1012)*UV(232)&
               &+JVS(1013)*UV(233)
  JUV(193) = JVS(1014)*UV(165)+JVS(1015)*UV(193)+JVS(1017)*UV(228)+JVS(1018)*UV(229)+JVS(1019)*UV(230)+JVS(1020)*UV(231)
  JUV(194) = JVS(1021)*UV(95)+JVS(1022)*UV(124)+JVS(1023)*UV(194)+JVS(1024)*UV(205)+JVS(1025)*UV(228)+JVS(1026)*UV(229)&
               &+JVS(1027)*UV(230)+JVS(1028)*UV(231)
  JUV(195) = JVS(1029)*UV(44)+JVS(1030)*UV(74)+JVS(1031)*UV(84)+JVS(1032)*UV(95)+JVS(1033)*UV(97)+JVS(1034)*UV(102)&
               &+JVS(1035)*UV(103)+JVS(1036)*UV(123)+JVS(1037)*UV(156)+JVS(1038)*UV(162)+JVS(1039)*UV(165)+JVS(1040)*UV(185)&
               &+JVS(1041)*UV(193)+JVS(1042)*UV(195)+JVS(1043)*UV(205)+JVS(1044)*UV(211)+JVS(1046)*UV(215)+JVS(1048)*UV(223)&
               &+JVS(1050)*UV(229)+JVS(1051)*UV(230)+JVS(1052)*UV(231)
  JUV(196) = JVS(1054)*UV(27)+JVS(1055)*UV(196)+JVS(1056)*UV(228)+JVS(1057)*UV(229)+JVS(1058)*UV(230)+JVS(1059)*UV(231)
  JUV(197) = JVS(1060)*UV(28)+JVS(1061)*UV(29)+JVS(1062)*UV(197)+JVS(1063)*UV(228)+JVS(1064)*UV(229)+JVS(1065)*UV(230)&
               &+JVS(1066)*UV(231)
  JUV(198) = JVS(1067)*UV(16)+JVS(1068)*UV(17)+JVS(1069)*UV(18)+JVS(1070)*UV(19)+JVS(1071)*UV(43)+JVS(1072)*UV(77)&
               &+JVS(1074)*UV(154)+JVS(1084)*UV(198)+JVS(1087)*UV(228)+JVS(1088)*UV(229)+JVS(1089)*UV(230)+JVS(1090)*UV(231)
  JUV(199) = JVS(1091)*UV(66)+JVS(1092)*UV(86)+JVS(1093)*UV(101)+JVS(1094)*UV(115)+JVS(1095)*UV(191)+JVS(1096)*UV(198)&
               &+JVS(1097)*UV(199)+JVS(1098)*UV(200)+JVS(1099)*UV(201)+JVS(1101)*UV(223)+JVS(1103)*UV(229)+JVS(1104)*UV(230)&
               &+JVS(1105)*UV(231)
  JUV(200) = JVS(1106)*UV(86)+JVS(1107)*UV(117)+JVS(1108)*UV(200)+JVS(1109)*UV(203)+JVS(1110)*UV(228)+JVS(1111)*UV(229)&
               &+JVS(1112)*UV(230)+JVS(1113)*UV(231)+JVS(1114)*UV(232)
  JUV(201) = JVS(1115)*UV(87)+JVS(1116)*UV(115)+JVS(1117)*UV(191)+JVS(1118)*UV(201)+JVS(1120)*UV(228)+JVS(1121)*UV(229)&
               &+JVS(1122)*UV(230)+JVS(1123)*UV(231)+JVS(1124)*UV(232)
  JUV(202) = JVS(1125)*UV(57)+JVS(1126)*UV(165)+JVS(1127)*UV(202)+JVS(1128)*UV(206)+JVS(1129)*UV(223)+JVS(1130)*UV(228)&
               &+JVS(1131)*UV(229)+JVS(1132)*UV(230)
  JUV(203) = JVS(1134)*UV(87)+JVS(1135)*UV(114)+JVS(1136)*UV(177)+JVS(1137)*UV(180)+JVS(1139)*UV(203)+JVS(1140)*UV(223)&
               &+JVS(1142)*UV(229)+JVS(1143)*UV(230)+JVS(1144)*UV(231)
  JUV(204) = JVS(1146)*UV(62)+JVS(1147)*UV(112)+JVS(1148)*UV(204)+JVS(1149)*UV(217)+JVS(1150)*UV(227)+JVS(1151)*UV(228)&
               &+JVS(1152)*UV(229)+JVS(1153)*UV(230)+JVS(1154)*UV(231)+JVS(1155)*UV(232)
  JUV(205) = JVS(1156)*UV(72)+JVS(1157)*UV(95)+JVS(1158)*UV(158)+JVS(1159)*UV(205)+JVS(1161)*UV(228)+JVS(1162)*UV(229)&
               &+JVS(1163)*UV(230)+JVS(1164)*UV(231)
  JUV(206) = JVS(1165)*UV(185)+JVS(1166)*UV(193)+JVS(1167)*UV(206)+JVS(1169)*UV(228)+JVS(1170)*UV(229)+JVS(1171)*UV(230)
  JUV(207) = JVS(1173)*UV(37)+JVS(1174)*UV(60)+JVS(1175)*UV(83)+JVS(1176)*UV(85)+JVS(1177)*UV(90)+JVS(1178)*UV(93)&
               &+JVS(1179)*UV(99)+JVS(1180)*UV(101)+JVS(1181)*UV(111)+JVS(1182)*UV(113)+JVS(1183)*UV(114)+JVS(1184)*UV(118)&
               &+JVS(1185)*UV(124)+JVS(1186)*UV(125)+JVS(1187)*UV(126)+JVS(1188)*UV(129)+JVS(1189)*UV(148)+JVS(1190)*UV(150)&
               &+JVS(1191)*UV(154)+JVS(1192)*UV(159)+JVS(1193)*UV(163)+JVS(1194)*UV(167)+JVS(1195)*UV(169)+JVS(1197)*UV(179)&
               &+JVS(1198)*UV(180)+JVS(1199)*UV(185)+JVS(1201)*UV(188)+JVS(1202)*UV(194)+JVS(1203)*UV(198)+JVS(1204)*UV(199)&
               &+JVS(1205)*UV(200)+JVS(1207)*UV(203)+JVS(1209)*UV(207)+JVS(1210)*UV(210)+JVS(1213)*UV(215)+JVS(1214)*UV(218)&
               &+JVS(1216)*UV(221)+JVS(1217)*UV(223)+JVS(1219)*UV(229)+JVS(1220)*UV(230)+JVS(1221)*UV(231)
  JUV(208) = JVS(1223)*UV(33)+JVS(1224)*UV(141)+JVS(1226)*UV(208)+JVS(1229)*UV(228)+JVS(1230)*UV(229)+JVS(1231)*UV(230)&
               &+JVS(1232)*UV(231)
  JUV(209) = JVS(1233)*UV(38)+JVS(1234)*UV(79)+JVS(1236)*UV(178)+JVS(1237)*UV(209)+JVS(1240)*UV(228)+JVS(1241)*UV(229)&
               &+JVS(1242)*UV(230)+JVS(1243)*UV(231)
  JUV(210) = JVS(1244)*UV(12)+JVS(1245)*UV(13)+JVS(1246)*UV(14)+JVS(1247)*UV(20)+JVS(1248)*UV(35)+JVS(1249)*UV(42)&
               &+JVS(1250)*UV(52)+JVS(1251)*UV(53)+JVS(1252)*UV(76)+JVS(1253)*UV(93)+JVS(1255)*UV(150)+JVS(1256)*UV(161)&
               &+JVS(1257)*UV(171)+JVS(1258)*UV(172)+JVS(1259)*UV(183)+JVS(1261)*UV(195)+JVS(1265)*UV(210)+JVS(1269)*UV(219)&
               &+JVS(1271)*UV(223)+JVS(1272)*UV(228)+JVS(1273)*UV(229)+JVS(1274)*UV(230)+JVS(1275)*UV(231)+JVS(1276)*UV(232)&
               &+JVS(1277)*UV(233)
  JUV(211) = JVS(1278)*UV(108)+JVS(1280)*UV(211)+JVS(1283)*UV(228)+JVS(1284)*UV(229)+JVS(1285)*UV(230)+JVS(1286)*UV(231)
  JUV(212) = JVS(1287)*UV(40)+JVS(1288)*UV(69)+JVS(1289)*UV(71)+JVS(1291)*UV(212)+JVS(1292)*UV(222)+JVS(1294)*UV(228)&
               &+JVS(1295)*UV(229)+JVS(1296)*UV(230)+JVS(1297)*UV(231)
  JUV(213) = JVS(1298)*UV(39)+JVS(1299)*UV(45)+JVS(1303)*UV(149)+JVS(1304)*UV(161)+JVS(1306)*UV(213)+JVS(1310)*UV(228)&
               &+JVS(1311)*UV(229)+JVS(1312)*UV(230)+JVS(1313)*UV(231)
  JUV(214) = JVS(1314)*UV(9)+JVS(1315)*UV(15)+JVS(1316)*UV(33)+JVS(1317)*UV(58)+JVS(1318)*UV(62)+JVS(1319)*UV(135)&
               &+JVS(1320)*UV(141)+JVS(1321)*UV(155)+JVS(1323)*UV(170)+JVS(1324)*UV(175)+JVS(1329)*UV(204)+JVS(1330)*UV(214)&
               &+JVS(1334)*UV(226)+JVS(1335)*UV(227)+JVS(1336)*UV(228)+JVS(1337)*UV(229)+JVS(1338)*UV(230)+JVS(1339)*UV(231)
  JUV(215) = JVS(1341)*UV(133)+JVS(1342)*UV(159)+JVS(1345)*UV(215)+JVS(1346)*UV(223)+JVS(1347)*UV(228)+JVS(1348)*UV(229)&
               &+JVS(1349)*UV(230)+JVS(1350)*UV(231)
  JUV(216) = JVS(1351)*UV(26)+JVS(1352)*UV(59)+JVS(1353)*UV(132)+JVS(1354)*UV(138)+JVS(1355)*UV(153)+JVS(1358)*UV(183)&
               &+JVS(1365)*UV(216)+JVS(1370)*UV(228)+JVS(1371)*UV(229)+JVS(1372)*UV(230)+JVS(1373)*UV(231)
  JUV(217) = JVS(1374)*UV(138)+JVS(1376)*UV(217)+JVS(1379)*UV(228)+JVS(1380)*UV(229)+JVS(1381)*UV(230)+JVS(1382)*UV(231)
  JUV(218) = JVS(1383)*UV(44)+JVS(1384)*UV(51)+JVS(1385)*UV(78)+JVS(1386)*UV(147)+JVS(1387)*UV(150)+JVS(1399)*UV(218)&
               &+JVS(1405)*UV(228)+JVS(1406)*UV(229)+JVS(1407)*UV(230)+JVS(1408)*UV(231)
  JUV(219) = JVS(1409)*UV(33)+JVS(1410)*UV(45)+JVS(1411)*UV(76)+JVS(1412)*UV(86)+JVS(1414)*UV(129)+JVS(1415)*UV(138)&
               &+JVS(1416)*UV(140)+JVS(1417)*UV(141)+JVS(1418)*UV(147)+JVS(1419)*UV(160)+JVS(1420)*UV(163)+JVS(1424)*UV(179)&
               &+JVS(1426)*UV(190)+JVS(1427)*UV(191)+JVS(1429)*UV(195)+JVS(1432)*UV(200)+JVS(1433)*UV(201)+JVS(1434)*UV(203)&
               &+JVS(1436)*UV(208)+JVS(1443)*UV(219)+JVS(1445)*UV(221)+JVS(1447)*UV(223)+JVS(1450)*UV(228)+JVS(1451)*UV(229)&
               &+JVS(1452)*UV(230)+JVS(1453)*UV(231)+JVS(1454)*UV(232)+JVS(1455)*UV(233)
  JUV(220) = JVS(1456)*UV(132)+JVS(1458)*UV(220)+JVS(1460)*UV(228)+JVS(1461)*UV(229)+JVS(1462)*UV(230)+JVS(1463)*UV(231)
  JUV(221) = JVS(1464)*UV(38)+JVS(1465)*UV(45)+JVS(1467)*UV(96)+JVS(1469)*UV(132)+JVS(1470)*UV(168)+JVS(1471)*UV(181)&
               &+JVS(1472)*UV(184)+JVS(1474)*UV(195)+JVS(1484)*UV(221)+JVS(1489)*UV(228)+JVS(1490)*UV(229)+JVS(1491)*UV(230)&
               &+JVS(1492)*UV(231)
  JUV(222) = JVS(1494)*UV(69)+JVS(1495)*UV(123)+JVS(1496)*UV(166)+JVS(1498)*UV(222)+JVS(1500)*UV(228)+JVS(1501)*UV(229)&
               &+JVS(1502)*UV(230)+JVS(1503)*UV(231)+JVS(1504)*UV(232)
  JUV(223) = JVS(1505)*UV(143)+JVS(1506)*UV(150)+JVS(1507)*UV(154)+JVS(1508)*UV(159)+JVS(1509)*UV(161)+JVS(1510)*UV(165)&
               &+JVS(1511)*UV(171)+JVS(1512)*UV(172)+JVS(1513)*UV(173)+JVS(1514)*UV(177)+JVS(1515)*UV(191)+JVS(1516)*UV(203)&
               &+JVS(1517)*UV(223)+JVS(1518)*UV(228)+JVS(1519)*UV(229)+JVS(1521)*UV(231)+JVS(1522)*UV(232)
  JUV(224) = JVS(1523)*UV(81)+JVS(1524)*UV(153)+JVS(1526)*UV(181)+JVS(1532)*UV(224)+JVS(1533)*UV(228)+JVS(1534)*UV(229)&
               &+JVS(1535)*UV(230)+JVS(1536)*UV(231)
  JUV(225) = JVS(1538)*UV(34)+JVS(1539)*UV(80)+JVS(1546)*UV(224)+JVS(1547)*UV(225)+JVS(1548)*UV(228)+JVS(1549)*UV(229)&
               &+JVS(1550)*UV(230)+JVS(1551)*UV(231)
  JUV(226) = JVS(1553)*UV(11)+JVS(1554)*UV(103)+JVS(1555)*UV(116)+JVS(1556)*UV(168)+JVS(1557)*UV(170)+JVS(1562)*UV(211)&
               &+JVS(1569)*UV(226)+JVS(1570)*UV(228)+JVS(1571)*UV(229)+JVS(1572)*UV(230)+JVS(1573)*UV(231)
  JUV(227) = JVS(1575)*UV(51)+JVS(1576)*UV(56)+JVS(1577)*UV(94)+JVS(1578)*UV(130)+JVS(1579)*UV(137)+JVS(1580)*UV(174)&
               &+JVS(1581)*UV(181)+JVS(1584)*UV(209)+JVS(1585)*UV(216)+JVS(1592)*UV(227)+JVS(1594)*UV(229)+JVS(1595)*UV(230)&
               &+JVS(1596)*UV(231)
  JUV(228) = JVS(1598)*UV(10)+JVS(1599)*UV(30)+JVS(1600)*UV(31)+JVS(1601)*UV(36)+JVS(1602)*UV(37)+JVS(1603)*UV(43)&
               &+JVS(1604)*UV(44)+JVS(1605)*UV(46)+JVS(1606)*UV(51)+JVS(1607)*UV(53)+JVS(1608)*UV(56)+JVS(1609)*UV(63)&
               &+JVS(1610)*UV(65)+JVS(1611)*UV(68)+JVS(1612)*UV(73)+JVS(1613)*UV(74)+JVS(1614)*UV(75)+JVS(1615)*UV(78)&
               &+JVS(1616)*UV(82)+JVS(1617)*UV(84)+JVS(1618)*UV(85)+JVS(1619)*UV(88)+JVS(1620)*UV(89)+JVS(1621)*UV(90)&
               &+JVS(1622)*UV(91)+JVS(1623)*UV(92)+JVS(1624)*UV(93)+JVS(1625)*UV(94)+JVS(1626)*UV(100)+JVS(1627)*UV(101)&
               &+JVS(1628)*UV(106)+JVS(1629)*UV(107)+JVS(1630)*UV(109)+JVS(1631)*UV(110)+JVS(1632)*UV(114)+JVS(1633)*UV(115)&
               &+JVS(1634)*UV(118)+JVS(1635)*UV(119)+JVS(1636)*UV(121)+JVS(1637)*UV(124)+JVS(1638)*UV(125)+JVS(1640)*UV(128)&
               &+JVS(1641)*UV(130)+JVS(1642)*UV(131)+JVS(1643)*UV(134)+JVS(1644)*UV(135)+JVS(1645)*UV(136)+JVS(1646)*UV(137)&
               &+JVS(1647)*UV(139)+JVS(1648)*UV(140)+JVS(1649)*UV(142)+JVS(1650)*UV(144)+JVS(1651)*UV(145)+JVS(1652)*UV(146)&
               &+JVS(1653)*UV(148)+JVS(1654)*UV(149)+JVS(1655)*UV(151)+JVS(1656)*UV(152)+JVS(1657)*UV(153)+JVS(1658)*UV(154)&
               &+JVS(1659)*UV(155)+JVS(1660)*UV(156)+JVS(1661)*UV(157)+JVS(1662)*UV(158)+JVS(1666)*UV(164)+JVS(1668)*UV(166)&
               &+JVS(1669)*UV(167)+JVS(1670)*UV(168)+JVS(1671)*UV(169)+JVS(1672)*UV(170)+JVS(1676)*UV(174)+JVS(1677)*UV(175)&
               &+JVS(1678)*UV(176)+JVS(1679)*UV(177)+JVS(1680)*UV(178)+JVS(1681)*UV(179)+JVS(1682)*UV(180)+JVS(1683)*UV(181)&
               &+JVS(1684)*UV(182)+JVS(1685)*UV(183)+JVS(1686)*UV(184)+JVS(1687)*UV(185)+JVS(1688)*UV(186)+JVS(1689)*UV(187)&
               &+JVS(1690)*UV(188)+JVS(1691)*UV(189)+JVS(1692)*UV(190)+JVS(1693)*UV(191)+JVS(1694)*UV(193)+JVS(1695)*UV(194)&
               &+JVS(1696)*UV(196)+JVS(1697)*UV(197)+JVS(1698)*UV(198)+JVS(1699)*UV(199)+JVS(1700)*UV(200)+JVS(1701)*UV(201)&
               &+JVS(1702)*UV(202)+JVS(1703)*UV(203)+JVS(1704)*UV(204)+JVS(1705)*UV(205)+JVS(1706)*UV(206)+JVS(1707)*UV(207)&
               &+JVS(1708)*UV(208)+JVS(1709)*UV(209)+JVS(1710)*UV(210)+JVS(1711)*UV(211)+JVS(1712)*UV(212)+JVS(1713)*UV(213)&
               &+JVS(1714)*UV(214)+JVS(1715)*UV(215)+JVS(1716)*UV(216)+JVS(1717)*UV(217)+JVS(1718)*UV(218)+JVS(1719)*UV(219)&
               &+JVS(1720)*UV(220)+JVS(1721)*UV(221)+JVS(1722)*UV(222)+JVS(1723)*UV(223)+JVS(1724)*UV(224)+JVS(1725)*UV(225)&
               &+JVS(1726)*UV(226)+JVS(1727)*UV(227)+JVS(1728)*UV(228)+JVS(1729)*UV(229)+JVS(1730)*UV(230)+JVS(1731)*UV(231)&
               &+JVS(1732)*UV(232)+JVS(1733)*UV(233)
  JUV(229) = JVS(1734)*UV(41)+JVS(1735)*UV(111)+JVS(1736)*UV(143)+JVS(1737)*UV(144)+JVS(1738)*UV(145)+JVS(1739)*UV(146)&
               &+JVS(1740)*UV(148)+JVS(1741)*UV(149)+JVS(1743)*UV(156)+JVS(1744)*UV(157)+JVS(1745)*UV(158)+JVS(1747)*UV(164)&
               &+JVS(1749)*UV(167)+JVS(1750)*UV(169)+JVS(1751)*UV(171)+JVS(1752)*UV(172)+JVS(1753)*UV(173)+JVS(1754)*UV(174)&
               &+JVS(1755)*UV(176)+JVS(1757)*UV(178)+JVS(1758)*UV(180)+JVS(1759)*UV(182)+JVS(1760)*UV(184)+JVS(1761)*UV(185)&
               &+JVS(1762)*UV(186)+JVS(1763)*UV(188)+JVS(1764)*UV(189)+JVS(1765)*UV(193)+JVS(1766)*UV(194)+JVS(1767)*UV(196)&
               &+JVS(1768)*UV(197)+JVS(1769)*UV(198)+JVS(1771)*UV(200)+JVS(1772)*UV(201)+JVS(1773)*UV(202)+JVS(1775)*UV(204)&
               &+JVS(1776)*UV(205)+JVS(1777)*UV(206)+JVS(1778)*UV(208)+JVS(1779)*UV(209)+JVS(1780)*UV(210)+JVS(1781)*UV(211)&
               &+JVS(1782)*UV(212)+JVS(1783)*UV(213)+JVS(1784)*UV(214)+JVS(1785)*UV(215)+JVS(1786)*UV(216)+JVS(1787)*UV(217)&
               &+JVS(1788)*UV(218)+JVS(1789)*UV(219)+JVS(1790)*UV(220)+JVS(1791)*UV(221)+JVS(1792)*UV(222)+JVS(1793)*UV(223)&
               &+JVS(1794)*UV(224)+JVS(1795)*UV(225)+JVS(1796)*UV(226)+JVS(1798)*UV(228)+JVS(1799)*UV(229)+JVS(1800)*UV(230)&
               &+JVS(1801)*UV(231)+JVS(1802)*UV(232)
  JUV(230) = JVS(1804)*UV(32)+JVS(1805)*UV(47)+JVS(1806)*UV(49)+JVS(1807)*UV(109)+JVS(1808)*UV(110)+JVS(1809)*UV(120)&
               &+JVS(1810)*UV(122)+JVS(1811)*UV(136)+JVS(1812)*UV(144)+JVS(1813)*UV(145)+JVS(1814)*UV(146)+JVS(1815)*UV(148)&
               &+JVS(1816)*UV(149)+JVS(1817)*UV(150)+JVS(1818)*UV(154)+JVS(1819)*UV(156)+JVS(1820)*UV(157)+JVS(1821)*UV(158)&
               &+JVS(1822)*UV(159)+JVS(1823)*UV(160)+JVS(1824)*UV(161)+JVS(1826)*UV(164)+JVS(1827)*UV(165)+JVS(1828)*UV(166)&
               &+JVS(1829)*UV(167)+JVS(1830)*UV(169)+JVS(1831)*UV(173)+JVS(1832)*UV(174)+JVS(1833)*UV(176)+JVS(1834)*UV(177)&
               &+JVS(1835)*UV(178)+JVS(1836)*UV(180)+JVS(1837)*UV(182)+JVS(1838)*UV(184)+JVS(1839)*UV(185)+JVS(1840)*UV(186)&
               &+JVS(1841)*UV(188)+JVS(1842)*UV(189)+JVS(1843)*UV(191)+JVS(1844)*UV(192)+JVS(1845)*UV(193)+JVS(1846)*UV(194)&
               &+JVS(1847)*UV(196)+JVS(1848)*UV(197)+JVS(1849)*UV(198)+JVS(1850)*UV(199)+JVS(1851)*UV(200)+JVS(1852)*UV(201)&
               &+JVS(1853)*UV(202)+JVS(1854)*UV(203)+JVS(1855)*UV(204)+JVS(1856)*UV(205)+JVS(1857)*UV(206)+JVS(1858)*UV(207)&
               &+JVS(1859)*UV(208)+JVS(1860)*UV(209)+JVS(1861)*UV(210)+JVS(1862)*UV(211)+JVS(1863)*UV(212)+JVS(1864)*UV(213)&
               &+JVS(1865)*UV(214)+JVS(1866)*UV(215)+JVS(1867)*UV(216)+JVS(1868)*UV(217)+JVS(1869)*UV(218)+JVS(1870)*UV(219)&
               &+JVS(1871)*UV(220)+JVS(1872)*UV(221)+JVS(1873)*UV(222)+JVS(1874)*UV(223)+JVS(1875)*UV(224)+JVS(1876)*UV(225)&
               &+JVS(1877)*UV(226)+JVS(1878)*UV(227)+JVS(1879)*UV(228)+JVS(1880)*UV(229)+JVS(1881)*UV(230)+JVS(1882)*UV(231)&
               &+JVS(1883)*UV(232)+JVS(1884)*UV(233)
  JUV(231) = JVS(1885)*UV(8)+JVS(1886)*UV(9)+JVS(1887)*UV(11)+JVS(1888)*UV(12)+JVS(1889)*UV(13)+JVS(1890)*UV(14)&
               &+JVS(1891)*UV(15)+JVS(1892)*UV(16)+JVS(1893)*UV(17)+JVS(1894)*UV(18)+JVS(1895)*UV(19)+JVS(1896)*UV(20)&
               &+JVS(1897)*UV(21)+JVS(1898)*UV(22)+JVS(1899)*UV(23)+JVS(1900)*UV(24)+JVS(1901)*UV(25)+JVS(1902)*UV(26)&
               &+JVS(1903)*UV(27)+JVS(1904)*UV(28)+JVS(1905)*UV(29)+JVS(1906)*UV(30)+JVS(1907)*UV(31)+JVS(1908)*UV(33)&
               &+JVS(1909)*UV(34)+JVS(1910)*UV(36)+JVS(1911)*UV(37)+JVS(1912)*UV(38)+JVS(1913)*UV(39)+JVS(1914)*UV(40)&
               &+JVS(1915)*UV(41)+JVS(1916)*UV(42)+JVS(1917)*UV(43)+JVS(1918)*UV(44)+JVS(1919)*UV(45)+JVS(1920)*UV(46)&
               &+JVS(1921)*UV(47)+JVS(1922)*UV(49)+JVS(1923)*UV(51)+JVS(1924)*UV(52)+JVS(1925)*UV(54)+JVS(1926)*UV(55)&
               &+JVS(1927)*UV(56)+JVS(1928)*UV(57)+JVS(1929)*UV(58)+JVS(1930)*UV(59)+JVS(1931)*UV(60)+JVS(1932)*UV(61)&
               &+JVS(1933)*UV(62)+JVS(1934)*UV(63)+JVS(1935)*UV(64)+JVS(1936)*UV(65)+JVS(1937)*UV(66)+JVS(1938)*UV(67)&
               &+JVS(1939)*UV(68)+JVS(1940)*UV(69)+JVS(1941)*UV(70)+JVS(1942)*UV(71)+JVS(1943)*UV(72)+JVS(1944)*UV(73)&
               &+JVS(1945)*UV(74)+JVS(1946)*UV(75)+JVS(1947)*UV(76)+JVS(1948)*UV(77)+JVS(1949)*UV(78)+JVS(1950)*UV(79)&
               &+JVS(1951)*UV(80)+JVS(1952)*UV(81)+JVS(1953)*UV(82)+JVS(1954)*UV(83)+JVS(1955)*UV(84)+JVS(1956)*UV(85)&
               &+JVS(1957)*UV(86)+JVS(1958)*UV(87)+JVS(1959)*UV(88)+JVS(1960)*UV(89)+JVS(1961)*UV(90)+JVS(1962)*UV(91)&
               &+JVS(1963)*UV(92)+JVS(1964)*UV(93)+JVS(1965)*UV(94)+JVS(1966)*UV(95)+JVS(1967)*UV(96)+JVS(1968)*UV(97)&
               &+JVS(1969)*UV(98)+JVS(1970)*UV(99)+JVS(1971)*UV(100)+JVS(1972)*UV(101)+JVS(1973)*UV(102)+JVS(1974)*UV(103)&
               &+JVS(1975)*UV(104)+JVS(1976)*UV(105)+JVS(1977)*UV(106)+JVS(1978)*UV(107)+JVS(1979)*UV(108)+JVS(1980)*UV(109)&
               &+JVS(1981)*UV(110)+JVS(1982)*UV(112)+JVS(1983)*UV(113)+JVS(1984)*UV(114)+JVS(1985)*UV(115)+JVS(1986)*UV(116)&
               &+JVS(1987)*UV(117)+JVS(1988)*UV(118)+JVS(1989)*UV(119)+JVS(1990)*UV(120)+JVS(1991)*UV(121)+JVS(1992)*UV(122)&
               &+JVS(1993)*UV(123)+JVS(1994)*UV(124)+JVS(1995)*UV(125)+JVS(1996)*UV(126)+JVS(1997)*UV(127)+JVS(1998)*UV(128)&
               &+JVS(1999)*UV(129)+JVS(2000)*UV(130)+JVS(2001)*UV(131)+JVS(2002)*UV(132)+JVS(2003)*UV(133)+JVS(2004)*UV(134)&
               &+JVS(2005)*UV(135)+JVS(2006)*UV(136)+JVS(2007)*UV(137)+JVS(2008)*UV(138)+JVS(2009)*UV(139)+JVS(2010)*UV(140)&
               &+JVS(2011)*UV(141)+JVS(2012)*UV(142)+JVS(2016)*UV(147)+JVS(2018)*UV(150)+JVS(2019)*UV(151)+JVS(2020)*UV(152)&
               &+JVS(2021)*UV(153)+JVS(2022)*UV(154)+JVS(2023)*UV(155)+JVS(2027)*UV(159)+JVS(2028)*UV(160)+JVS(2029)*UV(161)&
               &+JVS(2030)*UV(162)+JVS(2031)*UV(163)+JVS(2033)*UV(165)+JVS(2034)*UV(166)+JVS(2036)*UV(168)+JVS(2038)*UV(170)&
               &+JVS(2043)*UV(175)+JVS(2045)*UV(177)+JVS(2047)*UV(179)+JVS(2049)*UV(181)+JVS(2051)*UV(183)+JVS(2055)*UV(187)&
               &+JVS(2058)*UV(190)+JVS(2059)*UV(191)+JVS(2060)*UV(192)+JVS(2063)*UV(195)+JVS(2067)*UV(199)+JVS(2071)*UV(203)&
               &+JVS(2075)*UV(207)+JVS(2091)*UV(223)+JVS(2095)*UV(227)+JVS(2096)*UV(228)+JVS(2097)*UV(229)+JVS(2098)*UV(230)&
               &+JVS(2099)*UV(231)+JVS(2100)*UV(232)+JVS(2101)*UV(233)
  JUV(232) = JVS(2102)*UV(32)+JVS(2103)*UV(35)+JVS(2104)*UV(41)+JVS(2105)*UV(48)+JVS(2106)*UV(50)+JVS(2107)*UV(54)&
               &+JVS(2108)*UV(55)+JVS(2109)*UV(60)+JVS(2110)*UV(61)+JVS(2111)*UV(63)+JVS(2112)*UV(64)+JVS(2113)*UV(66)&
               &+JVS(2114)*UV(67)+JVS(2115)*UV(70)+JVS(2116)*UV(79)+JVS(2117)*UV(83)+JVS(2118)*UV(84)+JVS(2119)*UV(87)&
               &+JVS(2120)*UV(90)+JVS(2121)*UV(91)+JVS(2122)*UV(94)+JVS(2123)*UV(97)+JVS(2124)*UV(98)+JVS(2125)*UV(99)&
               &+JVS(2126)*UV(100)+JVS(2127)*UV(102)+JVS(2128)*UV(104)+JVS(2129)*UV(105)+JVS(2130)*UV(111)+JVS(2131)*UV(112)&
               &+JVS(2132)*UV(113)+JVS(2133)*UV(117)+JVS(2134)*UV(119)+JVS(2135)*UV(120)+JVS(2136)*UV(121)+JVS(2137)*UV(122)&
               &+JVS(2138)*UV(123)+JVS(2139)*UV(126)+JVS(2140)*UV(128)+JVS(2141)*UV(129)+JVS(2142)*UV(135)+JVS(2143)*UV(139)&
               &+JVS(2144)*UV(142)+JVS(2145)*UV(143)+JVS(2146)*UV(144)+JVS(2147)*UV(145)+JVS(2148)*UV(146)+JVS(2149)*UV(148)&
               &+JVS(2150)*UV(149)+JVS(2152)*UV(156)+JVS(2153)*UV(157)+JVS(2154)*UV(158)+JVS(2156)*UV(162)+JVS(2157)*UV(163)&
               &+JVS(2158)*UV(164)+JVS(2160)*UV(167)+JVS(2161)*UV(169)+JVS(2162)*UV(171)+JVS(2163)*UV(172)+JVS(2164)*UV(173)&
               &+JVS(2165)*UV(174)+JVS(2166)*UV(176)+JVS(2168)*UV(178)+JVS(2169)*UV(180)+JVS(2170)*UV(182)+JVS(2171)*UV(184)&
               &+JVS(2172)*UV(185)+JVS(2173)*UV(186)+JVS(2174)*UV(188)+JVS(2175)*UV(189)+JVS(2176)*UV(192)+JVS(2177)*UV(193)&
               &+JVS(2178)*UV(194)+JVS(2179)*UV(196)+JVS(2180)*UV(197)+JVS(2181)*UV(198)+JVS(2183)*UV(200)+JVS(2184)*UV(201)&
               &+JVS(2185)*UV(202)+JVS(2187)*UV(204)+JVS(2188)*UV(205)+JVS(2189)*UV(206)+JVS(2191)*UV(208)+JVS(2192)*UV(209)&
               &+JVS(2193)*UV(210)+JVS(2194)*UV(211)+JVS(2195)*UV(212)+JVS(2196)*UV(213)+JVS(2197)*UV(214)+JVS(2198)*UV(215)&
               &+JVS(2199)*UV(216)+JVS(2200)*UV(217)+JVS(2201)*UV(218)+JVS(2202)*UV(219)+JVS(2203)*UV(220)+JVS(2204)*UV(221)&
               &+JVS(2205)*UV(222)+JVS(2206)*UV(223)+JVS(2207)*UV(224)+JVS(2208)*UV(225)+JVS(2209)*UV(226)+JVS(2211)*UV(228)&
               &+JVS(2212)*UV(229)+JVS(2213)*UV(230)+JVS(2214)*UV(231)+JVS(2215)*UV(232)
  JUV(233) = JVS(2217)*UV(43)+JVS(2218)*UV(61)+JVS(2219)*UV(73)+JVS(2220)*UV(82)+JVS(2221)*UV(83)+JVS(2222)*UV(91)&
               &+JVS(2223)*UV(112)+JVS(2224)*UV(118)+JVS(2225)*UV(135)+JVS(2226)*UV(137)+JVS(2227)*UV(140)+JVS(2228)*UV(145)&
               &+JVS(2229)*UV(161)+JVS(2230)*UV(167)+JVS(2231)*UV(168)+JVS(2232)*UV(175)+JVS(2234)*UV(208)+JVS(2235)*UV(209)&
               &+JVS(2236)*UV(213)+JVS(2237)*UV(214)+JVS(2239)*UV(217)+JVS(2240)*UV(218)+JVS(2244)*UV(223)+JVS(2247)*UV(226)&
               &+JVS(2250)*UV(229)+JVS(2251)*UV(230)+JVS(2252)*UV(231)+JVS(2254)*UV(233)
      
END SUBROUTINE Jac_SP_Vec

! End of Jac_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacTR_SP_Vec - sparse multiplication: sparse Jacobian transposed times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JTUV      - Jacobian transposed times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacTR_SP_Vec ( JVS, UV, JTUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JTUV - Jacobian transposed times user vector
  REAL(kind=dp) :: JTUV(NVAR)

  JTUV(1) = JVS(1)*UV(1)
  JTUV(2) = JVS(2)*UV(2)
  JTUV(3) = JVS(3)*UV(3)
  JTUV(4) = JVS(4)*UV(4)
  JTUV(5) = JVS(5)*UV(4)+JVS(7)*UV(5)
  JTUV(6) = JVS(11)*UV(6)
  JTUV(7) = JVS(16)*UV(7)
  JTUV(8) = JVS(19)*UV(8)+JVS(767)*UV(173)+JVS(1885)*UV(231)
  JTUV(9) = JVS(21)*UV(9)+JVS(1314)*UV(214)+JVS(1886)*UV(231)
  JTUV(10) = JVS(8)*UV(5)+JVS(23)*UV(10)+JVS(1598)*UV(228)
  JTUV(11) = JVS(26)*UV(11)+JVS(1553)*UV(226)+JVS(1887)*UV(231)
  JTUV(12) = JVS(28)*UV(12)+JVS(1244)*UV(210)+JVS(1888)*UV(231)
  JTUV(13) = JVS(30)*UV(13)+JVS(1245)*UV(210)+JVS(1889)*UV(231)
  JTUV(14) = JVS(32)*UV(14)+JVS(1246)*UV(210)+JVS(1890)*UV(231)
  JTUV(15) = JVS(34)*UV(15)+JVS(1315)*UV(214)+JVS(1891)*UV(231)
  JTUV(16) = JVS(36)*UV(16)+JVS(1067)*UV(198)+JVS(1892)*UV(231)
  JTUV(17) = JVS(38)*UV(17)+JVS(1068)*UV(198)+JVS(1893)*UV(231)
  JTUV(18) = JVS(40)*UV(18)+JVS(1069)*UV(198)+JVS(1894)*UV(231)
  JTUV(19) = JVS(42)*UV(19)+JVS(1070)*UV(198)+JVS(1895)*UV(231)
  JTUV(20) = JVS(44)*UV(20)+JVS(1247)*UV(210)+JVS(1896)*UV(231)
  JTUV(21) = JVS(46)*UV(21)+JVS(647)*UV(157)+JVS(1897)*UV(231)
  JTUV(22) = JVS(48)*UV(22)+JVS(648)*UV(157)+JVS(1898)*UV(231)
  JTUV(23) = JVS(50)*UV(23)+JVS(649)*UV(157)+JVS(1899)*UV(231)
  JTUV(24) = JVS(52)*UV(24)+JVS(650)*UV(157)+JVS(1900)*UV(231)
  JTUV(25) = JVS(54)*UV(25)+JVS(792)*UV(176)+JVS(1901)*UV(231)
  JTUV(26) = JVS(56)*UV(26)+JVS(641)*UV(156)+JVS(1351)*UV(216)+JVS(1902)*UV(231)
  JTUV(27) = JVS(58)*UV(27)+JVS(942)*UV(189)+JVS(1054)*UV(196)+JVS(1903)*UV(231)
  JTUV(28) = JVS(60)*UV(28)+JVS(651)*UV(157)+JVS(1060)*UV(197)+JVS(1904)*UV(231)
  JTUV(29) = JVS(62)*UV(29)+JVS(652)*UV(157)+JVS(1061)*UV(197)+JVS(1905)*UV(231)
  JTUV(30) = JVS(64)*UV(30)+JVS(116)*UV(47)+JVS(694)*UV(164)+JVS(1599)*UV(228)+JVS(1906)*UV(231)
  JTUV(31) = JVS(66)*UV(31)+JVS(125)*UV(49)+JVS(840)*UV(182)+JVS(1600)*UV(228)+JVS(1907)*UV(231)
  JTUV(32) = JVS(68)*UV(32)+JVS(1804)*UV(230)+JVS(2102)*UV(232)
  JTUV(33) = JVS(71)*UV(33)+JVS(1223)*UV(208)+JVS(1316)*UV(214)+JVS(1409)*UV(219)+JVS(1908)*UV(231)
  JTUV(34) = JVS(73)*UV(34)+JVS(1538)*UV(225)+JVS(1909)*UV(231)
  JTUV(35) = JVS(76)*UV(35)+JVS(1248)*UV(210)+JVS(2103)*UV(232)
  JTUV(36) = JVS(79)*UV(36)+JVS(110)*UV(46)+JVS(597)*UV(151)+JVS(886)*UV(187)+JVS(1601)*UV(228)+JVS(1910)*UV(231)
  JTUV(37) = JVS(81)*UV(37)+JVS(1173)*UV(207)+JVS(1602)*UV(228)+JVS(1911)*UV(231)
  JTUV(38) = JVS(84)*UV(38)+JVS(1233)*UV(209)+JVS(1464)*UV(221)+JVS(1912)*UV(231)
  JTUV(39) = JVS(87)*UV(39)+JVS(1298)*UV(213)+JVS(1913)*UV(231)
  JTUV(40) = JVS(91)*UV(40)+JVS(1287)*UV(212)+JVS(1914)*UV(231)
  JTUV(41) = JVS(95)*UV(41)+JVS(1734)*UV(229)+JVS(1915)*UV(231)+JVS(2104)*UV(232)
  JTUV(42) = JVS(17)*UV(7)+JVS(98)*UV(42)+JVS(384)*UV(110)+JVS(1249)*UV(210)+JVS(1916)*UV(231)
  JTUV(43) = JVS(101)*UV(43)+JVS(1071)*UV(198)+JVS(1603)*UV(228)+JVS(1917)*UV(231)+JVS(2217)*UV(233)
  JTUV(44) = JVS(104)*UV(44)+JVS(1029)*UV(195)+JVS(1383)*UV(218)+JVS(1604)*UV(228)+JVS(1918)*UV(231)
  JTUV(45) = JVS(107)*UV(45)+JVS(1299)*UV(213)+JVS(1410)*UV(219)+JVS(1465)*UV(221)+JVS(1919)*UV(231)
  JTUV(46) = JVS(111)*UV(46)+JVS(1605)*UV(228)+JVS(1920)*UV(231)
  JTUV(47) = JVS(117)*UV(47)+JVS(120)*UV(48)+JVS(988)*UV(192)+JVS(1805)*UV(230)+JVS(1921)*UV(231)
  JTUV(48) = JVS(121)*UV(48)+JVS(426)*UV(120)+JVS(2105)*UV(232)
  JTUV(49) = JVS(126)*UV(49)+JVS(129)*UV(50)+JVS(989)*UV(192)+JVS(1806)*UV(230)+JVS(1922)*UV(231)
  JTUV(50) = JVS(130)*UV(50)+JVS(435)*UV(122)+JVS(2106)*UV(232)
  JTUV(51) = JVS(134)*UV(51)+JVS(1384)*UV(218)+JVS(1575)*UV(227)+JVS(1606)*UV(228)+JVS(1923)*UV(231)
  JTUV(52) = JVS(137)*UV(52)+JVS(1250)*UV(210)+JVS(1924)*UV(231)
  JTUV(53) = JVS(6)*UV(4)+JVS(12)*UV(6)+JVS(142)*UV(53)+JVS(1251)*UV(210)+JVS(1607)*UV(228)
  JTUV(54) = JVS(147)*UV(54)+JVS(807)*UV(179)+JVS(1925)*UV(231)+JVS(2107)*UV(232)
  JTUV(55) = JVS(151)*UV(55)+JVS(531)*UV(140)+JVS(1926)*UV(231)+JVS(2108)*UV(232)
  JTUV(56) = JVS(155)*UV(56)+JVS(1576)*UV(227)+JVS(1608)*UV(228)+JVS(1927)*UV(231)
  JTUV(57) = JVS(159)*UV(57)+JVS(480)*UV(132)+JVS(1125)*UV(202)+JVS(1928)*UV(231)
  JTUV(58) = JVS(163)*UV(58)+JVS(948)*UV(190)+JVS(1317)*UV(214)+JVS(1929)*UV(231)
  JTUV(59) = JVS(167)*UV(59)+JVS(572)*UV(147)+JVS(1352)*UV(216)+JVS(1930)*UV(231)
  JTUV(60) = JVS(171)*UV(60)+JVS(1174)*UV(207)+JVS(1931)*UV(231)+JVS(2109)*UV(232)
  JTUV(61) = JVS(175)*UV(61)+JVS(1932)*UV(231)+JVS(2110)*UV(232)+JVS(2218)*UV(233)
  JTUV(62) = JVS(179)*UV(62)+JVS(1146)*UV(204)+JVS(1318)*UV(214)+JVS(1933)*UV(231)
  JTUV(63) = JVS(183)*UV(63)+JVS(1609)*UV(228)+JVS(1934)*UV(231)+JVS(2111)*UV(232)
  JTUV(64) = JVS(187)*UV(64)+JVS(979)*UV(191)+JVS(1935)*UV(231)+JVS(2112)*UV(232)
  JTUV(65) = JVS(191)*UV(65)+JVS(611)*UV(152)+JVS(1610)*UV(228)+JVS(1936)*UV(231)
  JTUV(66) = JVS(195)*UV(66)+JVS(1091)*UV(199)+JVS(1937)*UV(231)+JVS(2113)*UV(232)
  JTUV(67) = JVS(199)*UV(67)+JVS(704)*UV(166)+JVS(1938)*UV(231)+JVS(2114)*UV(232)
  JTUV(68) = JVS(203)*UV(68)+JVS(705)*UV(166)+JVS(1611)*UV(228)+JVS(1939)*UV(231)
  JTUV(69) = JVS(207)*UV(69)+JVS(1288)*UV(212)+JVS(1494)*UV(222)+JVS(1940)*UV(231)
  JTUV(70) = JVS(211)*UV(70)+JVS(706)*UV(166)+JVS(1941)*UV(231)+JVS(2115)*UV(232)
  JTUV(71) = JVS(215)*UV(71)+JVS(658)*UV(158)+JVS(1289)*UV(212)+JVS(1942)*UV(231)
  JTUV(72) = JVS(219)*UV(72)+JVS(659)*UV(158)+JVS(1156)*UV(205)+JVS(1943)*UV(231)
  JTUV(73) = JVS(223)*UV(73)+JVS(1612)*UV(228)+JVS(1944)*UV(231)+JVS(2219)*UV(233)
  JTUV(74) = JVS(227)*UV(74)+JVS(1030)*UV(195)+JVS(1613)*UV(228)+JVS(1945)*UV(231)
  JTUV(75) = JVS(231)*UV(75)+JVS(371)*UV(108)+JVS(1614)*UV(228)+JVS(1946)*UV(231)
  JTUV(76) = JVS(235)*UV(76)+JVS(1252)*UV(210)+JVS(1411)*UV(219)+JVS(1947)*UV(231)
  JTUV(77) = JVS(239)*UV(77)+JVS(1072)*UV(198)+JVS(1948)*UV(231)
  JTUV(78) = JVS(245)*UV(78)+JVS(508)*UV(136)+JVS(930)*UV(188)+JVS(1385)*UV(218)+JVS(1615)*UV(228)+JVS(1949)*UV(231)
  JTUV(79) = JVS(248)*UV(79)+JVS(518)*UV(138)+JVS(1234)*UV(209)+JVS(1950)*UV(231)+JVS(2116)*UV(232)
  JTUV(80) = JVS(252)*UV(80)+JVS(519)*UV(138)+JVS(1539)*UV(225)+JVS(1951)*UV(231)
  JTUV(81) = JVS(85)*UV(38)+JVS(257)*UV(81)+JVS(1523)*UV(224)+JVS(1952)*UV(231)
  JTUV(82) = JVS(261)*UV(82)+JVS(532)*UV(140)+JVS(1616)*UV(228)+JVS(1953)*UV(231)+JVS(2220)*UV(233)
  JTUV(83) = JVS(265)*UV(83)+JVS(1175)*UV(207)+JVS(1954)*UV(231)+JVS(2117)*UV(232)+JVS(2221)*UV(233)
  JTUV(84) = JVS(269)*UV(84)+JVS(1031)*UV(195)+JVS(1617)*UV(228)+JVS(1955)*UV(231)+JVS(2118)*UV(232)
  JTUV(85) = JVS(273)*UV(85)+JVS(931)*UV(188)+JVS(1176)*UV(207)+JVS(1618)*UV(228)+JVS(1956)*UV(231)
  JTUV(86) = JVS(277)*UV(86)+JVS(1092)*UV(199)+JVS(1106)*UV(200)+JVS(1412)*UV(219)+JVS(1957)*UV(231)
  JTUV(87) = JVS(281)*UV(87)+JVS(1115)*UV(201)+JVS(1134)*UV(203)+JVS(1958)*UV(231)+JVS(2119)*UV(232)
  JTUV(88) = JVS(285)*UV(88)+JVS(685)*UV(163)+JVS(887)*UV(187)+JVS(1619)*UV(228)+JVS(1959)*UV(231)
  JTUV(89) = JVS(289)*UV(89)+JVS(598)*UV(151)+JVS(631)*UV(155)+JVS(1620)*UV(228)+JVS(1960)*UV(231)
  JTUV(90) = JVS(293)*UV(90)+JVS(1177)*UV(207)+JVS(1621)*UV(228)+JVS(1961)*UV(231)+JVS(2120)*UV(232)
  JTUV(91) = JVS(297)*UV(91)+JVS(1622)*UV(228)+JVS(1962)*UV(231)+JVS(2121)*UV(232)+JVS(2222)*UV(233)
  JTUV(92) = JVS(301)*UV(92)+JVS(599)*UV(151)+JVS(846)*UV(183)+JVS(1623)*UV(228)+JVS(1963)*UV(231)
  JTUV(93) = JVS(305)*UV(93)+JVS(1178)*UV(207)+JVS(1253)*UV(210)+JVS(1624)*UV(228)+JVS(1964)*UV(231)
  JTUV(94) = JVS(309)*UV(94)+JVS(1577)*UV(227)+JVS(1625)*UV(228)+JVS(1965)*UV(231)+JVS(2122)*UV(232)
  JTUV(95) = JVS(313)*UV(95)+JVS(1021)*UV(194)+JVS(1032)*UV(195)+JVS(1157)*UV(205)+JVS(1966)*UV(231)
  JTUV(96) = JVS(317)*UV(96)+JVS(859)*UV(184)+JVS(888)*UV(187)+JVS(1467)*UV(221)+JVS(1967)*UV(231)
  JTUV(97) = JVS(74)*UV(34)+JVS(321)*UV(97)+JVS(1033)*UV(195)+JVS(1968)*UV(231)+JVS(2123)*UV(232)
  JTUV(98) = JVS(325)*UV(98)+JVS(481)*UV(132)+JVS(777)*UV(174)+JVS(1969)*UV(231)+JVS(2124)*UV(232)
  JTUV(99) = JVS(329)*UV(99)+JVS(487)*UV(133)+JVS(1179)*UV(207)+JVS(1970)*UV(231)+JVS(2125)*UV(232)
  JTUV(100) = JVS(333)*UV(100)+JVS(372)*UV(108)+JVS(1626)*UV(228)+JVS(1971)*UV(231)+JVS(2126)*UV(232)
  JTUV(101) = JVS(337)*UV(101)+JVS(1093)*UV(199)+JVS(1180)*UV(207)+JVS(1627)*UV(228)+JVS(1972)*UV(231)
  JTUV(102) = JVS(88)*UV(39)+JVS(341)*UV(102)+JVS(1034)*UV(195)+JVS(1973)*UV(231)+JVS(2127)*UV(232)
  JTUV(103) = JVS(89)*UV(39)+JVS(345)*UV(103)+JVS(1035)*UV(195)+JVS(1554)*UV(226)+JVS(1974)*UV(231)
  JTUV(104) = JVS(349)*UV(104)+JVS(723)*UV(168)+JVS(1975)*UV(231)+JVS(2128)*UV(232)
  JTUV(105) = JVS(354)*UV(105)+JVS(826)*UV(181)+JVS(1976)*UV(231)+JVS(2129)*UV(232)
  JTUV(106) = JVS(359)*UV(106)+JVS(619)*UV(153)+JVS(949)*UV(190)+JVS(1628)*UV(228)+JVS(1977)*UV(231)
  JTUV(107) = JVS(363)*UV(107)+JVS(1629)*UV(228)+JVS(1978)*UV(231)
  JTUV(108) = JVS(373)*UV(108)+JVS(1278)*UV(211)+JVS(1979)*UV(231)
  JTUV(109) = JVS(99)*UV(42)+JVS(381)*UV(109)+JVS(389)*UV(111)+JVS(990)*UV(192)+JVS(1630)*UV(228)+JVS(1807)*UV(230)&
                &+JVS(1980)*UV(231)
  JTUV(110) = JVS(13)*UV(6)+JVS(386)*UV(110)+JVS(753)*UV(171)+JVS(991)*UV(192)+JVS(1631)*UV(228)+JVS(1808)*UV(230)&
                &+JVS(1981)*UV(231)
  JTUV(111) = JVS(390)*UV(111)+JVS(550)*UV(143)+JVS(1181)*UV(207)+JVS(1735)*UV(229)+JVS(2130)*UV(232)
  JTUV(112) = JVS(394)*UV(112)+JVS(889)*UV(187)+JVS(1147)*UV(204)+JVS(1982)*UV(231)+JVS(2131)*UV(232)+JVS(2223)*UV(233)
  JTUV(113) = JVS(398)*UV(113)+JVS(890)*UV(187)+JVS(932)*UV(188)+JVS(1182)*UV(207)+JVS(1983)*UV(231)+JVS(2132)*UV(232)
  JTUV(114) = JVS(402)*UV(114)+JVS(980)*UV(191)+JVS(1135)*UV(203)+JVS(1183)*UV(207)+JVS(1632)*UV(228)+JVS(1984)*UV(231)
  JTUV(115) = JVS(406)*UV(115)+JVS(950)*UV(190)+JVS(1094)*UV(199)+JVS(1116)*UV(201)+JVS(1633)*UV(228)+JVS(1985)*UV(231)
  JTUV(116) = JVS(108)*UV(45)+JVS(410)*UV(116)+JVS(1555)*UV(226)+JVS(1986)*UV(231)
  JTUV(117) = JVS(414)*UV(117)+JVS(808)*UV(179)+JVS(891)*UV(187)+JVS(1107)*UV(200)+JVS(1987)*UV(231)+JVS(2133)*UV(232)
  JTUV(118) = JVS(418)*UV(118)+JVS(809)*UV(179)+JVS(1184)*UV(207)+JVS(1634)*UV(228)+JVS(1988)*UV(231)+JVS(2224)*UV(233)
  JTUV(119) = JVS(422)*UV(119)+JVS(600)*UV(151)+JVS(632)*UV(155)+JVS(1635)*UV(228)+JVS(1989)*UV(231)+JVS(2134)*UV(232)
  JTUV(120) = JVS(427)*UV(120)+JVS(724)*UV(168)+JVS(992)*UV(192)+JVS(1809)*UV(230)+JVS(1990)*UV(231)+JVS(2135)*UV(232)
  JTUV(121) = JVS(431)*UV(121)+JVS(601)*UV(151)+JVS(847)*UV(183)+JVS(1636)*UV(228)+JVS(1991)*UV(231)+JVS(2136)*UV(232)
  JTUV(122) = JVS(436)*UV(122)+JVS(827)*UV(181)+JVS(993)*UV(192)+JVS(1810)*UV(230)+JVS(1992)*UV(231)+JVS(2137)*UV(232)
  JTUV(123) = JVS(440)*UV(123)+JVS(828)*UV(181)+JVS(1036)*UV(195)+JVS(1495)*UV(222)+JVS(1993)*UV(231)+JVS(2138)*UV(232)
  JTUV(124) = JVS(444)*UV(124)+JVS(670)*UV(160)+JVS(1022)*UV(194)+JVS(1185)*UV(207)+JVS(1637)*UV(228)+JVS(1994)*UV(231)
  JTUV(125) = JVS(448)*UV(125)+JVS(488)*UV(133)+JVS(870)*UV(185)+JVS(1186)*UV(207)+JVS(1638)*UV(228)+JVS(1995)*UV(231)
  JTUV(126) = JVS(452)*UV(126)+JVS(489)*UV(133)+JVS(734)*UV(169)+JVS(1187)*UV(207)+JVS(1996)*UV(231)+JVS(2139)*UV(232)
  JTUV(127) = JVS(9)*UV(5)+JVS(24)*UV(10)+JVS(456)*UV(127)+JVS(768)*UV(173)+JVS(1997)*UV(231)
  JTUV(128) = JVS(462)*UV(128)+JVS(620)*UV(153)+JVS(951)*UV(190)+JVS(1640)*UV(228)+JVS(1998)*UV(231)+JVS(2140)*UV(232)
  JTUV(129) = JVS(466)*UV(129)+JVS(892)*UV(187)+JVS(1188)*UV(207)+JVS(1414)*UV(219)+JVS(1999)*UV(231)+JVS(2141)*UV(232)
  JTUV(130) = JVS(470)*UV(130)+JVS(829)*UV(181)+JVS(1578)*UV(227)+JVS(1641)*UV(228)+JVS(2000)*UV(231)
  JTUV(131) = JVS(475)*UV(131)+JVS(848)*UV(183)+JVS(952)*UV(190)+JVS(1642)*UV(228)+JVS(2001)*UV(231)
  JTUV(132) = JVS(482)*UV(132)+JVS(1353)*UV(216)+JVS(1456)*UV(220)+JVS(1469)*UV(221)+JVS(2002)*UV(231)
  JTUV(133) = JVS(490)*UV(133)+JVS(1341)*UV(215)+JVS(2003)*UV(231)
  JTUV(134) = JVS(499)*UV(134)+JVS(742)*UV(170)+JVS(953)*UV(190)+JVS(1643)*UV(228)+JVS(2004)*UV(231)
  JTUV(135) = JVS(504)*UV(135)+JVS(538)*UV(141)+JVS(1319)*UV(214)+JVS(1644)*UV(228)+JVS(2005)*UV(231)+JVS(2142)*UV(232)&
                &+JVS(2225)*UV(233)
  JTUV(136) = JVS(509)*UV(136)+JVS(860)*UV(184)+JVS(893)*UV(187)+JVS(994)*UV(192)+JVS(1645)*UV(228)+JVS(1811)*UV(230)&
                &+JVS(2006)*UV(231)
  JTUV(137) = JVS(513)*UV(137)+JVS(725)*UV(168)+JVS(1579)*UV(227)+JVS(1646)*UV(228)+JVS(2007)*UV(231)+JVS(2226)*UV(233)
  JTUV(138) = JVS(520)*UV(138)+JVS(1354)*UV(216)+JVS(1374)*UV(217)+JVS(1415)*UV(219)+JVS(2008)*UV(231)
  JTUV(139) = JVS(526)*UV(139)+JVS(849)*UV(183)+JVS(954)*UV(190)+JVS(1647)*UV(228)+JVS(2009)*UV(231)+JVS(2143)*UV(232)
  JTUV(140) = JVS(533)*UV(140)+JVS(573)*UV(147)+JVS(1416)*UV(219)+JVS(1648)*UV(228)+JVS(2010)*UV(231)+JVS(2227)*UV(233)
  JTUV(141) = JVS(539)*UV(141)+JVS(1224)*UV(208)+JVS(1320)*UV(214)+JVS(1417)*UV(219)+JVS(2011)*UV(231)
  JTUV(142) = JVS(545)*UV(142)+JVS(743)*UV(170)+JVS(955)*UV(190)+JVS(1649)*UV(228)+JVS(2012)*UV(231)+JVS(2144)*UV(232)
  JTUV(143) = JVS(551)*UV(143)+JVS(760)*UV(172)+JVS(1505)*UV(223)+JVS(1736)*UV(229)+JVS(2145)*UV(232)
  JTUV(144) = JVS(192)*UV(65)+JVS(557)*UV(144)+JVS(612)*UV(152)+JVS(1650)*UV(228)+JVS(1737)*UV(229)+JVS(1812)*UV(230)&
                &+JVS(2146)*UV(232)
  JTUV(145) = JVS(176)*UV(61)+JVS(562)*UV(145)+JVS(1651)*UV(228)+JVS(1738)*UV(229)+JVS(1813)*UV(230)+JVS(2147)*UV(232)&
                &+JVS(2228)*UV(233)
  JTUV(146) = JVS(212)*UV(70)+JVS(567)*UV(146)+JVS(707)*UV(166)+JVS(1652)*UV(228)+JVS(1739)*UV(229)+JVS(1814)*UV(230)&
                &+JVS(2148)*UV(232)
  JTUV(147) = JVS(574)*UV(147)+JVS(1386)*UV(218)+JVS(1418)*UV(219)+JVS(2016)*UV(231)
  JTUV(148) = JVS(172)*UV(60)+JVS(583)*UV(148)+JVS(1189)*UV(207)+JVS(1653)*UV(228)+JVS(1740)*UV(229)+JVS(1815)*UV(230)&
                &+JVS(2149)*UV(232)
  JTUV(149) = JVS(588)*UV(149)+JVS(784)*UV(175)+JVS(1303)*UV(213)+JVS(1654)*UV(228)+JVS(1741)*UV(229)+JVS(1816)*UV(230)&
                &+JVS(2150)*UV(232)
  JTUV(150) = JVS(138)*UV(52)+JVS(593)*UV(150)+JVS(716)*UV(167)+JVS(894)*UV(187)+JVS(1190)*UV(207)+JVS(1255)*UV(210)&
                &+JVS(1387)*UV(218)+JVS(1506)*UV(223)+JVS(1817)*UV(230)+JVS(2018)*UV(231)
  JTUV(151) = JVS(602)*UV(151)+JVS(895)*UV(187)+JVS(1655)*UV(228)+JVS(2019)*UV(231)
  JTUV(152) = JVS(613)*UV(152)+JVS(686)*UV(163)+JVS(878)*UV(186)+JVS(896)*UV(187)+JVS(1656)*UV(228)+JVS(2020)*UV(231)
  JTUV(153) = JVS(240)*UV(77)+JVS(621)*UV(153)+JVS(1355)*UV(216)+JVS(1524)*UV(224)+JVS(1657)*UV(228)+JVS(2021)*UV(231)
  JTUV(154) = JVS(112)*UV(46)+JVS(584)*UV(148)+JVS(627)*UV(154)+JVS(897)*UV(187)+JVS(1074)*UV(198)+JVS(1191)*UV(207)&
                &+JVS(1507)*UV(223)+JVS(1658)*UV(228)+JVS(1818)*UV(230)+JVS(2022)*UV(231)
  JTUV(155) = JVS(241)*UV(77)+JVS(633)*UV(155)+JVS(1321)*UV(214)+JVS(1659)*UV(228)+JVS(2023)*UV(231)
  JTUV(156) = JVS(105)*UV(44)+JVS(228)*UV(74)+JVS(270)*UV(84)+JVS(642)*UV(156)+JVS(1037)*UV(195)+JVS(1660)*UV(228)&
                &+JVS(1743)*UV(229)+JVS(1819)*UV(230)+JVS(2152)*UV(232)
  JTUV(157) = JVS(500)*UV(134)+JVS(546)*UV(142)+JVS(653)*UV(157)+JVS(744)*UV(170)+JVS(956)*UV(190)+JVS(1661)*UV(228)&
                &+JVS(1744)*UV(229)+JVS(1820)*UV(230)+JVS(2153)*UV(232)
  JTUV(158) = JVS(220)*UV(72)+JVS(660)*UV(158)+JVS(1158)*UV(205)+JVS(1662)*UV(228)+JVS(1745)*UV(229)+JVS(1821)*UV(230)&
                &+JVS(2154)*UV(232)
  JTUV(159) = JVS(364)*UV(107)+JVS(374)*UV(108)+JVS(491)*UV(133)+JVS(666)*UV(159)+JVS(735)*UV(169)+JVS(871)*UV(185)&
                &+JVS(898)*UV(187)+JVS(1192)*UV(207)+JVS(1342)*UV(215)+JVS(1508)*UV(223)+JVS(1822)*UV(230)+JVS(2027)*UV(231)
  JTUV(160) = JVS(671)*UV(160)+JVS(861)*UV(184)+JVS(899)*UV(187)+JVS(995)*UV(192)+JVS(1419)*UV(219)+JVS(1823)*UV(230)&
                &+JVS(2028)*UV(231)
  JTUV(161) = JVS(139)*UV(52)+JVS(563)*UV(145)+JVS(677)*UV(161)+JVS(900)*UV(187)+JVS(1256)*UV(210)+JVS(1304)*UV(213)&
                &+JVS(1509)*UV(223)+JVS(1824)*UV(230)+JVS(2029)*UV(231)+JVS(2229)*UV(233)
  JTUV(162) = JVS(246)*UV(78)+JVS(681)*UV(162)+JVS(1038)*UV(195)+JVS(2030)*UV(231)+JVS(2156)*UV(232)
  JTUV(163) = JVS(687)*UV(163)+JVS(957)*UV(190)+JVS(1193)*UV(207)+JVS(1420)*UV(219)+JVS(2031)*UV(231)+JVS(2157)*UV(232)
  JTUV(164) = JVS(290)*UV(89)+JVS(423)*UV(119)+JVS(603)*UV(151)+JVS(634)*UV(155)+JVS(695)*UV(164)+JVS(1666)*UV(228)&
                &+JVS(1747)*UV(229)+JVS(1826)*UV(230)+JVS(2158)*UV(232)
  JTUV(165) = JVS(92)*UV(40)+JVS(365)*UV(107)+JVS(568)*UV(146)+JVS(700)*UV(165)+JVS(708)*UV(166)+JVS(1014)*UV(193)&
                &+JVS(1039)*UV(195)+JVS(1126)*UV(202)+JVS(1510)*UV(223)+JVS(1827)*UV(230)+JVS(2033)*UV(231)
  JTUV(166) = JVS(709)*UV(166)+JVS(997)*UV(192)+JVS(1496)*UV(222)+JVS(1668)*UV(228)+JVS(1828)*UV(230)+JVS(2034)*UV(231)
  JTUV(167) = JVS(266)*UV(83)+JVS(717)*UV(167)+JVS(1194)*UV(207)+JVS(1669)*UV(228)+JVS(1749)*UV(229)+JVS(1829)*UV(230)&
                &+JVS(2160)*UV(232)+JVS(2230)*UV(233)
  JTUV(168) = JVS(726)*UV(168)+JVS(1470)*UV(221)+JVS(1556)*UV(226)+JVS(1670)*UV(228)+JVS(2036)*UV(231)+JVS(2231)*UV(233)
  JTUV(169) = JVS(453)*UV(126)+JVS(492)*UV(133)+JVS(736)*UV(169)+JVS(1195)*UV(207)+JVS(1671)*UV(228)+JVS(1750)*UV(229)&
                &+JVS(1830)*UV(230)+JVS(2161)*UV(232)
  JTUV(170) = JVS(242)*UV(77)+JVS(745)*UV(170)+JVS(1323)*UV(214)+JVS(1557)*UV(226)+JVS(1672)*UV(228)+JVS(2038)*UV(231)
  JTUV(171) = JVS(143)*UV(53)+JVS(457)*UV(127)+JVS(754)*UV(171)+JVS(1257)*UV(210)+JVS(1511)*UV(223)+JVS(1751)*UV(229)&
                &+JVS(2162)*UV(232)
  JTUV(172) = JVS(458)*UV(127)+JVS(755)*UV(171)+JVS(761)*UV(172)+JVS(1258)*UV(210)+JVS(1512)*UV(223)+JVS(1752)*UV(229)&
                &+JVS(2163)*UV(232)
  JTUV(173) = JVS(10)*UV(5)+JVS(459)*UV(127)+JVS(771)*UV(173)+JVS(1513)*UV(223)+JVS(1753)*UV(229)+JVS(1831)*UV(230)&
                &+JVS(2164)*UV(232)
  JTUV(174) = JVS(355)*UV(105)+JVS(471)*UV(130)+JVS(778)*UV(174)+JVS(1580)*UV(227)+JVS(1676)*UV(228)+JVS(1754)*UV(229)&
                &+JVS(1832)*UV(230)+JVS(2165)*UV(232)
  JTUV(175) = JVS(540)*UV(141)+JVS(785)*UV(175)+JVS(1324)*UV(214)+JVS(1677)*UV(228)+JVS(2043)*UV(231)+JVS(2232)*UV(233)
  JTUV(176) = JVS(360)*UV(106)+JVS(463)*UV(128)+JVS(622)*UV(153)+JVS(793)*UV(176)+JVS(958)*UV(190)+JVS(1678)*UV(228)&
                &+JVS(1755)*UV(229)+JVS(1833)*UV(230)+JVS(2166)*UV(232)
  JTUV(177) = JVS(113)*UV(46)+JVS(558)*UV(144)+JVS(798)*UV(177)+JVS(819)*UV(180)+JVS(903)*UV(187)+JVS(1136)*UV(203)&
                &+JVS(1514)*UV(223)+JVS(1679)*UV(228)+JVS(1834)*UV(230)+JVS(2045)*UV(231)
  JTUV(178) = JVS(253)*UV(80)+JVS(802)*UV(178)+JVS(1236)*UV(209)+JVS(1680)*UV(228)+JVS(1757)*UV(229)+JVS(1835)*UV(230)&
                &+JVS(2168)*UV(232)
  JTUV(179) = JVS(810)*UV(179)+JVS(960)*UV(190)+JVS(1197)*UV(207)+JVS(1424)*UV(219)+JVS(1681)*UV(228)+JVS(2047)*UV(231)
  JTUV(180) = JVS(188)*UV(64)+JVS(403)*UV(114)+JVS(820)*UV(180)+JVS(981)*UV(191)+JVS(1137)*UV(203)+JVS(1198)*UV(207)&
                &+JVS(1682)*UV(228)+JVS(1758)*UV(229)+JVS(1836)*UV(230)+JVS(2169)*UV(232)
  JTUV(181) = JVS(831)*UV(181)+JVS(1471)*UV(221)+JVS(1526)*UV(224)+JVS(1581)*UV(227)+JVS(1683)*UV(228)+JVS(2049)*UV(231)
  JTUV(182) = JVS(302)*UV(92)+JVS(432)*UV(121)+JVS(604)*UV(151)+JVS(635)*UV(155)+JVS(841)*UV(182)+JVS(850)*UV(183)&
                &+JVS(961)*UV(190)+JVS(1684)*UV(228)+JVS(1759)*UV(229)+JVS(1837)*UV(230)+JVS(2170)*UV(232)
  JTUV(183) = JVS(243)*UV(77)+JVS(851)*UV(183)+JVS(1259)*UV(210)+JVS(1358)*UV(216)+JVS(1685)*UV(228)+JVS(2051)*UV(231)
  JTUV(184) = JVS(318)*UV(96)+JVS(863)*UV(184)+JVS(905)*UV(187)+JVS(1472)*UV(221)+JVS(1686)*UV(228)+JVS(1760)*UV(229)&
                &+JVS(1838)*UV(230)+JVS(2171)*UV(232)
  JTUV(185) = JVS(330)*UV(99)+JVS(449)*UV(125)+JVS(493)*UV(133)+JVS(872)*UV(185)+JVS(1040)*UV(195)+JVS(1165)*UV(206)&
                &+JVS(1199)*UV(207)+JVS(1687)*UV(228)+JVS(1761)*UV(229)+JVS(1839)*UV(230)+JVS(2172)*UV(232)
  JTUV(186) = JVS(286)*UV(88)+JVS(689)*UV(163)+JVS(880)*UV(186)+JVS(906)*UV(187)+JVS(1688)*UV(228)+JVS(1762)*UV(229)&
                &+JVS(1840)*UV(230)+JVS(2173)*UV(232)
  JTUV(187) = JVS(907)*UV(187)+JVS(1689)*UV(228)+JVS(2055)*UV(231)
  JTUV(188) = JVS(274)*UV(85)+JVS(399)*UV(113)+JVS(934)*UV(188)+JVS(1201)*UV(207)+JVS(1690)*UV(228)+JVS(1763)*UV(229)&
                &+JVS(1841)*UV(230)+JVS(2174)*UV(232)
  JTUV(189) = JVS(476)*UV(131)+JVS(527)*UV(139)+JVS(605)*UV(151)+JVS(746)*UV(170)+JVS(943)*UV(189)+JVS(1691)*UV(228)&
                &+JVS(1764)*UV(229)+JVS(1842)*UV(230)+JVS(2175)*UV(232)
  JTUV(190) = JVS(910)*UV(187)+JVS(964)*UV(190)+JVS(1426)*UV(219)+JVS(1692)*UV(228)+JVS(2058)*UV(231)
  JTUV(191) = JVS(366)*UV(107)+JVS(911)*UV(187)+JVS(965)*UV(190)+JVS(982)*UV(191)+JVS(998)*UV(192)+JVS(1095)*UV(199)&
                &+JVS(1117)*UV(201)+JVS(1427)*UV(219)+JVS(1515)*UV(223)+JVS(1693)*UV(228)+JVS(1843)*UV(230)+JVS(2059)&
                &*UV(231)
  JTUV(192) = JVS(999)*UV(192)+JVS(1844)*UV(230)+JVS(2060)*UV(231)+JVS(2176)*UV(232)
  JTUV(193) = JVS(200)*UV(67)+JVS(204)*UV(68)+JVS(710)*UV(166)+JVS(1015)*UV(193)+JVS(1041)*UV(195)+JVS(1166)*UV(206)&
                &+JVS(1694)*UV(228)+JVS(1765)*UV(229)+JVS(1845)*UV(230)+JVS(2177)*UV(232)
  JTUV(194) = JVS(445)*UV(124)+JVS(672)*UV(160)+JVS(1023)*UV(194)+JVS(1202)*UV(207)+JVS(1695)*UV(228)+JVS(1766)*UV(229)&
                &+JVS(1846)*UV(230)+JVS(2178)*UV(232)
  JTUV(195) = JVS(1042)*UV(195)+JVS(1261)*UV(210)+JVS(1429)*UV(219)+JVS(1474)*UV(221)+JVS(2063)*UV(231)
  JTUV(196) = JVS(477)*UV(131)+JVS(528)*UV(139)+JVS(575)*UV(147)+JVS(606)*UV(151)+JVS(636)*UV(155)+JVS(747)*UV(170)&
                &+JVS(1055)*UV(196)+JVS(1696)*UV(228)+JVS(1767)*UV(229)+JVS(1847)*UV(230)+JVS(2179)*UV(232)
  JTUV(197) = JVS(501)*UV(134)+JVS(547)*UV(142)+JVS(576)*UV(147)+JVS(854)*UV(183)+JVS(1062)*UV(197)+JVS(1697)*UV(228)&
                &+JVS(1768)*UV(229)+JVS(1848)*UV(230)+JVS(2180)*UV(232)
  JTUV(198) = JVS(196)*UV(66)+JVS(338)*UV(101)+JVS(1084)*UV(198)+JVS(1096)*UV(199)+JVS(1203)*UV(207)+JVS(1698)*UV(228)&
                &+JVS(1769)*UV(229)+JVS(1849)*UV(230)+JVS(2181)*UV(232)
  JTUV(199) = JVS(914)*UV(187)+JVS(935)*UV(188)+JVS(1002)*UV(192)+JVS(1097)*UV(199)+JVS(1204)*UV(207)+JVS(1699)*UV(228)&
                &+JVS(1850)*UV(230)+JVS(2067)*UV(231)
  JTUV(200) = JVS(278)*UV(86)+JVS(415)*UV(117)+JVS(811)*UV(179)+JVS(968)*UV(190)+JVS(1098)*UV(199)+JVS(1108)*UV(200)&
                &+JVS(1205)*UV(207)+JVS(1432)*UV(219)+JVS(1700)*UV(228)+JVS(1771)*UV(229)+JVS(1851)*UV(230)+JVS(2183)&
                &*UV(232)
  JTUV(201) = JVS(282)*UV(87)+JVS(407)*UV(115)+JVS(812)*UV(179)+JVS(916)*UV(187)+JVS(1099)*UV(199)+JVS(1118)*UV(201)&
                &+JVS(1433)*UV(219)+JVS(1701)*UV(228)+JVS(1772)*UV(229)+JVS(1852)*UV(230)+JVS(2184)*UV(232)
  JTUV(202) = JVS(356)*UV(105)+JVS(472)*UV(130)+JVS(832)*UV(181)+JVS(1127)*UV(202)+JVS(1702)*UV(228)+JVS(1773)*UV(229)&
                &+JVS(1853)*UV(230)+JVS(2185)*UV(232)
  JTUV(203) = JVS(367)*UV(107)+JVS(917)*UV(187)+JVS(970)*UV(190)+JVS(1003)*UV(192)+JVS(1109)*UV(200)+JVS(1139)*UV(203)&
                &+JVS(1207)*UV(207)+JVS(1434)*UV(219)+JVS(1516)*UV(223)+JVS(1703)*UV(228)+JVS(1854)*UV(230)+JVS(2071)&
                &*UV(231)
  JTUV(204) = JVS(180)*UV(62)+JVS(395)*UV(112)+JVS(1148)*UV(204)+JVS(1329)*UV(214)+JVS(1704)*UV(228)+JVS(1775)*UV(229)&
                &+JVS(1855)*UV(230)+JVS(2187)*UV(232)
  JTUV(205) = JVS(314)*UV(95)+JVS(682)*UV(162)+JVS(1024)*UV(194)+JVS(1043)*UV(195)+JVS(1159)*UV(205)+JVS(1705)*UV(228)&
                &+JVS(1776)*UV(229)+JVS(1856)*UV(230)+JVS(2188)*UV(232)
  JTUV(206) = JVS(160)*UV(57)+JVS(326)*UV(98)+JVS(1128)*UV(202)+JVS(1167)*UV(206)+JVS(1706)*UV(228)+JVS(1777)*UV(229)&
                &+JVS(1857)*UV(230)+JVS(2189)*UV(232)
  JTUV(207) = JVS(920)*UV(187)+JVS(1005)*UV(192)+JVS(1209)*UV(207)+JVS(1707)*UV(228)+JVS(1858)*UV(230)+JVS(2075)*UV(231)
  JTUV(208) = JVS(168)*UV(59)+JVS(1226)*UV(208)+JVS(1436)*UV(219)+JVS(1708)*UV(228)+JVS(1778)*UV(229)+JVS(1859)*UV(230)&
                &+JVS(2191)*UV(232)+JVS(2234)*UV(233)
  JTUV(209) = JVS(350)*UV(104)+JVS(514)*UV(137)+JVS(1237)*UV(209)+JVS(1584)*UV(227)+JVS(1709)*UV(228)+JVS(1779)*UV(229)&
                &+JVS(1860)*UV(230)+JVS(2192)*UV(232)+JVS(2235)*UV(233)
  JTUV(210) = JVS(77)*UV(35)+JVS(82)*UV(37)+JVS(294)*UV(90)+JVS(306)*UV(93)+JVS(1210)*UV(207)+JVS(1265)*UV(210)&
                &+JVS(1710)*UV(228)+JVS(1780)*UV(229)+JVS(1861)*UV(230)+JVS(2193)*UV(232)
  JTUV(211) = JVS(342)*UV(102)+JVS(346)*UV(103)+JVS(1044)*UV(195)+JVS(1280)*UV(211)+JVS(1562)*UV(226)+JVS(1711)*UV(228)&
                &+JVS(1781)*UV(229)+JVS(1862)*UV(230)+JVS(2194)*UV(232)
  JTUV(212) = JVS(216)*UV(71)+JVS(322)*UV(97)+JVS(661)*UV(158)+JVS(1291)*UV(212)+JVS(1712)*UV(228)+JVS(1782)*UV(229)&
                &+JVS(1863)*UV(230)+JVS(2195)*UV(232)
  JTUV(213) = JVS(152)*UV(55)+JVS(262)*UV(82)+JVS(1306)*UV(213)+JVS(1713)*UV(228)+JVS(1783)*UV(229)+JVS(1864)*UV(230)&
                &+JVS(2196)*UV(232)+JVS(2236)*UV(233)
  JTUV(214) = JVS(102)*UV(43)+JVS(224)*UV(73)+JVS(298)*UV(91)+JVS(1330)*UV(214)+JVS(1714)*UV(228)+JVS(1784)*UV(229)&
                &+JVS(1865)*UV(230)+JVS(2197)*UV(232)+JVS(2237)*UV(233)
  JTUV(215) = JVS(232)*UV(75)+JVS(334)*UV(100)+JVS(375)*UV(108)+JVS(589)*UV(149)+JVS(1046)*UV(195)+JVS(1213)*UV(207)&
                &+JVS(1345)*UV(215)+JVS(1715)*UV(228)+JVS(1785)*UV(229)+JVS(1866)*UV(230)+JVS(2198)*UV(232)
  JTUV(216) = JVS(135)*UV(51)+JVS(156)*UV(56)+JVS(310)*UV(94)+JVS(1365)*UV(216)+JVS(1585)*UV(227)+JVS(1716)*UV(228)&
                &+JVS(1786)*UV(229)+JVS(1867)*UV(230)+JVS(2199)*UV(232)
  JTUV(217) = JVS(411)*UV(116)+JVS(1149)*UV(204)+JVS(1376)*UV(217)+JVS(1717)*UV(228)+JVS(1787)*UV(229)+JVS(1868)*UV(230)&
                &+JVS(2200)*UV(232)+JVS(2239)*UV(233)
  JTUV(218) = JVS(148)*UV(54)+JVS(419)*UV(118)+JVS(1214)*UV(207)+JVS(1399)*UV(218)+JVS(1718)*UV(228)+JVS(1788)*UV(229)&
                &+JVS(1869)*UV(230)+JVS(2201)*UV(232)+JVS(2240)*UV(233)
  JTUV(219) = JVS(236)*UV(76)+JVS(467)*UV(129)+JVS(1269)*UV(210)+JVS(1443)*UV(219)+JVS(1719)*UV(228)+JVS(1789)*UV(229)&
                &+JVS(1870)*UV(230)+JVS(2202)*UV(232)
  JTUV(220) = JVS(258)*UV(81)+JVS(803)*UV(178)+JVS(1458)*UV(220)+JVS(1720)*UV(228)+JVS(1790)*UV(229)+JVS(1871)*UV(230)&
                &+JVS(2203)*UV(232)
  JTUV(221) = JVS(164)*UV(58)+JVS(1216)*UV(207)+JVS(1445)*UV(219)+JVS(1484)*UV(221)+JVS(1721)*UV(228)+JVS(1791)*UV(229)&
                &+JVS(1872)*UV(230)+JVS(2204)*UV(232)
  JTUV(222) = JVS(208)*UV(69)+JVS(441)*UV(123)+JVS(1292)*UV(212)+JVS(1498)*UV(222)+JVS(1722)*UV(228)+JVS(1792)*UV(229)&
                &+JVS(1873)*UV(230)+JVS(2205)*UV(232)
  JTUV(223) = JVS(20)*UV(8)+JVS(93)*UV(40)+JVS(114)*UV(46)+JVS(140)*UV(52)+JVS(144)*UV(53)+JVS(368)*UV(107)+JVS(376)&
                &*UV(108)+JVS(494)*UV(133)+JVS(552)*UV(143)+JVS(594)*UV(150)+JVS(628)*UV(154)+JVS(667)*UV(159)+JVS(678)&
                &*UV(161)+JVS(701)*UV(165)+JVS(711)*UV(166)+JVS(756)*UV(171)+JVS(762)*UV(172)+JVS(772)*UV(173)+JVS(799)&
                &*UV(177)+JVS(922)*UV(187)+JVS(973)*UV(190)+JVS(983)*UV(191)+JVS(1048)*UV(195)+JVS(1101)*UV(199)+JVS(1129)&
                &*UV(202)+JVS(1140)*UV(203)+JVS(1217)*UV(207)+JVS(1271)*UV(210)+JVS(1346)*UV(215)+JVS(1447)*UV(219)&
                &+JVS(1517)*UV(223)+JVS(1723)*UV(228)+JVS(1793)*UV(229)+JVS(1874)*UV(230)+JVS(2091)*UV(231)+JVS(2206)&
                &*UV(232)+JVS(2244)*UV(233)
  JTUV(224) = JVS(249)*UV(79)+JVS(254)*UV(80)+JVS(1532)*UV(224)+JVS(1546)*UV(225)+JVS(1724)*UV(228)+JVS(1794)*UV(229)&
                &+JVS(1875)*UV(230)+JVS(2207)*UV(232)
  JTUV(225) = JVS(351)*UV(104)+JVS(515)*UV(137)+JVS(728)*UV(168)+JVS(1547)*UV(225)+JVS(1725)*UV(228)+JVS(1795)*UV(229)&
                &+JVS(1876)*UV(230)+JVS(2208)*UV(232)
  JTUV(226) = JVS(505)*UV(135)+JVS(541)*UV(141)+JVS(787)*UV(175)+JVS(1334)*UV(214)+JVS(1569)*UV(226)+JVS(1726)*UV(228)&
                &+JVS(1796)*UV(229)+JVS(1877)*UV(230)+JVS(2209)*UV(232)+JVS(2247)*UV(233)
  JTUV(227) = JVS(923)*UV(187)+JVS(1007)*UV(192)+JVS(1150)*UV(204)+JVS(1335)*UV(214)+JVS(1592)*UV(227)+JVS(1727)*UV(228)&
                &+JVS(1878)*UV(230)+JVS(2095)*UV(231)
  JTUV(228) = JVS(14)*UV(6)+JVS(145)*UV(53)+JVS(157)*UV(56)+JVS(161)*UV(57)+JVS(165)*UV(58)+JVS(169)*UV(59)+JVS(173)&
                &*UV(60)+JVS(177)*UV(61)+JVS(181)*UV(62)+JVS(184)*UV(63)+JVS(193)*UV(65)+JVS(205)*UV(68)+JVS(209)*UV(69)&
                &+JVS(213)*UV(70)+JVS(217)*UV(71)+JVS(221)*UV(72)+JVS(225)*UV(73)+JVS(229)*UV(74)+JVS(233)*UV(75)+JVS(237)&
                &*UV(76)+JVS(255)*UV(80)+JVS(259)*UV(81)+JVS(263)*UV(82)+JVS(267)*UV(83)+JVS(275)*UV(85)+JVS(279)*UV(86)&
                &+JVS(287)*UV(88)+JVS(291)*UV(89)+JVS(303)*UV(92)+JVS(307)*UV(93)+JVS(315)*UV(95)+JVS(319)*UV(96)+JVS(339)&
                &*UV(101)+JVS(347)*UV(103)+JVS(361)*UV(106)+JVS(369)*UV(107)+JVS(404)*UV(114)+JVS(408)*UV(115)+JVS(412)&
                &*UV(116)+JVS(420)*UV(118)+JVS(446)*UV(124)+JVS(450)*UV(125)+JVS(454)*UV(126)+JVS(473)*UV(130)+JVS(478)&
                &*UV(131)+JVS(502)*UV(134)+JVS(516)*UV(137)+JVS(559)*UV(144)+JVS(564)*UV(145)+JVS(569)*UV(146)+JVS(585)&
                &*UV(148)+JVS(590)*UV(149)+JVS(643)*UV(156)+JVS(654)*UV(157)+JVS(662)*UV(158)+JVS(696)*UV(164)+JVS(719)&
                &*UV(167)+JVS(738)*UV(169)+JVS(780)*UV(174)+JVS(788)*UV(175)+JVS(794)*UV(176)+JVS(804)*UV(178)+JVS(822)&
                &*UV(180)+JVS(842)*UV(182)+JVS(866)*UV(184)+JVS(874)*UV(185)+JVS(882)*UV(186)+JVS(937)*UV(188)+JVS(944)&
                &*UV(189)+JVS(1017)*UV(193)+JVS(1025)*UV(194)+JVS(1056)*UV(196)+JVS(1063)*UV(197)+JVS(1087)*UV(198)&
                &+JVS(1110)*UV(200)+JVS(1120)*UV(201)+JVS(1130)*UV(202)+JVS(1151)*UV(204)+JVS(1161)*UV(205)+JVS(1169)&
                &*UV(206)+JVS(1229)*UV(208)+JVS(1240)*UV(209)+JVS(1272)*UV(210)+JVS(1283)*UV(211)+JVS(1294)*UV(212)&
                &+JVS(1310)*UV(213)+JVS(1336)*UV(214)+JVS(1347)*UV(215)+JVS(1370)*UV(216)+JVS(1379)*UV(217)+JVS(1405)&
                &*UV(218)+JVS(1450)*UV(219)+JVS(1460)*UV(220)+JVS(1489)*UV(221)+JVS(1500)*UV(222)+JVS(1518)*UV(223)&
                &+JVS(1533)*UV(224)+JVS(1548)*UV(225)+JVS(1570)*UV(226)+JVS(1728)*UV(228)+JVS(1798)*UV(229)+JVS(1879)&
                &*UV(230)+JVS(2096)*UV(231)+JVS(2211)*UV(232)
  JTUV(229) = JVS(96)*UV(41)+JVS(149)*UV(54)+JVS(153)*UV(55)+JVS(189)*UV(64)+JVS(197)*UV(66)+JVS(201)*UV(67)+JVS(250)&
                &*UV(79)+JVS(271)*UV(84)+JVS(295)*UV(90)+JVS(299)*UV(91)+JVS(311)*UV(94)+JVS(323)*UV(97)+JVS(327)*UV(98)&
                &+JVS(331)*UV(99)+JVS(335)*UV(100)+JVS(343)*UV(102)+JVS(352)*UV(104)+JVS(357)*UV(105)+JVS(378)*UV(108)&
                &+JVS(391)*UV(111)+JVS(424)*UV(119)+JVS(433)*UV(121)+JVS(464)*UV(128)+JVS(496)*UV(133)+JVS(506)*UV(135)&
                &+JVS(529)*UV(139)+JVS(542)*UV(141)+JVS(548)*UV(142)+JVS(553)*UV(143)+JVS(560)*UV(144)+JVS(565)*UV(145)&
                &+JVS(570)*UV(146)+JVS(580)*UV(147)+JVS(586)*UV(148)+JVS(591)*UV(149)+JVS(608)*UV(151)+JVS(616)*UV(152)&
                &+JVS(624)*UV(153)+JVS(638)*UV(155)+JVS(644)*UV(156)+JVS(655)*UV(157)+JVS(663)*UV(158)+JVS(674)*UV(160)&
                &+JVS(683)*UV(162)+JVS(691)*UV(163)+JVS(697)*UV(164)+JVS(713)*UV(166)+JVS(720)*UV(167)+JVS(730)*UV(168)&
                &+JVS(739)*UV(169)+JVS(750)*UV(170)+JVS(773)*UV(173)+JVS(781)*UV(174)+JVS(795)*UV(176)+JVS(805)*UV(178)&
                &+JVS(815)*UV(179)+JVS(823)*UV(180)+JVS(836)*UV(181)+JVS(843)*UV(182)+JVS(856)*UV(183)+JVS(867)*UV(184)&
                &+JVS(875)*UV(185)+JVS(883)*UV(186)+JVS(925)*UV(187)+JVS(938)*UV(188)+JVS(945)*UV(189)+JVS(975)*UV(190)&
                &+JVS(985)*UV(191)+JVS(1018)*UV(193)+JVS(1026)*UV(194)+JVS(1050)*UV(195)+JVS(1057)*UV(196)+JVS(1064)*UV(197)&
                &+JVS(1088)*UV(198)+JVS(1103)*UV(199)+JVS(1111)*UV(200)+JVS(1121)*UV(201)+JVS(1131)*UV(202)+JVS(1142)&
                &*UV(203)+JVS(1152)*UV(204)+JVS(1162)*UV(205)+JVS(1170)*UV(206)+JVS(1219)*UV(207)+JVS(1230)*UV(208)&
                &+JVS(1241)*UV(209)+JVS(1273)*UV(210)+JVS(1284)*UV(211)+JVS(1295)*UV(212)+JVS(1311)*UV(213)+JVS(1337)&
                &*UV(214)+JVS(1348)*UV(215)+JVS(1371)*UV(216)+JVS(1380)*UV(217)+JVS(1406)*UV(218)+JVS(1451)*UV(219)&
                &+JVS(1461)*UV(220)+JVS(1490)*UV(221)+JVS(1501)*UV(222)+JVS(1519)*UV(223)+JVS(1534)*UV(224)+JVS(1549)&
                &*UV(225)+JVS(1571)*UV(226)+JVS(1594)*UV(227)+JVS(1729)*UV(228)+JVS(1799)*UV(229)+JVS(1880)*UV(230)&
                &+JVS(2097)*UV(231)+JVS(2212)*UV(232)+JVS(2250)*UV(233)
  JTUV(230) = JVS(69)*UV(32)+JVS(118)*UV(47)+JVS(122)*UV(48)+JVS(127)*UV(49)+JVS(131)*UV(50)+JVS(379)*UV(108)+JVS(382)&
                &*UV(109)+JVS(387)*UV(110)+JVS(392)*UV(111)+JVS(428)*UV(120)+JVS(437)*UV(122)+JVS(497)*UV(133)+JVS(511)&
                &*UV(136)+JVS(543)*UV(141)+JVS(561)*UV(144)+JVS(566)*UV(145)+JVS(571)*UV(146)+JVS(581)*UV(147)+JVS(587)&
                &*UV(148)+JVS(592)*UV(149)+JVS(595)*UV(150)+JVS(609)*UV(151)+JVS(617)*UV(152)+JVS(625)*UV(153)+JVS(629)&
                &*UV(154)+JVS(639)*UV(155)+JVS(645)*UV(156)+JVS(656)*UV(157)+JVS(664)*UV(158)+JVS(668)*UV(159)+JVS(675)&
                &*UV(160)+JVS(679)*UV(161)+JVS(692)*UV(163)+JVS(698)*UV(164)+JVS(702)*UV(165)+JVS(714)*UV(166)+JVS(721)&
                &*UV(167)+JVS(731)*UV(168)+JVS(740)*UV(169)+JVS(751)*UV(170)+JVS(757)*UV(171)+JVS(774)*UV(173)+JVS(782)&
                &*UV(174)+JVS(796)*UV(176)+JVS(800)*UV(177)+JVS(806)*UV(178)+JVS(816)*UV(179)+JVS(824)*UV(180)+JVS(837)&
                &*UV(181)+JVS(844)*UV(182)+JVS(857)*UV(183)+JVS(868)*UV(184)+JVS(876)*UV(185)+JVS(884)*UV(186)+JVS(926)&
                &*UV(187)+JVS(939)*UV(188)+JVS(946)*UV(189)+JVS(976)*UV(190)+JVS(986)*UV(191)+JVS(1010)*UV(192)+JVS(1019)&
                &*UV(193)+JVS(1027)*UV(194)+JVS(1051)*UV(195)+JVS(1058)*UV(196)+JVS(1065)*UV(197)+JVS(1089)*UV(198)&
                &+JVS(1104)*UV(199)+JVS(1112)*UV(200)+JVS(1122)*UV(201)+JVS(1132)*UV(202)+JVS(1143)*UV(203)+JVS(1153)&
                &*UV(204)+JVS(1163)*UV(205)+JVS(1171)*UV(206)+JVS(1220)*UV(207)+JVS(1231)*UV(208)+JVS(1242)*UV(209)&
                &+JVS(1274)*UV(210)+JVS(1285)*UV(211)+JVS(1296)*UV(212)+JVS(1312)*UV(213)+JVS(1338)*UV(214)+JVS(1349)&
                &*UV(215)+JVS(1372)*UV(216)+JVS(1381)*UV(217)+JVS(1407)*UV(218)+JVS(1452)*UV(219)+JVS(1462)*UV(220)&
                &+JVS(1491)*UV(221)+JVS(1502)*UV(222)+JVS(1535)*UV(224)+JVS(1550)*UV(225)+JVS(1572)*UV(226)+JVS(1595)&
                &*UV(227)+JVS(1730)*UV(228)+JVS(1800)*UV(229)+JVS(1881)*UV(230)+JVS(2098)*UV(231)+JVS(2213)*UV(232)&
                &+JVS(2251)*UV(233)
  JTUV(231) = JVS(15)*UV(6)+JVS(18)*UV(7)+JVS(22)*UV(9)+JVS(25)*UV(10)+JVS(27)*UV(11)+JVS(29)*UV(12)+JVS(31)*UV(13)&
                &+JVS(33)*UV(14)+JVS(35)*UV(15)+JVS(37)*UV(16)+JVS(39)*UV(17)+JVS(41)*UV(18)+JVS(43)*UV(19)+JVS(45)*UV(20)&
                &+JVS(47)*UV(21)+JVS(49)*UV(22)+JVS(51)*UV(23)+JVS(53)*UV(24)+JVS(55)*UV(25)+JVS(57)*UV(26)+JVS(59)*UV(27)&
                &+JVS(61)*UV(28)+JVS(63)*UV(29)+JVS(65)*UV(30)+JVS(67)*UV(31)+JVS(72)*UV(33)+JVS(75)*UV(34)+JVS(80)*UV(36)&
                &+JVS(83)*UV(37)+JVS(86)*UV(38)+JVS(90)*UV(39)+JVS(94)*UV(40)+JVS(97)*UV(41)+JVS(100)*UV(42)+JVS(103)*UV(43)&
                &+JVS(106)*UV(44)+JVS(109)*UV(45)+JVS(115)*UV(46)+JVS(119)*UV(47)+JVS(123)*UV(48)+JVS(128)*UV(49)+JVS(132)&
                &*UV(50)+JVS(136)*UV(51)+JVS(141)*UV(52)+JVS(150)*UV(54)+JVS(154)*UV(55)+JVS(158)*UV(56)+JVS(162)*UV(57)&
                &+JVS(166)*UV(58)+JVS(170)*UV(59)+JVS(174)*UV(60)+JVS(178)*UV(61)+JVS(182)*UV(62)+JVS(185)*UV(63)+JVS(190)&
                &*UV(64)+JVS(194)*UV(65)+JVS(198)*UV(66)+JVS(202)*UV(67)+JVS(206)*UV(68)+JVS(210)*UV(69)+JVS(214)*UV(70)&
                &+JVS(218)*UV(71)+JVS(222)*UV(72)+JVS(226)*UV(73)+JVS(230)*UV(74)+JVS(234)*UV(75)+JVS(238)*UV(76)+JVS(244)&
                &*UV(77)+JVS(247)*UV(78)+JVS(251)*UV(79)+JVS(256)*UV(80)+JVS(260)*UV(81)+JVS(264)*UV(82)+JVS(268)*UV(83)&
                &+JVS(272)*UV(84)+JVS(276)*UV(85)+JVS(280)*UV(86)+JVS(283)*UV(87)+JVS(288)*UV(88)+JVS(292)*UV(89)+JVS(296)&
                &*UV(90)+JVS(300)*UV(91)+JVS(304)*UV(92)+JVS(308)*UV(93)+JVS(312)*UV(94)+JVS(316)*UV(95)+JVS(320)*UV(96)&
                &+JVS(324)*UV(97)+JVS(328)*UV(98)+JVS(332)*UV(99)+JVS(336)*UV(100)+JVS(340)*UV(101)+JVS(344)*UV(102)&
                &+JVS(348)*UV(103)+JVS(353)*UV(104)+JVS(358)*UV(105)+JVS(362)*UV(106)+JVS(370)*UV(107)+JVS(380)*UV(108)&
                &+JVS(383)*UV(109)+JVS(388)*UV(110)+JVS(393)*UV(111)+JVS(396)*UV(112)+JVS(400)*UV(113)+JVS(405)*UV(114)&
                &+JVS(409)*UV(115)+JVS(413)*UV(116)+JVS(416)*UV(117)+JVS(421)*UV(118)+JVS(425)*UV(119)+JVS(429)*UV(120)&
                &+JVS(434)*UV(121)+JVS(438)*UV(122)+JVS(442)*UV(123)+JVS(447)*UV(124)+JVS(451)*UV(125)+JVS(455)*UV(126)&
                &+JVS(460)*UV(127)+JVS(465)*UV(128)+JVS(468)*UV(129)+JVS(474)*UV(130)+JVS(479)*UV(131)+JVS(486)*UV(132)&
                &+JVS(498)*UV(133)+JVS(503)*UV(134)+JVS(507)*UV(135)+JVS(512)*UV(136)+JVS(517)*UV(137)+JVS(525)*UV(138)&
                &+JVS(530)*UV(139)+JVS(537)*UV(140)+JVS(544)*UV(141)+JVS(549)*UV(142)+JVS(582)*UV(147)+JVS(596)*UV(150)&
                &+JVS(610)*UV(151)+JVS(618)*UV(152)+JVS(626)*UV(153)+JVS(630)*UV(154)+JVS(640)*UV(155)+JVS(646)*UV(156)&
                &+JVS(657)*UV(157)+JVS(665)*UV(158)+JVS(669)*UV(159)+JVS(676)*UV(160)+JVS(680)*UV(161)+JVS(684)*UV(162)&
                &+JVS(693)*UV(163)+JVS(699)*UV(164)+JVS(703)*UV(165)+JVS(715)*UV(166)+JVS(732)*UV(168)+JVS(741)*UV(169)&
                &+JVS(752)*UV(170)+JVS(758)*UV(171)+JVS(791)*UV(175)+JVS(797)*UV(176)+JVS(801)*UV(177)+JVS(817)*UV(179)&
                &+JVS(825)*UV(180)+JVS(838)*UV(181)+JVS(845)*UV(182)+JVS(858)*UV(183)+JVS(869)*UV(184)+JVS(877)*UV(185)&
                &+JVS(885)*UV(186)+JVS(927)*UV(187)+JVS(940)*UV(188)+JVS(947)*UV(189)+JVS(977)*UV(190)+JVS(987)*UV(191)&
                &+JVS(1011)*UV(192)+JVS(1020)*UV(193)+JVS(1028)*UV(194)+JVS(1052)*UV(195)+JVS(1059)*UV(196)+JVS(1066)&
                &*UV(197)+JVS(1090)*UV(198)+JVS(1105)*UV(199)+JVS(1113)*UV(200)+JVS(1123)*UV(201)+JVS(1144)*UV(203)&
                &+JVS(1154)*UV(204)+JVS(1164)*UV(205)+JVS(1221)*UV(207)+JVS(1232)*UV(208)+JVS(1243)*UV(209)+JVS(1275)&
                &*UV(210)+JVS(1286)*UV(211)+JVS(1297)*UV(212)+JVS(1313)*UV(213)+JVS(1339)*UV(214)+JVS(1350)*UV(215)&
                &+JVS(1373)*UV(216)+JVS(1382)*UV(217)+JVS(1408)*UV(218)+JVS(1453)*UV(219)+JVS(1463)*UV(220)+JVS(1492)&
                &*UV(221)+JVS(1503)*UV(222)+JVS(1521)*UV(223)+JVS(1536)*UV(224)+JVS(1551)*UV(225)+JVS(1573)*UV(226)&
                &+JVS(1596)*UV(227)+JVS(1731)*UV(228)+JVS(1801)*UV(229)+JVS(1882)*UV(230)+JVS(2099)*UV(231)+JVS(2214)&
                &*UV(232)+JVS(2252)*UV(233)
  JTUV(232) = JVS(70)*UV(32)+JVS(78)*UV(35)+JVS(124)*UV(48)+JVS(133)*UV(50)+JVS(146)*UV(53)+JVS(186)*UV(63)+JVS(284)&
                &*UV(87)+JVS(397)*UV(112)+JVS(401)*UV(113)+JVS(417)*UV(117)+JVS(430)*UV(120)+JVS(439)*UV(122)+JVS(443)&
                &*UV(123)+JVS(461)*UV(127)+JVS(469)*UV(129)+JVS(556)*UV(143)+JVS(759)*UV(171)+JVS(766)*UV(172)+JVS(776)&
                &*UV(173)+JVS(941)*UV(188)+JVS(1012)*UV(192)+JVS(1114)*UV(200)+JVS(1124)*UV(201)+JVS(1155)*UV(204)+JVS(1276)&
                &*UV(210)+JVS(1454)*UV(219)+JVS(1504)*UV(222)+JVS(1522)*UV(223)+JVS(1732)*UV(228)+JVS(1802)*UV(229)&
                &+JVS(1883)*UV(230)+JVS(2100)*UV(231)+JVS(2215)*UV(232)
  JTUV(233) = JVS(929)*UV(187)+JVS(1013)*UV(192)+JVS(1277)*UV(210)+JVS(1455)*UV(219)+JVS(1733)*UV(228)+JVS(1884)*UV(230)&
                &+JVS(2101)*UV(231)+JVS(2254)*UV(233)
      
END SUBROUTINE JacTR_SP_Vec

! End of JacTR_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE cri_mosaic_4bin_aq_Jacobian

