! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : crimech_Parameters.f90
! Time                 : Tue Sep 16 01:33:51 2014
! Working directory    : /data/users/lenzen/WRF/WRFV3.5.1/WRFV3/chem/KPP/mechanisms/crimech
! Equation file        : crimech.kpp
! Output root filename : crimech
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE crimech_Parameters

  USE crimech_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 234 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 232 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 229 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 2 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 636 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 233 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 1886 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 2257 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 233 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 0 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 
! PI - Value of pi
  REAL(kind=dp), PARAMETER :: PI = 3.14159265358979 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_HCl = 1 
  INTEGER, PARAMETER :: ind_NH3 = 2 
  INTEGER, PARAMETER :: ind_H2SO4 = 3 
  INTEGER, PARAMETER :: ind_SO3 = 4 
  INTEGER, PARAMETER :: ind_MSA = 5 
  INTEGER, PARAMETER :: ind_DMSO2 = 6 
  INTEGER, PARAMETER :: ind_O1D = 7 
  INTEGER, PARAMETER :: ind_C2H6 = 8 
  INTEGER, PARAMETER :: ind_HSO3 = 9 
  INTEGER, PARAMETER :: ind_NC4H10 = 10 
  INTEGER, PARAMETER :: ind_CH3CL = 11 
  INTEGER, PARAMETER :: ind_CH2CL2 = 12 
  INTEGER, PARAMETER :: ind_CHCL3 = 13 
  INTEGER, PARAMETER :: ind_CH3CCL3 = 14 
  INTEGER, PARAMETER :: ind_CDICLETH = 15 
  INTEGER, PARAMETER :: ind_TDICLETH = 16 
  INTEGER, PARAMETER :: ind_TRICLETH = 17 
  INTEGER, PARAMETER :: ind_TCE = 18 
  INTEGER, PARAMETER :: ind_CH4 = 19 
  INTEGER, PARAMETER :: ind_TM135B = 20 
  INTEGER, PARAMETER :: ind_OETHTOL = 21 
  INTEGER, PARAMETER :: ind_METHTOL = 22 
  INTEGER, PARAMETER :: ind_PETHTOL = 23 
  INTEGER, PARAMETER :: ind_DIME35EB = 24 
  INTEGER, PARAMETER :: ind_C3H8 = 25 
  INTEGER, PARAMETER :: ind_OXYL = 26 
  INTEGER, PARAMETER :: ind_TM123B = 27 
  INTEGER, PARAMETER :: ind_TM124B = 28 
  INTEGER, PARAMETER :: ind_BENZENE = 29 
  INTEGER, PARAMETER :: ind_TOLUENE = 30 
  INTEGER, PARAMETER :: ind_MEK = 31 
  INTEGER, PARAMETER :: ind_N2O5 = 32 
  INTEGER, PARAMETER :: ind_TNCARB15 = 33 
  INTEGER, PARAMETER :: ind_CH3O2NO2 = 34 
  INTEGER, PARAMETER :: ind_C2H2 = 35 
  INTEGER, PARAMETER :: ind_CH3OH = 36 
  INTEGER, PARAMETER :: ind_CARB15 = 37 
  INTEGER, PARAMETER :: ind_CCARB12 = 38 
  INTEGER, PARAMETER :: ind_RCOOH25 = 39 
  INTEGER, PARAMETER :: ind_HONO = 40 
  INTEGER, PARAMETER :: ind_DMSO = 41 
  INTEGER, PARAMETER :: ind_C2H5OH = 42 
  INTEGER, PARAMETER :: ind_IPROPOL = 43 
  INTEGER, PARAMETER :: ind_CARB12 = 44 
  INTEGER, PARAMETER :: ind_HCOOH = 45 
  INTEGER, PARAMETER :: ind_AROH14 = 46 
  INTEGER, PARAMETER :: ind_RAROH14 = 47 
  INTEGER, PARAMETER :: ind_AROH17 = 48 
  INTEGER, PARAMETER :: ind_RAROH17 = 49 
  INTEGER, PARAMETER :: ind_NPROPOL = 50 
  INTEGER, PARAMETER :: ind_CH3CO2H = 51 
  INTEGER, PARAMETER :: ind_CH3SO3 = 52 
  INTEGER, PARAMETER :: ind_CH3CO3H = 53 
  INTEGER, PARAMETER :: ind_RN9NO3 = 54 
  INTEGER, PARAMETER :: ind_RN12NO3 = 55 
  INTEGER, PARAMETER :: ind_RN10OOH = 56 
  INTEGER, PARAMETER :: ind_RN19OOH = 57 
  INTEGER, PARAMETER :: ind_RN8OOH = 58 
  INTEGER, PARAMETER :: ind_RN11OOH = 59 
  INTEGER, PARAMETER :: ind_NRN6OOH = 60 
  INTEGER, PARAMETER :: ind_NRN12OOH = 61 
  INTEGER, PARAMETER :: ind_C2H5CO3H = 62 
  INTEGER, PARAMETER :: ind_RU14NO3 = 63 
  INTEGER, PARAMETER :: ind_NRU14OOH = 64 
  INTEGER, PARAMETER :: ind_HOC2H4NO3 = 65 
  INTEGER, PARAMETER :: ind_RTN28NO3 = 66 
  INTEGER, PARAMETER :: ind_RTN28OOH = 67 
  INTEGER, PARAMETER :: ind_RTN26OOH = 68 
  INTEGER, PARAMETER :: ind_NRTN28OOH = 69 
  INTEGER, PARAMETER :: ind_RTN25OOH = 70 
  INTEGER, PARAMETER :: ind_RTN24OOH = 71 
  INTEGER, PARAMETER :: ind_RTX24OOH = 72 
  INTEGER, PARAMETER :: ind_C2H5OOH = 73 
  INTEGER, PARAMETER :: ind_HNO4 = 74 
  INTEGER, PARAMETER :: ind_IC3H7OOH = 75 
  INTEGER, PARAMETER :: ind_ANHY = 76 
  INTEGER, PARAMETER :: ind_TNCARB12 = 77 
  INTEGER, PARAMETER :: ind_RN18NO3 = 78 
  INTEGER, PARAMETER :: ind_RN16NO3 = 79 
  INTEGER, PARAMETER :: ind_RN16OOH = 80 
  INTEGER, PARAMETER :: ind_RN17OOH = 81 
  INTEGER, PARAMETER :: ind_RN12OOH = 82 
  INTEGER, PARAMETER :: ind_NRN9OOH = 83 
  INTEGER, PARAMETER :: ind_HOCH2CO3H = 84 
  INTEGER, PARAMETER :: ind_IC3H7NO3 = 85 
  INTEGER, PARAMETER :: ind_RU10OOH = 86 
  INTEGER, PARAMETER :: ind_RU12PAN = 87 
  INTEGER, PARAMETER :: ind_NRU12OOH = 88 
  INTEGER, PARAMETER :: ind_RA13OOH = 89 
  INTEGER, PARAMETER :: ind_CH3NO3 = 90 
  INTEGER, PARAMETER :: ind_RA16OOH = 91 
  INTEGER, PARAMETER :: ind_C2H5NO3 = 92 
  INTEGER, PARAMETER :: ind_RTN23OOH = 93 
  INTEGER, PARAMETER :: ind_RTN10OOH = 94 
  INTEGER, PARAMETER :: ind_RTN25NO3 = 95 
  INTEGER, PARAMETER :: ind_RTX28NO3 = 96 
  INTEGER, PARAMETER :: ind_RTX24NO3 = 97 
  INTEGER, PARAMETER :: ind_RN10NO3 = 98 
  INTEGER, PARAMETER :: ind_RTX22NO3 = 99 
  INTEGER, PARAMETER :: ind_RTX22OOH = 100 
  INTEGER, PARAMETER :: ind_CH3OOH = 101 
  INTEGER, PARAMETER :: ind_RN15NO3 = 102 
  INTEGER, PARAMETER :: ind_RN19NO3 = 103 
  INTEGER, PARAMETER :: ind_RA25OOH = 104 
  INTEGER, PARAMETER :: ind_HOC2H4OOH = 105 
  INTEGER, PARAMETER :: ind_H2O2 = 106 
  INTEGER, PARAMETER :: ind_TXCARB22 = 107 
  INTEGER, PARAMETER :: ind_DMS = 108 
  INTEGER, PARAMETER :: ind_MSIA = 109 
  INTEGER, PARAMETER :: ind_CH3SCH2OO = 110 
  INTEGER, PARAMETER :: ind_PPN = 111 
  INTEGER, PARAMETER :: ind_PHAN = 112 
  INTEGER, PARAMETER :: ind_RU14OOH = 113 
  INTEGER, PARAMETER :: ind_RU12OOH = 114 
  INTEGER, PARAMETER :: ind_RN14OOH = 115 
  INTEGER, PARAMETER :: ind_MPAN = 116 
  INTEGER, PARAMETER :: ind_RN9OOH = 117 
  INTEGER, PARAMETER :: ind_RA13NO3 = 118 
  INTEGER, PARAMETER :: ind_ARNOH14 = 119 
  INTEGER, PARAMETER :: ind_RA16NO3 = 120 
  INTEGER, PARAMETER :: ind_ARNOH17 = 121 
  INTEGER, PARAMETER :: ind_RTN26PAN = 122 
  INTEGER, PARAMETER :: ind_RTN14OOH = 123 
  INTEGER, PARAMETER :: ind_RTX28OOH = 124 
  INTEGER, PARAMETER :: ind_NRTX28OOH = 125 
  INTEGER, PARAMETER :: ind_PAN = 126 
  INTEGER, PARAMETER :: ind_SO2 = 127 
  INTEGER, PARAMETER :: ind_RA25NO3 = 128 
  INTEGER, PARAMETER :: ind_RN18OOH = 129 
  INTEGER, PARAMETER :: ind_RA19OOH = 130 
  INTEGER, PARAMETER :: ind_CARB17 = 131 
  INTEGER, PARAMETER :: ind_TXCARB24 = 132 
  INTEGER, PARAMETER :: ind_RA22OOH = 133 
  INTEGER, PARAMETER :: ind_RN13NO3 = 134 
  INTEGER, PARAMETER :: ind_TNCARB11 = 135 
  INTEGER, PARAMETER :: ind_RN13OOH = 136 
  INTEGER, PARAMETER :: ind_RN15OOH = 137 
  INTEGER, PARAMETER :: ind_RA19NO3 = 138 
  INTEGER, PARAMETER :: ind_CARB14 = 139 
  INTEGER, PARAMETER :: ind_CARB10 = 140 
  INTEGER, PARAMETER :: ind_RA22NO3 = 141 
  INTEGER, PARAMETER :: ind_CH3S = 142 
  INTEGER, PARAMETER :: ind_C3H6 = 143 
  INTEGER, PARAMETER :: ind_NRU14O2 = 144 
  INTEGER, PARAMETER :: ind_NRN12O2 = 145 
  INTEGER, PARAMETER :: ind_NRTN28O2 = 146 
  INTEGER, PARAMETER :: ind_NRN6O2 = 147 
  INTEGER, PARAMETER :: ind_CARB9 = 148 
  INTEGER, PARAMETER :: ind_CARB11A = 149 
  INTEGER, PARAMETER :: ind_CARB3 = 150 
  INTEGER, PARAMETER :: ind_NUCARB12 = 151 
  INTEGER, PARAMETER :: ind_UDCARB17 = 152 
  INTEGER, PARAMETER :: ind_C2H4 = 153 
  INTEGER, PARAMETER :: ind_UDCARB8 = 154 
  INTEGER, PARAMETER :: ind_RA22AO2 = 155 
  INTEGER, PARAMETER :: ind_IC3H7O2 = 156 
  INTEGER, PARAMETER :: ind_RTN24O2 = 157 
  INTEGER, PARAMETER :: ind_TNCARB10 = 158 
  INTEGER, PARAMETER :: ind_BPINENE = 159 
  INTEGER, PARAMETER :: ind_RTN23NO3 = 160 
  INTEGER, PARAMETER :: ind_NOA = 161 
  INTEGER, PARAMETER :: ind_TBUT2ENE = 162 
  INTEGER, PARAMETER :: ind_RA13O2 = 163 
  INTEGER, PARAMETER :: ind_APINENE = 164 
  INTEGER, PARAMETER :: ind_TNCARB26 = 165 
  INTEGER, PARAMETER :: ind_NRN9O2 = 166 
  INTEGER, PARAMETER :: ind_UDCARB14 = 167 
  INTEGER, PARAMETER :: ind_NRTX28O2 = 168 
  INTEGER, PARAMETER :: ind_CARB13 = 169 
  INTEGER, PARAMETER :: ind_RN18O2 = 170 
  INTEGER, PARAMETER :: ind_CH3SO2 = 171 
  INTEGER, PARAMETER :: ind_CH3SO = 172 
  INTEGER, PARAMETER :: ind_O3P = 173 
  INTEGER, PARAMETER :: ind_RA25O2 = 174 
  INTEGER, PARAMETER :: ind_C5H8 = 175 
  INTEGER, PARAMETER :: ind_RN13AO2 = 176 
  INTEGER, PARAMETER :: ind_RN16AO2 = 177 
  INTEGER, PARAMETER :: ind_RU14O2 = 178 
  INTEGER, PARAMETER :: ind_CARB7 = 179 
  INTEGER, PARAMETER :: ind_CARB16 = 180 
  INTEGER, PARAMETER :: ind_RA16O2 = 181 
  INTEGER, PARAMETER :: ind_UDCARB11 = 182 
  INTEGER, PARAMETER :: ind_RTN10O2 = 183 
  INTEGER, PARAMETER :: ind_RTX28O2 = 184 
  INTEGER, PARAMETER :: ind_HNO3 = 185 
  INTEGER, PARAMETER :: ind_RTN28O2 = 186 
  INTEGER, PARAMETER :: ind_CH3COCH3 = 187 
  INTEGER, PARAMETER :: ind_NRU12O2 = 188 
  INTEGER, PARAMETER :: ind_CO = 189 
  INTEGER, PARAMETER :: ind_RTN14O2 = 190 
  INTEGER, PARAMETER :: ind_HOCH2CO3 = 191 
  INTEGER, PARAMETER :: ind_RA19AO2 = 192 
  INTEGER, PARAMETER :: ind_CARB6 = 193 
  INTEGER, PARAMETER :: ind_UCARB12 = 194 
  INTEGER, PARAMETER :: ind_RN18AO2 = 195 
  INTEGER, PARAMETER :: ind_HOCH2CHO = 196 
  INTEGER, PARAMETER :: ind_RU10O2 = 197 
  INTEGER, PARAMETER :: ind_RU12O2 = 198 
  INTEGER, PARAMETER :: ind_HOCH2CH2O2 = 199 
  INTEGER, PARAMETER :: ind_RA22BO2 = 200 
  INTEGER, PARAMETER :: ind_UCARB10 = 201 
  INTEGER, PARAMETER :: ind_RA19CO2 = 202 
  INTEGER, PARAMETER :: ind_C2H5CO3 = 203 
  INTEGER, PARAMETER :: ind_RTN23O2 = 204 
  INTEGER, PARAMETER :: ind_RN19O2 = 205 
  INTEGER, PARAMETER :: ind_HCHO = 206 
  INTEGER, PARAMETER :: ind_RN15O2 = 207 
  INTEGER, PARAMETER :: ind_RN11O2 = 208 
  INTEGER, PARAMETER :: ind_C2H5O2 = 209 
  INTEGER, PARAMETER :: ind_RTX22O2 = 210 
  INTEGER, PARAMETER :: ind_CH3OO = 211 
  INTEGER, PARAMETER :: ind_RTN25O2 = 212 
  INTEGER, PARAMETER :: ind_RN12O2 = 213 
  INTEGER, PARAMETER :: ind_RTX24O2 = 214 
  INTEGER, PARAMETER :: ind_RN10O2 = 215 
  INTEGER, PARAMETER :: ind_RN14O2 = 216 
  INTEGER, PARAMETER :: ind_RN9O2 = 217 
  INTEGER, PARAMETER :: ind_RN17O2 = 218 
  INTEGER, PARAMETER :: ind_CH3CO3 = 219 
  INTEGER, PARAMETER :: ind_RN8O2 = 220 
  INTEGER, PARAMETER :: ind_RTN26O2 = 221 
  INTEGER, PARAMETER :: ind_O3 = 222 
  INTEGER, PARAMETER :: ind_RN16O2 = 223 
  INTEGER, PARAMETER :: ind_RN15AO2 = 224 
  INTEGER, PARAMETER :: ind_RN13O2 = 225 
  INTEGER, PARAMETER :: ind_C2H5CHO = 226 
  INTEGER, PARAMETER :: ind_NO = 227 
  INTEGER, PARAMETER :: ind_OH = 228 
  INTEGER, PARAMETER :: ind_NO2 = 229 
  INTEGER, PARAMETER :: ind_NO3 = 230 
  INTEGER, PARAMETER :: ind_CH3CHO = 231 
  INTEGER, PARAMETER :: ind_HO2 = 232 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_H2O = 233 
  INTEGER, PARAMETER :: ind_M = 234 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_H2O = 1 
  INTEGER, PARAMETER :: indf_M = 2 

END MODULE crimech_Parameters

