! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : radm2sorg_Parameters.f90
! Time                 : Tue Sep 16 01:34:21 2014
! Working directory    : /data/users/lenzen/WRF/WRFV3.5.1/WRFV3/chem/KPP/mechanisms/radm2sorg
! Equation file        : radm2sorg.kpp
! Output root filename : radm2sorg
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE radm2sorg_Parameters

  USE radm2sorg_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 61 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 59 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 55 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 2 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 156 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 60 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 572 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 659 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 60 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 0 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 
! PI - Value of pi
  REAL(kind=dp), PARAMETER :: PI = 3.14159265358979 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_SULF = 1 
  INTEGER, PARAMETER :: ind_ORA1 = 2 
  INTEGER, PARAMETER :: ind_ORA2 = 3 
  INTEGER, PARAMETER :: ind_CO2 = 4 
  INTEGER, PARAMETER :: ind_SO2 = 5 
  INTEGER, PARAMETER :: ind_ETH = 6 
  INTEGER, PARAMETER :: ind_O1D = 7 
  INTEGER, PARAMETER :: ind_HC5 = 8 
  INTEGER, PARAMETER :: ind_HC8 = 9 
  INTEGER, PARAMETER :: ind_TOL = 10 
  INTEGER, PARAMETER :: ind_XYL = 11 
  INTEGER, PARAMETER :: ind_TPAN = 12 
  INTEGER, PARAMETER :: ind_HONO = 13 
  INTEGER, PARAMETER :: ind_H2O2 = 14 
  INTEGER, PARAMETER :: ind_N2O5 = 15 
  INTEGER, PARAMETER :: ind_HC3 = 16 
  INTEGER, PARAMETER :: ind_CH4 = 17 
  INTEGER, PARAMETER :: ind_PAA = 18 
  INTEGER, PARAMETER :: ind_O3P = 19 
  INTEGER, PARAMETER :: ind_HNO4 = 20 
  INTEGER, PARAMETER :: ind_OP1 = 21 
  INTEGER, PARAMETER :: ind_CSL = 22 
  INTEGER, PARAMETER :: ind_PAN = 23 
  INTEGER, PARAMETER :: ind_OL2 = 24 
  INTEGER, PARAMETER :: ind_HNO3 = 25 
  INTEGER, PARAMETER :: ind_CO = 26 
  INTEGER, PARAMETER :: ind_ISO = 27 
  INTEGER, PARAMETER :: ind_OLT = 28 
  INTEGER, PARAMETER :: ind_OLI = 29 
  INTEGER, PARAMETER :: ind_DCB = 30 
  INTEGER, PARAMETER :: ind_GLY = 31 
  INTEGER, PARAMETER :: ind_XNO2 = 32 
  INTEGER, PARAMETER :: ind_KET = 33 
  INTEGER, PARAMETER :: ind_MGLY = 34 
  INTEGER, PARAMETER :: ind_TOLP = 35 
  INTEGER, PARAMETER :: ind_XYLP = 36 
  INTEGER, PARAMETER :: ind_OLTP = 37 
  INTEGER, PARAMETER :: ind_OLN = 38 
  INTEGER, PARAMETER :: ind_XO2 = 39 
  INTEGER, PARAMETER :: ind_OL2P = 40 
  INTEGER, PARAMETER :: ind_HC5P = 41 
  INTEGER, PARAMETER :: ind_OP2 = 42 
  INTEGER, PARAMETER :: ind_HCHO = 43 
  INTEGER, PARAMETER :: ind_HC8P = 44 
  INTEGER, PARAMETER :: ind_TCO3 = 45 
  INTEGER, PARAMETER :: ind_O3 = 46 
  INTEGER, PARAMETER :: ind_ONIT = 47 
  INTEGER, PARAMETER :: ind_ALD = 48 
  INTEGER, PARAMETER :: ind_OLIP = 49 
  INTEGER, PARAMETER :: ind_KETP = 50 
  INTEGER, PARAMETER :: ind_HO2 = 51 
  INTEGER, PARAMETER :: ind_MO2 = 52 
  INTEGER, PARAMETER :: ind_OH = 53 
  INTEGER, PARAMETER :: ind_NO3 = 54 
  INTEGER, PARAMETER :: ind_ACO3 = 55 
  INTEGER, PARAMETER :: ind_HC3P = 56 
  INTEGER, PARAMETER :: ind_ETHP = 57 
  INTEGER, PARAMETER :: ind_NO = 58 
  INTEGER, PARAMETER :: ind_NO2 = 59 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_H2O = 60 
  INTEGER, PARAMETER :: ind_M = 61 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_H2O = 1 
  INTEGER, PARAMETER :: indf_M = 2 

END MODULE radm2sorg_Parameters

