! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : saprc99_Parameters.f90
! Time                 : Tue Sep 16 01:34:24 2014
! Working directory    : /data/users/lenzen/WRF/WRFV3.5.1/WRFV3/chem/KPP/mechanisms/saprc99
! Equation file        : saprc99.kpp
! Output root filename : saprc99
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE saprc99_Parameters

  USE saprc99_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 81 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 79 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 72 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 2 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 225 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 80 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 887 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 968 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 80 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 0 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 0 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 
! PI - Value of pi
  REAL(kind=dp), PARAMETER :: PI = 3.14159265358979 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_H2SO4 = 1 
  INTEGER, PARAMETER :: ind_CO2 = 2 
  INTEGER, PARAMETER :: ind_HCOOH = 3 
  INTEGER, PARAMETER :: ind_CCO_OH = 4 
  INTEGER, PARAMETER :: ind_RCO_OH = 5 
  INTEGER, PARAMETER :: ind_CCO_OOH = 6 
  INTEGER, PARAMETER :: ind_RCO_OOH = 7 
  INTEGER, PARAMETER :: ind_XN = 8 
  INTEGER, PARAMETER :: ind_XC = 9 
  INTEGER, PARAMETER :: ind_SO2 = 10 
  INTEGER, PARAMETER :: ind_O1D = 11 
  INTEGER, PARAMETER :: ind_CH4 = 12 
  INTEGER, PARAMETER :: ind_C2H6 = 13 
  INTEGER, PARAMETER :: ind_BACL = 14 
  INTEGER, PARAMETER :: ind_PAN = 15 
  INTEGER, PARAMETER :: ind_PAN2 = 16 
  INTEGER, PARAMETER :: ind_PBZN = 17 
  INTEGER, PARAMETER :: ind_MA_PAN = 18 
  INTEGER, PARAMETER :: ind_H2O2 = 19 
  INTEGER, PARAMETER :: ind_C3H8 = 20 
  INTEGER, PARAMETER :: ind_ETOH = 21 
  INTEGER, PARAMETER :: ind_N2O5 = 22 
  INTEGER, PARAMETER :: ind_HONO = 23 
  INTEGER, PARAMETER :: ind_ALK3 = 24 
  INTEGER, PARAMETER :: ind_TBU_O = 25 
  INTEGER, PARAMETER :: ind_ALK5 = 26 
  INTEGER, PARAMETER :: ind_ARO2 = 27 
  INTEGER, PARAMETER :: ind_MEOH = 28 
  INTEGER, PARAMETER :: ind_COOH = 29 
  INTEGER, PARAMETER :: ind_HOCOO = 30 
  INTEGER, PARAMETER :: ind_BZNO2_O = 31 
  INTEGER, PARAMETER :: ind_HNO4 = 32 
  INTEGER, PARAMETER :: ind_ALK4 = 33 
  INTEGER, PARAMETER :: ind_ARO1 = 34 
  INTEGER, PARAMETER :: ind_DCB2 = 35 
  INTEGER, PARAMETER :: ind_DCB3 = 36 
  INTEGER, PARAMETER :: ind_CRES = 37 
  INTEGER, PARAMETER :: ind_DCB1 = 38 
  INTEGER, PARAMETER :: ind_C2H2 = 39 
  INTEGER, PARAMETER :: ind_NPHE = 40 
  INTEGER, PARAMETER :: ind_BALD = 41 
  INTEGER, PARAMETER :: ind_ROOH = 42 
  INTEGER, PARAMETER :: ind_PHEN = 43 
  INTEGER, PARAMETER :: ind_MGLY = 44 
  INTEGER, PARAMETER :: ind_CO = 45 
  INTEGER, PARAMETER :: ind_ACET = 46 
  INTEGER, PARAMETER :: ind_HNO3 = 47 
  INTEGER, PARAMETER :: ind_ETHENE = 48 
  INTEGER, PARAMETER :: ind_GLY = 49 
  INTEGER, PARAMETER :: ind_C3H6 = 50 
  INTEGER, PARAMETER :: ind_BZ_O = 51 
  INTEGER, PARAMETER :: ind_ISOPRENE = 52 
  INTEGER, PARAMETER :: ind_R2O2 = 53 
  INTEGER, PARAMETER :: ind_TERP = 54 
  INTEGER, PARAMETER :: ind_METHACRO = 55 
  INTEGER, PARAMETER :: ind_OLE1 = 56 
  INTEGER, PARAMETER :: ind_ISOPROD = 57 
  INTEGER, PARAMETER :: ind_OLE2 = 58 
  INTEGER, PARAMETER :: ind_MVK = 59 
  INTEGER, PARAMETER :: ind_CCHO = 60 
  INTEGER, PARAMETER :: ind_HCHO = 61 
  INTEGER, PARAMETER :: ind_RNO3 = 62 
  INTEGER, PARAMETER :: ind_O3P = 63 
  INTEGER, PARAMETER :: ind_RCHO = 64 
  INTEGER, PARAMETER :: ind_MEK = 65 
  INTEGER, PARAMETER :: ind_PROD2 = 66 
  INTEGER, PARAMETER :: ind_O3 = 67 
  INTEGER, PARAMETER :: ind_CCO_O2 = 68 
  INTEGER, PARAMETER :: ind_RO2_N = 69 
  INTEGER, PARAMETER :: ind_MA_RCO3 = 70 
  INTEGER, PARAMETER :: ind_OH = 71 
  INTEGER, PARAMETER :: ind_RCO_O2 = 72 
  INTEGER, PARAMETER :: ind_NO = 73 
  INTEGER, PARAMETER :: ind_NO2 = 74 
  INTEGER, PARAMETER :: ind_NO3 = 75 
  INTEGER, PARAMETER :: ind_C_O2 = 76 
  INTEGER, PARAMETER :: ind_RO2_R = 77 
  INTEGER, PARAMETER :: ind_HO2 = 78 
  INTEGER, PARAMETER :: ind_BZCO_O2 = 79 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_H2O = 80 
  INTEGER, PARAMETER :: ind_M = 81 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_H2O = 1 
  INTEGER, PARAMETER :: indf_M = 2 

END MODULE saprc99_Parameters

