! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Jacobian of Chemical Model File
! 
! Generated by KPP-2.1 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : saprc99_mosaic_4bin_vbs2_Jacobian.f90
! Time                 : Tue Sep 16 01:34:22 2014
! Working directory    : /data/users/lenzen/WRF/WRFV3.5.1/WRFV3/chem/KPP/mechanisms/saprc99_mosaic_4bin_vbs2
! Equation file        : saprc99_mosaic_4bin_vbs2.kpp
! Output root filename : saprc99_mosaic_4bin_vbs2
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE saprc99_mosaic_4bin_vbs2_Jacobian

  USE saprc99_mosaic_4bin_vbs2_Parameters
  USE saprc99_mosaic_4bin_vbs2_JacobianSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP_Vec - function for sparse multiplication: sparse Jacobian times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JUV       - Jacobian times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP_Vec ( JVS, UV, JUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JUV - Jacobian times user vector
  REAL(kind=dp) :: JUV(NVAR)

  JUV(1) = JVS(1)*UV(1)+JVS(2)*UV(32)+JVS(3)*UV(98)
  JUV(2) = JVS(4)*UV(2)+JVS(5)*UV(59)+JVS(6)*UV(69)+JVS(7)*UV(88)
  JUV(3) = JVS(8)*UV(3)
  JUV(4) = JVS(9)*UV(4)
  JUV(5) = JVS(10)*UV(5)
  JUV(6) = JVS(11)*UV(6)
  JUV(7) = JVS(12)*UV(7)+JVS(13)*UV(48)+JVS(14)*UV(59)+JVS(15)*UV(67)+JVS(16)*UV(69)+JVS(17)*UV(71)+JVS(18)*UV(72)&
             &+JVS(19)*UV(74)+JVS(20)*UV(75)+JVS(21)*UV(76)+JVS(22)*UV(78)+JVS(23)*UV(80)+JVS(24)*UV(81)+JVS(25)*UV(88)&
             &+JVS(26)*UV(98)+JVS(27)*UV(100)
  JUV(8) = JVS(28)*UV(8)+JVS(29)*UV(69)+JVS(30)*UV(72)+JVS(31)*UV(80)+JVS(32)*UV(88)+JVS(33)*UV(89)+JVS(34)*UV(90)&
             &+JVS(35)*UV(91)+JVS(36)*UV(94)+JVS(37)*UV(97)
  JUV(9) = JVS(38)*UV(9)+JVS(39)*UV(71)+JVS(40)*UV(72)+JVS(41)*UV(75)+JVS(42)*UV(76)+JVS(43)*UV(78)+JVS(44)*UV(80)&
             &+JVS(45)*UV(88)+JVS(46)*UV(90)+JVS(47)*UV(91)+JVS(48)*UV(94)+JVS(49)*UV(95)+JVS(50)*UV(96)+JVS(51)*UV(97)&
             &+JVS(52)*UV(99)
  JUV(10) = JVS(53)*UV(10)+JVS(54)*UV(89)+JVS(55)*UV(97)
  JUV(11) = JVS(56)*UV(11)+JVS(57)*UV(95)+JVS(58)*UV(96)+JVS(59)*UV(97)+JVS(60)*UV(99)
  JUV(12) = JVS(61)*UV(12)+JVS(62)*UV(49)+JVS(63)*UV(69)+JVS(64)*UV(92)+JVS(65)*UV(93)
  JUV(13) = JVS(66)*UV(13)+JVS(67)*UV(49)+JVS(68)*UV(62)+JVS(69)*UV(69)+JVS(70)*UV(84)+JVS(71)*UV(88)+JVS(72)*UV(92)&
              &+JVS(73)*UV(93)+JVS(74)*UV(98)
  JUV(14) = JVS(75)*UV(14)+JVS(76)*UV(73)+JVS(77)*UV(90)+JVS(78)*UV(91)+JVS(79)*UV(93)+JVS(80)*UV(94)+JVS(81)*UV(100)
  JUV(15) = JVS(82)*UV(15)+JVS(83)*UV(73)+JVS(84)*UV(90)+JVS(85)*UV(91)+JVS(86)*UV(94)+JVS(87)*UV(97)
  JUV(16) = JVS(88)*UV(16)+JVS(89)*UV(46)+JVS(90)*UV(53)+JVS(91)*UV(72)+JVS(92)*UV(80)+JVS(93)*UV(98)
  JUV(17) = JVS(94)*UV(17)+JVS(95)*UV(50)+JVS(96)*UV(54)+JVS(97)*UV(98)
  JUV(18) = JVS(98)*UV(18)+JVS(99)*UV(71)+JVS(100)*UV(98)
  JUV(19) = JVS(101)*UV(19)+JVS(102)*UV(75)+JVS(103)*UV(76)+JVS(104)*UV(98)
  JUV(20) = JVS(105)*UV(20)+JVS(106)*UV(31)+JVS(107)*UV(32)+JVS(108)*UV(33)+JVS(109)*UV(39)+JVS(110)*UV(41)+JVS(111)&
              &*UV(43)+JVS(112)*UV(44)+JVS(113)*UV(46)+JVS(114)*UV(47)+JVS(115)*UV(50)+JVS(116)*UV(52)+JVS(117)*UV(53)&
              &+JVS(118)*UV(54)+JVS(119)*UV(55)+JVS(120)*UV(56)+JVS(121)*UV(57)+JVS(122)*UV(58)+JVS(123)*UV(59)+JVS(124)&
              &*UV(60)+JVS(125)*UV(62)+JVS(126)*UV(63)+JVS(127)*UV(64)+JVS(128)*UV(65)+JVS(129)*UV(66)+JVS(130)*UV(67)&
              &+JVS(131)*UV(68)+JVS(132)*UV(69)+JVS(133)*UV(71)+JVS(134)*UV(72)+JVS(135)*UV(74)+JVS(136)*UV(75)+JVS(137)&
              &*UV(76)+JVS(138)*UV(77)+JVS(139)*UV(78)+JVS(140)*UV(79)+JVS(141)*UV(80)+JVS(142)*UV(81)+JVS(143)*UV(82)&
              &+JVS(144)*UV(83)+JVS(145)*UV(85)+JVS(146)*UV(86)+JVS(147)*UV(87)+JVS(148)*UV(88)+JVS(149)*UV(92)+JVS(150)&
              &*UV(93)+JVS(151)*UV(97)+JVS(152)*UV(98)+JVS(153)*UV(100)
  JUV(21) = JVS(154)*UV(3)+JVS(155)*UV(4)+JVS(156)*UV(5)+JVS(157)*UV(6)+JVS(158)*UV(21)+JVS(159)*UV(22)+JVS(160)*UV(23)&
              &+JVS(161)*UV(24)+JVS(162)*UV(25)+JVS(163)*UV(27)+JVS(164)*UV(28)+JVS(165)*UV(29)+JVS(166)*UV(30)+JVS(167)&
              &*UV(98)
  JUV(22) = JVS(168)*UV(22)+JVS(169)*UV(23)+JVS(170)*UV(27)+JVS(171)*UV(98)
  JUV(23) = JVS(172)*UV(23)+JVS(173)*UV(98)
  JUV(24) = JVS(174)*UV(24)+JVS(175)*UV(25)+JVS(176)*UV(29)+JVS(177)*UV(98)
  JUV(25) = JVS(178)*UV(25)+JVS(179)*UV(98)
  JUV(26) = JVS(180)*UV(26)+JVS(181)*UV(88)
  JUV(27) = JVS(182)*UV(27)+JVS(183)*UV(98)
  JUV(28) = JVS(184)*UV(27)+JVS(185)*UV(28)+JVS(186)*UV(98)
  JUV(29) = JVS(187)*UV(29)+JVS(188)*UV(98)
  JUV(30) = JVS(189)*UV(29)+JVS(190)*UV(30)+JVS(191)*UV(98)
  JUV(31) = JVS(192)*UV(31)+JVS(193)*UV(98)
  JUV(32) = JVS(194)*UV(32)+JVS(195)*UV(98)
  JUV(33) = JVS(196)*UV(33)+JVS(197)*UV(98)
  JUV(34) = JVS(198)*UV(34)+JVS(199)*UV(89)+JVS(200)*UV(92)
  JUV(35) = JVS(201)*UV(35)+JVS(202)*UV(92)+JVS(203)*UV(99)
  JUV(36) = JVS(204)*UV(36)+JVS(205)*UV(92)+JVS(206)*UV(95)
  JUV(37) = JVS(207)*UV(37)+JVS(208)*UV(92)+JVS(209)*UV(96)
  JUV(38) = JVS(210)*UV(38)+JVS(211)*UV(97)+JVS(212)*UV(98)
  JUV(39) = JVS(213)*UV(39)+JVS(214)*UV(98)
  JUV(40) = JVS(215)*UV(40)+JVS(216)*UV(50)+JVS(217)*UV(75)+JVS(218)*UV(76)+JVS(219)*UV(88)+JVS(220)*UV(98)
  JUV(41) = JVS(221)*UV(41)+JVS(222)*UV(98)
  JUV(42) = JVS(223)*UV(42)+JVS(224)*UV(92)+JVS(225)*UV(93)
  JUV(43) = JVS(226)*UV(43)+JVS(227)*UV(98)+JVS(228)*UV(100)
  JUV(44) = JVS(229)*UV(44)+JVS(230)*UV(98)
  JUV(45) = JVS(231)*UV(44)+JVS(232)*UV(45)+JVS(233)*UV(92)+JVS(234)*UV(98)
  JUV(46) = JVS(235)*UV(46)+JVS(236)*UV(98)
  JUV(47) = JVS(237)*UV(47)+JVS(238)*UV(94)+JVS(239)*UV(97)+JVS(240)*UV(98)
  JUV(48) = JVS(241)*UV(48)+JVS(242)*UV(82)+JVS(243)*UV(97)+JVS(244)*UV(100)
  JUV(49) = JVS(245)*UV(49)+JVS(246)*UV(61)+JVS(247)*UV(92)+JVS(248)*UV(93)+JVS(249)*UV(97)
  JUV(50) = JVS(250)*UV(50)+JVS(251)*UV(98)
  JUV(51) = JVS(252)*UV(51)+JVS(253)*UV(92)+JVS(254)*UV(97)+JVS(255)*UV(98)
  JUV(52) = JVS(256)*UV(52)+JVS(257)*UV(90)+JVS(258)*UV(91)+JVS(259)*UV(94)+JVS(260)*UV(98)
  JUV(53) = JVS(261)*UV(53)+JVS(262)*UV(98)
  JUV(54) = JVS(263)*UV(54)+JVS(264)*UV(98)
  JUV(55) = JVS(265)*UV(50)+JVS(266)*UV(54)+JVS(267)*UV(55)+JVS(268)*UV(98)
  JUV(56) = JVS(269)*UV(50)+JVS(270)*UV(54)+JVS(271)*UV(56)+JVS(272)*UV(98)
  JUV(57) = JVS(273)*UV(50)+JVS(274)*UV(54)+JVS(275)*UV(57)+JVS(276)*UV(93)+JVS(277)*UV(98)
  JUV(58) = JVS(278)*UV(50)+JVS(279)*UV(54)+JVS(280)*UV(58)+JVS(281)*UV(88)+JVS(282)*UV(98)
  JUV(59) = JVS(283)*UV(59)+JVS(284)*UV(88)+JVS(285)*UV(98)
  JUV(60) = JVS(286)*UV(60)+JVS(287)*UV(90)+JVS(288)*UV(91)+JVS(289)*UV(97)+JVS(290)*UV(98)
  JUV(61) = JVS(291)*UV(49)+JVS(292)*UV(61)+JVS(293)*UV(70)+JVS(294)*UV(92)+JVS(295)*UV(93)+JVS(296)*UV(97)
  JUV(62) = JVS(297)*UV(50)+JVS(298)*UV(54)+JVS(299)*UV(62)+JVS(300)*UV(80)+JVS(301)*UV(88)+JVS(302)*UV(93)+JVS(303)&
              &*UV(98)
  JUV(63) = JVS(304)*UV(54)+JVS(305)*UV(63)+JVS(306)*UV(70)+JVS(307)*UV(93)+JVS(308)*UV(97)+JVS(309)*UV(98)
  JUV(64) = JVS(310)*UV(50)+JVS(311)*UV(54)+JVS(312)*UV(55)+JVS(313)*UV(56)+JVS(314)*UV(57)+JVS(315)*UV(64)+JVS(316)&
              &*UV(74)+JVS(317)*UV(78)+JVS(318)*UV(81)+JVS(319)*UV(88)+JVS(320)*UV(93)+JVS(321)*UV(98)
  JUV(65) = JVS(322)*UV(53)+JVS(323)*UV(55)+JVS(324)*UV(56)+JVS(325)*UV(58)+JVS(326)*UV(59)+JVS(327)*UV(64)+JVS(328)&
              &*UV(65)+JVS(329)*UV(67)+JVS(330)*UV(69)+JVS(331)*UV(71)+JVS(332)*UV(72)+JVS(333)*UV(74)+JVS(334)*UV(75)&
              &+JVS(335)*UV(76)+JVS(336)*UV(77)+JVS(337)*UV(78)+JVS(338)*UV(79)+JVS(339)*UV(80)+JVS(340)*UV(81)+JVS(341)&
              &*UV(82)+JVS(342)*UV(84)+JVS(343)*UV(85)+JVS(344)*UV(88)+JVS(345)*UV(93)+JVS(346)*UV(98)
  JUV(66) = JVS(347)*UV(42)+JVS(348)*UV(57)+JVS(349)*UV(61)+JVS(350)*UV(62)+JVS(351)*UV(63)+JVS(352)*UV(64)+JVS(353)&
              &*UV(66)+JVS(355)*UV(74)+JVS(356)*UV(77)+JVS(357)*UV(78)+JVS(358)*UV(79)+JVS(361)*UV(82)+JVS(362)*UV(85)&
              &+JVS(364)*UV(92)+JVS(365)*UV(93)+JVS(366)*UV(97)+JVS(367)*UV(98)
  JUV(67) = JVS(368)*UV(67)+JVS(369)*UV(84)+JVS(370)*UV(88)+JVS(371)*UV(93)+JVS(372)*UV(98)
  JUV(68) = JVS(373)*UV(39)+JVS(374)*UV(44)+JVS(375)*UV(45)+JVS(376)*UV(46)+JVS(377)*UV(53)+JVS(378)*UV(68)+JVS(379)&
              &*UV(72)+JVS(380)*UV(75)+JVS(381)*UV(76)+JVS(382)*UV(80)+JVS(383)*UV(83)+JVS(384)*UV(88)+JVS(386)*UV(93)&
              &+JVS(387)*UV(98)
  JUV(69) = JVS(388)*UV(69)+JVS(389)*UV(84)+JVS(390)*UV(88)+JVS(391)*UV(93)+JVS(392)*UV(98)
  JUV(70) = JVS(393)*UV(57)+JVS(394)*UV(63)+JVS(395)*UV(70)+JVS(396)*UV(89)+JVS(397)*UV(92)+JVS(398)*UV(93)+JVS(399)&
              &*UV(95)+JVS(400)*UV(96)+JVS(401)*UV(97)+JVS(402)*UV(98)+JVS(403)*UV(99)+JVS(404)*UV(100)
  JUV(71) = JVS(405)*UV(71)+JVS(406)*UV(84)+JVS(407)*UV(88)+JVS(408)*UV(93)+JVS(409)*UV(98)
  JUV(72) = JVS(410)*UV(72)+JVS(411)*UV(84)+JVS(412)*UV(88)+JVS(413)*UV(93)+JVS(414)*UV(98)
  JUV(73) = JVS(415)*UV(44)+JVS(416)*UV(46)+JVS(417)*UV(53)+JVS(418)*UV(55)+JVS(419)*UV(56)+JVS(420)*UV(68)+JVS(421)&
              &*UV(71)+JVS(422)*UV(72)+JVS(423)*UV(73)+JVS(424)*UV(75)+JVS(425)*UV(76)+JVS(426)*UV(80)+JVS(427)*UV(81)&
              &+JVS(428)*UV(83)+JVS(429)*UV(84)+JVS(430)*UV(86)+JVS(431)*UV(87)+JVS(432)*UV(88)+JVS(433)*UV(89)+JVS(434)&
              &*UV(90)+JVS(435)*UV(91)+JVS(437)*UV(93)+JVS(438)*UV(94)+JVS(439)*UV(95)+JVS(440)*UV(96)+JVS(441)*UV(97)&
              &+JVS(442)*UV(98)+JVS(443)*UV(99)+JVS(444)*UV(100)
  JUV(74) = JVS(445)*UV(71)+JVS(446)*UV(74)+JVS(447)*UV(80)+JVS(448)*UV(84)+JVS(449)*UV(88)+JVS(450)*UV(93)+JVS(451)&
              &*UV(98)
  JUV(75) = JVS(452)*UV(75)+JVS(453)*UV(84)+JVS(454)*UV(88)+JVS(455)*UV(93)+JVS(456)*UV(98)
  JUV(76) = JVS(457)*UV(76)+JVS(458)*UV(84)+JVS(459)*UV(88)+JVS(460)*UV(93)+JVS(461)*UV(98)
  JUV(77) = JVS(462)*UV(50)+JVS(463)*UV(54)+JVS(464)*UV(55)+JVS(465)*UV(56)+JVS(466)*UV(58)+JVS(467)*UV(59)+JVS(468)&
              &*UV(63)+JVS(469)*UV(67)+JVS(471)*UV(75)+JVS(472)*UV(76)+JVS(473)*UV(77)+JVS(474)*UV(78)+JVS(475)*UV(84)&
              &+JVS(476)*UV(88)+JVS(479)*UV(93)+JVS(483)*UV(98)
  JUV(78) = JVS(486)*UV(71)+JVS(487)*UV(78)+JVS(488)*UV(80)+JVS(490)*UV(88)+JVS(491)*UV(93)+JVS(492)*UV(98)
  JUV(79) = JVS(493)*UV(33)+JVS(494)*UV(41)+JVS(495)*UV(44)+JVS(496)*UV(46)+JVS(497)*UV(53)+JVS(498)*UV(67)+JVS(499)&
              &*UV(69)+JVS(500)*UV(72)+JVS(501)*UV(78)+JVS(502)*UV(79)+JVS(503)*UV(80)+JVS(504)*UV(83)+JVS(505)*UV(84)&
              &+JVS(506)*UV(85)+JVS(507)*UV(86)+JVS(508)*UV(87)+JVS(509)*UV(88)+JVS(510)*UV(89)+JVS(511)*UV(93)+JVS(512)&
              &*UV(95)+JVS(513)*UV(96)+JVS(514)*UV(98)+JVS(515)*UV(99)+JVS(516)*UV(100)
  JUV(80) = JVS(517)*UV(80)+JVS(518)*UV(84)+JVS(519)*UV(88)+JVS(520)*UV(93)+JVS(521)*UV(98)
  JUV(81) = JVS(522)*UV(71)+JVS(523)*UV(80)+JVS(524)*UV(81)+JVS(525)*UV(84)+JVS(526)*UV(88)+JVS(527)*UV(93)+JVS(528)&
              &*UV(98)
  JUV(82) = JVS(529)*UV(41)+JVS(530)*UV(44)+JVS(531)*UV(46)+JVS(532)*UV(47)+JVS(533)*UV(48)+JVS(534)*UV(52)+JVS(535)&
              &*UV(53)+JVS(536)*UV(59)+JVS(537)*UV(67)+JVS(538)*UV(68)+JVS(539)*UV(69)+JVS(540)*UV(71)+JVS(541)*UV(72)&
              &+JVS(542)*UV(74)+JVS(543)*UV(75)+JVS(544)*UV(76)+JVS(545)*UV(77)+JVS(546)*UV(78)+JVS(547)*UV(80)+JVS(548)&
              &*UV(81)+JVS(549)*UV(82)+JVS(550)*UV(83)+JVS(551)*UV(84)+JVS(552)*UV(86)+JVS(553)*UV(87)+JVS(554)*UV(88)&
              &+JVS(555)*UV(89)+JVS(556)*UV(90)+JVS(557)*UV(91)+JVS(559)*UV(93)+JVS(560)*UV(94)+JVS(561)*UV(95)+JVS(562)&
              &*UV(96)+JVS(563)*UV(97)+JVS(564)*UV(98)+JVS(565)*UV(99)+JVS(566)*UV(100)
  JUV(83) = JVS(567)*UV(45)+JVS(568)*UV(72)+JVS(569)*UV(75)+JVS(570)*UV(76)+JVS(571)*UV(78)+JVS(572)*UV(80)+JVS(573)&
              &*UV(83)+JVS(576)*UV(91)+JVS(577)*UV(92)+JVS(578)*UV(93)+JVS(579)*UV(98)+JVS(580)*UV(100)
  JUV(84) = JVS(581)*UV(26)+JVS(582)*UV(67)+JVS(583)*UV(69)+JVS(584)*UV(71)+JVS(585)*UV(72)+JVS(586)*UV(74)+JVS(587)&
              &*UV(75)+JVS(588)*UV(76)+JVS(589)*UV(80)+JVS(590)*UV(81)+JVS(591)*UV(84)+JVS(592)*UV(88)+JVS(593)*UV(92)&
              &+JVS(594)*UV(93)+JVS(596)*UV(100)
  JUV(85) = JVS(597)*UV(39)+JVS(598)*UV(44)+JVS(599)*UV(46)+JVS(600)*UV(53)+JVS(601)*UV(55)+JVS(602)*UV(56)+JVS(603)&
              &*UV(58)+JVS(604)*UV(60)+JVS(605)*UV(67)+JVS(606)*UV(69)+JVS(607)*UV(72)+JVS(608)*UV(74)+JVS(609)*UV(75)&
              &+JVS(610)*UV(76)+JVS(611)*UV(78)+JVS(612)*UV(80)+JVS(613)*UV(81)+JVS(614)*UV(83)+JVS(615)*UV(84)+JVS(616)&
              &*UV(85)+JVS(617)*UV(86)+JVS(618)*UV(87)+JVS(619)*UV(88)+JVS(623)*UV(93)+JVS(625)*UV(98)
  JUV(86) = JVS(627)*UV(44)+JVS(628)*UV(46)+JVS(629)*UV(53)+JVS(630)*UV(69)+JVS(631)*UV(72)+JVS(632)*UV(74)+JVS(633)&
              &*UV(78)+JVS(634)*UV(80)+JVS(635)*UV(81)+JVS(636)*UV(83)+JVS(637)*UV(84)+JVS(638)*UV(86)+JVS(639)*UV(87)&
              &+JVS(640)*UV(88)+JVS(641)*UV(90)+JVS(642)*UV(91)+JVS(644)*UV(93)+JVS(645)*UV(94)+JVS(646)*UV(98)
  JUV(87) = JVS(648)*UV(46)+JVS(649)*UV(53)+JVS(650)*UV(54)+JVS(651)*UV(71)+JVS(652)*UV(72)+JVS(653)*UV(75)+JVS(654)&
              &*UV(76)+JVS(655)*UV(78)+JVS(656)*UV(80)+JVS(657)*UV(81)+JVS(658)*UV(83)+JVS(659)*UV(84)+JVS(660)*UV(87)&
              &+JVS(661)*UV(88)+JVS(662)*UV(89)+JVS(663)*UV(90)+JVS(664)*UV(91)+JVS(667)*UV(94)+JVS(668)*UV(95)+JVS(669)&
              &*UV(98)+JVS(670)*UV(99)
  JUV(88) = JVS(672)*UV(58)+JVS(673)*UV(59)+JVS(674)*UV(67)+JVS(675)*UV(69)+JVS(676)*UV(71)+JVS(677)*UV(72)+JVS(678)&
              &*UV(74)+JVS(679)*UV(75)+JVS(680)*UV(76)+JVS(681)*UV(78)+JVS(682)*UV(80)+JVS(683)*UV(81)+JVS(684)*UV(84)&
              &+JVS(685)*UV(88)+JVS(686)*UV(89)+JVS(687)*UV(92)+JVS(689)*UV(95)+JVS(690)*UV(96)+JVS(691)*UV(97)+JVS(692)&
              &*UV(98)+JVS(693)*UV(99)+JVS(694)*UV(100)
  JUV(89) = JVS(695)*UV(34)+JVS(696)*UV(40)+JVS(698)*UV(53)+JVS(699)*UV(55)+JVS(700)*UV(56)+JVS(701)*UV(64)+JVS(702)&
              &*UV(68)+JVS(704)*UV(74)+JVS(705)*UV(75)+JVS(706)*UV(76)+JVS(707)*UV(78)+JVS(708)*UV(79)+JVS(709)*UV(80)&
              &+JVS(710)*UV(81)+JVS(714)*UV(86)+JVS(715)*UV(87)+JVS(716)*UV(88)+JVS(717)*UV(89)+JVS(718)*UV(90)+JVS(719)&
              &*UV(91)+JVS(720)*UV(92)+JVS(721)*UV(93)+JVS(722)*UV(94)+JVS(723)*UV(95)+JVS(724)*UV(96)+JVS(725)*UV(97)&
              &+JVS(726)*UV(98)+JVS(727)*UV(99)+JVS(728)*UV(100)
  JUV(90) = JVS(729)*UV(33)+JVS(730)*UV(39)+JVS(731)*UV(41)+JVS(732)*UV(44)+JVS(733)*UV(46)+JVS(734)*UV(50)+JVS(735)&
              &*UV(53)+JVS(736)*UV(54)+JVS(737)*UV(55)+JVS(738)*UV(56)+JVS(739)*UV(57)+JVS(740)*UV(58)+JVS(741)*UV(59)&
              &+JVS(742)*UV(60)+JVS(743)*UV(63)+JVS(744)*UV(67)+JVS(745)*UV(69)+JVS(747)*UV(71)+JVS(748)*UV(72)+JVS(749)&
              &*UV(74)+JVS(750)*UV(75)+JVS(751)*UV(76)+JVS(752)*UV(78)+JVS(753)*UV(80)+JVS(754)*UV(81)+JVS(755)*UV(83)&
              &+JVS(756)*UV(84)+JVS(757)*UV(85)+JVS(758)*UV(86)+JVS(759)*UV(87)+JVS(760)*UV(88)+JVS(761)*UV(89)+JVS(762)&
              &*UV(90)+JVS(763)*UV(91)+JVS(765)*UV(93)+JVS(766)*UV(94)+JVS(767)*UV(95)+JVS(768)*UV(96)+JVS(769)*UV(97)&
              &+JVS(770)*UV(98)+JVS(771)*UV(99)+JVS(772)*UV(100)
  JUV(91) = JVS(773)*UV(39)+JVS(774)*UV(44)+JVS(775)*UV(46)+JVS(776)*UV(50)+JVS(777)*UV(53)+JVS(778)*UV(54)+JVS(779)&
              &*UV(69)+JVS(780)*UV(71)+JVS(781)*UV(72)+JVS(782)*UV(75)+JVS(783)*UV(76)+JVS(784)*UV(78)+JVS(785)*UV(80)&
              &+JVS(786)*UV(81)+JVS(787)*UV(83)+JVS(788)*UV(84)+JVS(789)*UV(85)+JVS(790)*UV(86)+JVS(791)*UV(87)+JVS(792)&
              &*UV(88)+JVS(793)*UV(89)+JVS(794)*UV(90)+JVS(795)*UV(91)+JVS(797)*UV(93)+JVS(798)*UV(94)+JVS(799)*UV(95)&
              &+JVS(800)*UV(96)+JVS(801)*UV(97)+JVS(802)*UV(98)+JVS(803)*UV(99)+JVS(804)*UV(100)
  JUV(92) = JVS(805)*UV(34)+JVS(806)*UV(35)+JVS(807)*UV(36)+JVS(808)*UV(37)+JVS(809)*UV(42)+JVS(810)*UV(43)+JVS(811)&
              &*UV(45)+JVS(812)*UV(48)+JVS(813)*UV(49)+JVS(814)*UV(51)+JVS(816)*UV(66)+JVS(817)*UV(70)+JVS(818)*UV(71)&
              &+JVS(819)*UV(73)+JVS(821)*UV(75)+JVS(822)*UV(76)+JVS(826)*UV(80)+JVS(829)*UV(83)+JVS(830)*UV(84)+JVS(834)&
              &*UV(88)+JVS(835)*UV(89)+JVS(836)*UV(90)+JVS(837)*UV(91)+JVS(838)*UV(92)+JVS(839)*UV(93)+JVS(840)*UV(94)&
              &+JVS(841)*UV(95)+JVS(842)*UV(96)+JVS(843)*UV(97)+JVS(844)*UV(98)+JVS(845)*UV(99)+JVS(846)*UV(100)
  JUV(93) = JVS(847)*UV(42)+JVS(848)*UV(51)+JVS(849)*UV(57)+JVS(850)*UV(61)+JVS(851)*UV(62)+JVS(852)*UV(63)+JVS(853)&
              &*UV(64)+JVS(854)*UV(66)+JVS(855)*UV(67)+JVS(856)*UV(69)+JVS(858)*UV(71)+JVS(859)*UV(72)+JVS(860)*UV(73)&
              &+JVS(861)*UV(74)+JVS(862)*UV(75)+JVS(863)*UV(76)+JVS(864)*UV(77)+JVS(865)*UV(78)+JVS(866)*UV(79)+JVS(867)&
              &*UV(80)+JVS(869)*UV(82)+JVS(871)*UV(84)+JVS(872)*UV(85)+JVS(875)*UV(88)+JVS(876)*UV(89)+JVS(877)*UV(90)&
              &+JVS(878)*UV(91)+JVS(879)*UV(92)+JVS(880)*UV(93)+JVS(881)*UV(94)+JVS(882)*UV(95)+JVS(883)*UV(96)+JVS(884)&
              &*UV(97)+JVS(885)*UV(98)+JVS(886)*UV(99)+JVS(887)*UV(100)
  JUV(94) = JVS(888)*UV(31)+JVS(889)*UV(45)+JVS(890)*UV(47)+JVS(891)*UV(53)+JVS(892)*UV(67)+JVS(893)*UV(68)+JVS(894)&
              &*UV(69)+JVS(895)*UV(71)+JVS(896)*UV(72)+JVS(899)*UV(79)+JVS(900)*UV(80)+JVS(901)*UV(81)+JVS(903)*UV(84)&
              &+JVS(907)*UV(88)+JVS(908)*UV(89)+JVS(909)*UV(90)+JVS(910)*UV(91)+JVS(912)*UV(93)+JVS(913)*UV(94)+JVS(914)&
              &*UV(95)+JVS(915)*UV(96)+JVS(916)*UV(97)+JVS(917)*UV(98)+JVS(918)*UV(99)+JVS(919)*UV(100)
  JUV(95) = JVS(920)*UV(36)+JVS(921)*UV(62)+JVS(925)*UV(89)+JVS(926)*UV(90)+JVS(927)*UV(91)+JVS(928)*UV(92)+JVS(929)&
              &*UV(93)+JVS(930)*UV(94)+JVS(931)*UV(95)+JVS(932)*UV(96)+JVS(933)*UV(97)+JVS(934)*UV(98)+JVS(935)*UV(99)&
              &+JVS(936)*UV(100)
  JUV(96) = JVS(937)*UV(37)+JVS(938)*UV(71)+JVS(939)*UV(74)+JVS(940)*UV(78)+JVS(942)*UV(81)+JVS(943)*UV(84)+JVS(944)&
              &*UV(88)+JVS(945)*UV(89)+JVS(946)*UV(90)+JVS(947)*UV(91)+JVS(948)*UV(92)+JVS(949)*UV(93)+JVS(950)*UV(94)&
              &+JVS(951)*UV(95)+JVS(952)*UV(96)+JVS(953)*UV(97)+JVS(954)*UV(98)+JVS(955)*UV(99)+JVS(956)*UV(100)
  JUV(97) = JVS(957)*UV(32)+JVS(958)*UV(38)+JVS(959)*UV(41)+JVS(960)*UV(43)+JVS(961)*UV(47)+JVS(962)*UV(48)+JVS(963)&
              &*UV(49)+JVS(964)*UV(50)+JVS(965)*UV(51)+JVS(966)*UV(52)+JVS(967)*UV(54)+JVS(968)*UV(55)+JVS(969)*UV(56)&
              &+JVS(970)*UV(58)+JVS(971)*UV(59)+JVS(972)*UV(60)+JVS(974)*UV(64)+JVS(975)*UV(65)+JVS(976)*UV(67)+JVS(977)&
              &*UV(69)+JVS(978)*UV(70)+JVS(980)*UV(72)+JVS(981)*UV(74)+JVS(982)*UV(75)+JVS(983)*UV(76)+JVS(984)*UV(77)&
              &+JVS(985)*UV(78)+JVS(986)*UV(79)+JVS(987)*UV(80)+JVS(988)*UV(81)+JVS(989)*UV(82)+JVS(990)*UV(83)+JVS(991)&
              &*UV(84)+JVS(992)*UV(85)+JVS(994)*UV(87)+JVS(995)*UV(88)+JVS(996)*UV(89)+JVS(997)*UV(90)+JVS(998)*UV(91)&
              &+JVS(999)*UV(92)+JVS(1000)*UV(93)+JVS(1001)*UV(94)+JVS(1002)*UV(95)+JVS(1003)*UV(96)+JVS(1004)*UV(97)&
              &+JVS(1005)*UV(98)+JVS(1006)*UV(99)+JVS(1007)*UV(100)
  JUV(98) = JVS(1008)*UV(3)+JVS(1009)*UV(5)+JVS(1010)*UV(26)+JVS(1011)*UV(27)+JVS(1012)*UV(28)+JVS(1013)*UV(29)&
              &+JVS(1014)*UV(30)+JVS(1015)*UV(31)+JVS(1016)*UV(32)+JVS(1017)*UV(33)+JVS(1018)*UV(38)+JVS(1019)*UV(39)&
              &+JVS(1020)*UV(41)+JVS(1021)*UV(43)+JVS(1022)*UV(44)+JVS(1023)*UV(46)+JVS(1024)*UV(47)+JVS(1025)*UV(50)&
              &+JVS(1026)*UV(51)+JVS(1027)*UV(52)+JVS(1028)*UV(53)+JVS(1029)*UV(54)+JVS(1030)*UV(55)+JVS(1031)*UV(56)&
              &+JVS(1032)*UV(57)+JVS(1033)*UV(58)+JVS(1034)*UV(59)+JVS(1035)*UV(60)+JVS(1036)*UV(62)+JVS(1037)*UV(63)&
              &+JVS(1038)*UV(64)+JVS(1039)*UV(65)+JVS(1040)*UV(66)+JVS(1041)*UV(67)+JVS(1042)*UV(68)+JVS(1043)*UV(69)&
              &+JVS(1045)*UV(71)+JVS(1046)*UV(72)+JVS(1047)*UV(74)+JVS(1048)*UV(75)+JVS(1049)*UV(76)+JVS(1050)*UV(77)&
              &+JVS(1051)*UV(78)+JVS(1052)*UV(79)+JVS(1053)*UV(80)+JVS(1054)*UV(81)+JVS(1055)*UV(82)+JVS(1056)*UV(83)&
              &+JVS(1058)*UV(85)+JVS(1059)*UV(86)+JVS(1060)*UV(87)+JVS(1061)*UV(88)+JVS(1065)*UV(92)+JVS(1066)*UV(93)&
              &+JVS(1070)*UV(97)+JVS(1071)*UV(98)+JVS(1073)*UV(100)
  JUV(99) = JVS(1074)*UV(35)+JVS(1075)*UV(74)+JVS(1076)*UV(75)+JVS(1077)*UV(76)+JVS(1078)*UV(77)+JVS(1079)*UV(78)&
              &+JVS(1080)*UV(80)+JVS(1081)*UV(81)+JVS(1083)*UV(85)+JVS(1084)*UV(86)+JVS(1085)*UV(87)+JVS(1086)*UV(88)&
              &+JVS(1087)*UV(89)+JVS(1088)*UV(90)+JVS(1089)*UV(91)+JVS(1090)*UV(92)+JVS(1091)*UV(93)+JVS(1092)*UV(94)&
              &+JVS(1093)*UV(95)+JVS(1094)*UV(96)+JVS(1095)*UV(97)+JVS(1096)*UV(98)+JVS(1097)*UV(99)+JVS(1098)*UV(100)
  JUV(100) = JVS(1099)*UV(43)+JVS(1100)*UV(48)+JVS(1101)*UV(73)+JVS(1108)*UV(84)+JVS(1111)*UV(88)+JVS(1112)*UV(89)&
               &+JVS(1113)*UV(90)+JVS(1114)*UV(91)+JVS(1115)*UV(92)+JVS(1116)*UV(93)+JVS(1117)*UV(94)+JVS(1118)*UV(95)&
               &+JVS(1119)*UV(96)+JVS(1120)*UV(97)+JVS(1121)*UV(98)+JVS(1122)*UV(99)+JVS(1123)*UV(100)
      
END SUBROUTINE Jac_SP_Vec

! End of Jac_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacTR_SP_Vec - sparse multiplication: sparse Jacobian transposed times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JTUV      - Jacobian transposed times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacTR_SP_Vec ( JVS, UV, JTUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JTUV - Jacobian transposed times user vector
  REAL(kind=dp) :: JTUV(NVAR)

  JTUV(1) = JVS(1)*UV(1)
  JTUV(2) = JVS(4)*UV(2)
  JTUV(3) = JVS(8)*UV(3)+JVS(154)*UV(21)+JVS(1008)*UV(98)
  JTUV(4) = JVS(9)*UV(4)+JVS(155)*UV(21)
  JTUV(5) = JVS(10)*UV(5)+JVS(156)*UV(21)+JVS(1009)*UV(98)
  JTUV(6) = JVS(11)*UV(6)+JVS(157)*UV(21)
  JTUV(7) = JVS(12)*UV(7)
  JTUV(8) = JVS(28)*UV(8)
  JTUV(9) = JVS(38)*UV(9)
  JTUV(10) = JVS(53)*UV(10)
  JTUV(11) = JVS(56)*UV(11)
  JTUV(12) = JVS(61)*UV(12)
  JTUV(13) = JVS(66)*UV(13)
  JTUV(14) = JVS(75)*UV(14)
  JTUV(15) = JVS(82)*UV(15)
  JTUV(16) = JVS(88)*UV(16)
  JTUV(17) = JVS(94)*UV(17)
  JTUV(18) = JVS(98)*UV(18)
  JTUV(19) = JVS(101)*UV(19)
  JTUV(20) = JVS(105)*UV(20)
  JTUV(21) = JVS(158)*UV(21)
  JTUV(22) = JVS(159)*UV(21)+JVS(168)*UV(22)
  JTUV(23) = JVS(160)*UV(21)+JVS(169)*UV(22)+JVS(172)*UV(23)
  JTUV(24) = JVS(161)*UV(21)+JVS(174)*UV(24)
  JTUV(25) = JVS(162)*UV(21)+JVS(175)*UV(24)+JVS(178)*UV(25)
  JTUV(26) = JVS(180)*UV(26)+JVS(581)*UV(84)+JVS(1010)*UV(98)
  JTUV(27) = JVS(163)*UV(21)+JVS(170)*UV(22)+JVS(182)*UV(27)+JVS(184)*UV(28)+JVS(1011)*UV(98)
  JTUV(28) = JVS(164)*UV(21)+JVS(185)*UV(28)+JVS(1012)*UV(98)
  JTUV(29) = JVS(165)*UV(21)+JVS(176)*UV(24)+JVS(187)*UV(29)+JVS(189)*UV(30)+JVS(1013)*UV(98)
  JTUV(30) = JVS(166)*UV(21)+JVS(190)*UV(30)+JVS(1014)*UV(98)
  JTUV(31) = JVS(106)*UV(20)+JVS(192)*UV(31)+JVS(888)*UV(94)+JVS(1015)*UV(98)
  JTUV(32) = JVS(2)*UV(1)+JVS(107)*UV(20)+JVS(194)*UV(32)+JVS(957)*UV(97)+JVS(1016)*UV(98)
  JTUV(33) = JVS(108)*UV(20)+JVS(196)*UV(33)+JVS(493)*UV(79)+JVS(729)*UV(90)+JVS(1017)*UV(98)
  JTUV(34) = JVS(198)*UV(34)+JVS(695)*UV(89)+JVS(805)*UV(92)
  JTUV(35) = JVS(201)*UV(35)+JVS(806)*UV(92)+JVS(1074)*UV(99)
  JTUV(36) = JVS(204)*UV(36)+JVS(807)*UV(92)+JVS(920)*UV(95)
  JTUV(37) = JVS(207)*UV(37)+JVS(808)*UV(92)+JVS(937)*UV(96)
  JTUV(38) = JVS(210)*UV(38)+JVS(958)*UV(97)+JVS(1018)*UV(98)
  JTUV(39) = JVS(109)*UV(20)+JVS(213)*UV(39)+JVS(373)*UV(68)+JVS(597)*UV(85)+JVS(730)*UV(90)+JVS(773)*UV(91)+JVS(1019)&
               &*UV(98)
  JTUV(40) = JVS(215)*UV(40)+JVS(696)*UV(89)
  JTUV(41) = JVS(110)*UV(20)+JVS(221)*UV(41)+JVS(494)*UV(79)+JVS(529)*UV(82)+JVS(731)*UV(90)+JVS(959)*UV(97)+JVS(1020)&
               &*UV(98)
  JTUV(42) = JVS(223)*UV(42)+JVS(347)*UV(66)+JVS(809)*UV(92)+JVS(847)*UV(93)
  JTUV(43) = JVS(111)*UV(20)+JVS(226)*UV(43)+JVS(810)*UV(92)+JVS(960)*UV(97)+JVS(1021)*UV(98)+JVS(1099)*UV(100)
  JTUV(44) = JVS(112)*UV(20)+JVS(229)*UV(44)+JVS(231)*UV(45)+JVS(374)*UV(68)+JVS(415)*UV(73)+JVS(495)*UV(79)+JVS(530)&
               &*UV(82)+JVS(598)*UV(85)+JVS(627)*UV(86)+JVS(732)*UV(90)+JVS(774)*UV(91)+JVS(1022)*UV(98)
  JTUV(45) = JVS(232)*UV(45)+JVS(375)*UV(68)+JVS(567)*UV(83)+JVS(811)*UV(92)+JVS(889)*UV(94)
  JTUV(46) = JVS(89)*UV(16)+JVS(113)*UV(20)+JVS(235)*UV(46)+JVS(376)*UV(68)+JVS(416)*UV(73)+JVS(496)*UV(79)+JVS(531)&
               &*UV(82)+JVS(599)*UV(85)+JVS(628)*UV(86)+JVS(648)*UV(87)+JVS(733)*UV(90)+JVS(775)*UV(91)+JVS(1023)*UV(98)
  JTUV(47) = JVS(114)*UV(20)+JVS(237)*UV(47)+JVS(532)*UV(82)+JVS(890)*UV(94)+JVS(961)*UV(97)+JVS(1024)*UV(98)
  JTUV(48) = JVS(13)*UV(7)+JVS(241)*UV(48)+JVS(533)*UV(82)+JVS(812)*UV(92)+JVS(962)*UV(97)+JVS(1100)*UV(100)
  JTUV(49) = JVS(62)*UV(12)+JVS(67)*UV(13)+JVS(245)*UV(49)+JVS(291)*UV(61)+JVS(813)*UV(92)+JVS(963)*UV(97)
  JTUV(50) = JVS(95)*UV(17)+JVS(115)*UV(20)+JVS(216)*UV(40)+JVS(250)*UV(50)+JVS(265)*UV(55)+JVS(269)*UV(56)+JVS(273)&
               &*UV(57)+JVS(278)*UV(58)+JVS(297)*UV(62)+JVS(310)*UV(64)+JVS(462)*UV(77)+JVS(734)*UV(90)+JVS(776)*UV(91)&
               &+JVS(964)*UV(97)+JVS(1025)*UV(98)
  JTUV(51) = JVS(252)*UV(51)+JVS(814)*UV(92)+JVS(848)*UV(93)+JVS(965)*UV(97)+JVS(1026)*UV(98)
  JTUV(52) = JVS(116)*UV(20)+JVS(256)*UV(52)+JVS(534)*UV(82)+JVS(966)*UV(97)+JVS(1027)*UV(98)
  JTUV(53) = JVS(90)*UV(16)+JVS(117)*UV(20)+JVS(261)*UV(53)+JVS(322)*UV(65)+JVS(377)*UV(68)+JVS(417)*UV(73)+JVS(497)&
               &*UV(79)+JVS(535)*UV(82)+JVS(600)*UV(85)+JVS(629)*UV(86)+JVS(649)*UV(87)+JVS(698)*UV(89)+JVS(735)*UV(90)&
               &+JVS(777)*UV(91)+JVS(891)*UV(94)+JVS(1028)*UV(98)
  JTUV(54) = JVS(96)*UV(17)+JVS(118)*UV(20)+JVS(263)*UV(54)+JVS(266)*UV(55)+JVS(270)*UV(56)+JVS(274)*UV(57)+JVS(279)&
               &*UV(58)+JVS(298)*UV(62)+JVS(304)*UV(63)+JVS(311)*UV(64)+JVS(463)*UV(77)+JVS(650)*UV(87)+JVS(736)*UV(90)&
               &+JVS(778)*UV(91)+JVS(967)*UV(97)+JVS(1029)*UV(98)
  JTUV(55) = JVS(119)*UV(20)+JVS(267)*UV(55)+JVS(312)*UV(64)+JVS(323)*UV(65)+JVS(418)*UV(73)+JVS(464)*UV(77)+JVS(601)&
               &*UV(85)+JVS(699)*UV(89)+JVS(737)*UV(90)+JVS(968)*UV(97)+JVS(1030)*UV(98)
  JTUV(56) = JVS(120)*UV(20)+JVS(271)*UV(56)+JVS(313)*UV(64)+JVS(324)*UV(65)+JVS(419)*UV(73)+JVS(465)*UV(77)+JVS(602)&
               &*UV(85)+JVS(700)*UV(89)+JVS(738)*UV(90)+JVS(969)*UV(97)+JVS(1031)*UV(98)
  JTUV(57) = JVS(121)*UV(20)+JVS(275)*UV(57)+JVS(314)*UV(64)+JVS(348)*UV(66)+JVS(393)*UV(70)+JVS(739)*UV(90)+JVS(849)&
               &*UV(93)+JVS(1032)*UV(98)
  JTUV(58) = JVS(122)*UV(20)+JVS(280)*UV(58)+JVS(325)*UV(65)+JVS(466)*UV(77)+JVS(603)*UV(85)+JVS(672)*UV(88)+JVS(740)&
               &*UV(90)+JVS(970)*UV(97)+JVS(1033)*UV(98)
  JTUV(59) = JVS(5)*UV(2)+JVS(14)*UV(7)+JVS(123)*UV(20)+JVS(283)*UV(59)+JVS(326)*UV(65)+JVS(467)*UV(77)+JVS(536)*UV(82)&
               &+JVS(673)*UV(88)+JVS(741)*UV(90)+JVS(971)*UV(97)+JVS(1034)*UV(98)
  JTUV(60) = JVS(124)*UV(20)+JVS(286)*UV(60)+JVS(604)*UV(85)+JVS(742)*UV(90)+JVS(972)*UV(97)+JVS(1035)*UV(98)
  JTUV(61) = JVS(246)*UV(49)+JVS(292)*UV(61)+JVS(349)*UV(66)+JVS(850)*UV(93)
  JTUV(62) = JVS(68)*UV(13)+JVS(125)*UV(20)+JVS(299)*UV(62)+JVS(350)*UV(66)+JVS(851)*UV(93)+JVS(921)*UV(95)+JVS(1036)&
               &*UV(98)
  JTUV(63) = JVS(126)*UV(20)+JVS(305)*UV(63)+JVS(351)*UV(66)+JVS(394)*UV(70)+JVS(468)*UV(77)+JVS(743)*UV(90)+JVS(852)&
               &*UV(93)+JVS(1037)*UV(98)
  JTUV(64) = JVS(127)*UV(20)+JVS(315)*UV(64)+JVS(327)*UV(65)+JVS(352)*UV(66)+JVS(701)*UV(89)+JVS(853)*UV(93)+JVS(974)&
               &*UV(97)+JVS(1038)*UV(98)
  JTUV(65) = JVS(128)*UV(20)+JVS(328)*UV(65)+JVS(975)*UV(97)+JVS(1039)*UV(98)
  JTUV(66) = JVS(129)*UV(20)+JVS(353)*UV(66)+JVS(816)*UV(92)+JVS(854)*UV(93)+JVS(1040)*UV(98)
  JTUV(67) = JVS(15)*UV(7)+JVS(130)*UV(20)+JVS(329)*UV(65)+JVS(368)*UV(67)+JVS(469)*UV(77)+JVS(498)*UV(79)+JVS(537)&
               &*UV(82)+JVS(582)*UV(84)+JVS(605)*UV(85)+JVS(674)*UV(88)+JVS(744)*UV(90)+JVS(855)*UV(93)+JVS(892)*UV(94)&
               &+JVS(976)*UV(97)+JVS(1041)*UV(98)
  JTUV(68) = JVS(131)*UV(20)+JVS(378)*UV(68)+JVS(420)*UV(73)+JVS(538)*UV(82)+JVS(702)*UV(89)+JVS(893)*UV(94)+JVS(1042)&
               &*UV(98)
  JTUV(69) = JVS(6)*UV(2)+JVS(16)*UV(7)+JVS(29)*UV(8)+JVS(63)*UV(12)+JVS(69)*UV(13)+JVS(132)*UV(20)+JVS(330)*UV(65)&
               &+JVS(388)*UV(69)+JVS(499)*UV(79)+JVS(539)*UV(82)+JVS(583)*UV(84)+JVS(606)*UV(85)+JVS(630)*UV(86)+JVS(675)&
               &*UV(88)+JVS(745)*UV(90)+JVS(779)*UV(91)+JVS(856)*UV(93)+JVS(894)*UV(94)+JVS(977)*UV(97)+JVS(1043)*UV(98)
  JTUV(70) = JVS(293)*UV(61)+JVS(306)*UV(63)+JVS(395)*UV(70)+JVS(817)*UV(92)+JVS(978)*UV(97)
  JTUV(71) = JVS(17)*UV(7)+JVS(39)*UV(9)+JVS(99)*UV(18)+JVS(133)*UV(20)+JVS(331)*UV(65)+JVS(405)*UV(71)+JVS(421)*UV(73)&
               &+JVS(445)*UV(74)+JVS(486)*UV(78)+JVS(522)*UV(81)+JVS(540)*UV(82)+JVS(584)*UV(84)+JVS(651)*UV(87)+JVS(676)&
               &*UV(88)+JVS(747)*UV(90)+JVS(780)*UV(91)+JVS(818)*UV(92)+JVS(858)*UV(93)+JVS(895)*UV(94)+JVS(938)*UV(96)&
               &+JVS(1045)*UV(98)
  JTUV(72) = JVS(18)*UV(7)+JVS(30)*UV(8)+JVS(40)*UV(9)+JVS(91)*UV(16)+JVS(134)*UV(20)+JVS(332)*UV(65)+JVS(379)*UV(68)&
               &+JVS(410)*UV(72)+JVS(422)*UV(73)+JVS(500)*UV(79)+JVS(541)*UV(82)+JVS(568)*UV(83)+JVS(585)*UV(84)+JVS(607)&
               &*UV(85)+JVS(631)*UV(86)+JVS(652)*UV(87)+JVS(677)*UV(88)+JVS(748)*UV(90)+JVS(781)*UV(91)+JVS(859)*UV(93)&
               &+JVS(896)*UV(94)+JVS(980)*UV(97)+JVS(1046)*UV(98)
  JTUV(73) = JVS(76)*UV(14)+JVS(83)*UV(15)+JVS(423)*UV(73)+JVS(819)*UV(92)+JVS(860)*UV(93)+JVS(1101)*UV(100)
  JTUV(74) = JVS(19)*UV(7)+JVS(135)*UV(20)+JVS(316)*UV(64)+JVS(333)*UV(65)+JVS(355)*UV(66)+JVS(446)*UV(74)+JVS(542)&
               &*UV(82)+JVS(586)*UV(84)+JVS(608)*UV(85)+JVS(632)*UV(86)+JVS(678)*UV(88)+JVS(704)*UV(89)+JVS(749)*UV(90)&
               &+JVS(861)*UV(93)+JVS(939)*UV(96)+JVS(981)*UV(97)+JVS(1047)*UV(98)+JVS(1075)*UV(99)
  JTUV(75) = JVS(20)*UV(7)+JVS(41)*UV(9)+JVS(102)*UV(19)+JVS(136)*UV(20)+JVS(217)*UV(40)+JVS(334)*UV(65)+JVS(380)*UV(68)&
               &+JVS(424)*UV(73)+JVS(452)*UV(75)+JVS(471)*UV(77)+JVS(543)*UV(82)+JVS(569)*UV(83)+JVS(587)*UV(84)+JVS(609)&
               &*UV(85)+JVS(653)*UV(87)+JVS(679)*UV(88)+JVS(705)*UV(89)+JVS(750)*UV(90)+JVS(782)*UV(91)+JVS(821)*UV(92)&
               &+JVS(862)*UV(93)+JVS(982)*UV(97)+JVS(1048)*UV(98)+JVS(1076)*UV(99)
  JTUV(76) = JVS(21)*UV(7)+JVS(42)*UV(9)+JVS(103)*UV(19)+JVS(137)*UV(20)+JVS(218)*UV(40)+JVS(335)*UV(65)+JVS(381)*UV(68)&
               &+JVS(425)*UV(73)+JVS(457)*UV(76)+JVS(472)*UV(77)+JVS(544)*UV(82)+JVS(570)*UV(83)+JVS(588)*UV(84)+JVS(610)&
               &*UV(85)+JVS(654)*UV(87)+JVS(680)*UV(88)+JVS(706)*UV(89)+JVS(751)*UV(90)+JVS(783)*UV(91)+JVS(822)*UV(92)&
               &+JVS(863)*UV(93)+JVS(983)*UV(97)+JVS(1049)*UV(98)+JVS(1077)*UV(99)
  JTUV(77) = JVS(138)*UV(20)+JVS(336)*UV(65)+JVS(356)*UV(66)+JVS(473)*UV(77)+JVS(545)*UV(82)+JVS(864)*UV(93)+JVS(984)&
               &*UV(97)+JVS(1050)*UV(98)+JVS(1078)*UV(99)
  JTUV(78) = JVS(22)*UV(7)+JVS(43)*UV(9)+JVS(139)*UV(20)+JVS(317)*UV(64)+JVS(337)*UV(65)+JVS(357)*UV(66)+JVS(474)*UV(77)&
               &+JVS(487)*UV(78)+JVS(501)*UV(79)+JVS(546)*UV(82)+JVS(571)*UV(83)+JVS(611)*UV(85)+JVS(633)*UV(86)+JVS(655)&
               &*UV(87)+JVS(681)*UV(88)+JVS(707)*UV(89)+JVS(752)*UV(90)+JVS(784)*UV(91)+JVS(865)*UV(93)+JVS(940)*UV(96)&
               &+JVS(985)*UV(97)+JVS(1051)*UV(98)+JVS(1079)*UV(99)
  JTUV(79) = JVS(140)*UV(20)+JVS(338)*UV(65)+JVS(358)*UV(66)+JVS(502)*UV(79)+JVS(708)*UV(89)+JVS(866)*UV(93)+JVS(899)&
               &*UV(94)+JVS(986)*UV(97)+JVS(1052)*UV(98)
  JTUV(80) = JVS(23)*UV(7)+JVS(31)*UV(8)+JVS(44)*UV(9)+JVS(92)*UV(16)+JVS(141)*UV(20)+JVS(300)*UV(62)+JVS(339)*UV(65)&
               &+JVS(382)*UV(68)+JVS(426)*UV(73)+JVS(447)*UV(74)+JVS(488)*UV(78)+JVS(503)*UV(79)+JVS(517)*UV(80)+JVS(523)&
               &*UV(81)+JVS(547)*UV(82)+JVS(572)*UV(83)+JVS(589)*UV(84)+JVS(612)*UV(85)+JVS(634)*UV(86)+JVS(656)*UV(87)&
               &+JVS(682)*UV(88)+JVS(709)*UV(89)+JVS(753)*UV(90)+JVS(785)*UV(91)+JVS(826)*UV(92)+JVS(867)*UV(93)+JVS(900)&
               &*UV(94)+JVS(987)*UV(97)+JVS(1053)*UV(98)+JVS(1080)*UV(99)
  JTUV(81) = JVS(24)*UV(7)+JVS(142)*UV(20)+JVS(318)*UV(64)+JVS(340)*UV(65)+JVS(427)*UV(73)+JVS(524)*UV(81)+JVS(548)&
               &*UV(82)+JVS(590)*UV(84)+JVS(613)*UV(85)+JVS(635)*UV(86)+JVS(657)*UV(87)+JVS(683)*UV(88)+JVS(710)*UV(89)&
               &+JVS(754)*UV(90)+JVS(786)*UV(91)+JVS(901)*UV(94)+JVS(942)*UV(96)+JVS(988)*UV(97)+JVS(1054)*UV(98)+JVS(1081)&
               &*UV(99)
  JTUV(82) = JVS(143)*UV(20)+JVS(242)*UV(48)+JVS(341)*UV(65)+JVS(361)*UV(66)+JVS(549)*UV(82)+JVS(869)*UV(93)+JVS(989)&
               &*UV(97)+JVS(1055)*UV(98)
  JTUV(83) = JVS(144)*UV(20)+JVS(383)*UV(68)+JVS(428)*UV(73)+JVS(504)*UV(79)+JVS(550)*UV(82)+JVS(573)*UV(83)+JVS(614)&
               &*UV(85)+JVS(636)*UV(86)+JVS(658)*UV(87)+JVS(755)*UV(90)+JVS(787)*UV(91)+JVS(829)*UV(92)+JVS(990)*UV(97)&
               &+JVS(1056)*UV(98)
  JTUV(84) = JVS(70)*UV(13)+JVS(342)*UV(65)+JVS(369)*UV(67)+JVS(389)*UV(69)+JVS(406)*UV(71)+JVS(411)*UV(72)+JVS(429)&
               &*UV(73)+JVS(448)*UV(74)+JVS(453)*UV(75)+JVS(458)*UV(76)+JVS(475)*UV(77)+JVS(505)*UV(79)+JVS(518)*UV(80)&
               &+JVS(525)*UV(81)+JVS(551)*UV(82)+JVS(591)*UV(84)+JVS(615)*UV(85)+JVS(637)*UV(86)+JVS(659)*UV(87)+JVS(684)&
               &*UV(88)+JVS(756)*UV(90)+JVS(788)*UV(91)+JVS(830)*UV(92)+JVS(871)*UV(93)+JVS(903)*UV(94)+JVS(943)*UV(96)&
               &+JVS(991)*UV(97)+JVS(1108)*UV(100)
  JTUV(85) = JVS(145)*UV(20)+JVS(343)*UV(65)+JVS(362)*UV(66)+JVS(506)*UV(79)+JVS(616)*UV(85)+JVS(757)*UV(90)+JVS(789)&
               &*UV(91)+JVS(872)*UV(93)+JVS(992)*UV(97)+JVS(1058)*UV(98)+JVS(1083)*UV(99)
  JTUV(86) = JVS(146)*UV(20)+JVS(430)*UV(73)+JVS(507)*UV(79)+JVS(552)*UV(82)+JVS(617)*UV(85)+JVS(638)*UV(86)+JVS(714)&
               &*UV(89)+JVS(758)*UV(90)+JVS(790)*UV(91)+JVS(1059)*UV(98)+JVS(1084)*UV(99)
  JTUV(87) = JVS(147)*UV(20)+JVS(431)*UV(73)+JVS(508)*UV(79)+JVS(553)*UV(82)+JVS(618)*UV(85)+JVS(639)*UV(86)+JVS(660)&
               &*UV(87)+JVS(715)*UV(89)+JVS(759)*UV(90)+JVS(791)*UV(91)+JVS(994)*UV(97)+JVS(1060)*UV(98)+JVS(1085)*UV(99)
  JTUV(88) = JVS(7)*UV(2)+JVS(25)*UV(7)+JVS(32)*UV(8)+JVS(45)*UV(9)+JVS(71)*UV(13)+JVS(148)*UV(20)+JVS(181)*UV(26)&
               &+JVS(219)*UV(40)+JVS(281)*UV(58)+JVS(284)*UV(59)+JVS(301)*UV(62)+JVS(319)*UV(64)+JVS(344)*UV(65)+JVS(370)&
               &*UV(67)+JVS(384)*UV(68)+JVS(390)*UV(69)+JVS(407)*UV(71)+JVS(412)*UV(72)+JVS(432)*UV(73)+JVS(449)*UV(74)&
               &+JVS(454)*UV(75)+JVS(459)*UV(76)+JVS(476)*UV(77)+JVS(490)*UV(78)+JVS(509)*UV(79)+JVS(519)*UV(80)+JVS(526)&
               &*UV(81)+JVS(554)*UV(82)+JVS(592)*UV(84)+JVS(619)*UV(85)+JVS(640)*UV(86)+JVS(661)*UV(87)+JVS(685)*UV(88)&
               &+JVS(716)*UV(89)+JVS(760)*UV(90)+JVS(792)*UV(91)+JVS(834)*UV(92)+JVS(875)*UV(93)+JVS(907)*UV(94)+JVS(944)&
               &*UV(96)+JVS(995)*UV(97)+JVS(1061)*UV(98)+JVS(1086)*UV(99)+JVS(1111)*UV(100)
  JTUV(89) = JVS(33)*UV(8)+JVS(54)*UV(10)+JVS(199)*UV(34)+JVS(396)*UV(70)+JVS(433)*UV(73)+JVS(510)*UV(79)+JVS(555)&
               &*UV(82)+JVS(662)*UV(87)+JVS(686)*UV(88)+JVS(717)*UV(89)+JVS(761)*UV(90)+JVS(793)*UV(91)+JVS(835)*UV(92)&
               &+JVS(876)*UV(93)+JVS(908)*UV(94)+JVS(925)*UV(95)+JVS(945)*UV(96)+JVS(996)*UV(97)+JVS(1087)*UV(99)+JVS(1112)&
               &*UV(100)
  JTUV(90) = JVS(34)*UV(8)+JVS(46)*UV(9)+JVS(77)*UV(14)+JVS(84)*UV(15)+JVS(257)*UV(52)+JVS(287)*UV(60)+JVS(434)*UV(73)&
               &+JVS(556)*UV(82)+JVS(641)*UV(86)+JVS(663)*UV(87)+JVS(718)*UV(89)+JVS(762)*UV(90)+JVS(794)*UV(91)+JVS(836)&
               &*UV(92)+JVS(877)*UV(93)+JVS(909)*UV(94)+JVS(926)*UV(95)+JVS(946)*UV(96)+JVS(997)*UV(97)+JVS(1088)*UV(99)&
               &+JVS(1113)*UV(100)
  JTUV(91) = JVS(35)*UV(8)+JVS(47)*UV(9)+JVS(78)*UV(14)+JVS(85)*UV(15)+JVS(258)*UV(52)+JVS(288)*UV(60)+JVS(435)*UV(73)&
               &+JVS(557)*UV(82)+JVS(576)*UV(83)+JVS(642)*UV(86)+JVS(664)*UV(87)+JVS(719)*UV(89)+JVS(763)*UV(90)+JVS(795)&
               &*UV(91)+JVS(837)*UV(92)+JVS(878)*UV(93)+JVS(910)*UV(94)+JVS(927)*UV(95)+JVS(947)*UV(96)+JVS(998)*UV(97)&
               &+JVS(1089)*UV(99)+JVS(1114)*UV(100)
  JTUV(92) = JVS(64)*UV(12)+JVS(72)*UV(13)+JVS(149)*UV(20)+JVS(200)*UV(34)+JVS(202)*UV(35)+JVS(205)*UV(36)+JVS(208)&
               &*UV(37)+JVS(224)*UV(42)+JVS(233)*UV(45)+JVS(247)*UV(49)+JVS(253)*UV(51)+JVS(294)*UV(61)+JVS(364)*UV(66)&
               &+JVS(397)*UV(70)+JVS(577)*UV(83)+JVS(593)*UV(84)+JVS(687)*UV(88)+JVS(720)*UV(89)+JVS(838)*UV(92)+JVS(879)&
               &*UV(93)+JVS(928)*UV(95)+JVS(948)*UV(96)+JVS(999)*UV(97)+JVS(1065)*UV(98)+JVS(1090)*UV(99)+JVS(1115)*UV(100)
  JTUV(93) = JVS(65)*UV(12)+JVS(73)*UV(13)+JVS(79)*UV(14)+JVS(150)*UV(20)+JVS(225)*UV(42)+JVS(248)*UV(49)+JVS(276)&
               &*UV(57)+JVS(295)*UV(61)+JVS(302)*UV(62)+JVS(307)*UV(63)+JVS(320)*UV(64)+JVS(345)*UV(65)+JVS(365)*UV(66)&
               &+JVS(371)*UV(67)+JVS(386)*UV(68)+JVS(391)*UV(69)+JVS(398)*UV(70)+JVS(408)*UV(71)+JVS(413)*UV(72)+JVS(437)&
               &*UV(73)+JVS(450)*UV(74)+JVS(455)*UV(75)+JVS(460)*UV(76)+JVS(479)*UV(77)+JVS(491)*UV(78)+JVS(511)*UV(79)&
               &+JVS(520)*UV(80)+JVS(527)*UV(81)+JVS(559)*UV(82)+JVS(578)*UV(83)+JVS(594)*UV(84)+JVS(623)*UV(85)+JVS(644)&
               &*UV(86)+JVS(721)*UV(89)+JVS(765)*UV(90)+JVS(797)*UV(91)+JVS(839)*UV(92)+JVS(880)*UV(93)+JVS(912)*UV(94)&
               &+JVS(929)*UV(95)+JVS(949)*UV(96)+JVS(1000)*UV(97)+JVS(1066)*UV(98)+JVS(1091)*UV(99)+JVS(1116)*UV(100)
  JTUV(94) = JVS(36)*UV(8)+JVS(48)*UV(9)+JVS(80)*UV(14)+JVS(86)*UV(15)+JVS(238)*UV(47)+JVS(259)*UV(52)+JVS(438)*UV(73)&
               &+JVS(560)*UV(82)+JVS(645)*UV(86)+JVS(667)*UV(87)+JVS(722)*UV(89)+JVS(766)*UV(90)+JVS(798)*UV(91)+JVS(840)&
               &*UV(92)+JVS(881)*UV(93)+JVS(913)*UV(94)+JVS(930)*UV(95)+JVS(950)*UV(96)+JVS(1001)*UV(97)+JVS(1092)*UV(99)&
               &+JVS(1117)*UV(100)
  JTUV(95) = JVS(49)*UV(9)+JVS(57)*UV(11)+JVS(206)*UV(36)+JVS(399)*UV(70)+JVS(439)*UV(73)+JVS(512)*UV(79)+JVS(561)&
               &*UV(82)+JVS(668)*UV(87)+JVS(689)*UV(88)+JVS(723)*UV(89)+JVS(767)*UV(90)+JVS(799)*UV(91)+JVS(841)*UV(92)&
               &+JVS(882)*UV(93)+JVS(914)*UV(94)+JVS(931)*UV(95)+JVS(951)*UV(96)+JVS(1002)*UV(97)+JVS(1093)*UV(99)+JVS(1118)&
               &*UV(100)
  JTUV(96) = JVS(50)*UV(9)+JVS(58)*UV(11)+JVS(209)*UV(37)+JVS(400)*UV(70)+JVS(440)*UV(73)+JVS(513)*UV(79)+JVS(562)&
               &*UV(82)+JVS(690)*UV(88)+JVS(724)*UV(89)+JVS(768)*UV(90)+JVS(800)*UV(91)+JVS(842)*UV(92)+JVS(883)*UV(93)&
               &+JVS(915)*UV(94)+JVS(932)*UV(95)+JVS(952)*UV(96)+JVS(1003)*UV(97)+JVS(1094)*UV(99)+JVS(1119)*UV(100)
  JTUV(97) = JVS(37)*UV(8)+JVS(51)*UV(9)+JVS(55)*UV(10)+JVS(59)*UV(11)+JVS(87)*UV(15)+JVS(151)*UV(20)+JVS(211)*UV(38)&
               &+JVS(239)*UV(47)+JVS(243)*UV(48)+JVS(249)*UV(49)+JVS(254)*UV(51)+JVS(289)*UV(60)+JVS(296)*UV(61)+JVS(308)&
               &*UV(63)+JVS(366)*UV(66)+JVS(401)*UV(70)+JVS(441)*UV(73)+JVS(563)*UV(82)+JVS(691)*UV(88)+JVS(725)*UV(89)&
               &+JVS(769)*UV(90)+JVS(801)*UV(91)+JVS(843)*UV(92)+JVS(884)*UV(93)+JVS(916)*UV(94)+JVS(933)*UV(95)+JVS(953)&
               &*UV(96)+JVS(1004)*UV(97)+JVS(1070)*UV(98)+JVS(1095)*UV(99)+JVS(1120)*UV(100)
  JTUV(98) = JVS(3)*UV(1)+JVS(26)*UV(7)+JVS(74)*UV(13)+JVS(93)*UV(16)+JVS(97)*UV(17)+JVS(100)*UV(18)+JVS(104)*UV(19)&
               &+JVS(152)*UV(20)+JVS(167)*UV(21)+JVS(171)*UV(22)+JVS(173)*UV(23)+JVS(177)*UV(24)+JVS(179)*UV(25)+JVS(183)&
               &*UV(27)+JVS(186)*UV(28)+JVS(188)*UV(29)+JVS(191)*UV(30)+JVS(193)*UV(31)+JVS(195)*UV(32)+JVS(197)*UV(33)&
               &+JVS(212)*UV(38)+JVS(214)*UV(39)+JVS(220)*UV(40)+JVS(222)*UV(41)+JVS(227)*UV(43)+JVS(230)*UV(44)+JVS(234)&
               &*UV(45)+JVS(236)*UV(46)+JVS(240)*UV(47)+JVS(251)*UV(50)+JVS(255)*UV(51)+JVS(260)*UV(52)+JVS(262)*UV(53)&
               &+JVS(264)*UV(54)+JVS(268)*UV(55)+JVS(272)*UV(56)+JVS(277)*UV(57)+JVS(282)*UV(58)+JVS(285)*UV(59)+JVS(290)&
               &*UV(60)+JVS(303)*UV(62)+JVS(309)*UV(63)+JVS(321)*UV(64)+JVS(346)*UV(65)+JVS(367)*UV(66)+JVS(372)*UV(67)&
               &+JVS(387)*UV(68)+JVS(392)*UV(69)+JVS(402)*UV(70)+JVS(409)*UV(71)+JVS(414)*UV(72)+JVS(442)*UV(73)+JVS(451)&
               &*UV(74)+JVS(456)*UV(75)+JVS(461)*UV(76)+JVS(483)*UV(77)+JVS(492)*UV(78)+JVS(514)*UV(79)+JVS(521)*UV(80)&
               &+JVS(528)*UV(81)+JVS(564)*UV(82)+JVS(579)*UV(83)+JVS(625)*UV(85)+JVS(646)*UV(86)+JVS(669)*UV(87)+JVS(692)&
               &*UV(88)+JVS(726)*UV(89)+JVS(770)*UV(90)+JVS(802)*UV(91)+JVS(844)*UV(92)+JVS(885)*UV(93)+JVS(917)*UV(94)&
               &+JVS(934)*UV(95)+JVS(954)*UV(96)+JVS(1005)*UV(97)+JVS(1071)*UV(98)+JVS(1096)*UV(99)+JVS(1121)*UV(100)
  JTUV(99) = JVS(52)*UV(9)+JVS(60)*UV(11)+JVS(203)*UV(35)+JVS(403)*UV(70)+JVS(443)*UV(73)+JVS(515)*UV(79)+JVS(565)&
               &*UV(82)+JVS(670)*UV(87)+JVS(693)*UV(88)+JVS(727)*UV(89)+JVS(771)*UV(90)+JVS(803)*UV(91)+JVS(845)*UV(92)&
               &+JVS(886)*UV(93)+JVS(918)*UV(94)+JVS(935)*UV(95)+JVS(955)*UV(96)+JVS(1006)*UV(97)+JVS(1097)*UV(99)+JVS(1122)&
               &*UV(100)
  JTUV(100) = JVS(27)*UV(7)+JVS(81)*UV(14)+JVS(153)*UV(20)+JVS(228)*UV(43)+JVS(244)*UV(48)+JVS(404)*UV(70)+JVS(444)&
                &*UV(73)+JVS(516)*UV(79)+JVS(566)*UV(82)+JVS(580)*UV(83)+JVS(596)*UV(84)+JVS(694)*UV(88)+JVS(728)*UV(89)&
                &+JVS(772)*UV(90)+JVS(804)*UV(91)+JVS(846)*UV(92)+JVS(887)*UV(93)+JVS(919)*UV(94)+JVS(936)*UV(95)+JVS(956)&
                &*UV(96)+JVS(1007)*UV(97)+JVS(1073)*UV(98)+JVS(1098)*UV(99)+JVS(1123)*UV(100)
      
END SUBROUTINE JacTR_SP_Vec

! End of JacTR_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE saprc99_mosaic_4bin_vbs2_Jacobian

