#!/bin/bash 

echo ' '
echo 'start get_initial '$(date)
#exit
#
#NCPUS - number of cpus for real.exe
NCPUS=1

#work directory

#programs
export WRFPRGS=${WRFCHEM_DIR}/WRFV3
#export WPSPRGS=${WRFCHEM_DIR}/WPS
export WPSPRGS=${WRFCHEM_DIR_WPS}/WPS
export RAQMS_LBC_DIR=${WRFCHEM_UTILS}/Lateral_BC/LBC_AUG2010_USE
####export RAQMS_LBC_DIR=${WRFCHEM_UTILS}/Lateral_BC/FINAL_2D_1D_raqms_only
export BIN_FIRES_DIR=${WRFCHEM_UTILS}/EMISSION_PROGRAMS/PREP_CHEM_SRC_1.3/bin

#data
GEOG_DATA=${WRFCHEM_UTILS}/WRF_GEOG/geog_v3.5
export EMISS_DIR=${WRFCHEM_UTILS}/Global_emissions_v3
######export FIRES_LOC=$FIRE_DAT
export RAQMS_DATA=$RAQMS_DIR
GFS_INPUT_DIR=$GFS_DATA

#output directory where IC are written
WRF_INIT_DATA=${base_data_disk}/8KM_INPUT/${grid_dims}

export AREAFIX=yes
export NOXLIGHTNING=yes

echo 'base data disk '$base_data_disk   $EMISS_DIR

######################### Settings for AOD run ######################
#export L_NOX=/home/schaack/WRF_LNOX
export L_NOX=/home/lenzen/WRF_LNOX
export AEREXPSTART=2010042600
export OBFAC=0.1
export SETCHLAER=300.
export SETCHAER=300.
export ASSIMAOD=save
####export SDFAOD

mkdir ${scratch_d_wps}
export Rundir=${scratch_d_wps}
echo 'Rundir '$Rundir

#go to run directory
cd $Rundir

/bin/rm -f real.exe
/bin/rm -f convert_emiss.exe
/bin/rm -f wrf.exe
/bin/rm -f rsl.*

#Set up run ********************************************
COMPUTE_IC=.true.
DO_LBC=.true.
DO_IC=.true.
#Set up run ********************************************

#environment variables read in from job script ${user_dir}/PROJECTS/REALTIME_PROXY/run_realtime_proxy.sh 
echo ' '
echo 'Get initial data'
echo 'local day, WRF IC, gfs dir date,raqms dr date '$LOCAL_DAY ${WRF_START} $GFS_DATE $RAQMS_DATE

gfs_year=`echo "${GFS_DATE}" | cut -c1-4`
gfs_month=`echo "${GFS_DATE}" | cut -c6-7`
gfs_day=`echo "${GFS_DATE}" | cut -c9-10`
GFS_DIR=${gfs_year}${gfs_month}${gfs_day}

#fires date and GFS data directories have same date
fires_year=`echo "${GFS_DATE}" | cut -c1-4`
fires_month=`echo "${GFS_DATE}" | cut -c6-7`
fires_day=`echo "${GFS_DATE}" | cut -c9-10`
export iday_fires=${GFS_DATE}_00

#date of IC for WRF/Chem
export wrf_start=${WRF_START}
#for this application wrf_stop=wrf_start
wrf_stop=${wrf_start}

#start date
year=`echo "${wrf_start}" | cut -c1-4`
month=`echo "${wrf_start}" | cut -c6-7`
day=`echo "${wrf_start}" | cut -c9-10`
hr=`echo "${wrf_start}" | cut -c12-13`
current_time=${year}${month}${day}${hr}

#stop date
stop_time=${current_time}


echo '********************************************'
echo ' '
echo 'Job start date '$LOCAL_DAY
echo 'WRF/Chem start time ',$current_time
echo 'GFS directory date ',$GFS_DATE
echo 'FIRES date ',$fires_year$fires_month$fires_day
echo 'RAQMS directory date ',$RAQMS_DATE
echo
echo 'WRF timestep '${timestep}
echo 'Num cols '${npt_we}
echo 'Num rows '${npt_sn}
echo 'forecast length '$fcst_length
echo ' '
echo '**************************************************************************'

#WRFDA routine used to increment time
#rsync -av ${user_dir}/UTILS/da_advance_time.exe .
rsync -av ${user_dir}/UTILS/da_advance_time.exe .
if [ $? -ne 0 ];then
  rsync -av ${user_dir}/UTILS/da_advance_time.exe .
fi
new_date=./da_advance_time.exe

#copy over WRF/Chem 
#rsync -av $WRFPRGS/main/real.exe real.exe 
rsync -av $WRFPRGS/main/real.exe real.exe 
if [ $? -ne 0 ];then
  rsync -av $WRFPRGS/main/real.exe real.exe 
  if [ $? -ne 0 ];then
     exit 1
  fi
fi
#rsync -av $WRFPRGS/main/wrf.exe wrf.exe 
rsync -av $WRFPRGS/main/wrf.exe wrf.exe 
if [ $? -ne 0 ];then
  rsync -av $WRFPRGS/main/wrf.exe wrf.exe 
  if [ $? -ne 0 ];then 
    exit 1
  fi
fi
rsync -av $WRFPRGS/chem/convert_emiss.exe convert_emiss.exe 
if [ $? -ne 0 ];then
  rsync -av $WRFPRGS/chem/convert_emiss.exe convert_emiss.exe 
fi
rsync -av $WRFPRGS/run/*.tbl .
if [ $? -ne 0 ];then
  rsync -av $WRFPRGS/run/*.tbl .
fi
rsync -av $WRFPRGS/run/*.TBL .
if [ $? -ne 0 ];then
  rsync -av $WRFPRGS/run/*.TBL .
fi
rsync -av $WRFPRGS/run/*.txt .
if [ $? -ne 0 ];then
  rsync -av $WRFPRGS/run/*.txt .
fi 
rsync -av $WRFPRGS/run/*DATA .
if [ $? -ne 0 ];then
  rsync -av $WRFPRGS/run/*DATA .
fi
#####rsync -av firefly:$L_NOX/* .
pwd
echo WPSPRGS $WPSPRGS
ls -l $WPSPRGS
rsync -av $WPSPRGS .

rsync -av ${RAQMS_LBC_DIR}/wrfchembc wrfchembc.exe

#Move over programs for making binary fires
rsync -avL $BIN_FIRES_DIR/prep_chem_sources_RADM_WRF_FIM.exe .
rsync -av $BIN_FIRES_DIR/getjulday.x getjulday.x
rsync -av $BIN_FIRES_DIR/run_wrfchem_binary_emissions_v1.3.sh run_wrfchem_binary_emissions.sh

echo 'reading geography from '${GEOG_DATA}

echo ' '
echo '############################################### '
echo '############################################### '
echo "Get WRF intial conditions, LBCs, biomass burning emissions for  "${current_time}
echo '############################################### '
echo '############################################### '
echo ' '


#WHILE LOOP (keep going until stop_time)

#NOTE: current_time and stop_time are the same here, the while loop  is left for future use


while [ ${current_time} -le ${stop_time} ]
do

year=`echo "${current_time}" | cut -c1-4`
month=`echo "${current_time}" | cut -c5-6`
day=`echo "${current_time}" | cut -c7-8`
hr=`echo "${current_time}" | cut -c9-10`
# ajl find out if new or old grb2 files
# old before 2016051112 with 27 levels
# new after of on 2016051112 with 32 levels
export metgrid_levels=32
if [ ${current_time} -lt 2016051112 ]; then
  export metgrid_levels=27
fi


end_year=`echo "${current_time}" | cut -c1-4`
end_month=`echo "${current_time}" | cut -c5-6`
end_day=`echo "${current_time}" | cut -c7-8`
end_hr=`echo "${current_time}" | cut -c9-10`

export WRFDATE=${year}-${month}-${day}_${hr}:00:00
export FIRE_DIR=${year}_${month}_${day}_${hr}

# Need to get next days date also (day after current_time)
nxt_time=$($new_date $current_time 1d)
nxt_year=`echo "${nxt_time}" | cut -c1-4`
nxt_month=`echo "${nxt_time}" | cut -c5-6`
nxt_day=`echo "${nxt_time}" | cut -c7-8`
nxt_hr=`echo "${nxt_time}" | cut -c9-10`


# find time at end of forecast 

numday=$((${fcst_length}/24))
numhr=$((${fcst_length}%24))
run_days=${numday}
run_hours=${numhr}

end_date=${current_time}
nxt_time=$($new_date $end_date ${numday}d)
nxt_time=$($new_date $nxt_time ${numhr}h)

end_year=`echo "${nxt_time}" | cut -c1-4`
end_month=`echo "${nxt_time}" | cut -c5-6`
end_day=`echo "${nxt_time}" | cut -c7-8`
end_hr=`echo "${nxt_time}" | cut -c9-10`

export FCST_START=${year}-${month}-${day}_${hr}
export FCST_STOP=${end_year}-${end_month}-${end_day}_${end_hr}

echo 'fcst start, stop '$FCST_START $FCST_STOP

# check if existing simulation exists for chemistry

have_chem=0
if [ -e wrfrst_d01_${WRFDATE} ]; then
   ln -sf wrfrst_d01_${WRFDATE}  wrf_chem_input_d01
   have_chem=1
   echo 'Using chemistry from existing simulation 'wrfrst_d01_${WRFDATE}
fi

echo ' '
echo 'Is there a existing restart file, 1=yes; 0=no: '${have_chem}
echo ' '


if [ ${COMPUTE_IC} = .true. ]; then

#Make MET initial conditions and LBC

wps_date=${FCST_START}':00:00'
wps_date_end=${FCST_STOP}':00:00'

echo ' '
echo 'Run wps for  '${wps_date} ${wps_date_end}

cd WPS
mkdir ungrib/Variable_Tables/
rsync -rlvtD $PROG_DIR/WPS/ungrib/Variable_Tables/Vtable.GFS_new ungrib/Variable_Tables/
pwd

#clear out old files
rm FILE* 
rm GRIBFILE* 

mkdir GFSDAT
cd GFSDAT
#clear out old files
rm gfs.p5*

echo $PWD

# copy GFS data 12hr to 48hr forecasts
# 4-16-13 Brad wants 12hr to 60hr now
# 5-18-2018 Brad wants 12hr to 84hr now
yes_gfs=0

rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_01* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi
rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_02* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi
rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_03* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi
rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_04* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi
#rsync  forecast hours 54hr
rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_05* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi
#rsync  forecast hours 60hr
rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_06* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi
#rsync  forecast hours 72,78 hr
rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_07* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi
#rsync  forecast hours 84 hr
rsync -av ${user_1}@${GFS_INPUT_DIR}/${GFS_DIR}/gfs.p5.${gfs_year}${gfs_month}${gfs_day}_12_08* .
if [ $? -ne 0 ]; then
yes_gfs=1
fi

if [ ${yes_gfs} -ne 0 ]; then
echo "GFS input data missing" >> $Rundir/${WRF_START}_problems.out
rsync -av /scratch/lenzen/gfs5deg/${gfs_year}${gfs_month}${gfs_day}12/ldm/gfs*_0* .
fi

cd ../
pwd
echo $PWD
# /bin/rm -rf namelist.wps
cat > namelist.wps << __EOF
&share
 wrf_core = 'ARW',
 max_dom = 1,
 start_date = ${wps_date},
 end_date = ${wps_date_end},
 interval_seconds = 21600,
 io_form_geogrid = 2,
/

&geogrid
 parent_id         =   1, 
 parent_grid_ratio =   1,
 i_parent_start    =   1, 
 j_parent_start    =   1, 
 e_we              =  ${npt_we},
 e_sn              =  ${npt_sn},
 geog_data_res     = '${geog_data_res}',
 dx = ${dx_grid},
 dy = ${dy_grid},
 map_proj = 'lambert',
 ref_lat   = ${ref_lat},
 ref_lon   = ${ref_lon},
 truelat1  = ${truelat1},
 truelat2  = ${truelat2},
 stand_lon = ${stand_lon},
 geog_data_path = '$GEOG_DATA'
/

&ungrib
 out_format = 'WPS',
 prefix = 'FILE',
/

&metgrid
 fg_name = 'FILE'
 io_form_metgrid = 2,
/

__EOF

echo $PWD

# ./geogrid.exe
#mpirun ./geogrid.exe
pwd
srun --export=ALL -n 1 ./geogrid.exe

./link_grib.csh GFSDAT/gfs.p5.*
pwd
echo do ungrib.exe
#ln -fs Vtable ungrib/Variable_Tables/Vtable.GFS.new
#ln -fs Vtable ungrib/Variable_Tables/Vtable.GFS_new
pwd
ln -fs  ungrib/Variable_Tables/Vtable.GFS_new Vtable
ls -l Vtable

./ungrib.exe

##/opt/intel/impi/current/bin64/mpiexec -n $NCPUS ./metgrid.exe

#mpirun ./metgrid.exe
srun --export=ALL -n 1 ./metgrid.exe
pwd
ls -l 

mv met_em* $Rundir
cd $Rundir
pwd
#####echo 'Done with WPS '$(date)

#met-em files are here now make wrf IC and LBC

#Set up Namelist for real.exe

cat > namelist.input << __EOF
 &time_control
 run_days                            = ${run_days},
 run_hours                           = ${run_hours},
 run_minutes                         = 0,
 run_seconds                         = 0,
 start_year                          = ${year}, 2999, 2999,
 start_month                         = ${month},   06,   06,
 start_day                           = ${day},   11,   11,
 start_hour                          = ${hr},   12,   12,
 start_minute                        = 00,   00,   00,
 start_second                        = 00,   00,   00,
 end_year                            = ${end_year}, 2999, 2999,
 end_month                           = ${end_month},   06,   06,
 end_day                             = ${end_day},   12,   12,
 end_hour                            = ${end_hr},   12,   12,
 end_minute                          = 00,   00,   00,
 end_second                          = 00,   00,   00,
 interval_seconds                    = 21600,
 input_from_file                     = .true.,.true.,.true.,
 history_interval                    = 60,   60,   60,
 frames_per_outfile                  = 1, 1000, 1000,
 restart                             = .false.,
 restart_interval                    = 60,
 io_form_history                     = 2
 io_form_restart                     = 2
 io_form_input                       = 2
 io_form_boundary                    = 2
 io_form_auxinput4                   = 2
 debug_level                         = 00
 auxinput1_inname                    = "met_em.d<domain>.<date>"
 /

 &domains
 time_step                           = ${timestep},
 time_step_fract_num                 = 0,
 time_step_fract_den                 = 1,
 max_dom                             = 1,
 e_we                                = ${npt_we},    112,   94,
 e_sn                                = ${npt_sn},    97,    91,
 e_vert                              = ${nlvl},    20,    20,
 dx                                  = ${dx_grid}, 20000, 6666.66,
 dy                                  = ${dy_grid}, 20000, 6666.66,
 p_top_requested                     = 5000,
 num_metgrid_levels                  = ${metgrid_levels},
 num_metgrid_soil_levels             = 4,
 grid_id                             = 1,     2,     3,
 parent_id                           = 1,     1,     2,
 i_parent_start                      = 1,     30,    30,
 j_parent_start                      = 1,     20,    30,
 parent_grid_ratio                   = 1,     3,     3,
 parent_time_step_ratio              = 1,     3,     3,
 feedback                            = 1,
 smooth_option                       = 0,
 eta_levels                          =    1, 0.993, 0.983, 0.97, 0.954, 0.935, 0.913, 0.888, 0.86, 0.83, 0.799,
    0.767, 0.733, 0.7, 0.667, 0.633, 0.6, 0.567, 0.533, 0.5, 0.467, 0.433,
    0.4, 0.367, 0.333, 0.3, 0.267, 0.233, 0.2, 0.167, 0.133, 0.1, 0.067,0.033, 0.
 /

 &physics
 mp_physics                          = 8,     2,     2,
 ra_lw_physics                       = 1,     1,     1,
 ra_sw_physics                       = 1,     2,     2,
 radt                                = 30,    10,    10,
 sf_sfclay_physics                   = 2,     1,     1,
 sf_surface_physics                  = 2,     2,     2,
 bl_pbl_physics                      = 2,     1,     1,
 bldt                                = 0,     0,     0,
 cu_physics                          = 0,     5,     0,
 cudt                                = 0,     1,     1,
 isfflx                              = 1,
 ifsnow                              = 1,
 icloud                              = 1,
 surface_input_source                = 1,
 num_soil_layers                     = 4,
 sf_urban_physics                    = 0,
 swrad_scat                          = 1,
 mp_zero_out                         = 2,
 mp_zero_out_thresh                  = 1.e-8,
 maxiens                             = 1,
 maxens                              = 3,
 maxens2                             = 3,
 maxens3                             = 16,
 ensdim                              = 144,
 cu_rad_feedback                     = .false.,
 cu_diag                             = 0,
 cugd_avedx                          = 3
 /

 &fdda
 /

 &dynamics
 rk_ord                              = 3,
 w_damping                           = 1,
 diff_opt                            = 1,
 km_opt                              = 4,
 diff_6th_opt                        = 0,      0,      0,
 diff_6th_factor                     = 0.12,   0.12,   0.12,
 base_temp                           = 290.
 damp_opt                            = 0,
 zdamp                               = 5000.,  5000.,  5000.,
 dampcoef                            = 0.01,    0.2,    0.2
 khdif                               = 0,      0,      0,
 kvdif                               = 0,      0,      0,
 smdiv                               = 0.1,    0.1,    0.1,
 emdiv                               = 0.01,   0.01,   0.01,
 non_hydrostatic                     = .true., .true., .true.,
 tke_adv_opt                         = 2,      1,      1,     
 moist_adv_opt                       = 2,      1,      1,     
 scalar_adv_opt                      = 2,      1,      1,     
 chem_adv_opt                        = 2,      1,      1,     
 use_baseparam_fr_nml                = .true.,
 h_mom_adv_order                     = 5,      5,      5,
 v_mom_adv_order                     = 3,      3,      3,
 h_sca_adv_order                     = 5,      5,      5,
 v_sca_adv_order                     = 3,      3,      3,
 time_step_sound                     = 4,      4,      4,
 epssm                               = .1,     .1,     .1,
 /

 &bdy_control
 spec_bdy_width                      = 5,
 spec_zone                           = 1,
 relax_zone                          = 4,
 specified                           = .true., .false.,.false.,
 nested                              = .false., .true., .true.,
 /

 &grib2
 /

 &chem
 kemit                               = 19,
 chem_opt                            = 300,        2,
 bioemdt                             = 30,       30,
 photdt                              = 30,       30,
 chemdt                              = ${chemdtt},       2.,
 io_style_emissions                  = 0,
 emiss_inpt_opt                      = 0,        1,
 emiss_opt                           = 0,        3,
 chem_in_opt                         = 0,        0,
/

 &namelist_quilt
 nio_tasks_per_group = 0,
 nio_groups = 1,
 /

__EOF

##############################################################

###### RUN REAL.EXE
echo 'Time before run real.exe '$(date)
cp -p namelist.input namelist.input.save1

srun --export=ALL -n 1 ./real.exe 
echo did real.exe

mv rsl.out.0000 rsl.out.real.0000
mv rsl.error.0000 rsl.error.real.0000
####echo "done with real.exe "$(date)


echo ' '
echo ' Make biomass burning emissions'
#FIRES PROCESSING
echo ajl FIRES_LOC $FIRES_LOC

###########################Make binary Fires#######################################

./run_wrfchem_binary_emissions.sh

if [ $? -ne 0 ]; then
echo 'Problems with fires data' >> $Rundir/${WRF_START}_problems.out
echo 'ajl problem after run_wrfchem_binary_emissions.sh'
fi

mv GOCART-T-${fires_year}-${fires_month}-${fires_day}-000000-g1-gocartBG.bin wrf_gocart_backg
mv GOCART-T-${fires_year}-${fires_month}-${fires_day}-000000-g1-ab.bin emissopt3_d01
mv GOCART-T-${fires_year}-${fires_month}-${fires_day}-000000-g1-bb.bin emissfire_d01

echo GOCART-T-${fires_year}-${fires_month}-${fires_day}-000000-g1-gocartBG.bin
echo GOCART-T-${fires_year}-${fires_month}-${fires_day}-000000-g1-ab.bin
echo GOCART-T-${fires_year}-${fires_month}-${fires_day}-000000-g1-bb.bin

rm GOCART*.vfm
rm GOCART*.ctl
rm GOCART*.gra
######################################

echo ' '
echo 'convert_emiss ',${run_days} ${run_hours} ${fires_year}${fires_month}${fires_day}${fires_hr}
echo 'using fires from previous day'

#NOTE:  using binary fires from previous day for this real-time simulation
#example: for the 00z May 6 to 12z May 7 run we are using fires from May 5


#Namelist for convert_emiss.exe

cat > namelist.input << __EOF
 &time_control
 run_days                            = 1,
 run_hours                           = 0,
 run_minutes                         = 0,
 run_seconds                         = 0,
 start_year                          = ${year}, 2999, 2999,
 start_month                         = ${month},   06,   06,
 start_day                           = ${day},   11,   11,
 start_hour                          = ${hr},   12,   12,
 start_minute                        = 00,   00,   00,
 start_second                        = 00,   00,   00,
 end_year                            = ${end_year}, 2999, 2999,
 end_month                           = ${end_month},   06,   06,
 end_day                             = ${end_day},   12,   12,
 end_hour                            = ${end_hr},   12,   12,
 end_minute                          = 00,   00,   00,
 end_second                          = 00,   00,   00,
 interval_seconds                    = 21600,
 input_from_file                     = .true.,.true.,.true.,
 history_interval                    = 60,   60,   60,
 frames_per_outfile                  = 1, 1000, 1000,
 restart                             = .false.,
 restart_interval                    = 60,
 auxinput5_interval_m                = 2880, 60, 60
 auxinput7_interval_m                = 2880, 60, 60
 auxinput8_interval_m                = 2880, 86400, 60
 io_form_history                     = 2
 io_form_restart                     = 2
 io_form_input                       = 2
 io_form_boundary                    = 2
 io_form_auxinput4                   = 2
 io_form_auxinput5                   = 2
 io_form_auxinput7                   = 2
 io_form_auxinput8                   = 2
 debug_level                         = 00
 auxinput1_inname                    = "met_em.d<domain>.<date>"
 /

 &domains
 time_step                           = ${timestep},
 time_step_fract_num                 = 0,
 time_step_fract_den                 = 1,
 max_dom                             = 1,
 e_we                                = ${npt_we},    112,   94,
 e_sn                                = ${npt_sn},    97,    91,
 e_vert                              = ${nlvl},    20,    20,
 dx                                  = ${dx_grid}, 20000, 6666.66,
 dy                                  = ${dy_grid}, 20000, 6666.66,
 p_top_requested                     = 5000,
 num_metgrid_levels                  = ${metgrid_levels},
 num_metgrid_soil_levels             = 4,
 grid_id                             = 1,     2,     3,
 parent_id                           = 1,     1,     2,
 i_parent_start                      = 1,     30,    30,
 j_parent_start                      = 1,     20,    30,
 parent_grid_ratio                   = 1,     3,     3,
 parent_time_step_ratio              = 1,     3,     3,
 feedback                            = 1,
 smooth_option                       = 0
 eta_levels                          =    1, 0.993, 0.983, 0.97, 0.954, 0.935, 0.913, 0.888, 0.86, 0.83, 0.799,
    0.767, 0.733, 0.7, 0.667, 0.633, 0.6, 0.567, 0.533, 0.5, 0.467, 0.433,
    0.4, 0.367, 0.333, 0.3, 0.267, 0.233, 0.2, 0.167, 0.133, 0.1, 0.067,0.033, 0.
 /

 &physics
 mp_physics                          = 8,     2,     2,
 ra_lw_physics                       = 1,     1,     1,
 ra_sw_physics                       = 1,     2,     2,
 radt                                = 30,    10,    10,
 sf_sfclay_physics                   = 2,     1,     1,
 sf_surface_physics                  = 2,     2,     2,
 bl_pbl_physics                      = 2,     1,     1,
 bldt                                = 0,     0,     0,
 cu_physics                          = 0,     5,     0,
 cudt                                = 0,     1,     1,
 isfflx                              = 1,
 ifsnow                              = 1,
 icloud                              = 1,
 surface_input_source                = 1,
 num_soil_layers                     = 4,
 sf_urban_physics                    = 0,
 swrad_scat                          = 1,
 mp_zero_out                         = 2,
 mp_zero_out_thresh                  = 1.e-8,
 maxiens                             = 1,
 maxens                              = 3,
 maxens2                             = 3,
 maxens3                             = 16,
 ensdim                              = 144,
 cu_rad_feedback                     = .false.,
 cu_diag                             = 0,
 cugd_avedx                          = 1
 /

 &fdda
 /
 

 &dynamics
 rk_ord                              = 3,
 w_damping                           = 1,
 diff_opt                            = 1,
 km_opt                              = 4,
 diff_6th_opt                        = 0,      0,      0,
 diff_6th_factor                     = 0.12,   0.12,   0.12,
 base_temp                           = 290.
 damp_opt                            = 0,
 zdamp                               = 5000.,  5000.,  5000.,
 dampcoef                            = 0.01,    0.2,    0.2
 khdif                               = 0,      0,      0,
 kvdif                               = 0,      0,      0,
 smdiv                               = 0.1,    0.1,    0.1,
 emdiv                               = 0.01,   0.01,   0.01,
 non_hydrostatic                     = .true., .true., .true.,
 moist_adv_opt                       = 2,      1,      1,
 scalar_adv_opt                      = 2,      1,      1,
 chem_adv_opt                        = 2,      1,      1,
 use_baseparam_fr_nml                = .true.,
 h_mom_adv_order                     = 5,      5,      5,
 v_mom_adv_order                     = 3,      3,      3,
 h_sca_adv_order                     = 5,      5,      5,
 v_sca_adv_order                     = 3,      3,      3,
 time_step_sound                     = 4,      4,      4,
 epssm                               = .1,     .1,     .1,
 /

 &bdy_control
 spec_bdy_width                      = 5,
 spec_zone                           = 1,
 relax_zone                          = 4,
 specified                           = .true., .false.,.false.,
 nested                              = .false., .true., .true.,
 /

 &grib2
 /

 &chem
 kemit                               = 1,
 chem_opt                            = 300,        2,
 bioemdt                             = 3,       30,
 photdt                              = 3,       30,
 chemdt                              = ${chemdtt},       2.,
 io_style_emissions                  = 2,
 emiss_inpt_opt                      = 1,        1,
 emiss_opt                           = 0,        3,
 chem_in_opt                         = 0,        0,
 phot_opt                            = 0,        1,
 gas_drydep_opt                      = 0,        1,
 aer_drydep_opt                      = 0,        1,
 aer_op_opt                          = 0,
 bio_emiss_opt                       = 1,        1,
 dust_opt                            = 1,
 dmsemis_opt                         = 0,
 seas_opt                            = 1,
 gas_bc_opt                          = 0,        1,
 gas_ic_opt                          = 0,        1,
 aer_bc_opt                          = 0,        1,
 aer_ic_opt                          = 0,        1,
 gaschem_onoff                       = 0,        1,
 aerchem_onoff                       = 0,        1,
 wetscav_onoff                       = 0,        0,
 cldchem_onoff                       = 0,        0,
 vertmix_onoff                       = 0,        1,
 chem_conv_tr                        = 0,        1,
 biomass_burn_opt                    = 1,        0,
 plumerisefire_frq                   = 30,       30,
 aer_ra_feedback                     = 0,        0,
 have_bcs_chem                       = .false., .false.,
/

 &namelist_quilt
 nio_tasks_per_group = 0,
 nio_groups = 1,
 /

__EOF

####echo "before convert_emiss.exe "$(date)

#RUN convert_emiss.exe to make fire emissions
cp -p namelist.input namelist.input.save2

#mpirun ./convert_emiss.exe 
srun --export=ALL -n 1 ./convert_emiss.exe 

mv rsl.out.0000 rsl.out.convert.0000
mv rsl.error.0000 rsl.error.convert.0000

#####echo 'Time after convert_emiss.exe '$(date)


#add date to fire emissions
##mv wrffirechemi_d01 wrffirechemi_d01_${year}-${month}-${day}_${hr}':00:00'
echo ajl cp wrffirechemi_d01 wrffirechemi_d01_${year}-${month}-${day}_${hr}':00:00'
ls -l  wrffirechemi_d01
cp wrffirechemi_d01 wrffirechemi_d01_${year}-${month}-${day}_${hr}':00:00'


#If RAQMS data not available, keep going

raq_year=`echo "${RAQMS_DATE}" | cut -c3-4`
raq_month=`echo "${RAQMS_DATE}" | cut -c6-7`
raq_day=`echo "${RAQMS_DATE}" | cut -c9-10`

#CHECKFILE=`ssh ${user_1}@firefly "ls ${RAQMS_DATA}/${raq_year}${raq_month}${raq_day}/ | grep uwhyb_${end_month}_${end_day}_${end_year}_${end_hr}Z.chem.assim.nc"`
#if [ $? -ne 0 ]; then
#echo 'RAQMS data not available, skip chem IC and LBC'
#DO_LBC=.false.
#fi

echo 'Make LBCs from RAQMS ',$DO_LBC

#RAQMS LBC

if [ ${DO_LBC} = .true. ]; then

raq_year=`echo "${RAQMS_DATE}" | cut -c3-4`
raq_month=`echo "${RAQMS_DATE}" | cut -c6-7`
raq_day=`echo "${RAQMS_DATE}" | cut -c9-10`


ln -sf ${scratch_d_raqms}/${raq_year}${raq_month}${raq_day}/uwh* .

# make lateral boundary conditions

cat > wrfchembc_namelist.input.racm-gocart << __EOF
&control

dir_wrf = './'
fnb_wrf  = 'wrfbdy_d01'
fni_wrf  = 'wrfinput_d01'

chem_bc_opt = 2
dir_global = './'
fn_global  = 'uwhyb_${month}_${day}_${year}_${hr}Z.chem.assim.nc'

do_ic =${DO_IC}
do_bc =${DO_LBC}

nspec = 17

specname = 'so2',
           'sulf',
           'dms',
           'msa',
           'BC1',
           'BC2',
           'OC1',
           'OC2',
           'DUST_1',
           'DUST_2',
           'DUST_3',
           'DUST_4',
           'DUST_5',
           'SEAS_1',
           'SEAS_2',
           'SEAS_3',
           'SEAS_4'
/
__EOF

#run lateral boundary condtion programs

####echo 'Time before lbc '$(date)

#### RUN LBC code 

./wrfchembc.exe < wrfchembc_namelist.input.racm-gocart

####echo 'Time after lbc '$(date)
fi    #end do_bc

fi     #if compute_ic


####echo 'Done with get_initial '$(date)

#write data to directory

dir_out=${year}${month}${day}${hr}
echo ajl dir_out $dir_out

rm -rf ${dir_out}

mkdir ${dir_out}

mv -f wrfbdy_d01 ${dir_out}
mv -f wrfinput_d01 ${dir_out}
mv -f wrffirechemi_d01* ${dir_out}
mv -f wrfchemi_gocart_bg_d01 ${dir_out}
mv -f wrfchemi_d01 ${dir_out}

#move wrf IC, emissions and LBC data to disk
echo  'move directory '${dir_out} 'to '${WRF_INIT_DATA}
rm -rf ${WRF_INIT_DATA}/${dir_out}
mv -f ${dir_out} ${WRF_INIT_DATA}

#clean up
#rm -r ${dir_out}

year=${nxt_year}
month=${nxt_month}
day=${nxt_day}
hr=${nxt_hr}

current_time=${nxt_year}${nxt_month}${nxt_day}${nxt_hr}
echo ' '
echo ' '

done

if [ -e ${WRF_START}_problems.out ]; then
rsync -av ${WRF_START}_problems.out ${user_dir}/DATA_PROBLEMS_REALTIME
fi

echo 'Done with get_initial'
echo ' '

exit
