#!/bin/bash -x

#If RAQMS data not available, keep going

raq_year=`echo "${RAQMS_DATE}" | cut -c3-4`
raq_month=`echo "${RAQMS_DATE}" | cut -c6-7`
raq_day=`echo "${RAQMS_DATE}" | cut -c9-10`

#CHECKFILE=`ssh ${user_1}@firefly "ls ${RAQMS_DATA}/${raq_year}${raq_month}${raq_day}/ | grep uwhyb_${end_month}_${end_day}_${end_year}_${end_hr}Z.chem.assim.nc"`
#if [ $? -ne 0 ]; then
#echo 'RAQMS data not available, skip chem IC and LBC'
#DO_LBC=.false.
#fi

raq_year=`echo "${RAQMS_DATE}" | cut -c3-4`
raq_month=`echo "${RAQMS_DATE}" | cut -c6-7`
raq_day=`echo "${RAQMS_DATE}" | cut -c9-10`

#make sure all required raqms data exists, when 12z of of nxt_day is there, rsync

# Make chem lateral boundary conditions from RAQMS

#rsync all RAQMS data
export new_date=$HOME/UTILS/da_advance_time.exe

export PATHUWH=${scratch_d_raqms}/${raq_year}${raq_month}${raq_day}
mkdir ${PATHUWH}
#mkdir ${scratch_d_raqms}/${raq_year}${raq_month}${raq_day}
export CDATE=`echo '20'${raq_year}${raq_month}${raq_day}'12'`
echo CDATE $CDAte
start=$($new_date $CDATE 36h)
stop=$($new_date $CDATE 120h)
uwhdate=$start
RSYNCPATH=${user_1}@${RAQMS_DIR}/${raq_year}${raq_month}${raq_day}
RSYNCPATH2=/odyssey/proxy/CalNex/UW-Hybrid/Mission_1X1/Netcdf/${raq_year}${raq_month}${raq_day}
RSYNCPATH2=/iliad/proxy/lenzen/CalNex/UW-Hybrid/Mission_1X1/Netcdf/${raq_year}${raq_month}${raq_day}
while [ $uwhdate -le $stop ]
  do  
     echo uwhdate $uwhdate
     export MM=`echo $uwhdate | cut -c5-6`
     export DD=`echo $uwhdate | cut -c7-8`
     export HH=`echo $uwhdate | cut -c9-10`
     export YYYY=`echo $uwhdate | cut -c1-4`
     echo YYYY $YYYY MM $MM DD $DD HH $HH 
     export uwhfile="uwhyb_"$MM"_"$DD"_"$YYYY"_"$HH"Z.chem.assim.nc"
#     rsync -av /odyssey/proxy/CalNex/UW-Hybrid/Mission_1X1/Netcdf/${raq_year}${raq_month}${raq_day}/$uwhfile $PATHUWH
     rsync -av $RSYNCPATH2/$uwhfile $PATHUWH
     rsync -av $RSYNCPATH/$uwhfile $PATHUWH
     uwhdate=$(${new_date} $uwhdate 6h) 
  done
echo start $start $stop


exit

