#!/bin/bash -x
echo "  "
echo "  "
echo "run_real started "$(date)

if [ -f ~/.bashrc ]; then
source ~/.bashrc 
fi

#source /etc/links/mpivars.sh intel64
. $HOME/.bashrc
#export MPD_CON_EXT="sge_$JOB_ID.$SGE_TASK_ID"
#export MPD_CON_EXT="sge_$JOB_ID.$SGE_TASK_ID"
# need to fix for slurm
export QQ=`echo $QUEUE | cut -c1-2`
export OMP_NUM_THREADS=2
export OMP_STACKSIZE=100000
export I_MPI_PIN_DOMAIN=omp
export OMP_NESTED=1
export NPERNODE=24
export MPICH_MPIIO_HINTS_DISPLAY=yes
export LD_LIBRARY_PATH
ulimit -l unlimited
ulimit -s unlimited

#NCPUS  - number of cpus for real.exe
NCPUS=8

echo 'Get ready to run WRFCHEM, run_real n directory '$PROG_DIR
env >$HOME/outenvthompson

export SCRIPT_DIR=$PROG_DIR/
export WRFPRGS=${WRFCHEM_DIR}/WRFV3

WRF_INPUT=${base_data_disk}/8KM_INPUT/$grid_dims
export FIRES_EMISS=${WRF_INPUT}
#export ANTHRO_EMISS=/data/users/${user_1}/REALTIME_PROXY/WRFCHEMI_8KM/NSSL_VERTICAL_GRID/${grid_dims}
# ajl switch to NEI 2011 01/13/2017
#export ANTHRO_EMISS=/iliad/proxy/lenzen/get_init_nei_2011_proxy/
#export ANTHRO_EMISS2=/odyssey/proxy/lenzen/get_init_nei_2011_proxy/
#export ANTHRO_EMISS3=/data/users/lenzen/get_init_nei_2011_proxy/
# ajl switch to scaled 7/6/2017
export ANTHRO_EMISS=/iliad/proxy/lenzen/get_init_nei_2011_proxy/scaleSO2BCOC/
export ANTHRO_EMISS2=/odyssey/proxy/lenzen/get_init_nei_2011_proxy/scaleSO2BCOC/
export ANTHRO_EMISS3=/data/users/lenzen/get_init_nei_2011_proxy/scaleSO2BCOC/


export L_NOX=${user_dir}/WRF_LNOX

export MPICH_MPIIO_HINTS_DISPLAY=yes
export USEPR94=yes
export AREAFIX=yes
#export NOXLIGHTNING=yes
export NOXLIGHTNING=no

######################### Settings for AOD run ######################
export AEREXPSTART=2010042600
export OBFAC=0.1
export SETCHLAER=300.
export SETCHAER=300.
export ASSIMAOD=save
####export SDFAOD

export Rundir=$scratch_d_wrf
mkdir $Rundir
echo 'Rundir '$Rundir

#go to run directory
cd $Rundir

#WRFDA routine used to increment time
rsync -av ${user_dir}/UTILS/da_advance_time.exe .
new_date=./da_advance_time.exe

/bin/rm -f masternode
/bin/rm -f real.exe
/bin/rm -f convert_emiss.exe
/bin/rm -f wrf.exe
/bin/rm -f rsl.*

#remove previous days files

/bin/rm wrfout*
/bin/rm rsl.*
/bin/rm wrffirechemi_d01_*

#Set up run  *******************************************
#passed in

identstart=${identstart}
raqms_day=${raqms_date}

echo 'identstart ',${identstart}
echo 'raqms_day ',${raqms_day}

#number of hours between new MET fields
export fcst_length=$fcst_length
export assim_cycle=$fcst_length

identstop=$identstart    


# look at run_real.scr.sav for version of code capable of doing the following
#if MAKE_WRFINPUT=.true., wrfinput files are calculated here, otherwise wrfinput files are read in from $WRF_INPUT

export timestep=$timestep    
export chemdtt=$chemdtt    
export npt_we=$npt_we
export npt_sn=$npt_sn
export dx_grid=$dx_grid
export dy_grid=$dy_grid
export nlvl=$nlvl

echo 'Met timestep '${timestep}
echo 'Chem timestep '${chemdtt}
echo 'Number of columns, staggered grid '${npt_we}
echo 'Number of rows, staggered grid '${npt_sn}
echo 'dx,dy ',$dx_grid $dy_grid

echo 'fcst_length assim_cycle Rundir ' $fcst_length $assim_cycle $Rundir
ls -l --time=atime wrfchemi*

#move anthropogenic emission files if necessary
if [ -e wrfchemi_00z_d01 ]; then
  echo 'wrfchemi_00z_d01'
else
  rsync -arv ${computer_2}${ANTHRO_EMISS}/wrfchemi_00z_d01 .
  if   [ $? -ne 0 ] ; then
    rsync -arv ${ANTHRO_EMISS}/wrfchemi_00z_d01 .
    rsync -arv ${ANTHRO_EMISS2}/wrfchemi_00z_d01 .
    rsync -arv ${ANTHRO_EMISS3}/wrfchemi_00z_d01 .
  fi
fi

if [ -e wrfchemi_12z_d01 ]; then
  echo 'wrfchemi_12z_d01'
else
  rsync -arv ${computer_2}${ANTHRO_EMISS}/wrfchemi_12z_d01 .
  if   [ $? -ne 0 ] ; then
    rsync -arv ${ANTHRO_EMISS}/wrfchemi_12z_d01 .
    rsync -arv ${ANTHRO_EMISS2}/wrfchemi_12z_d01 .
    rsync -arv ${ANTHRO_EMISS3}/wrfchemi_12z_d01 .
  fi
fi
ls -l --time=atime wrfchemi*


#copy WRF/Chem programs to rundir
echo ajl11 ${computer_2} $WRFPRGS
rsync -av ${computer_2}$WRFPRGS/main/real.exe real.exe 
if [ $? -ne 0 ] ; then
  rsync -av $WRFPRGS/main/real.exe real.exe 
fi
rsync -av ${computer_2}$WRFPRGS/main/wrf.exe wrf.exe 
if [ $? -ne 0 ] ; then
  rsync -av $WRFPRGS/main/wrf.exe wrf.exe 
fi
rsync -av ${computer_2}$WRFPRGS/chem/convert_emiss.exe convert_emiss.exe 
if [ $? -ne 0 ] ; then
  rsync -av $WRFPRGS/chem/convert_emiss.exe convert_emiss.exe 
fi
rsync -av ${computer_2}$WRFPRGS/run/*.tbl .
if [ $? -ne 0 ] ; then
  rsync -av $WRFPRGS/run/*.tbl .
fi
rsync -av ${computer_2}$WRFPRGS/run/*.TBL .
if [ $? -ne 0 ] ; then
  rsync -av $WRFPRGS/run/*.TBL .
fi
rsync -av ${computer_2}$WRFPRGS/run/*.txt .
if [ $? -ne 0 ] ; then
  rsync -av $WRFPRGS/run/*.txt .
fi 
rsync -av ${computer_2}$WRFPRGS/run/*DATA .
if   [ $? -ne 0 ] ; then
  rsync -av $WRFPRGS/run/*DATA .
fi
rsync -av ${computer_2}$L_NOX/* .
if   [ $? -ne 0 ] ; then
  rsync -av $L_NOX/* .
fi
echo ajl22

#stop date
year=`echo "${identstop}" | cut -c1-4`
month=`echo "${identstop}" | cut -c6-7`
day=`echo "${identstop}" | cut -c9-10`
hr=`echo "${identstop}" | cut -c12-13`
stop_time=${year}${month}${day}${hr}


#start date
year=`echo "${identstart}" | cut -c1-4`
month=`echo "${identstart}" | cut -c6-7`
day=`echo "${identstart}" | cut -c9-10`
hr=`echo "${identstart}" | cut -c12-13`
current_time=${year}${month}${day}${hr}

echo ' '
echo '############################################### '
echo '############################################### '
echo "Start date of run  "${current_time} ${stop_time}
echo '############################################### '
echo '############################################### '
echo ' '

echo 'Wall clock time at start of run '$(date)

while [ ${current_time} -le ${stop_time} ]      #just 1 at a time
do

export WRFDATE=${year}-${month}-${day}_${hr}:00:00

# Need to also get next days initial condtions
next_day=$($new_date $current_time 1d)
nxt_year=`echo "${next_day}" | cut -c1-4`
nxt_month=`echo "${next_day}" | cut -c5-6`
nxt_day=`echo "${next_day}" | cut -c7-8`
nxt_hr=`echo "${next_day}" | cut -c9-10`

# Increment time to end of WRF/Chem run

numday=$((${assim_cycle}/24))
numhr=$((${assim_cycle}%24))
run_days=${numday}
run_hours=${numhr}

end_time=$($new_date $current_time ${numday}d)
end_time=$($new_date $end_time ${numhr}h)
end_year=`echo "${end_time}" | cut -c1-4`
end_month=`echo "${end_time}" | cut -c5-6`
end_day=`echo "${end_time}" | cut -c7-8`
end_hr=`echo "${end_time}" | cut -c9-10`

export ASSIM_START=${year}_${month}_${day}_${hr}
export ASSIM_STOP=${end_year}_${end_month}_${end_day}_${end_hr}

# copy over wrf IC, LBC and fire emissions
echo ajl33

rsync -av ${base_computer}${WRF_INPUT}/${year}${month}${day}${hr}/wrfinput_d01 wrfinput_d01
if [ $? -ne 0 ]; then
  rsync -av ${WRF_INPUT}/${year}${month}${day}${hr}/wrfinput_d01 wrfinput_d01
fi
rsync -av ${base_computer}${WRF_INPUT}/${year}${month}${day}${hr}/wrfbdy_d01 wrfbdy_d01
if [ $? -ne 0 ]; then
  rsync -av ${WRF_INPUT}/${year}${month}${day}${hr}/wrfbdy_d01 wrfbdy_d01
fi
echo ajl rsync -av ${base_computer}${FIRES_EMISS}/${year}${month}${day}${hr}/wrffirechemi_d01* .
rsync -av ${base_computer}${FIRES_EMISS}/${year}${month}${day}${hr}/wrffirechemi_d01* .
if [ $? -ne 0 ]; then
  rsync -av ${FIRES_EMISS}/${year}${month}${day}${hr}/wrffirechemi_d01* .
fi
rsync -av ${base_computer}${FIRES_EMISS}/${year}${month}${day}${hr}/wrfchemi_gocart_bg_d01 wrfchemi_gocart_bg_d01
if [ $? -ne 0 ]; then
  rsync -av ${FIRES_EMISS}/${year}${month}${day}${hr}/wrfchemi_gocart_bg_d01 wrfchemi_gocart_bg_d01
fi 
echo ajl44

#add date to fire emissions
echo ajl cp wrffirechemi_d01 wrffirechemi_d01_${year}-${month}-${day}_${hr}':00:00'
cp wrffirechemi_d01 wrffirechemi_d01_${year}-${month}-${day}_${hr}':00:00'

#Call script to run WRF/CHEM
echo run_wrfchem_v3.5.1

${SCRIPT_DIR}run_wrfchem_v3.5.1_thomp.3day.sh

#check exit code to make sure wrf chem run worked
if [ $? -ne 0 ]; then
echo 'Problem in run_real 625'
# ajl let run for now in case have data
#  exit 111
fi
ls -l --time=atime wrfchemi*

echo 'Done with forecast, back in run_real '$(date)

year=${nxt_year}
month=${nxt_month}
day=${nxt_day}
hr=${nxt_hr}

current_time=${nxt_year}${nxt_month}${nxt_day}${nxt_hr}
echo ' '
echo ' '
done
# for s4-cardinal need to sbatch to serial for rest of script
exit
