#!/bin/bash -x

#WRFDA routine used to increment time
new_date=${user_dir}/UTILS/da_advance_time.exe

dx_grid=${dx_grid}
dy_grid=${dy_grid}
npt_we=${npt_we}
npt_sn=${npt_sn}

istart=$iday_fires
istop=$istart

#stop date
year=`echo "${istop}" | cut -c1-4`
month=`echo "${istop}" | cut -c6-7`
day=`echo "${istop}" | cut -c9-10`
hr=`echo "${istop}" | cut -c12-13`
stop_time=${year}${month}${day}${hr}

#start date
year=`echo "${istart}" | cut -c1-4`
month=`echo "${istart}" | cut -c6-7`
day=`echo "${istart}" | cut -c9-10`
hr=`echo "${istart}" | cut -c12-13`

current_time=${year}${month}${day}${hr}

echo ' '
echo '############################################### '
echo '############################################### '
echo "Starting date of for fires processing  "${current_time}
echo "End of fires processing run "${stop_time}
echo '############################################### '
echo '############################################### '
echo ' '

#WHILE LOOP (keep going until stop_time)

echo ${current_time} ${stop_time}

while [ ${current_time} -le ${stop_time} ]
do

echo 'working on time' ${current_time}

#start date
year=`echo "${current_time}" | cut -c1-4`
month=`echo "${current_time}" | cut -c5-6`
day=`echo "${current_time}" | cut -c7-8`
hr=`echo "${current_time}" | cut -c9-10`

echo 'top '${year} ${month} ${day} ${hr}

./getjulday.x ${year} ${month} ${day} 

file=jday
exec 3<&0
exec 0<$file
while read -r line
do
  echo "line $line"
  julday=$line
done < "$file"
#exec 0<&3

#need three digits
if [ $julday -lt 10 ]; then
  julday=00${julday}
elif [ $julday -lt 100 ]; then
  julday=0${julday}
fi

echo 'julday ' $julday

echo 'working on time,julday ' ${current_time} $julday

mkdir $julday
echo ajl rsync -av ${user_1}@${FIRES_LOC}/$year$julday/f2*filt $julday/$year$julday
rsync -av ${user_1}@${FIRES_LOC}/$year$julday/f2*filt $julday/$year$julday

if [ $? -ne 0 ]; then
echo "ajl rsync get problems fires"
echo 'Problems with fires data $Rundir/${wrf_start}_problems.out'
echo 'Problems with fires data' >> $Rundir/${wrf_start}_problems.out
fi

   echo 'global emissions '
   echo 'nc,nr '$npt_we $npt_sn
   echo 'dx,dy '${dx_grid} ${dy_grid}
   echo 'truelat, truelon '${truelat1}  ${truelat2}
   echo 'reflat,reflon '${ref_lat} ${ref_lon}
   echo 'reflat,reflon '${ref_lat} ${ref_lon}
   echo 'date '${hr} ${day} ${month} ${year},

cat > prep_chem_sources.inp << __EOF

 &RP_INPUT

!##############################################################################!
!  CPTEC emission model    CPTEC/INPE                          !
!  version 1: 20/may/2008                                                      !
!  developed/coded by Saulo Freitas and Karla Longo                            !
!  contact: saulo.freitas@cptec.inpe.br  web: meio_ambiente.cptec.inpe.br      !
!###############################################################################

 
!---------------- grid_type of the grid output
   grid_type= 'lambert',	
                        !'polar' = polar stereo. grid output
                        !'lambert' = lambert. grid output
                        ! 'gg'  = gaussian grid output
			! 'll'  = lat/lon grid output
 

!---------------- date of emission  
!  ihour=00, iday=09, imon=07, iyear=2008,

   ihour=${hr}, 
   iday=${day} 
   imon=${month}, 
   iyear=${year},

!---------------- select the sources datasets to be used   
   use_retro=1,  ! 1 = yes, 0 = not
   retro_data_dir='$EMISS_DIR/Emission_data/RETRO/anthro',

!  use_edgar=1, 
   use_edgar=2, 
   edgar_data_dir='$EMISS_DIR/Emission_data/EDGARV4',

   use_gocart=1, 
   gocart_data_dir='$EMISS_DIR/Emission_data/GOCART/emissions',

   use_gocart_bg=1

   use_bioge=1, 
   bioge_data_dir='$EMISS_DIR/Emission_data/biogenic_emissions',

   use_fwbawb=0,
   fwbawb_data_dir='$EMISS_DIR/Emission_data/Emissions_Yevich_Logan',

   use_gfedv2=0,
   gfedv2_data_dir='$EMISS_DIR/Emission_data/GFEDv2-8days',

   use_bbem=1,
   use_bbem_plumerise=1,

!---------------- if  the merging of gfedv2 with 3bem is desired (=1, yes, 0 = no)  
   merge_GFEDv2_bbem =0,
!---------------- Fire product for BBBEM/BBBEM-plumerise emission models

! GOES 13 fires data for end April, May and June 2010 gotten from Jay Hoffman

   bbem_wfabba_data_dir   ='./$julday/',

   bbem_modis_data_dir    ='$EMISS_DIR/Emission_data/fires_data/MODIS',
   bbem_inpe_data_dir     ='$EMISS_DIR/Emission_data/fires_data/DSA',
   bbem_extra_data_dir    ='$EMISS_DIR/Emission_data/fires_data/BLMALASKA',

!---------------- veg type data set (dir + prefix)
   veg_type_data_dir      ='$EMISS_DIR/surface_data/GL_IGBP_MODIS_INPE/MODIS',	       

!---------------- carbon density data set (dir + prefix)
   carbon_density_data_dir='$EMISS_DIR/surface_data/GL_OGE_INPE/OGE',

   fuel_data_dir      =' ',		     

   olson_data_dir= '$EMISS_DIR/Emission_data/OLSON2/OLSON',

!---------------- gocart background
   use_gocart_bg=1, 
   gocart_bg_data_dir='$EMISS_DIR/Emission_data/GOCART',

   user_data_dir='NONE',

!---------------- vcf type data set (dir + prefix)
  use_vcf = 0,
  vcf_type_data_dir      ='/dados/dados3/stockler/VCF/data_out/2004/VCF',

!---------------- volcanoes emissions
   use_volcanoes =0,
!---------------- degassing volcanoes emissions
   use_degass_volcanoes =0,

!---------------- For regional grids (polar or lambert)

   NGRIDS   = 1,             ! Number of grids to run

   NNXP     = ${npt_we},     ! Number of x gridpoints - Todd   
   NNYP     = ${npt_sn},     ! Number of y gridpoints

   NXTNEST  = 0,             ! Grid number which is the next coarser grid
   DELTAX   = ${dx_grid},
   DELTAY   = ${dy_grid},    ! X and Y grid spacing

   ! Nest ratios between this grid and the next coarser grid.
   NSTRATX  = 1,             ! x-direction
   NSTRATY  = 1,             ! y-direction
   
!tks for lambert set polelat, polelon, centlat, centlon to the center of the grid
!tks centlon=polelon must range only from -180 to +180

   POLELAT  = ${ref_lat},     ! If polar, latitude/longitude of pole point
   POLELON  = ${ref_lon},     ! If lambert, lat/lon of grid origin (x=y=0.)

   STDLAT1  = ${truelat1},    ! If polar, unused, if lambert, southern standard latitude
   STDLAT2  = ${truelat2},    ! If lambert, northern standard latitudes of projection

   CENTLAT  = ${ref_lat},
   CENTLON  = ${ref_lon}, 

!---------------- project  grid  to lat/lon: 'YES' or 'NOT' (only set up for GrADS visualization)
   proj_to_ll='NO', 
   
!---------------- model output domain for each grid (only set up for GrADS visualization)
   lati =  -90.,  -90.,   -90., 
   latf =  +90.,  +90.,   +90.,  
   loni = -180., -180.,  -180., 
   lonf =  180.,  180.,   180., 

!---------------- output file prefix (may include directory other than the current)

   chem_out_prefix = './GOCART', 

   chem_out_format = 'vfm', ! don't change' this

!---------------- convert to WRF/CHEM (yes,no)
!---------------- convert to WRF/CHEM (yes,not)
  special_output_to_wrf = 'YES',

/

__EOF

# execute fires program
echo ajl run prep_chem_sources_RADM_WRF_FIM.exe

./prep_chem_sources_RADM_WRF_FIM.exe >& bin_fires_${year}${month}${day}${hr}.out2
echo ajl did run prep_chem_sources_RADM_WRF_FIM.exe status $?


# Increment time


gdate=$($new_date $current_time 1d)
current_time=$gdate
echo 'current_time at end of loop '${current_time}
echo ${year} ${month} ${day} ${hr}
done
echo ajl do rm
rm *.ctl
rm *.gra
rm *.vfm
exit

